/*
 * FILE		: sscdebug.cpp
 * FUNCTION	: Debugp֐
 * AUTHOR   : 2004.08.05 s.kobayashi
 */
/*	Ŝ extern "C" {   ... } ɂĉ܂܍쐬ł̂ȂƂ肠c++ō쐬
+**/
static char __file[] = __FILE__ ;
#define CLASS_DEF 

#include			<stdio.h>
#include			<string.h>
#include			"zgsscp.h"

#define			MAXCHK	1000		/* CHKx()̏o͉MAX */
#define			MAXLIST	2000000L		/* LIST̏oMAX */

#define			USE_LOCALE
#ifdef USE_LOCALE	/* TCHAR.Htprintf()n֐gpȂŎ͂ŊR[hݒ */
#include			<locale.h>
#endif
static int list_count=0 ;	/* o͂C */
static int err_count=0 ;	/* CHKo͂C */

#ifndef Dprintf
static FILE	*dbgFp   = 0 ;  /* stdout ; */
static int	dbgMode  = 0 ;	/* "w" */
static char	*dbgFname=NULL ;
#endif
#ifdef _DEBUG
#define DBGF 1
#else
#define DBGF 0
#endif
/*	basenm:
+**/
static char *CLASS_DEF basenm( char *s )
{
	char	*r = s;
	for( ; *s; ++s ) if( *s == '\\' || *s == '/' ) r = s+1;
	return( r );
}
/*	Dprintf:
+**/
#ifndef Dprintf
//#	ifdef __cplusplus
#		include			<stdarg.h>
#		if !defined(USE_LOCALE) 
#			include			<iostream.h>
#			include			<TCHAR.H>
#		endif
#		if !defined(_WIN32) /* UNIX ݊o[W */
#			include <varargs.h>
#		endif
#if 1 || defined(_WIN32)
int Dprintf( const char *lpszFormat, ... )
#else	/* UNIX݊ */
int Dprintf( va_alist )
va_dcl
#endif
{
//#ifdef _DEBUG
	va_list args;
	int nBuf;
//#if !defined(USE_LOCALE)
//	TCHAR szBuffer[1024] ;
//#endif

	if( list_count >= MAXLIST ) return 0 ;

#if 1 || defined(_WIN32)
	va_start(args, lpszFormat);
#else	/* UNIX݊ */
	va_start(args);
#endif
	if( dbgMode == 1 && dbgFname ) dbgFp = fopen( dbgFname, "a" ) ;
	if( dbgFp ) {
#ifdef USE_LOCALE
			nBuf = vfprintf( dbgFp, lpszFormat, args ) ;
#else
//			nBuf = _vstprintf( szBuffer, lpszFormat, args ) ;	/* TCHARϊ */
//			szBuffer[1023] = '\0' ;
//			if( dbgfp == stdout )	cout << szBuffer ;			/* coutK̂ŎcĂ */
//			else 					fprintf( dbgFp, szBuffer ) ;
			nBuf = _vftprintf( dbgFp, lpszFormat, args ) ;		/* TCHAR(OK) */
#endif	/* USE_LOCALE */

			if( ++list_count >= MAXLIST ) 
				fprintf( dbgFp, "C%ld𒴂܂Bȍ~o͂܂B\n",MAXLIST ) ;
			fflush( dbgFp ) ;
			if( dbgMode == 1 && dbgFname && dbgFp != stdout ) { fclose( dbgFp ) ; dbgFp = NULL ; }
	}
	va_end( args ) ;
	return( 0 ) ;
}
//#	else	/* !__cplusplus */
//int CLASS_DEF Dprintf( /* fmt, p0, p1, p2, p3, p4, p5, p6, p7, p8, p9
//	        , q0, q1, q2, q3, q4, q5, q6, q7, q8, q9 ) */
//			const char *ftmt, 
//			...	
//			)
//{
//	if( list_count >= MAXLIST ) return 0 ;
//	
//	if( dbgMode == 1 && dbgFname ) {
//		dbgFp = fopen( dbgFname, "a" );
//	}
//	if( dbgFp ) {
//			fprintf( dbgFp, fmt, p0, p1, p2, p3, p4, p5, p6, p7, p8, p9
//						  , q0, q1, q2, q3, q4, q5, q6, q7, q8, q9 );
//			fflush( dbgFp );
//			if( ++list_count >= MAXLIST ) 
//				fprintf( dbgFp, "C%ld𒴂܂Bȍ~o͂܂B\n",MAXLIST ) ;
//	#ifdef _WIN32
//			if( dbgMode == 1 && dbgFname && dbgFp != stdout ) { fclose(dbgFp), dbgFp = NULL; }
//	#endif
//	}
//	return( 0 );
//}
//#	endif	/* __cplusplus */
#endif		/* Dprintf */
/*	trace_ab:
+**/
int CLASS_DEF trace_ab (int type,char *file,int line,int xx)
{
	static const char	*arc[] = {" ==>", " -- ", "<== ", "", "", "" };
	Dprintf("%s %-10s(%3d) %c", arc[type], basenm(file), line, xx?'\n':' ') ;
	return(0);
}
/*	chk_ab:
+**/
int CLASS_DEF chk_ab  (int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz)
{
	static const char	*arc[] = { "A", "B" };
	if( err_count < MAXCHK ) { 
		Dprintf("*** CHK%s error <== %8s(%d) %s(%ld) %s(%ld) %s(%ld)\n",
			arc[t], basenm(file), line, sx, lx, sy, ly, sz, lz ) ;
		if( ++err_count >= MAXCHK) {
			Dprintf( "CHK(%d)𒴂܂Bȍ~o͂܂B\n", MAXCHK );
		}
	}
	return(1);
}
/*	Dpintflag:	DBG[]ɃZbg
+**/
int CLASS_DEF Dpinitflag( char *fname )
{	
	FILE	*fp ;
	int 	i, ng, ch;
	if(DBGF) TRACEA(0),Dprintf("Dinitflag:fname(%s)\n",fname);
	ng = sizeof( DBG ) / sizeof( DBG[0] );
	memset( DBG, 0, sizeof(DBG[0]) * ng ) ;

	if( (fp = fopen( fname, "r" )) != NULL ) {
		for( i = 0 ; (ch = getc(fp)) != EOF && i < ng; )
			if( ch >= '0' && ch <= '9' )  DBG[i++] = (unsigned char)(ch - '0') ;
		fclose(fp);
	}
/*	print DBG[] if flags are not all 0 */
	for( i = 0 ; i < ng ; i++ ) if( DBG[i] ) break;
	if( i >= ng ) goto                           quit;
	if(DBGF) {
		Dprintf("\nDBG[] = ") ;
		for( i = 0 ; i < ng ; i++ )  {
			Dprintf( "%d", DBG[i] );
			if     ( i%50 ==49 ) Dprintf( "\n        ");
			else if( i%10 == 9 ) Dprintf( " " );
		}
		Dprintf( "\n");
	}
quit:
	if(DBGF) TRACEC(0),Dprintf("Dinitflag: rc(0)\n");
	return(0);
}
/*	Dpopen:	 ŏɂPĂ
+**/
int CLASS_DEF Dpopen( char *fname,	/*(i) fname :t@C̐擪AhX NULL̎Wo͂ɏo */
			int writeMode 	/*(i) writeMode 0:"w" , 1:"a"ŃI[v */
		   )
{
	if(DBGF) TRACEA(0), Dprintf("Dpopen: fname(%s)writeMode(%d)\n",fname,writeMode ) ;
#ifdef USE_LOCALE
	setlocale( LC_ALL, "Japanese" ) ;
#endif

#ifndef Dprintf
	dbgFname = fname ;
	if( strlen( dbgFname ) <= 0 ) dbgFname = NULL ;
	dbgMode = writeMode ;
	if( dbgFp != stdout  ) {
		if( dbgFp != NULL ) fclose( dbgFp ) ;
		if( dbgFname == NULL ) dbgFp = stdout ;
//		else if( (dbgFp=fopen( dbgFname, "w" )) == NULL ) /* dbgFp = stdout ; */ {rc = -1; goto quit ;}
		else if( dbgMode == 0 ) {
			if( (dbgFp=fopen( dbgFname, "w" )) == NULL ) dbgFp = stdout ;
		}
		else if( dbgMode == 1 ) {
			if( (dbgFp=fopen( dbgFname, "a" )) == NULL ) dbgFp = stdout ;
		}
		if( dbgMode == 1 && dbgFname && dbgFp != stdout ) { fclose( dbgFp ) ; dbgFp = NULL ; }
	}
#endif
	if(DBGF) TRACEC(0), Dprintf("Dpopen: rc(0)\n") ;
	return( 0 ) ;
}
/*	Dpclose:	I ŌɂPĂ
+**/
int CLASS_DEF Dpclose( void )
{
	if(DBGF) TRACEA(0), Dprintf("Dpclose:\n") ;
#ifndef Dprintf
	if( dbgFp != NULL && dbgFp != stdout ) { fclose( dbgFp ) ; dbgFp = stdout ; }
#endif
	if(DBGF) TRACEC(0), Dprintf("Dpclose:rc(0)\n") ;
	return( 0 ) ;
}
