/*
 * FILE      : zfcmssla1.cpp	VbvR(Vbv)
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : VbvR(Vbv)
 * AUTHOR    : N.Tsuchiya  2004.08.30
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

#if 0  //add NT140612
/*	ID_compFrp2	Frp2R[hr
********************************************************/
static int compFrp2( ZMRP &g, int *p, int *q )
{
	int		rc, pitm, qitm, pfsh, qfsh;

	if( (rc = g.frp2[*p].maetaosi - g.frp2[*q].maetaosi) != 0 ) goto    quit; /* O|\ */
	if( (rc = g.frp2[*p].bgn - g.frp2[*q].bgn) != 0 ) goto              quit; /*  */
	if( (rc = g.frp2[*p].due - g.frp2[*q].due) != 0 ) goto              quit; /* [ */
	pfsh = g.frp2[*p].fsh;      CHKA(0, pfsh, g.fsh.n);
	qfsh = g.frp2[*q].fsh;      CHKA(0, qfsh, g.fsh.n);
	pitm = g.fsh.v[pfsh].itm;   CHKA(0, pitm, g.itm.n);
	qitm = g.fsh.v[qfsh].itm;   CHKA(0, qitm, g.itm.n);
	rc = g.itm.v[pitm].prty - g.itm.v[qitm].prty;
	if( rc == 0 )  rc = *p - *q;
quit:
	return rc;
}
#endif //0
/*	ID_compFrp2Pbgn	Frp2𒅎\莞Ŕr
********************************************************/
static int compFrp2Pbgn( ZMRP &g, int *p, int *q )
{
	int		rc, pitm, qitm, pfsh, qfsh;

	if( (rc = g.frp2[*p].yukobgn   - g.frp2[*q].yukobgn)   != 0 ) goto quit; /* gpl\ */
	if( (rc = g.frp2[*p].planbgn   - g.frp2[*q].planbgn)   != 0 ) goto quit; /* \ */
	if( (rc = g.frp2[*p].planbgntm - g.frp2[*q].planbgntm) != 0 ) goto quit; /* \莞 */
	if( (rc = g.frp2[*p].plandue   - g.frp2[*q].plandue)   != 0 ) goto quit; /* H\ */
	if( (rc = g.frp2[*p].planduetm - g.frp2[*q].planduetm) != 0 ) goto quit; /* H\莞 */
	pfsh = g.frp2[*p].fsh;      CHKA(0, pfsh, g.fsh.n);
	qfsh = g.frp2[*q].fsh;      CHKA(0, qfsh, g.fsh.n);
	pitm = g.fsh.v[pfsh].itm;   CHKA(0, pitm, g.itm.n);
	qitm = g.fsh.v[qfsh].itm;   CHKA(0, qitm, g.itm.n);
	rc = g.itm.v[pitm].prty - g.itm.v[qitm].prty;
	if( rc == 0 )  rc = *p - *q;
quit:
	return rc;
}
#if 0  //add NT140612
/*	ID_compFrp2Pdue	Frp2H\莞Ŕr
********************************************************/
static int compFrp2Pdue( ZMRP &g, int *p, int *q )
{
	int		rc, pitm, qitm, pfsh, qfsh;

	if( (rc = g.frp2[*p].plandue   - g.frp2[*q].plandue)   != 0 ) goto quit; /* H\ */
	if( (rc = g.frp2[*p].planduetm - g.frp2[*q].planduetm) != 0 ) goto quit; /* H\莞 */
	if( (rc = g.frp2[*p].yukobgn   - g.frp2[*q].yukobgn)   != 0 ) goto quit; /* O|\ */
	if( (rc = g.frp2[*p].planbgn   - g.frp2[*q].planbgn)   != 0 ) goto quit; /* \ */
	if( (rc = g.frp2[*p].planbgntm - g.frp2[*q].planbgntm) != 0 ) goto quit; /* \莞 */
	pfsh = g.frp2[*p].fsh;      CHKA(0, pfsh, g.fsh.n);
	qfsh = g.frp2[*q].fsh;      CHKA(0, qfsh, g.fsh.n);
	pitm = g.fsh.v[pfsh].itm;     CHKA(0, pitm, g.itm.n);
	qitm = g.fsh.v[qfsh].itm;     CHKA(0, qitm, g.itm.n);
	rc = g.itm.v[pitm].prty - g.itm.v[qitm].prty;
	if( rc == 0 )  rc = *p - *q;
quit:
	return rc;
}
#endif //0
/*	ID_zsortfrp2opo	I[_쐬Frp2\[g
********************************************************/
static int zsortFrp2Opo( ZMRP &g, int ashm )
{
	int		rc = 0, afsh, aodm, afrp2, aitm, yukodays, yukotd, aclm;
	frp2_td	*wfrp2;
	                                       CHKA(0, ashm, g.shm.n);
	/* I[_𒅎\莞AH\莞AiڗD揇ʏɃNtւ */
	g.sortw.clear();
	aclm = g.shm.v[ashm].clm;
	for( afsh = g.shm.v[ashm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].shmnext ) {
		aitm = g.fsh.v[afsh].itm;  CHKA(0, aitm, g.itm.n);
		yukodays = g.itm.v[aitm].yukodays;    /*  gp  Pʂ͓B */
		for( afrp2 = g.fsh.v[afsh].topfrp2due; afrp2 >= 0; afrp2 = wfrp2->duenext ) { CHKA(0, afrp2, g.frp2.n);
			wfrp2 = &g.frp2[afrp2];
			if( (aodm = wfrp2->oyodm) < 0 ) continue;  /* I[_쐬ȊO */
			                             CHKA(0, aodm, g.odm.n); CHKB(4, g.odm.v[aodm].odm_typ, 4);
										 CHKA(0, g.odm.v[aodm].index, g.opo.n);
			yukotd = wfrp2->lastusetd - yukodays;
			if( yukotd < 0 ) yukotd = 0; CHKB(yukotd, yukotd, wfrp2->due);
			if( g.clm.v[aclm].cal[yukotd] == 0 ) {  /* x */
				yukotd = zmd_zurasi(g, aclm, yukotd, 1);
			}
			if( yukotd < wfrp2->maetaosi ) wfrp2->yukobgn = wfrp2->maetaosi;
			else                           wfrp2->yukobgn = yukotd;
			if( ( rc = g.sortw.push_back(afrp2)) < 0 ) goto             quit;
		}
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp2Pbgn );
quit:
	return rc;
}
/*	ID_zSortFrp2	wVbvFrp2R[h\[g
********************************************************/
static int zSortFrp2( ZMRP &g, int ashm )
{
	int afsh, afrp2, aitm, yukodays, yukotd, aclm, rc = 0;
	frp2_td	*wfrp2;
	                                       CHKA(0, ashm, g.shm.n);
	g.sortw.clear();
	aclm = g.shm.v[ashm].clm;
	for( afsh = g.shm.v[ashm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].shmnext ) {
		aitm = g.fsh.v[afsh].itm;  CHKA(0, aitm, g.itm.n);
		yukodays = g.itm.v[aitm].yukodays;    /*  gp  Pʂ͓B */
		for( afrp2 = g.fsh.v[afsh].topfrp2due; afrp2 >= 0; afrp2 = wfrp2->duenext ) { CHKA(0, afrp2, g.frp2.n);
			wfrp2 = &g.frp2[afrp2];
			if( wfrp2->oyodm >= 0 ) continue;  /* I[_쐬 */
			yukotd = wfrp2->lastusetd - yukodays;
			if( yukotd < 0 ) yukotd = 0; CHKB(yukotd, yukotd, wfrp2->due);
			if( g.clm.v[aclm].cal[yukotd] == 0 ) {  /* x */
				yukotd = zmd_zurasi(g, aclm, yukotd, 1);
			}
			if( yukotd < wfrp2->maetaosi ) wfrp2->yukobgn = wfrp2->maetaosi;
			else                           wfrp2->yukobgn = yukotd;
			if( ( rc = g.sortw.push_back(afrp2)) < 0 ) goto             quit;
		}
	}
    if( g.shm.v[ashm].kuzusi == 1 ) {  /*  R   1:l 2:Ol */
		/* Frp2R[hH\莞AO|\A\莞AiڗD揇ʏɃNtւ */
//		zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp2Pdue );
		zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp2Pbgn );
	} else if( g.shm.v[ashm].kuzusi == 2 ) {
		/* Frp2R[hO|\A\莞AH\莞AiڗD揇ʏɃNtւ */
		zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp2Pbgn );
	} else CHKB(1, g.shm.v[ashm].kuzusi, 2);
quit:
	return rc;
}
/*	ID_tdayTotmin	ʎZʎZ
********************************************************/
static double tdayTotmin( ZMRP &g, int tday, double min )
{
	double drc;
	                              CHKB(g.today, tday, g.endtd);
	if( --tday < g.today ) drc = 0.0;
	else                   drc = g.ruiseki.v[tday];
	drc += min;
	return( drc );
}
/*	ID_tminTotday	ʎZʎZibgn{̂݁j
********************************************************/
static int tminTotday( ZMRP &g, int bgn, double tmin, double *min, int mode, int aclm )
{
	int		tday;
	                              CHKB(g.today, bgn, g.endtd);
								  CHKY10(g.ruiseki.v[bgn-1], tmin, tmin);
	for( tday = bgn; tday <= g.endtd; ++tday ) {
		if( g.ruiseki.v[tday] > tmin ) break;
	}
	if( tday > g.endtd ) { // CHKY10(tmin, g.ruiseki.v[g.endtd], tmin);
		tday = g.endtd;
	} else if( mode ) {
		if( tmin == g.ruiseki.v[tday-1] ) {
			--tday;
			if( g.clm.v[aclm].cal[tday] == 0 ) { /* x */
				tday = zmd_zurasi( g, aclm, tday, -1 );
			}
		}
	}
	if( min != NULL ) *min = tmin - g.ruiseki.v[tday-1];
	return( tday );
}
static void dumpfrp2( ZMRP &g, int mode, int aclm )
{
	int		i, afrp2, aitm, ashm, afsh, second = 0;
	frp2_td *wfrp2;

	for( i = 0; i < g.sortw.n; ++i ) {
		afrp2 = g.sortw.v[i];        CHKA(0, afrp2, g.frp2.n);
		wfrp2 = &g.frp2[afrp2];
		if( mode ) {
			if( wfrp2->oyodm < 0 ) continue;
		} else {
			if( wfrp2->oyodm >= 0 ) continue;
		}
		afsh = wfrp2->fsh;
		aitm = g.fsh.v[afsh].itm;
		ashm = g.fsh.v[afsh].shm;
		if( ! second ) {
			if( g.jmf ) Dprintf( "    \ fsh i Vbv  [  O| H " CR);
			second = 1;
		}
		Dprintf( "frp2(%4d) %d %d %s %s %g (%d:%s) (%d:%s) (%d:%s) (%d:%s) (%d:%s)" CR
			,afrp2,wfrp2->odm,afsh,g.itm.v[aitm].itm_cd,g.shm.v[ashm].shm_cd,wfrp2->size
			,wfrp2->due,ST(wfrp2->due),wfrp2->bgn,ST(wfrp2->bgn),wfrp2->maetaosi,ST(wfrp2->maetaosi)
			,wfrp2->plandue,ST(wfrp2->plandue),wfrp2->planbgn,ST(wfrp2->planbgn));
	}
}
static void dumpwmrp( ZMRP &g, int top, int aclm )
{
	int		awmrp, afrp2, aitm, afsh, bgntd, endtd, pred, td;
	double	tim;
	frp2_td	*wfrp2;

	if( top < 0 ) goto                                                  quit;
	if( (awmrp = g.wmrp.v[top].next) < 0 ) goto                         quit;
	pred = 0;
	endtd = g.today;
	if( g.jmf ) Dprintf( CR "frp2 fsh i (:) H(:) ]T ST" CR );
	for( ; awmrp >= 0; pred = awmrp, awmrp = g.wmrp.v[awmrp].next ) { CHKA(0, awmrp, g.wmrp.n); 
		afrp2 = g.wmrp.v[awmrp].mrp;  CHKA(0, afrp2, g.frp2.n);
		wfrp2 = &g.frp2[afrp2];
		afsh  = wfrp2->fsh;           CHKA(0, afsh, g.fsh.n);
		aitm = g.fsh.v[afsh].itm;     CHKA(0, aitm, g.itm.n);
		bgntd = tminTotday( g, endtd, g.wmrp.v[awmrp].bgntm, NULL, 0, aclm );
		endtd = tminTotday( g, bgntd, g.wmrp.v[awmrp].duetm, NULL, 1, aclm );
		Dprintf( "%3d %d %s %s:%6g %s:%6g %6g %4g" CR, g.wmrp.v[awmrp].mrp, afsh, g.itm.v[aitm].itm_cd, ST(bgntd)
			, g.wmrp.v[awmrp].bgntm, ST(endtd), g.wmrp.v[awmrp].duetm, g.wmrp.v[awmrp].yoyu, g.wmrp.v[awmrp].st);
		/* f[^`FbN */
		CHKB(pred, g.wmrp.v[awmrp].pred, pred);
		CHKX(0, g.wmrp.v[pred].duetm, g.wmrp.v[awmrp].bgntm);
		td = wfrp2->maetaosi;
		tim = tdayTotmin( g, td, 0.0 );  /* ʎZɕϊ */
		CHKY(tim, g.wmrp.v[awmrp].bgntm, g.wmrp.v[awmrp].duetm);
		td = wfrp2->due;
		tim = tdayTotmin( g, td+1, 0.0 );  /* ʎZɕϊ */
		CHKY(g.wmrp.v[awmrp].bgntm, g.wmrp.v[awmrp].duetm, tim);
	}
quit:
	return;
}
/*	ID_zSelBest	ŗǂƂ͂̔r֐
********************************************************/
static int zSelBest( ZMRP &g,
	int selwmrp, /* O܂ł̍ŗǂ̃bgzi̎ɑ}j */
	int curwmrp, /* }bgzi̎ɑ}j */
	int	afrp2, int mode )
{
	int		sfrp2, cfrp2, afsh, cfsh, sfsh, aitm, citm, sitm, cprty, sprty, aprty, rc;
	int		nwmrp, nfrp2, nfsh;
	int 	amaetd, smaetd;
	frp2_td	*awfrp2, *swfrp2, *cwfrp2, *nwfrp2;
			                         CHKA(-1, selwmrp, g.wmrp.n);
			                         CHKA(0, curwmrp, g.wmrp.n);
									 CHKA(0, afrp2, g.frp2.n);
	if(zdbgf[163]>5) {TRACEA(0); Dprintf("zSelBest selwmrp(%d) curwmrp(%d) frp2(%d)" CR, selwmrp, curwmrp, afrp2 );}
	rc = curwmrp;
	if( selwmrp < 0 ) goto                                              quit;
	/* } frp2[] */
	awfrp2 = &g.frp2[afrp2];
	afsh = awfrp2->fsh;              CHKA(0, afsh, g.fsh.n);
	aitm = g.fsh.v[afsh].itm;        CHKA(0, aitm, g.itm.n);
	aprty = g.itm.v[aitm].prty;
	amaetd = awfrp2->maetaosi;
	/* O܂ł̍ŗǃbgz frp2[] */
	sfrp2 = g.wmrp.v[selwmrp].mrp;   CHKA(0, sfrp2, g.frp2.n);
	swfrp2 = &g.frp2[sfrp2];
	sfsh = swfrp2->fsh;              CHKA(0, sfsh, g.fsh.n);
	sitm = g.fsh.v[sfsh].itm;        CHKA(0, sitm, g.itm.n);
	sprty = g.itm.v[sitm].prty;
	smaetd = swfrp2->maetaosi;
	/* 񎟂ɑ}bgz frp2[] */
	cfrp2 = g.wmrp.v[curwmrp].mrp;   CHKA(-1, cfrp2, g.frp2.n);  /* _~[:[0]-1 */
	if( cfrp2 >= 0 ) {
		cwfrp2 = &g.frp2[cfrp2];
		cfsh = cwfrp2->fsh;              CHKA(0, cfsh, g.fsh.n);
		citm = g.fsh.v[cfsh].itm;        CHKA(0, citm, g.itm.n);
		cprty = g.itm.v[citm].prty;
	} else { /* _~[̎i擪j */
		/* next ̒lݒ */
		nwmrp = g.wmrp.v[curwmrp].next;  CHKA(1, nwmrp, g.wmrp.n);
		nfrp2 = g.wmrp.v[nwmrp].mrp;     CHKA(0, nfrp2, g.frp2.n);
		nwfrp2 = &g.frp2[nfrp2];
		nfsh   = nwfrp2->fsh;            CHKA(0, nfsh, g.fsh.n);
		citm  = g.fsh.v[nfsh].itm;       CHKA(0, citm, g.itm.n);  // -1?
		cprty = g.itm.v[citm].prty;                               // -1?
	}
	if(zdbgf[163]>5) {TRACEB(0); Dprintf("zSelBest cur(%d:%d) ins(%d:%d) sel(%d:%d)" CR, citm, cprty, aitm, aprty, sitm, sprty );}
	/* ̗ǂقI */
	/* @iڂ */
	if( citm == aitm && sitm == aitm ) { /* Si=\莞̑ق */
		if( smaetd <= amaetd )  rc = selwmrp;
		else                    rc = curwmrp;
	} else if( citm == aitm ) { rc = curwmrp; /* Ɠi */
	} else if( sitm == aitm ) { rc = selwmrp; /* O܂łƓi=\莞̒xق */
	} else {
		if( cprty == aprty && sprty == aprty ) { /* D揇ׂē=\莞̑ق */
			if( smaetd <= amaetd )    rc = selwmrp;
			else                      rc = curwmrp;
		} else if( cprty == aprty ) { rc = curwmrp; /* Bƕiڂ̗D揇 */
		} else if( sprty == aprty ) { rc = selwmrp; /* CO܂łƕiڂ̗D揇 */
	} else if( cprty > aprty && sprty > aprty 
				|| cprty < aprty && sprty < aprty) {
			/* Ƃ傫()ꍇ͑傫ق */
			if( sprty >= cprty ) rc = selwmrp;
			else                 rc = curwmrp;
		} else if( sprty < aprty ) {  // cprty > aprty
			rc = selwmrp;
		} else rc = curwmrp;
	}
quit:
	if(zdbgf[163]>5) {TRACEC(0); Dprintf("zSelBest rc(%d)" CR, rc );}
	return( rc );
}
/*	ID_zGetBest	ŗǂ̒ǉʒu擾
********************************************************/
static int zGetBest( ZMRP &g, int afrp2, int las, int bgn, double bgntm, double *st, double rmax )
{
	int		awmrp, afsh, aitm, ashm, aodm, insf, selwmrp, next, rc;
	double	pbgntm, pduetm, duetm, maetm;
	char	wstr[16], wstr1[16];
	wmrp_td	*wwmrp, *nextwmrp;
	frp2_td	*wfrp2;
	                                      CHKA(0, las, g.wmrp.n); CHKY(0, bgntm, rmax);
										  CHKB(g.today, bgn, g.endtd); CHKA(0, afrp2, g.frp2.n);
	if(zdbgf[163]>2) {TRACEA(0); Dprintf("zGetBest las(%d) bgn(%d) frp2(%d) bgntm(%g)" CR, las, bgn, afrp2, bgntm );}
	*st = 0.0;
	selwmrp = -1;
	if( las < 0 ) goto                                                  quit;
	wfrp2 = &g.frp2[afrp2];               CHKB(g.today, wfrp2->due, g.endtd);
	afsh  = wfrp2->fsh;                   CHKA(0, afsh, g.fsh.n);
	                                      CHKA(-1, g.fsh.v[afsh].iwk1, g.fsh2.n);
	if( ! ISPLUS(wfrp2->size) )           CHKX(0.0, 0.0, wfrp2->size - g.epsi);
	/* ő\݂̍ƎԂvZ */
	g.fsh.v[afsh].iwk1 = zGetSt( g, afsh, g.fsh.v[afsh].iwk1, wfrp2->size, bgn, st); CHKA(0, g.fsh.v[afsh].iwk1, g.fsh2.n);
	/* [ʎZɕϊ */
	duetm = g.ruiseki.v[wfrp2->due];
	/* O|\ʎZɕϊ */
	maetm = tdayTotmin( g, wfrp2->maetaosi, 0.0 );
	/* O|\ƂĂ[x:f[^ */
	if( maetm + *st > duetm ) goto                                      err2;
	pduetm = bgntm + *st;                 CHKY10(bgntm, pduetm, rmax); 
	for( awmrp = las; awmrp >= 0; awmrp = wwmrp->pred ) {
		wwmrp = &g.wmrp.v[awmrp];
		if( wwmrp->duetm >= bgntm ) pbgntm = wwmrp->duetm + 1.0;
		else                        pbgntm = bgntm;
		                                  CHKY(wwmrp->duetm, pbgntm, rmax);
 		pduetm = pbgntm + *st;            CHKY(pbgntm, pduetm, rmax); /* H\莞 */
		if( pduetm > duetm ) continue;
		if( ( next = wwmrp->next ) < 0 ) { CHKB(-1, selwmrp, -1);
			selwmrp = awmrp;    /* Ƃ肠Ōɑ}\ */
		} else {
			insf = 0;
			nextwmrp = &g.wmrp.v[next];
			/* bgic̍ƎԂik̔[]TȉȂAik̑Ołłic}\ */
//			if( wwmrp->yoyu >= *st ) {} //Jn+1̂߁͂߁H
			if( wwmrp->yoyu > *st ) {
				insf = 2;
			}
			/* PDic̒ik̍H\莞Ȁꍇ */
			/*	ic̍Ǝԁ\莞(ik+1)|H\莞(ik){[]T(ik+1) */
			else if( bgntm <= wwmrp->duetm ) {
//KS140603chg	if( *st < nextwmrp->bgntm - wwmrp->duetm + nextwmrp->yoyu ) {}
				if( *st <= nextwmrp->bgntm - wwmrp->duetm + nextwmrp->yoyu ) {
					insf = 1;
				}
			}
			/* QDik̍H\莞ic̒Ȁꍇiik+1̒\莞|ic̒O܂ށj */
			/*	ic̍Ǝԁ(ik+1̒\莞|ic̒){ik+1̔[]T */
			else if( bgntm > wwmrp->duetm ) {
//KS140603chg	if( *st < nextwmrp->bgntm - bgntm + nextwmrp->yoyu ) {}
				if( *st <= nextwmrp->bgntm - bgntm + nextwmrp->yoyu ) {
					insf = 1;
				}
			}
			if( insf ) {
				/* O܂ł̃xXgƍr */
				selwmrp = zSelBest( g, selwmrp, awmrp, afrp2, insf );
			}
		}
		if( wwmrp->bgntm <= bgntm && wwmrp->yoyu < (bgntm - wwmrp->bgntm + *st ) ) break;
	}	                         CHKA10(-1, selwmrp, g.wmrp.n);
	if( selwmrp < 0 ) {
		aitm = g.fsh.v[afsh].itm; CHKA(0, aitm, g.itm.n);
		ashm = g.fsh.v[afsh].shm; CHKA(0, ashm, g.shm.n);
		aodm = wfrp2->odm;        CHKA(0, aodm, g.odm.n);
		zmd_td2str(g, wstr,  wfrp2->maetaosi);
		zmd_td2str(g, wstr1, wfrp2->due);
		Esprintf(g.ermes, "zfcmssla1.cpp 0010  (%d) (%s) (%s) (%s) (%g) (%s) (%s) " CR
			, afrp2,g.odm.v[aodm].odm_cd,g.itm.v[aitm].itm_cd,g.shm.v[ashm].shm_cd,wfrp2->size,wstr,wstr1);
		Eprintf(g.ermes);
		if( g.jmf ) {
			Esprintf(g.ermes, "frp2[%d] \(%s)i(%s)Vbv(%s)(%g)O|\(%s)͔\͕ŝ߁A[(%s)Ɋł܂B" CR
			, afrp2,g.odm.v[aodm].odm_cd,g.itm.v[aitm].itm_cd,g.shm.v[ashm].shm_cd,wfrp2->size,wstr,wstr1);
			Eprintf(g.ermes);
		}
	}
quit:
	rc = selwmrp;
	if(zdbgf[163]>2) {TRACEC(0); Dprintf("zGetBest rc(%d) st(%g)" CR, rc, *st);}
	return( rc );
err2:
	aitm = g.fsh.v[afsh].itm; CHKA(0, aitm, g.itm.n);
	ashm = g.fsh.v[afsh].shm; CHKA(0, ashm, g.shm.n);
	aodm = wfrp2->odm;        CHKA(0, aodm, g.odm.n);
	zmd_td2str(g, wstr,  wfrp2->maetaosi);
	zmd_td2str(g, wstr1, wfrp2->due);
	Esprintf(g.ermes, "zfcmssla1.cpp 0020 (%d) (%s) (%s) (%s) (%g) (%g) (%s) (%s) " CR
		, afrp2,g.odm.v[aodm].odm_cd,g.itm.v[aitm].itm_cd,g.shm.v[ashm].shm_cd,wfrp2->size,*st,wstr,wstr1);
	Eprintf(g.ermes);
	if( g.jmf ) {
		Esprintf(g.ermes, "frp2[%d] \(%s)i(%s)Vbv(%s)(%g)̋VbvRŁAƎ(%g)O|\(%s)`[(%s)̔\͂𒴂Ă܂B" CR
		, afrp2,g.odm.v[aodm].odm_cd,g.itm.v[aitm].itm_cd,g.shm.v[ashm].shm_cd,wfrp2->size,*st,wstr,wstr1);
		Eprintf(g.ermes);
	}
	goto                                                                quit;
}
/*	ID_zgetyoyu	[]TijČvZ
********************************************************/
static double zgetyoyu( ZMRP &g, int awmrp )
{
	int		due, next, afrp2;
	double	yoyu, yoyu2, pduetm, duetm;
	wmrp_td	*wwmrp;
	frp2_td *wfrp2;
	                                       CHKA(1, awmrp, g.wmrp.n);
	wwmrp = &g.wmrp.v[awmrp];
	afrp2 = wwmrp->mrp;                    CHKA(0, afrp2, g.frp2.n);
	wfrp2 = &g.frp2[afrp2];
	due   = wfrp2->due;                    CHKB(0, due, g.endtd);
	duetm = g.ruiseki.v[due];
	pduetm = wwmrp->duetm;
	yoyu = duetm - pduetm;
	if( ( next = wwmrp->next) >= 0 ) {
		wwmrp = &g.wmrp.v[next];
		yoyu2 = wwmrp->bgntm - pduetm + wwmrp->yoyu;
		if( yoyu2 < yoyu ) yoyu = yoyu2;
	}
	return( yoyu );
}
/*	ID_zyoyu_nextchg	}bg̎ȍ~̔[]TijČvZ
********************************************************/
static int zyoyu_nextchg(ZMRP &g, int awmrp, double maedue)
{
	int		rc = 0;
	wmrp_td *wwmrp;

	if(zdbgf[163]>=9) {TRACEA(0); Dprintf("zyoyu_chg awmrp(%d) maedue(%g)" CR, awmrp, maedue );}
	if( awmrp < 0 ) goto                                                quit;
	wwmrp = &g.wmrp.v[awmrp];
	if( wwmrp->bgntm <= maedue ) {
		wwmrp->bgntm = maedue + 1.0;
		wwmrp->duetm = wwmrp->bgntm + wwmrp->st;
		rc = zyoyu_nextchg(g, wwmrp->next, wwmrp->duetm );
	}
	wwmrp->yoyu = zgetyoyu( g, awmrp );
	if(zdbgf[163]>=9) {TRACEB(0); Dprintf("zyoyu_chg bgntm(%g) duetm(%g) yoyu(%g)" CR, wwmrp->bgntm, wwmrp->duetm, wwmrp->yoyu );}
quit:
	if(zdbgf[163]>=9) {TRACEC(0); Dprintf("zyoyu_chg rc(%d)" CR, rc );}
	return( rc );
}
/*	ID_zWmrp_add	prednext̊Ԃɑ}
********************************************************/
static int zWmrp_add( ZMRP &g, wmrp_td &pwmrp, int *top, int *las, int pred, int next, double bgntm )
{
	int		awmrp, rc = 0;
	double	yoyu2;
	wmrp_td *wwmrp;
			                        CHKA(0, pred, g.wmrp.n); CHKA(-1, next, g.wmrp.n);
									CHKA(0, *top, g.wmrp.n);
									CHKA(0, *las, g.wmrp.n);
	awmrp = g.wmrp.n;        /* ǉ̃R[hԍ */
	wwmrp = &g.wmrp.v[pred];
	if( wwmrp->duetm >= bgntm ) pwmrp.bgntm = wwmrp->duetm + 1.0;
	else                        pwmrp.bgntm = bgntm;
	pwmrp.duetm = pwmrp.bgntm + pwmrp.st;
	pwmrp.next = next;       /* bgz  wmrp[]or -1 */
	pwmrp.pred = pred;       /* Obgz  wmrp[]or -1 */
	g.wmrp.v[pred].next = awmrp;
	if( next >= 0 ) g.wmrp.v[next].pred = awmrp;
	else            *las = awmrp;
	if( (rc = g.wmrp.push_back(pwmrp)) < 0 ) goto                       quit;
	if( next >= 0 ) {
		/* }bg̎ȍ~̔[]TijČvZ */
		rc = zyoyu_nextchg( g, next, pwmrp.duetm );
	}
	/* }bgbg̔[]TvZ */
	g.wmrp.v[awmrp].yoyu = zgetyoyu( g, awmrp );
	/* }bg̑OȑO̔[]TijČvZ */
	for( ; pred > 0; pred = g.wmrp.v[pred].pred ) { /* 0:_~[ */
		if( g.wmrp.v[pred].yoyu <= 0.0 ) break;
		yoyu2 = zgetyoyu( g, pred );
		if( yoyu2 >= g.wmrp.v[pred].yoyu ) break;  /* []TύX */
		g.wmrp.v[pred].yoyu = yoyu2;
	}
	rc = awmrp;
quit:
	return( rc );
}
static void zfrp2set(  ZMRP &g, int top, int ashm )
{
	int		awmrp, afrp2, bgntd, duetd, aclm, aitm, afsh, yukoday;
	double	bgntm, duetm, *capa;
	frp2_td	*wfrp2;
                                     CHKA(0, ashm, g.shm.n);
	bgntd = g.today;  /* ruiseki.v[]̊Jnʒu */
	capa = g.shm.v[ashm].capa;
	aclm = g.shm.v[ashm].clm;
	for( awmrp = top; awmrp >= 0; awmrp = g.wmrp.v[awmrp].next ) { CHKA(0, awmrp, g.wmrp.n);
		if( (afrp2 = g.wmrp.v[awmrp].mrp) < 0 ) { CHKB(0, awmrp, 0); continue; }
		wfrp2 = &g.frp2[afrp2];
		bgntd = tminTotday( g, bgntd, g.wmrp.v[awmrp].bgntm, &bgntm, 0, aclm );
					             CHKB(1, g.clm.v[aclm].cal[bgntd], g.clm.v[aclm].cal[bgntd]);
		duetd = tminTotday( g, bgntd, g.wmrp.v[awmrp].duetm, &duetm, 1, aclm );
					             CHKB(1, g.clm.v[aclm].cal[duetd], g.clm.v[aclm].cal[duetd]);
		                         CHKB(g.today, bgntd, duetd); CHKY10(0, bgntm, capa[bgntd]);
		                         CHKB(bgntd, duetd, g.endtd); //CHKY10(0, duetm, capa[duetd]);
								 CHKB(wfrp2->yukobgn, bgntd, duetd);
		wfrp2->planbgn   = bgntd;
		wfrp2->planbgntm = (int)bgntm;
		wfrp2->plandue   = duetd;
		wfrp2->planduetm = (int)duetm;
		wfrp2->st        = g.wmrp.v[awmrp].st;
		afsh  = wfrp2->fsh;      CHKA(0, afsh, g.fsh.n);
		aitm  = g.fsh.v[afsh].itm; CHKA(0, aitm, g.itm.n);
		/* gp */
		if( g.shm.v[ashm].shm_typ == 2 ) yukoday = -1;
		else if( g.itm.v[aitm].yukodays >= g.endtd ) yukoday = -1;
		else {
			yukoday = wfrp2->plandue + g.itm.v[aitm].yukodays;
			if( yukoday > g.endtd ) yukoday = g.endtd;
		}                      CHKB(-1, yukoday, g.endtd);
		wfrp2->yukoday   = yukoday;
		bgntd = duetd;  /* ruiseki.v[]̊JnʒuXV */
	}
}
/*	ID_zfCMSSLA1	63.VbvR
********************************************************/
int zfCMSSLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh) /* rc 0: <0:ُ */
{
	int		rc = 0;
	int		acpm, acap, aclm, afrp2, wmrptop, wmrplas;
	int		aswk, bgntd, fukabgntd, awmrp;
	double	*capa;
	double	rcapa, fukabgntm, bgntm, todaytm, maxtm, st1, wktm;
	frp2_td	*wfrp2;
	wmrp_td	wwmrp;
	                                    CHKA(0, ashm, g.shm.n);  CHKB(-1, aitm, -1);
	if(zdbgf[99]) {Dprintf("63.zfCMSSLA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); goto quit;}
	if(zdbgf[163]) {TRACEA(0); Dprintf("zfCMSSLA1 nodtyp(%d) ashm(%d) aitm(%d) afsh(%d)" CR, nodtyp, ashm, aitm, afsh );}
	acpm = g.shm.v[ashm].cpm;     CHKA(0, acpm, g.cpm.n); CHKB(1, g.shm.v[ashm].kuzusi, 2);
	acap = g.cpm.v[acpm].topcap;  CHKA(0, acap, g.cap.n);
	aclm = g.shm.v[ashm].clm;     CHKA(0, aclm, g.clm.n);
    if( g.shm.v[ashm].kuzusi != 2 ) { CHKB(1, g.shm.v[ashm].kuzusi, 1); /*  R   1:l 2:Ol */
		Esprintf(g.ermes, "zfcmssla1.cpp 0030 (%d:)" CR, g.shm.v[ashm].kuzusi );
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "R(%d:l)͖T|[głBOl߂s܂B" CR, g.shm.v[ashm].kuzusi ); Eprintf(g.ermes); }
	}
	/* wVbv̗ݐϔ\͈ꗗ쐬 */
	if( (rc = g.ruiseki.resize( g.cal.n, 0.0 )) < 0 ) goto              quit;
	rcapa = 0.0;
	capa  = g.shm.v[ashm].capa;
	for( bgntd = g.today; bgntd <= g.endtd; ++bgntd ) {   /* Jn */
		rcapa += capa[bgntd];
		g.ruiseki.v[bgntd] = rcapa;
	}
    if( rcapa <= 0.0 ) { /*  SԔ\͂Ȃ */
		Esprintf(g.ermes, "zfcmssla1.cpp 0040 (%s)" CR, g.shm.v[ashm].shm_cd );
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "wVbv(%s)̔\͂Ô߁ARs܂B" CR, g.shm.v[ashm].shm_cd ); Eprintf(g.ermes); }
		goto                                                           quit;
	}
	todaytm = tdayTotmin( g, g.today, 0.0 );  /* [uv̊JnʎZ */
	maxtm   = g.ruiseki.v[g.endtd];
	/* Vbṽ[Niڊԕʏj */
	for( afsh = g.shm.v[ashm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].shmnext ) { CHKA(0, afsh, g.fsh.n);
		                                         CHKB(0, g.fsh.v[afsh].bunkatuflg, 0);
		g.fsh.v[afsh].iwk1 = -1;
	}
	g.wmrp.clear();
	/* _~[̃bgz쐬 */
	wwmrp.mrp   = -1;
	wwmrp.yoyu  = 0.0;       /* []Tij                                  */
	wwmrp.bgntm = todaytm;   /* \莞                                    */
	wwmrp.duetm = todaytm;   /* H\莞                                    */
	wwmrp.st    = 0.0;       /* Ǝ      Pʂ͕                          */
	wwmrp.next  = -1;        /* bgz                        wmrp[]or -1 */
	wwmrp.pred  = -1;        /* Obgz                        wmrp[]or -1 */
	if( (rc = g.wmrp.push_back(wwmrp)) < 0 ) goto                       quit;
	wmrptop = wmrplas = rc;
	/* wVbv̐I[_쐬Frp2\[g */
	if( ( rc = zsortFrp2Opo( g, ashm )) < 0 ) goto                      quit;
	if(zdbgf[163]>1) { TRACEB(1);dumpfrp2( g, 1, aclm );}
	for( aswk = 0; aswk < g.sortw.n; ++aswk ) {
		afrp2 = g.sortw.v[aswk];   CHKA(0, afrp2, g.frp2.n);
		wfrp2 = &g.frp2[afrp2];    CHKA(0, wfrp2->oyodm, g.odm.n);
		bgntd = wfrp2->yukobgn;    CHKB(0, bgntd, g.endtd);
		if( bgntd < g.today ) bgntd = g.today;
		                           CHKB(0, bgntd, g.endtd);
		bgntm = tdayTotmin( g, bgntd, 0.0 ); CHKY(todaytm, bgntm, maxtm); /* \莞iʎZj */
		/* ŗǂ̒ǉʒu擾 */
		rc = zGetBest( g, afrp2, wmrplas, bgntd, bgntm, &st1, maxtm );
		if( rc < 0 ) { /* }ʒuȂ΁i\̓I[o[jŌɑ} */
			rc = wmrplas;
		}                               CHKA(0, rc, g.wmrp.n);
		/* ǉʒuƎ̊ԂɂPR[hǉ */
		wwmrp.mrp = afrp2; 
		wwmrp.st  = st1; 
		if( (rc = zWmrp_add( g, wwmrp, &wmrptop, &wmrplas, rc, g.wmrp.v[rc].next, bgntm )) < 0 ) goto quit;
	}
	/* I[_̍ŒxH\擾 */
	if( g.wmrp.v[wmrplas].duetm > 0.0 ) {
		g.shm.v[ashm].lastdue = tminTotday( g, g.today, g.wmrp.v[wmrplas].duetm, &wktm, 1, aclm );
	                                     CHKB(g.today, g.shm.v[ashm].lastdue, g.endtd);
	} else {
		g.shm.v[ashm].lastdue = g.today;
	}
	/* O|Jn\vZi{O|֎~j */
	fukabgntd = g.today + g.shm.v[ashm].ngdays;
	if( g.clm.v[aclm].cal[fukabgntd] == 0 ) { /* x */
		fukabgntd = zmd_zurasi( g, aclm, fukabgntd, 1 );
	}
	                                     CHKB(g.today, fukabgntd, g.endtd);
	/*  ݉\ */
	if( g.shm.v[ashm].warikomi <= 0 ) {  /* 0:ȍ~ł */
		fukabgntm = tdayTotmin( g, fukabgntd, 0.0 ); CHKY(todaytm, fukabgntm, maxtm); /* ʎZɕϊ */
	} else {
		/* I[_쐬̃bgz̔[]TO */
		for( awmrp = wmrptop; awmrp >= 0; awmrp = g.wmrp.v[awmrp].next ) { CHKA(0, awmrp, g.wmrp.n); 
			g.wmrp.v[awmrp].yoyu = 0.0;
		}
		if( g.shm.v[ashm].warikomi == 1 ) { /* 1:I[_̍ŒxH\̗ */
			/* ŒxH\O|Jn\ȍ~̏ꍇ͑O|Jn\ɍŒxH\{Pݒ */
			if( g.shm.v[ashm].lastdue >= fukabgntd ) {
				fukabgntd = zmd_zurasi( g, aclm, g.shm.v[ashm].lastdue, 1 ); CHKB(g.today, fukabgntd, g.endtd);
			}
			fukabgntm = tdayTotmin( g, fukabgntd, 0.0 );     CHKY(todaytm, fukabgntm, maxtm);
		} else { /* 2:Œxbg̎ */ CHKB(2, g.shm.v[ashm].warikomi, 2); 
			fukabgntm = g.wmrp.v[wmrplas].duetm + 1.0;       CHKY(todaytm, fukabgntm, maxtm);
			fukabgntd = tminTotday(g, fukabgntd, fukabgntm, &wktm, 0, aclm); CHKB(g.today, fukabgntd, g.endtd); /* ʎZɕϊ */
		}
	}
	/* wVbvFrp2R[hO|\AA[AiڗD揇ʏɕבւ */
	if( ( rc = zSortFrp2( g, ashm )) < 0 ) goto                         quit;
	if(zdbgf[163]>1) { TRACEB(1);dumpfrp2( g, 0, aclm );}
	for( aswk = 0; aswk < g.sortw.n; ++aswk ) {
		afrp2 = g.sortw.v[aswk];   CHKA(0, afrp2, g.frp2.n);
		wfrp2 = &g.frp2[afrp2];    CHKB(-1, wfrp2->oyodm, -1);
		bgntd = wfrp2->yukobgn;    CHKB(0, bgntd, g.endtd);
		if( bgntd < g.today ) bgntd = g.today;
		                           CHKB(0, bgntd, g.endtd);
		bgntm = tdayTotmin( g, bgntd, 0.0 ); CHKY(todaytm, bgntm, maxtm); /* \莞iʎZj */
		if( bgntm < fukabgntm ) {
			bgntm = fukabgntm;  /* O|Jn\ */
			bgntd = fukabgntd;  /* O|Jn\ */
		}
		/* ŗǂ̒ǉʒu擾 */
		rc = zGetBest( g, afrp2, wmrplas, bgntd, bgntm, &st1, maxtm );
		if( rc < 0 ) { /* }ʒuȂ΁i\̓I[o[jŌɑ} */
			rc = wmrplas;
		}                               CHKA(0, rc, g.wmrp.n);
		/* ǉʒuƎ̊ԂɂPR[hǉ */
		wwmrp.mrp = afrp2; 
		wwmrp.st  = st1; 
		if( (rc = zWmrp_add( g, wwmrp, &wmrptop, &wmrplas, rc, g.wmrp.v[rc].next, bgntm )) < 0 ) goto quit;
		if(zdbgf[163]>2) {TRACEB(0); dumpwmrp(g, wmrptop, aclm); }
	}
	if(zdbgf[163]>1) {TRACEB(0); dumpwmrp(g, wmrptop, aclm); }
	/* frp2[]\莞XV */
	zfrp2set( g, wmrptop, ashm );
	rc = 0;
quit:
	if(zdbgf[163]) {TRACEC(0); Dprintf("zfCMSSLA1 rc(%d)" CR, rc);}
	return( rc );
}
