/*
 * FILE      : zdataout.cpp	t@Co͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : t@Co͊֐
 * AUTHOR    : H.Yamagiwa  2004.11.17
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "z1mrp.h"
/*	ID_zwtPLANFTOD01	oɌvo
********************************************************/
static int zwtPLANFTOD01(ZMRP &g, char *fname)
{
	int		adrp2, atsh, afsh, frshm, toshm, aitm, aodm, adlm, rc = 0; //, cnt = 0
	int		outseq, frstyp, tostyp;
	char	*itmcd, *frshmcd, *toshmcd, *odmcd, ftocd[64];
	unsigned char del;         /* ؕBTAB(^u)A,(J})A|(Xg[N) */
	drp2_td	*wdrp2;
	FILE	*fp = NULL;

	if(zdbgf[51]) {TRACEA(0); Dprintf("zwtPLANFTOD01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_out, fname );
	if( (fp = fopen(g.fname, "w")) == NULL ) goto                       err_op;
	outseq = 0;
	del = g.delimiter;         /* ؕBTAB(^u)A,(J})A|(Xg[N) */
	/* Psڂ̃o[Wo */
	fprintf( fp, "%s" CR, "!V01" );
	if( g.jmf ) {
	/* 擪̌oo */
		fprintf( fp, "!%s%s",  "", "sNo"          );  /* sNo */
		fprintf( fp, "%c%s", del, "I[_No"   );  /* I[_No */
		fprintf( fp, "%c%s", del, "i"           );  /* iڃR[h */
		fprintf( fp, "%c%s", del, "݌vԍ"       );  /* ݌vԍ */
		fprintf( fp, "%c%s", del, "gpVbv" );  /* gpVbvR[h */
		fprintf( fp, "%c%s", del, "gpVbv敪" );  /* gpVbvR[h */
		fprintf( fp, "%c%s", del, "Vbv" );  /* VbvR[h */
		fprintf( fp, "%c%s", del, "Vbv敪" );  /* VbvR[h */
		fprintf( fp, "%c%s", del, "ߐ"         );  /* ߐ */
		fprintf( fp, "%c%s", del, ""         );  /*  */
		fprintf( fp, "%c%s", del, "gpɓ"   );  /* gpɓ */
		fprintf( fp, "%c%s", del, "oɓ"   );  /* oɓ */
		fprintf( fp, "%c%s", del, "gp"       );  /* gp */
		fprintf( fp, "%c%s", del, "tO"     );  /* tO */
		fprintf( fp, "%c%s", del, "\P"         );  /* \P */
		fprintf( fp, "%c%s", del, "\Q"         );  /* \Q */
		fprintf( fp, "%c%s", del, "\R"         );  /* \R */
		fprintf( fp, "%c%s", del, "\"       );  /* \ */
#if defined SSC_TEST
		fprintf( fp, "%c%s", del, "drp2[]"         );  /* drp2[] */
#endif
		fprintf( fp, CR );
	}
	for( atsh = 0; atsh < g.tsh.n; ++atsh ) {
		aitm  = g.tsh.v[atsh].itm;
		itmcd = ( aitm >= 0 ) ? g.itm.v[aitm].itm_cd : "";
		toshm = g.tsh.v[atsh].shm;
		toshmcd = ( toshm >= 0 ) ? g.shm.v[toshm].shm_cd : "";
		tostyp  = ( toshm >= 0 ) ? g.shm.v[toshm].shm_typ : 0;
		for( adlm = g.tsh.v[atsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].tshnext ) { CHKA(0, adlm, g.dlm.n);
			afsh = g.dlm.v[adlm].fsh;
			frshm = g.fsh.v[afsh].shm;
			frshmcd = ( frshm >= 0 ) ? g.shm.v[frshm].shm_cd : "";
			frstyp  = ( frshm >= 0 ) ? g.shm.v[frshm].shm_typ : 0;
			for( adrp2 = g.dlm.v[adlm].topdrp2i; adrp2 >= 0; adrp2 = wdrp2->dlmidaynext ) {  CHKA(0, adrp2, g.drp2.n);
				wdrp2 = &g.drp2(adrp2);
				wdrp2->outseq = ++outseq;
#if defined SSC_TEST
				sprintf( ftocd, "FT%05d", ++cnt );
#else
				ftocd[0] = 0;
#endif
				aodm = wdrp2->odm;
				odmcd = ( aodm >= 0 ) ? g.odm.v[aodm].odm_cd : "";
#if 0
				fprintf( fp, "%s%d",  "", wdrp2->outseq );  /* sNo */
				fprintf( fp, "%c%s", del, ftocd       );  /* I[_No */
				fprintf( fp, "%c%s", del, itmcd       );  /* iڃR[h */
				fprintf( fp, "%c%s", del, ""          );  /* ݌vԍ */
				fprintf( fp, "%c%s", del, toshmcd     );  /* gpVbvR[h */
				fprintf( fp, "%c%d", del, tostyp      );  /* gpVbv敪 */
				fprintf( fp, "%c%s", del, frshmcd     );  /* VbvR[h */
				fprintf( fp, "%c%d", del, frstyp      );  /* Vbv敪 */
				fprintf( fp, "%c%g", del, wdrp2->size );  /* ߐ */
				fprintf( fp, "%c%g", del, 0.0         );  /*  */
				fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wdrp2->iday) );  /* gpɓ */
				fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wdrp2->oday) );  /* oɓ */
				fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wdrp2->yukoday) ); /* gp */
				fprintf( fp, "%c%d", del, 0           );  /* tO */
				fprintf( fp, "%c%s", del, ""          );  /* \P */
				fprintf( fp, "%c%s", del, ""          );  /* \Q */
				fprintf( fp, "%c%s", del, ""          );  /* \R */
				fprintf( fp, "%c%s", del, odmcd       );  /* \ */
#if defined SSC_TEST
				fprintf( fp, "%c%d", del, adrp2       );  /* drp2[] */
#endif
				fprintf( fp, CR );
#elif 1
		int pos = 0;
				pos = zssc_itobf(g.ermes, pos, 0  , wdrp2->outseq); /* "%s%d" sNo */
				pos = zssc_stobf(g.ermes, pos, del, ftocd       );  /* "%c%s" I[_No */
				pos = zssc_stobf(g.ermes, pos, del, itmcd       );  /* "%c%s" iڃR[h */
				g.ermes[pos++] = del;  /* "%c%s" ݌vԍ */
				pos = zssc_stobf(g.ermes, pos, del, toshmcd     );  /* "%c%s" gpVbvR[h */
				pos = zssc_itobf(g.ermes, pos, del, tostyp      );  /* "%c%d" gpVbv敪 */
				pos = zssc_stobf(g.ermes, pos, del, frshmcd     );  /* "%c%s" VbvR[h */
				pos = zssc_itobf(g.ermes, pos, del, frstyp      );  /* "%c%d" Vbv敪 */
				pos = zssc_dtobf(g.ermes, pos, del, wdrp2->size );  /* "%c%g" ߐ */
				pos = zssc_dtobf(g.ermes, pos, del, 0.0         );  /* "%c%g"  */
				g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wdrp2->iday); pos += strlen(g.ermes+pos); /* "%c%s" gpɓ */
				g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wdrp2->oday); pos += strlen(g.ermes+pos); /* "%c%s" oɓ */
				g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wdrp2->yukoday); pos += strlen(g.ermes+pos); /* "%c%s" gp */
				g.ermes[pos++] = del; g.ermes[pos++] = '0';  /* "%c%d" tO */
				g.ermes[pos++] = del;                        /* "%c%s" \P */
				g.ermes[pos++] = del;                        /* "%c%s" \Q */
				g.ermes[pos++] = del;                        /* "%c%s" \R */
				pos = zssc_stobf(g.ermes, pos, del, odmcd       );  /* "%c%s" \ */
#if defined SSC_TEST
				pos = zssc_itobf(g.ermes, pos, del, adrp2       );  /* "%c%d" drp2[] */
#endif
				fprintf( fp, "%s" CR, g.ermes );
#else
				fprintf( fp, "%d%c%s%c%s%c%s%c%s%c%d%c%s%c%d%c%g%c%g%c%s%c%s%c%s%c%d%c%s%c%s%c%s%c%s"
					,  wdrp2->outseq   /* sNo */
					, del, ftocd         /* I[_No */
					, del, itmcd         /* iڃR[h */
					, del, ""            /* ݌vԍ */
					, del, toshmcd       /* gpVbvR[h */
					, del, tostyp        /* gpVbv敪 */
					, del, frshmcd       /* VbvR[h */
					, del, frstyp        /* Vbv敪 */
					, del, wdrp2->size   /* ߐ */
					, del, 0.0           /*  */
					, del, zmd_td2str(g,NULL,wdrp2->iday)   /* gpɓ */
					, del, zmd_td2str(g,NULL,wdrp2->oday)   /* oɓ */
					, del, zmd_td2str(g,NULL,wdrp2->yukoday) /* gp */
					, del, 0             /* tO */
					, del, ""            /* \P */
					, del, ""            /* \Q */
					, del, ""            /* \R */
					, del, odmcd       );  /* \ */

#if defined SSC_TEST
				fprintf( fp, "%c%d", del, adrp2       );  /* drp2[] */
#endif
				fprintf( fp, CR );
#endif
			}
		}
	}
	rc = 0;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[51]) {TRACEC(0); Dprintf("zwtPLANFTOD01 rc(%d)" CR, rc);}
	return rc;
err_op: rc = -1;
	Esprintf(g.ermes, "zdataout.cpp 0010 (%s)" CR, g.fname);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "oɌvt@C(%s)J܂" CR, g.fname); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zwtPLANODER01	vo
********************************************************/
static int zwtPLANODER01(ZMRP &g, char *fname)
{
	int		afrp2, afsh, frshm, aitm, aodm, aopo, rc = 0; //, cnt = 0
	int		outseq, frstyp;
	char	*itmcd, *frshmcd, *odmcd, opocd[64];
	unsigned char del;         /* ؕBTAB(^u)A,(J})A|(Xg[N) */
	double	osize;
	frp2_td	*wfrp2;
	FILE	*fp = NULL;

	if(zdbgf[51]) {TRACEA(0); Dprintf("zwtPLANODER01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_out, fname );
	if( (fp = fopen(g.fname, "w")) == NULL ) goto                       err_op;
	outseq = 0;
	del = g.delimiter;         /* ؕBTAB(^u)A,(J})A|(Xg[N) */
	/* Psڂ̃o[Wo */
	fprintf( fp, "%s" CR, "!V01" );
	if( g.jmf ) {
	/* 擪̌oo */
		fprintf( fp, "!%s%s", "", "sNo"         );  /* sNo */
		fprintf( fp, "%c%s", del, "I[_No"     );  /* I[_No */
		fprintf( fp, "%c%s", del, "i"         );  /* iڃR[h */
		fprintf( fp, "%c%s", del, "݌vԍ"     );  /* ݌vԍ */
		fprintf( fp, "%c%s", del, "Vbv" );  /* VbvR[h */
		fprintf( fp, "%c%s", del, "Vbv敪" );  /* Vbv敪 */
		fprintf( fp, "%c%s", del, "ߐ"       );  /* ߐ */
		fprintf( fp, "%c%s", del, ""       );  /*  */
		fprintf( fp, "%c%s", del, "["       );  /* [ */
		fprintf( fp, "%c%s", del, ""       );  /* \ */
		fprintf( fp, "%c%s", del, "O|"       );  /* O|\ */
		fprintf( fp, "%c%s", del, "H\"   );  /* H\ */
		fprintf( fp, "%c%s", del, "H"     );  /* H\莞 */
		fprintf( fp, "%c%s", del, "\"   );  /* \ */
		fprintf( fp, "%c%s", del, "莞"     );  /* \莞 */
		fprintf( fp, "%c%s", del, "tO"   );  /* tO */
		fprintf( fp, "%c%s", del, "\P"         );  /* \P */
		fprintf( fp, "%c%s", del, "\Q"         );  /* \Q */
		fprintf( fp, "%c%s", del, "\R"         );  /* \R */
		fprintf( fp, "%c%s", del, "\"     );  /* \ */
#if defined SSC_TEST
		fprintf( fp, "%c%s", del, "frp2[]"       );  /* frp2[] */
#endif
		fprintf( fp, CR );
	}
	for( afsh = 0; afsh < g.fsh.n; ++afsh ) {
		aitm  = g.fsh.v[afsh].itm;
		itmcd = ( aitm >= 0 ) ? g.itm.v[aitm].itm_cd : "";
		frshm = g.fsh.v[afsh].shm;
		frshmcd = ( frshm >= 0 ) ? g.shm.v[frshm].shm_cd : "";
		frstyp  = ( frshm >= 0 ) ? g.shm.v[frshm].shm_typ : 0;
		for( afrp2 = g.fsh.v[afsh].topfrp2due; afrp2 >= 0; afrp2 = wfrp2->duenext ) {  CHKA10(0, afrp2, g.frp2.n);
			wfrp2 = &g.frp2(afrp2);
			wfrp2->outseq = ++outseq;
			aodm = wfrp2->odm;
			odmcd = ( aodm >= 0 ) ? g.odm.v[aodm].odm_cd : "";
			if( wfrp2->oyodm >= 0 ) { CHKB(aodm, wfrp2->oyodm, aodm);
				sprintf( opocd, "%s", odmcd );
				aopo = g.odm.v[aodm].index;
			} else {
#if defined SSC_TEST
				sprintf( opocd, "PO%05d", ++cnt );
#else
				opocd[0] = 0;
#endif
				aopo = -1;
			}
			if( aopo >= 0 ) osize = g.opo.v[aopo].osize;
			else            osize = wfrp2->size;
#if 0
			fprintf( fp, "%s%d",  "", wfrp2->outseq);  /* sNo */
			fprintf( fp, "%c%s", del, opocd   );  /* I[_No */
			fprintf( fp, "%c%s", del, itmcd   );  /* iڃR[h */
			fprintf( fp, "%c%s", del, ""      );  /* ݌vԍ */
			fprintf( fp, "%c%s", del, frshmcd );  /* VbvR[h */
			fprintf( fp, "%c%d", del, frstyp  );  /* Vbv敪 */
			fprintf( fp, "%c%g", del, osize               );  /* ߐ */
			fprintf( fp, "%c%g", del, osize - wfrp2->size );  /*  */
			fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wfrp2->due) );     /* [ */
			fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wfrp2->bgn) );     /* \ */
			fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wfrp2->maetaosi)); /* O|\ */
			fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wfrp2->plandue) ); /* H\ */
			fprintf( fp, "%c%d", del, wfrp2->planduetm    );               /* H\莞 */
			fprintf( fp, "%c%s", del, zmd_td2str(g,NULL,wfrp2->planbgn) ); /* \ */
			fprintf( fp, "%c%d", del, wfrp2->planbgntm    );  /* \莞 */
			fprintf( fp, "%c%d", del, 0                   );  /* tO */
			fprintf( fp, "%c%s", del, ""                  );  /* \P */
			fprintf( fp, "%c%s", del, ""                  );  /* \Q */
			fprintf( fp, "%c%s", del, ""                  );  /* \R */
			fprintf( fp, "%c%s", del, odmcd               );  /* \ */
#if defined SSC_TEST
			fprintf( fp, "%c%d", del, afrp2               );  /* frp2[] */
#endif
			fprintf( fp, CR );
#elif 1
		int pos = 0;
			pos = zssc_itobf(g.ermes, pos, 0  , wfrp2->outseq);                      /* "%s%d" sNo */
			pos = zssc_stobf(g.ermes, pos, del, opocd   );                           /* "%c%s" I[_No */
			pos = zssc_stobf(g.ermes, pos, del, itmcd   );                           /* "%c%s" iڃR[h */
			g.ermes[pos++] = del;                                    /* "%c%s" ݌vԍ */
			pos = zssc_stobf(g.ermes, pos, del, frshmcd );                           /* "%c%s" VbvR[h */
			pos = zssc_itobf(g.ermes, pos, del, frstyp  );                           /* "%c%d" Vbv敪 */
			pos = zssc_dtobf(g.ermes, pos, del, osize               );               /* "%c%g" ߐ */
			pos = zssc_dtobf(g.ermes, pos, del, osize - wfrp2->size );               /* "%c%g"  */
			g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wfrp2->due);      pos += strlen(g.ermes+pos); /* "%c%s" [ */
			g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wfrp2->bgn);      pos += strlen(g.ermes+pos); /* "%c%s" \ */
			g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wfrp2->maetaosi); pos += strlen(g.ermes+pos); /* "%c%s" O|\ */
			g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wfrp2->plandue);  pos += strlen(g.ermes+pos); /* "%c%s" H\ */
			pos = zssc_itobf(g.ermes, pos, del, wfrp2->planduetm    );               /* "%c%d" H\莞 */
			g.ermes[pos++] = del; zmd_td2str(g, g.ermes+pos, wfrp2->planbgn);  pos += strlen(g.ermes+pos); /* "%c%s" \ */
			pos = zssc_itobf(g.ermes, pos, del, wfrp2->planbgntm    );               /* "%c%d" \莞 */
			g.ermes[pos++] = del; g.ermes[pos++] = '0'; /* "%c%d" tO */
			g.ermes[pos++] = del;                       /* "%c%s" \P */
			g.ermes[pos++] = del;                       /* "%c%s" \Q */
			g.ermes[pos++] = del;                       /* "%c%s" \R */
			pos = zssc_stobf(g.ermes, pos, del, odmcd               );               /* "%c%s" \ */
#if defined SSC_TEST
			pos = zssc_itobf(g.ermes, pos, del, afrp2               );               /* "%c%d" frp2[] */
#endif
			fprintf( fp, "%s" CR, g.ermes );
#else
			fprintf( fp, "%d%c%s%c%s%c%s%c%s%c%d%c%g%c%g%c%s%c%s%c%s%c%s%c%d%c%s%c%d%c%d%c%s%c%s%c%s%c%s"
				,  wfrp2->outseq  /* sNo */
				, del, opocd     /* I[_No */
				, del, itmcd     /* iڃR[h */
				, del, ""        /* ݌vԍ */
				, del, frshmcd   /* VbvR[h */
				, del, frstyp    /* Vbv敪 */
				, del, osize                 /* ߐ */
				, del, osize - wfrp2->size   /*  */
				, del, zmd_td2str(g,NULL,wfrp2->due)      /* [ */
				, del, zmd_td2str(g,NULL,wfrp2->bgn)      /* \ */
				, del, zmd_td2str(g,NULL,wfrp2->maetaosi) /* O|\ */
				, del, zmd_td2str(g,NULL,wfrp2->plandue)  /* H\ */
				, del, wfrp2->planduetm                   /* H\莞 */
				, del, zmd_td2str(g,NULL,wfrp2->planbgn)  /* \ */
				, del, wfrp2->planbgntm      /* \莞 */
				, del, 0                     /* tO */
				, del, ""                    /* \P */
				, del, ""                    /* \Q */
				, del, ""                    /* \R */
				, del, odmcd               );  /* \ */
#if defined SSC_TEST
			fprintf( fp, "%c%d", del, afrp2               );  /* frp2[] */
#endif
			fprintf( fp, CR );
#endif
		}
	}
	rc = 0;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[51]) {TRACEC(0); Dprintf("zwtPLANODER01 rc(%d)" CR, rc);}
	return rc;
err_op: rc = -1;
	Esprintf(g.ermes, "zdataout.cpp 0020 (%s)" CR, g.fname);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "vt@C(%s)J܂" CR, g.fname); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zdatawrt	f[^t@Co
********************************************************/
int zdataout(ZMRP &g)
{
	int		rc;
	rc = zwtPLANODER01(g, "PLANODER.TXT");
	rc = zwtPLANFTOD01(g, "PLANFTOD.TXT");
	rc = zwtPEGGING01(g, "PEGGING.TXT");

	return( rc );
}
