/*
 * FILE      : zdatarduse.cpp	[XAbvi\t@C͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : [XAbvi\t@C͊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"

/*	ID_zadUSEUPBOM01	[XAbvi\PR[hǉ
********************************************************/
static int zadUSEUPBOM01(ZMRP &g, char **dat)
{
	int		rc = 0, iwk;
	int		newitm, olditm, ashm = -1, aubm, newtsh = -1, oldtsh = -1, abom;
	ubm_td	wubm;   /* [XAbvi\ ubm */

	if(zdbgf[68]>1) {TRACEA(0); Dprintf("zadUSEUPBOM01 fname(%s)" CR, g.fname);}

	if( dat[0][0] != 0 ) {
		if( ( ashm = g.h_shm.hashfind( dat[0], 0 )) < 0 ) {
			++g.errcnt_rd;
			Esprintf(g.ermes, "zdatarduse.cpp 0010 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "[XAbvi\t@C(%s:%d)̃VbvR[h(%s)Vbv}X^ɖo^ł" CR, g.fname,g.rdseq,dat[0]); Eprintf(g.ermes); }
		} else {   CHKA(0, ashm, g.shm.n);
			if( g.shm.v[ashm].shm_typ != 1 ) {
			++g.errcnt_rd;
			Esprintf(g.ermes, "zdatarduse.cpp 0020 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "[XAbvi\t@C(%s:%d)̃VbvR[h(%s)ɂ͐Vbvwł܂B" CR, g.fname,g.rdseq,dat[0]); Eprintf(g.ermes); }
			}
		}
	}
	if( ( newitm = g.h_itm.hashfind( dat[1], 0 )) < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatarduse.cpp 0030 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[1]);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "[XAbvi\t@C(%s:%d)̐ViڃR[h(%s)iڃ}X^ɖo^ł" CR, g.fname,g.rdseq,dat[1]); Eprintf(g.ermes); }
	}
	if( ( olditm = g.h_itm.hashfind( dat[3], 0 )) < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatarduse.cpp 0040 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[3]);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "[XAbvi\t@C(%s:%d)̋iڃR[h(%s)iڃ}X^ɖo^ł" CR, g.fname,g.rdseq,dat[3]); Eprintf(g.ermes); }
	}
	if( dat[0][0] != 0 && ashm < 0 || newitm < 0 || olditm < 0 ) goto quit;
	aubm = g.ubm.n;
    wubm.shm = ashm;         /* KgpVbvR[h                 shm[]or-1 */
    wubm.newitm = newitm;    /* KViڃR[h                             itm[] */
    wubm.olditm = olditm;    /* KiڃR[h                             itm[] */
//	sscatof(g, dat[5], &wubm.size, UNIT, -1,  "");  /*    */
	sscatof(g, dat[5], &wubm.size, UNIT, -1,  (g.jmf ? "" : ""));  /*    */
//	sscatoi(g, dat[6], &iwk, 0, 0, 0, "");
	sscatoi(g, dat[6], &iwk, 0, 0, 0, (g.jmf ? "iڎz" : ""));
	wubm.tehai_typ = iwk;
	if( ashm >= 0 ) {
//		if( (newtsh = ztshget(g, newitm, ashm, "", 0 )) < 0 ) {
		if( (newtsh = ztshget(g, newitm, ashm, (g.jmf ? "[XAbvi\" : ""), 0 )) < 0 ) {
			++g.errcnt_rd;
			Esprintf(g.ermes, "zdatarduse.cpp 0050 (%s:%d) (%s) (%s)" CR
					, g.fname,g.rdseq,dat[0],dat[1]);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "[XAbvi\t@C(%s:%d)̃VbvR[h(%s)Vi(%s)̎gpVbv񂪖o^ł" CR, g.fname,g.rdseq,dat[0],dat[1]); Eprintf(g.ermes); }
		}
//		if( (oldtsh = ztshget(g, olditm, ashm, "", 0 )) < 0 ) {
		if( (oldtsh = ztshget(g, olditm, ashm, (g.jmf ? "[XAbvi\" : ""), 0 )) < 0 ) {
			++g.errcnt_rd;
			Esprintf(g.ermes, "zdatarduse.cpp 0060 (%s:%d) (%s) (%s)" CR
					, g.fname,g.rdseq,dat[0],dat[3]);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "[XAbvi\t@C(%s:%d)̃VbvR[h(%s)i(%s)̎gpVbv񂪖o^ł" CR, g.fname,g.rdseq,dat[0],dat[3]); Eprintf(g.ermes); }
		}
		if( newtsh < 0 || oldtsh < 0 ) goto                             quit;
		wubm.nextnew = g.tsh.v[oldtsh].topnewubm;  /* VbvR[h{iڂ̎̐Viڂal ubm[]or-1 */
		g.tsh.v[oldtsh].topnewubm = aubm;		   /* 擪tsh[].topnewubm(VbvR[hgp)   */
		wubm.nextold = g.tsh.v[newtsh].topoldubm;  /* VbvR[h{Viڂ̎̋iڂal ubm[]or-1 */
		g.tsh.v[newtsh].topoldubm = aubm;		   /* 擪tsh[].topoldubm(VbvR[hgp)   */
		/* i\̎q[XAbvݒ */
		for( abom = g.tsh.v[oldtsh].topoybm; abom >= 0; abom = g.bom.v[abom].nextoy )
			g.bom.v[abom].kouseup = 1;
	} else {
		wubm.nextnew = g.itm.v[olditm].topnewubm;  /* VbvR[h{iڂ̎̐Viڂal ubm[]or-1 */
		g.itm.v[olditm].topnewubm = aubm;	       /* 擪itm[].topnewubm(VbvR[hgpȂ) */
		wubm.nextold = g.itm.v[newitm].topoldubm;  /* VbvR[h{Viڂ̎̋iڂal ubm[]or-1 */
		g.itm.v[newitm].topoldubm = aubm;		   /* 擪itm[].topoldubm(VbvR[hgpȂ) */
		/* i\̎q[XAbvݒ */
		for( abom = g.itm.v[olditm].topoybm; abom >= 0; abom = g.bom.v[abom].nextoy )
			g.bom.v[abom].kouseup = 1;
	}
	rc = g.ubm.push_back(wubm);

quit:
	if(zdbgf[68]>1) {TRACEC(0); Dprintf("zadUSEUPBOM01 rc(%d)" CR, rc);}
	return( rc );
}
/*	ID_zrdUSEUPBOM01	[XAbvi\
********************************************************/
int zrdUSEUPBOM01(ZMRP &g, char *fname)
{
	int		rc = 0, bflen;
	char	*dat[100];
	FILE	*fp = NULL;

	if(zdbgf[68]) {TRACEA(0); Dprintf("zrdUSEUPBOM01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_in, fname );
	bflen = sizeof(g.rdbf);
	if( (fp = fopen(g.fname, "r")) == NULL ) goto                       quit;
	g.rdseq = 0;
	/* Psڂ̃o[WmF */
	if( fgets(g.rdbf, bflen, fp) == NULL ) { rc = 0; goto               quit; }
	++g.rdseq;
	if( (rc = vercheck(g, g.rdbf, "!V01")) != 1 ) goto                  quit;
	/* f[^s[v */
	for( g.rdbf[0] = 0; fgets(g.rdbf, bflen, fp) != NULL; g.rdbf[0] = 0 ) {
		++g.rdseq;
		if( g.rdbf[0] == '!' ) continue;  //RgsXLbv
		rc = bunkatu_chk(g, g.rdbf, dat, 10, 10, bflen); CHKB(10, rc, 10);
		if( (rc = zadUSEUPBOM01( g, dat )) < 0 ) goto                   quit;
	}
	rc = g.ubm.n;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[68]) {TRACEC(0); Dprintf("zrdUSEUPBOM01 rc(%d)" CR, rc);}
	return rc;
}
