/*
 * FILE      : zdatardyus.cpp	A}X^t@C͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : A}X^t@C͊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"

/*	ID_zadYUSOM01	A}X^PR[hǉ
********************************************************/
static int zadYUSOM01(ZMRP &g, char **dat)
{
	int		rc = 0, iwk, bgntd, endtd;
	int		toshm, frshm, atpm;
	tpm_td	wtpm;   /* A}X^ tpm */
	tpm2_td	wtpm2;  /* A}X^iԕʁj tpm2 */

	if(zdbgf[61]>1) {TRACEA(0); Dprintf("zadYUSOM01 fname(%s)" CR, g.fname);}
	if( ( toshm = g.h_shm.hashfind( dat[0], 0 )) < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatardyus.cpp 0010 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "A}X^t@C(%s:%d)̎gpVbvR[h(%s)Vbv}X^ɖo^ł" CR, g.fname,g.rdseq,dat[0]); Eprintf(g.ermes); }
	}
	if( ( frshm = g.h_shm.hashfind( dat[1], 0 )) < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatardyus.cpp 0020 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[1]);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "A}X^t@C(%s:%d)̋VbvR[h(%s)Vbv}X^ɖo^ł" CR, g.fname,g.rdseq,dat[1]); Eprintf(g.ermes); }
	}
	if( toshm < 0 || frshm < 0 ) goto                                   quit;
	/* KLJn */
	rc = zmd_str2td( g, dat[8], &bgntd, 0 );
	/*  LI */
	rc = zmd_str2td( g, dat[9], &endtd, g.endtd );
	if( bgntd < 0 ) bgntd = 0;
	if( endtd > g.endtd ) endtd = g.endtd;
	if( bgntd > g.endtd || endtd < 0 ) goto                             err1;
	if( bgntd > endtd ) goto                                            err2;
	for( atpm = g.shm.v[frshm].toptotpm; atpm >= 0; atpm = g.tpm.v[atpm].nextto )
		if( g.tpm.v[atpm].toshm == toshm ) break;
	if( atpm < 0 ) {
		atpm = g.tpm.n;
		wtpm.toshm   = toshm;  /* KgpVbvR[h                     shm[] */
		wtpm.frshm   = frshm;  /* KVbvR[h                     shm[] */
		wtpm.toptpm2 = -1;     /*  擪̗A}X^iԕʁj               trn2[] */
		wtpm.nextfr = g.shm.v[toshm].topfrtpm; /*  gpVbv̋A}X^ tpm[]or-1 */
		g.shm.v[toshm].topfrtpm = atpm;		   /*  擪shm[].topfrtpm                           */
		wtpm.nextto = g.shm.v[frshm].toptotpm; /*  ꋟVbv̎gpA}X^ tpm[]or-1 */
		g.shm.v[frshm].toptotpm = atpm;		   /*  擪shm[].toptotpm                           */
		if( (rc = g.tpm.push_back(wtpm)) < 0 ) goto                     quit;
	}
    wtpm2.tpm    = atpm;       /* KA}X^ tpm[] */
	wtpm2.bgnday = bgntd;      /* KLJn */
	wtpm2.endday = endtd;      /*  LI */
//	sscatoi(g, dat[2], &wtpm2.ylt, 0, 366, 0, "");
	sscatoi(g, dat[2], &wtpm2.ylt, 0, 366, 0, (g.jmf ? "ALT" : ""));
//	sscatoi(g, dat[3], &iwk, 0, 0, 0, "");  /* 0:ȊO͖T|[g */
	sscatoi(g, dat[3], &iwk, 0, 0, 0, (g.jmf ? "AksP" : ""));  /* 0:ȊO͖T|[g */
    wtpm2.ylt_uni = iwk;     /*  AksP 0:t 1: 2: 3:b */
//	sscatoi(g, dat[4], &iwk, 0, 3, 0, " ");
	sscatoi(g, dat[4], &iwk, 0, 3, 0, (g.jmf ? " Aks" : ""));
    wtpm2.ylt_typ = iwk;     /*  Aks */
	/*  AksŎgpJ_ clm[] */
	if(      iwk == 0 ) wtpm2.ylt_clm = 0;
	else if( iwk == 2 ) wtpm2.ylt_clm = g.shm.v[toshm].clm;
	else if( iwk == 3 ) wtpm2.ylt_clm = g.shm.v[frshm].clm;
	else              { wtpm2.ylt_clm = -1;  CHKA(iwk, g.rdseq, g.rdseq); } //chg KS140624
//	else                CHKA(iwk, g.rdseq, g.rdseq);
//	sscatoi(g, dat[5], &wtpm2.buylt, 0, 366, 0, "");
	sscatoi(g, dat[5], &wtpm2.buylt, 0, 366, 0, (g.jmf ? "wLT" : ""));
//	sscatoi(g, dat[6], &iwk, 0, 0, 0, "");  /* 0:ȊO͖T|[g */
	sscatoi(g, dat[6], &iwk, 0, 0, 0, (g.jmf ? "wksP" : ""));  /* 0:ȊO͖T|[g */
    wtpm2.blt_uni = iwk;     /*  wksP 0:t 1: 2: 3:b           */
//	sscatoi(g, dat[7], &iwk, 0, 3, 0, " ");
	sscatoi(g, dat[7], &iwk, 0, 3, 0, (g.jmf ? " wks" : ""));
    wtpm2.blt_typ = iwk;     /*  wks 0:tx[X 2:ғx[Xigp̃J_j */
	/*  wksŎgpJ_  */
	if(      iwk == 0 ) wtpm2.blt_clm = 0;
	else if( iwk == 2 ) wtpm2.blt_clm = g.shm.v[toshm].clm;
	else              { wtpm2.blt_clm = -1;  CHKA(iwk, g.rdseq, g.rdseq); } //chg KS140624
//	else                CHKA(iwk, g.rdseq, g.rdseq);
    wtpm2.tpmnext = g.tpm.v[atpm].toptpm2;  /*  A}X^̊Jn tpm2[]or-1 */
    g.tpm.v[atpm].toptpm2 = g.tpm2.n;       /*  擪tpm[].toptpm2                 */
	rc = g.tpm2.push_back(wtpm2);

quit:
	if(zdbgf[61]>1) {TRACEC(0); Dprintf("zadYUSOM01 rc(%d)" CR, rc);}
	return( rc );
err1: rc = 0;
	Esprintf(g.ermes, "zdatardyus.cpp 0030 (%s:%d) (%s) (%s)" CR, g.fname,g.rdseq,dat[8],dat[9]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "A}X^t@C(%s:%d)̗LJn(%s)LI(%s)Ɍv͈͊Oł" CR, g.fname,g.rdseq,dat[8],dat[9]); Eprintf(g.ermes); }
	goto                                                                quit;
err2: rc = 0;
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardyus.cpp 0040 (%s:%d) (%s) (%s)" CR, g.fname,g.rdseq,dat[8],dat[9]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "A}X^t@C(%s:%d)̗LJn(%s)LI(%s)sł" CR, g.fname,g.rdseq,dat[8],dat[9]); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zrdYUSOM01	A}X^
********************************************************/
int zrdYUSOM01(ZMRP &g, char *fname)
{
	int		rc = 0, bflen;
	char	*dat[100];
	FILE	*fp = NULL;

	if(zdbgf[61]) {TRACEA(0); Dprintf("zrdYUSOM01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_in, fname );
	bflen = sizeof(g.rdbf);
	if( (fp = fopen(g.fname, "r")) == NULL ) goto                       quit;
	g.rdseq = 0;
	/* Psڂ̃o[WmF */
	if( fgets(g.rdbf, bflen, fp) == NULL ) { rc = 0; goto               quit; }
	++g.rdseq;
	if( (rc = vercheck(g, g.rdbf, "!V01")) != 1 ) goto                  quit;
	/* f[^s[v */
	for( g.rdbf[0] = 0; fgets(g.rdbf, bflen, fp) != NULL; g.rdbf[0] = 0 ) {
		++g.rdseq;
		if( g.rdbf[0] == '!' ) continue;  //RgsXLbv
		rc = bunkatu_chk(g, g.rdbf, dat, 13, 13, bflen); CHKB(13, rc, 13);
		if( (rc = zadYUSOM01( g, dat )) < 0 ) goto                     quit;
	}
	rc = g.tpm.n;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[61]) {TRACEC(0); Dprintf("zrdYUSOM01 rc(%d)" CR, rc);}
	return rc;
}
