/*
 * FILE      : zdchkrec.cpp	lqoR[h̒l`FbN
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : lqoR[h̒l`FbN
 * AUTHOR    : H.Yamagiwa  2004.09.27
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include	<stdio.h>
#include "z1mrp.h"

/*	ID_zchkrrod	󒍃I[_ rod[]̃`FbN
********************************************************/
static int zchkrrod(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		afrp1;
	rod_td	*wrod;
	frp1_td	*wfrp1;

	for( i = 0; i < g.rod.n; ++i ) {
		wrod = &g.rod.v[i];
		afrp1 = wrod->frp1;     CHKA10(0, afrp1, g.frp1.n);
		wfrp1 = &g.frp1(afrp1);
		CHKB10(wrod->odm, wfrp1->odm, wrod->odm);    /*  \                                 odm[] */
		CHKB10(wrod->fsh, wfrp1->fsh, wrod->fsh);    /*  Vbv                         fsh[] */
		CHKY10(wrod->size, wfrp1->size, wrod->size); /*  v                                       */
		CHKB10(wrod->due, wfrp1->due, wrod->due);    /*  oɓ                                         */
		CHKB10(-1, wfrp1->oydrp2, -1);               /*  elqo O΂P                 drp2[]or-1 */
		CHKB10(wrod->odm, wfrp1->oyodm, wrod->odm);  /*  쐬ԏB󒍁AoɁA     odm[]or-1 */
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkrpln	ݐY(MPS)  pln[]̃`FbN
********************************************************/
static int zchkrpln(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		afrp1, azhi;
	double	size;
	pln_td	*wpln;
	frp1_td	*wfrp1;

	for( i = 0; i < g.pln.n; ++i ) {
		wpln = &g.pln.v[i];
		afrp1 = wpln->frp1;     CHKA10(0, afrp1, g.frp1.n);
		wfrp1 = &g.frp1(afrp1);
		CHKB10(wpln->odm, wfrp1->odm, wpln->odm);    /*  \                                 odm[] */
		CHKB10(wpln->fsh, wfrp1->fsh, wpln->fsh);    /*  Vbv                         fsh[] */
		CHKY10(wpln->size, wfrp1->size, wpln->size); /*  v                                       */
		CHKB10(wpln->due, wfrp1->due, wpln->due);    /*  oɓ                                         */
		CHKB10(-1, wfrp1->oydrp2, -1);               /*  elqo O΂P                 drp2[]or-1 */
		CHKB10(wpln->odm, wfrp1->oyodm, wpln->odm);  /*  쐬ԏB󒍁AoɁA     odm[]or-1 */
		size = 0.0;
		/* ݌Ɉ`FbN */
		for( azhi = wpln->topzhi3; azhi >= 0; azhi = g.zhi[azhi].nextmrp ) { CHKA10(0, azhi, g.zhi.n);
			CHKB10(3, g.zhi[azhi].ityp, 3);
			CHKB10(i, g.zhi[azhi].nyuko, i);
			size += g.zhi[azhi].size;
		}
		/* ʂ̃`FbN */
		CHKY10(0.0, size, wpln->size);
		size = wpln->size - size;  /* c */
		CHKY10(size, wpln->zan, size);
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkrfto	oɗ\ fto[]̃`FbN
********************************************************/
static int zchkrfto(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		afrp1, azhi, adlm, afsh;
	double	size;
	fto_td	*wfto;
	frp1_td	*wfrp1;

	for( i = 0; i < g.fto.n; ++i ) {
		wfto = &g.fto.v[i];
		if( wfto->outday < 0 ) continue;  /* oɓȗfrp1쐬Ȃ */
		adlm = wfto->dlm;           CHKA10(0, adlm, g.dlm.n);
		afsh = g.dlm.v[adlm].fsh;   CHKA10(0, afsh, g.fsh.n);
		afrp1 = wfto->frp1;         CHKA10(0, afrp1, g.frp1.n);
		wfrp1 = &g.frp1(afrp1);
		CHKB10(wfto->odm, wfrp1->odm, wfto->odm);    /*  \                                 odm[] */
		CHKB10(afsh, wfrp1->fsh, afsh);              /*  Vbv                         fsh[] */
		CHKY10(wfto->size, wfrp1->size, wfto->size); /*  v                                       */
		CHKB10(wfto->outday, wfrp1->due, wfto->outday); /*  oɓ                                      */
		CHKB10(-1, wfrp1->oydrp2, -1);               /*  elqo O΂P                 drp2[]or-1 */
		CHKB10(wfto->odm, wfrp1->oyodm, wfto->odm);  /*  쐬ԏB󒍁AoɁA     odm[]or-1 */
		size = 0.0;
		/* ݌Ɉ`FbN */
		for( azhi = wfto->topzhi2; azhi >= 0; azhi = g.zhi[azhi].nextmrp ) { CHKA10(0, azhi, g.zhi.n);
			CHKB10(2, g.zhi[azhi].ityp, 2);
			CHKB10(i, g.zhi[azhi].nyuko, i);
			size += g.zhi[azhi].size;
		}
		/* ʂ̃`FbN */
		CHKY10(0.0, size, wfto->size);
		size = wfto->size - size;  /* c */
		CHKY10(size, wfto->zan, size);
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkropo	I[_ opo[]̃`FbN
********************************************************/
static int zchkropo(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		afrp2, azhi;
	double	size;
	opo_td	*wopo;
	frp2_td	*wfrp2;

	for( i = 0; i < g.opo.n; ++i ) {
		wopo = &g.opo.v[i];
		afrp2 = wopo->frp2;         CHKA10(0, afrp2, g.frp2.n);
		wfrp2 = &g.frp2(afrp2);
		CHKB10(wopo->odm, wfrp2->odm, wopo->odm);      /*  \                                 odm[] */
		CHKB10(wopo->fsh, wfrp2->fsh, wopo->fsh);      /*  Vbv                         fsh[] */
		CHKY10(wopo->size, wfrp2->size, wopo->size);   /*  v                                       */
		CHKB10(wfrp2->due, wopo->due, wfrp2->due);     /*  [                                           */
//		CHKB10(wfrp2->planbgn, wopo->plandue, wfrp2->plandue); /*  H\                             */
		/*  \  */
		if( wopo->bgn >= 0 ) { CHKB10(wfrp2->bgn, wopo->bgn, wfrp2->bgn); }
		else                 { CHKB10(0, wfrp2->bgn, g.endtd); }
		CHKB10(wopo->odm, wfrp2->oyodm, wopo->odm);  /*  쐬ԏB󒍁AoɁA     odm[]or-1 */
		size = 0.0;
		/* ݌Ɉ`FbN */
		for( azhi = wopo->topzhi4; azhi >= 0; azhi = g.zhi[azhi].nextmrp ) { CHKA10(0, azhi, g.zhi.n);
			CHKB10(4, g.zhi[azhi].ityp, 4);
			CHKB10(i, g.zhi[azhi].nyuko, i);
			size += g.zhi[azhi].size;
		}
		/* ʂ̃`FbN */
		CHKY10(0.0, size, wopo->size);
		size = wopo->size - size;  /* c */
		CHKY10(size, wopo->zan, size);
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkzhi	݌Ɉڍ zhi[]̃`FbN
********************************************************/
static int zchkzhi(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		idx;
	double	size;
	zhi_td	*wzhi;

	for( i = 0; i < g.zhi.n; ++i ) {
		wzhi = &g.zhi[i];
		CHKB10(1, wzhi->otyp, 2);  /*  oɑ 1:TRP1 2:FRP1  */
		CHKB10(1, wzhi->ityp, 5);  /*  ɑ 1:tonh 2:fto 3:pln 4:opo 5:fonh */
		/* MRP */
		if( wzhi->otyp == 1 ) { CHKA10(0, wzhi->mrp1, g.trp1.n); }
		else                  { CHKA10(0, wzhi->mrp1, g.frp1.n); }
		/*K ɑ  */
		idx = wzhi->nyuko;
		if( wzhi->ityp == 1 || wzhi->ityp == 5 ) { CHKA10(0, idx, g.onh.n);
			size = g.onh.v[idx].size;
		} else if( wzhi->ityp == 2 ) {             CHKA10(0, idx, g.fto.n);
			size = g.fto.v[idx].size;
		} else if( wzhi->ityp == 3 ) {             CHKA10(0, idx, g.pln.n);
			size = g.pln.v[idx].size;
		} else                       {             CHKA10(0, idx, g.opo.n);
			size = g.opo.v[idx].size;
		}
		CHKY10(UNIT, wzhi->size, size);  /*  ʁiOj */
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchklsz_1	bg܂Ƃߏڍ lsz[]1R[h`FbN
********************************************************/
static int zchklsz_1(ZMRP &g, int alsz, int mode) //0:e`FbN 1:q`FbN
{
	int 	rc = 0, chkn = ssc_get_chk();
	int		komrp, oymrp, blsz;
	lsz_td	*wlsz, *wwlsz;
	trp2_td	*wtrp2;
	drp2_td	*wdrp2;
	frp2_td	*wfrp2;
	trp1_td	*wtrp1;
	drp1_td	*wdrp1;
	frp1_td	*wfrp1;

	wlsz = &g.lsz[alsz];
	CHKB10(1, wlsz->zhi_typ, 3);     /*  敪 1:TRP1-TRP2 2:DRP1-DRP2 3:FRP1-FRP2 */
	oymrp = wlsz->oymrp;
	komrp = wlsz->komrp;
	/* MRP */
	if( wlsz->zhi_typ == 1 ) {
		CHKA10(0, oymrp, g.trp1.n);  /*K ܂Ƃߌ̐eMRP */
		CHKA10(0, komrp, g.trp2.n);  /*K ܂Ƃߌ̎qMRP */
		wtrp1 = &g.trp1(oymrp);
		wtrp2 = &g.trp2(komrp);
		CHKB10(wtrp1->tsh, wtrp2->tsh, wtrp1->tsh);
		CHKB10(0, wtrp2->due, wtrp1->due);
		if( mode == 0 ) {
			blsz = wtrp2->topoylsz1;    CHKA10(0, blsz, g.lsz.n);
			for( ; blsz >= 0; blsz = wwlsz->nextoy ) { CHKA10(0, blsz, g.lsz.n);
				wwlsz = &g.lsz[blsz];
				if( blsz == alsz ) break;
			}
		} else {
			blsz = wtrp1->topkolsz1;    CHKA10(0, blsz, g.lsz.n);
			for( ; blsz >= 0; blsz = wwlsz->nextko ) { CHKA10(0, blsz, g.lsz.n);
				wwlsz = &g.lsz[blsz];
				if( blsz == alsz ) break;
			}
		}
		CHKB10(alsz, blsz, alsz);
	} else if( wlsz->zhi_typ == 2 ) {
		CHKA10(0, oymrp, g.drp1.n);  /*K ܂Ƃߌ̐eMRP */
		CHKA10(0, komrp, g.drp2.n);  /*K ܂Ƃߌ̎qMRP */
		wdrp1 = &g.drp1(oymrp);
		wdrp2 = &g.drp2(komrp);
		CHKB10(wdrp1->dlm, wdrp2->dlm, wdrp1->dlm);
		CHKB10(0, wdrp2->iday, wdrp1->oday);
		if( mode == 0 ) {
			blsz = wdrp2->topoylsz2;    CHKA10(0, blsz, g.lsz.n);
			for( ; blsz >= 0; blsz = wwlsz->nextoy ) { CHKA10(0, blsz, g.lsz.n);
				wwlsz = &g.lsz[blsz];
				if( blsz == alsz ) break;
			}
		} else {
			blsz = wdrp1->topkolsz2;    CHKA10(0, blsz, g.lsz.n);
			for( ; blsz >= 0; blsz = wwlsz->nextko ) { CHKA10(0, blsz, g.lsz.n);
				wwlsz = &g.lsz[blsz];
				if( blsz == alsz ) break;
			}
		}
		CHKB10(alsz, blsz, alsz);
	} else if( wlsz->zhi_typ == 3 ) {
		CHKA10(0, oymrp, g.frp1.n);  /*K ܂Ƃߌ̎qMRP */       
		CHKA10(0, komrp, g.frp2.n);  /*K ܂Ƃߌ̎qMRP */       
		wfrp1 = &g.frp1(oymrp);
		wfrp2 = &g.frp2(komrp);
		CHKB10(wfrp1->fsh, wfrp2->fsh, wfrp1->fsh);
		CHKB10(0, wfrp2->due, wfrp1->due);
		if( mode == 0 ) {
			blsz = wfrp2->topoylsz3;    CHKA10(0, blsz, g.lsz.n);
			for( ; blsz >= 0; blsz = wwlsz->nextoy ) { CHKA10(0, blsz, g.lsz.n);
				wwlsz = &g.lsz[blsz];
				if( blsz == alsz ) break;
			}
		} else {
			blsz = wfrp1->topkolsz3;    CHKA10(0, blsz, g.lsz.n);
			for( ; blsz >= 0; blsz = wwlsz->nextko ) { CHKA10(0, blsz, g.lsz.n);
				wwlsz = &g.lsz[blsz];
				if( blsz == alsz ) break;
			}
		}
		CHKB10(alsz, blsz, alsz);
	} else  CHKB10(1, wlsz->zhi_typ, 3);
	CHKY10(UNIT, wlsz->size, wlsz->size);  /*  ʁiOj */
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchktrp1 gpVbvsqoPibg܂ƂߑOj̃`FbN
********************************************************/
static int zchktrp1(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		atsh, ashm, azhi, alsz, atrp1;
	double	size, net;
	trp1_td	*wtrp1, *utrp1;

	for( atsh = 0; atsh < g.tsh.n; ++atsh ) {
		for( i = g.tsh.v[atsh].toptrp1; i >= 0; i = wtrp1->daynext ) {
			wtrp1 = &g.trp1(i);
				CHKA10(0, wtrp1->odm, g.odm.n);          /*  \         odm[] */
				CHKB10(atsh, wtrp1->tsh, atsh);          /*  gpVbv tsh[] */
			ashm = g.tsh.v[atsh].shm;  CHKA10(0, ashm, g.shm.n);
				CHKY10(UNIT, wtrp1->size, wtrp1->size);  /*  v                                       */
				CHKB10(0, wtrp1->due, g.endtd);          /*  v                                         */
				CHKA10(-1, wtrp1->oyfrp2, g.frp2.n);     /*  elqo P΂(ei)             frp2[] */
				CHKA10(-1, wtrp1->uuoldtrp1, g.trp1.n);  /*  iڂsqoP P΂(i)      trp1[] */
				CHKY10(0.0, wtrp1->net, wtrp1->size);    /*  vʂP(=0͎̎q)                   */
				CHKY10(0.0, wtrp1->uunet, wtrp1->size);  /*  [XAbvvʂQ   */
			net = wtrp1->net + wtrp1->uunet;         /* inet+uunet=vʁj */
				CHKY10(0.0, net, wtrp1->size);
			if( net == 0.0 )  CHKB10( -1, wtrp1->topkolsz1, -1);
			if( wtrp1->bom < 0 && wtrp1->ubm < 0 ) {
				CHKB10(2, g.shm.v[ashm].shm_typ, 2); /* 񐻑Vbv */
			}
			if( wtrp1->oyfrp2 >= 0 ) {
				CHKB10(-1, wtrp1->uuoldtrp1, -1);    /*  iڂsqoP P΂(i)      trp1[] */
				if( g.shm.v[ashm].shm_typ == 1 ) {   /* Vbv */
					CHKA10(0, wtrp1->bom, g.bom.n);  /*  WJɎgalB-1:iuuNet -1:񐻑ł̃Rs[ bom[]or-1 */
				}
				CHKB10(-1, wtrp1->ubm, -1);          /*  WJɎguualB-1:bomOȏ -1:񐻑ł̃Rs[ ubm[]or-1 */
			} else {
				CHKA10(0, wtrp1->uuoldtrp1, g.trp1.n);  /*  iڂsqoP P΂(i)      trp1[] */
				CHKB10(-1, wtrp1->oyfrp2, -1);      /*  elqo P΂(ei)             frp2[] */
				CHKB10(-1, wtrp1->bom, -1);         /*  WJɎgalB-1:iuuNet -1:񐻑ł̃Rs[ bom[]or-1 */
				CHKA10(0, wtrp1->ubm, g.ubm.n);     /*  WJɎguualB-1:bomOȏ -1:񐻑ł̃Rs[ ubm[]or-1 */
			}
			/*  qlqo ΂                 lsz[1]or-1 */
			size = 0.0;
			for( alsz = wtrp1->topkolsz1; alsz >= 0; alsz = g.lsz[alsz].nextko ) { CHKA10(0, alsz, g.lsz.n);
				CHKB10(i, g.lsz[alsz].oymrp, i);
				CHKB10(1, g.lsz[alsz].zhi_typ, 1);
				size += g.lsz[alsz].size;
				if( ( rc = zchklsz_1(g, alsz, 0)) != 0 ) errf = 1;
			}
			CHKY10(size, wtrp1->net, size);    /*  vʂP(=0͎̎q) */
			/*  擪̐Vi P΂                trp1[1]or-1 */
			for( atrp1 = wtrp1->topuunew; atrp1 >= 0; atrp1 = utrp1->nextuunew ) { CHKA10(0, atrp1, g.trp1.n);
				utrp1 = &g.trp1(atrp1);
				CHKB10(i, utrp1->uuoldtrp1, i);
			}
			/*  擪̍݌ɈBnetvZ̏ڍ       zhi[1] */
			size = 0.0;
			for( azhi = wtrp1->topzhi1; azhi >= 0; azhi = g.zhi[azhi].nextnyuko ) { CHKA10(0, azhi, g.zhi.n);
				CHKB10(i, g.zhi[azhi].mrp1, i);
				CHKB10(1, g.zhi[azhi].otyp, 1);
				size += g.zhi[azhi].size;
			}
			size = wtrp1->size - size;
			CHKY10(size-g.epsi, net, size+g.epsi);    /*  vʂP(=0͎̎q) */
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchktrp2 gpVbvsqoQibg܂Ƃߌj̃`FbN
********************************************************/
static int zchktrp2(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		alsz, atsh, adrp1, adlm;
	double	size;
	trp2_td	*wtrp2;
	drp1_td	*wdrp1;

	for( atsh = 0; atsh < g.tsh.n; ++atsh ) {
		for( i = g.tsh.v[atsh].toptrp2; i >= 0; i = wtrp2->daynext) { CHKA10(0, i, g.trp2.n);
			wtrp2 = &g.trp2(i);
			CHKA10(0, wtrp2->odm, g.odm.n);          /*  \ odm[] */
			CHKB10(atsh, wtrp2->tsh, atsh);          /*  gpVbv  */
			CHKY10(UNIT, wtrp2->size, wtrp2->size);  /*     */
			CHKB10(0, wtrp2->due, g.endtd);          /*  v */
			/*  elqo ΂                 lsz[1]or-1 */
			size = 0.0;
			alsz = wtrp2->topoylsz1;   CHKA10(0, alsz, g.lsz.n);
			for( ; alsz >= 0; alsz = g.lsz[alsz].nextoy ) { CHKA10(0, alsz, g.lsz.n);
				CHKB10(i, g.lsz[alsz].komrp, i);
				CHKB10(1, g.lsz[alsz].zhi_typ, 1);
				size += g.lsz[alsz].size;
				if( ( rc = zchklsz_1(g, alsz, 1)) != 0 ) errf = 1;
			}
			CHKY10(size, wtrp2->size, size);
			/*  qlqo P΂ */
			size = 0.0;
			adrp1 = wtrp2->topkodrp1;  CHKA10(0, adrp1, g.drp1.n);
			for( ; adrp1 >= 0; adrp1 = wdrp1->nextko ) { CHKA10(0, adrp1, g.drp1.n);
				wdrp1 = &g.drp1(adrp1);
				CHKB10(i, wdrp1->oytrp2, i);
				adlm = wdrp1->dlm;  CHKA10(0, adlm, g.dlm.n);
				CHKB10( atsh, g.dlm.v[adlm].tsh, atsh);
				CHKB10(wtrp2->due, wdrp1->iday, wtrp2->due);        /*  v */
				size += wdrp1->size;
			}
			CHKY10(wtrp2->size-g.epsi, size, size);
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdrp1 zcqoPibg܂ƂߑOj̃`FbN
********************************************************/
static int zchkdrp1(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		alsz, adlm, oytrp2, atsh;
	double	size;
	drp1_td	*wdrp1;
	trp2_td	*wtrp2;

	for( atsh = 0; atsh < g.tsh.n; ++atsh ) {
		for( adlm = g.tsh.v[atsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].tshnext ) { CHKA10(0, adlm, g.dlm.n); 
			for( i = g.dlm.v[adlm].topdrp1i; i >= 0; i = wdrp1->dlmidaynext ) { CHKA10(0, i, g.drp1.n);
				wdrp1 = &g.drp1(i);
				CHKA10(0, wdrp1->odm, g.odm.n);          /*  \ odm[] */
				CHKB10(adlm, wdrp1->dlm, adlm); /*  }X^ dlm[] */
				CHKB10(atsh, g.dlm.v[adlm].tsh, atsh);
				oytrp2 = wdrp1->oytrp2;  CHKA10( 0, oytrp2, g.trp2.n);
				wtrp2 = &g.trp2(oytrp2);

				CHKY10(UNIT, wdrp1->size, wdrp1->size);  /*     */
				CHKB10(wdrp1->iday, wtrp2->due, wdrp1->iday);        /*  v */
				CHKB10(0, wdrp1->oday, wdrp1->iday);        /*  ɓiv|ɂks|wksj */
				size = 0.0;
				alsz = wdrp1->topkolsz2;    CHKA10(0, alsz, g.lsz.n);
				/*  qlqo ΂                 lsz[2]or-1 */
				for( ; alsz >= 0; alsz = g.lsz[alsz].nextko ) { CHKA10(0, alsz, g.lsz.n);
					CHKB10(i, g.lsz[alsz].oymrp, i);
					CHKB10(2, g.lsz[alsz].zhi_typ, 2);
					size += g.lsz[alsz].size;
					if( ( rc = zchklsz_1(g, alsz, 0)) != 0 ) errf = 1;
				}
				CHKY10(size, wdrp1->size, size);
			}
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdrp2 zcqoQibg܂Ƃߌj̃`FbN
********************************************************/
static int zchkdrp2(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		afsh, adlm, alsz, erridx;
	double	size, esize;
	drp2_td	*wdrp2, *edrp2;

	for( afsh = 0; afsh < g.fsh.n; ++afsh ) {
		for( adlm = g.fsh.v[afsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].fshnext ) { CHKA(0, adlm, g.dlm.n);
			erridx = -1;
			esize  = 0.0;  //add NT140612 warning C4701 
			for( i = g.dlm.v[adlm].topdrp2i; i >= 0; i = wdrp2->dlmidaynext ) {  CHKA10(0, i, g.drp2.n);
				wdrp2 = &g.drp2(i);
				CHKA10(0, wdrp2->odm, g.odm.n);          /*  \ odm[] */
				CHKB10(adlm, wdrp2->dlm, adlm);          /* }X^ dlm[] */
				CHKB10(afsh, g.dlm.v[adlm].fsh, afsh);          
				CHKY10(UNIT, wdrp2->size, wdrp2->size);    /*     */
				CHKB10(wdrp2->oday, wdrp2->iday, g.endtd); /*  ɓ          */
				CHKB10(0, wdrp2->oday, wdrp2->iday);       /*  oɓiɓ|Aksj */
				CHKB10(0, wdrp2->expstopflg, 1);    /*  qmrpWJXgbvtO 1:WJȂ 0:WJ */
				/*  qlqo O΂P frp1[]or-1 */
				if( wdrp2->expstopflg ) { CHKB10(-1, wdrp2->kofrp1, -1); }
				else                    { CHKA10(0, wdrp2->kofrp1, g.frp1.n); }       
				/*  elqo ΂                     trp2[] */
				alsz = wdrp2->topoylsz2;   CHKA10(0, alsz, g.lsz.n);
				size = 0.0;
				for( ; alsz >= 0; alsz = g.lsz[alsz].nextoy ) {
					CHKB10(i, g.lsz[alsz].komrp, i);
					CHKB10(2, g.lsz[alsz].zhi_typ, 2);
					size += g.lsz[alsz].size;
					if( ( rc = zchklsz_1(g, alsz, 1)) != 0 ) errf = 1;
				}
				if( size > wdrp2->size ) { CHKY10(size, wdrp2->size, size); }
				else if( wdrp2->size > size ) {
					if( erridx < 0 ) { erridx = i; esize = size; }
					else {
						edrp2 = &g.drp2(erridx);
						if( edrp2->iday > wdrp2->iday ) { /* ÕG[f[^̓ɓx */
							CHKY10(size, wdrp2->size, size);
						} else if( edrp2->iday < wdrp2->iday ) { /* ÕG[f[^̓ɓ */
							CHKY10(esize, edrp2->size, esize);
							erridx = i;  esize = size;
						} else if( erridx > i ) {
							CHKY10(size, wdrp2->size, size);
						} else {
							CHKY10(esize, edrp2->size, esize);
							erridx = i;  esize = size;
						}
					}
				}
			}
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfrp1 VbveqoPibg܂ƂߑOj̃`FbN
********************************************************/
static int zchkfrp1(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		afsh, alsz, oydrp2, oyodm, idx, azhi;
	double	size;
	frp1_td	*wfrp1;
	drp2_td	*wdrp2;

	for( afsh = 0; afsh < g.fsh.n; ++afsh ) {
		for( i = g.fsh.v[afsh].topfrp1; i >= 0; i = wfrp1->daynext ) {  CHKA10(0, i, g.frp1.n);
			wfrp1 = &g.frp1(i);
			CHKB10(afsh, wfrp1->fsh, afsh);
			CHKA10(0, wfrp1->odm, g.odm.n);          /*  \ odm[] */
			CHKY10(UNIT, wfrp1->size, wfrp1->size);  /*  v   */
			CHKY10(0.0, wfrp1->net, wfrp1->size);    /*  v(size̐ݒƓɓlŏ) */
			CHKB10(0, wfrp1->due, g.endtd);          /*  oɓ                                         */
			oydrp2 = wfrp1->oydrp2;  CHKA10(-1, oydrp2, g.drp2.n); /*  elqo O΂P                 drp2[]or-1 */
			oyodm  = wfrp1->oyodm;   CHKA10(-1, oyodm, g.odm.n);   /*  쐬ԏB󒍁AoɁA     odm[]or-1 */
			if( oydrp2 >= 0 ) {       CHKB10(-1, oyodm, -1);
				wdrp2 = &g.drp2(oydrp2);
				CHKY10(wfrp1->size, wdrp2->size, wfrp1->size); /*  v   */
				CHKB10(wfrp1->due, wdrp2->oday, wfrp1->due);   /*  oɓ              */
				CHKB10(i, wdrp2->kofrp1, i);                   /*  qlqo O΂P */
			} else if( oyodm >= 0 ) { CHKB10(-1, oydrp2, -1);
				CHKB10(oyodm, wfrp1->odm, oyodm);
				idx = g.odm.v[oyodm].index;
				if(        g.odm.v[oyodm].odm_typ == 1 ) { CHKA10(0, idx, g.rod.n);
					CHKY10(wfrp1->size, g.rod.v[idx].size, wfrp1->size); /*  v      */
					CHKB10(wfrp1->due, g.rod.v[idx].due, wfrp1->due);    /*  oɓ        */
					CHKB10(i, g.rod.v[idx].frp1, i);                     /*  qlqo  */
				} else if( g.odm.v[oyodm].odm_typ == 2 ) { CHKA10(0, idx, g.pln.n);
					CHKY10(wfrp1->size, g.pln.v[idx].size, wfrp1->size); /*  v      */
					CHKB10(wfrp1->due, g.pln.v[idx].due, wfrp1->due);    /*  oɓ        */
					CHKB10(i, g.pln.v[idx].frp1, i);                     /*  qlqo  */
				} else if( g.odm.v[oyodm].odm_typ == 3 ) { CHKA10(0, idx, g.fto.n);
					CHKY10(wfrp1->size, g.fto.v[idx].size, wfrp1->size); /*  v      */
					CHKB10(wfrp1->due, g.fto.v[idx].outday, wfrp1->due); /*  oɓ        */
					CHKB10(i, g.fto.v[idx].frp1, i);                     /*  qlqo  */
				} else {   CHKB10(1, g.odm.v[oyodm].odm_typ, 3); }
			} else {                  CHKA10(oydrp2, oyodm, oyodm);
			}
			/*  qlqo ΂                 lsz[3]or-1 */
			alsz = wfrp1->topkolsz3;
			if( wfrp1->net > 0.0 ) { CHKA10(0, alsz, g.lsz.n); }
			else                   { CHKB10(-1, alsz, -1); }
			size = 0.0;
			for( ; alsz >= 0; alsz = g.lsz[alsz].nextko ) {  CHKA10(0, alsz, g.lsz.n);
				CHKB10(i, g.lsz[alsz].oymrp, i);
				CHKB10(3, g.lsz[alsz].zhi_typ, 3);
				size += g.lsz[alsz].size;
				if( ( rc = zchklsz_1(g, alsz, 0)) != 0 ) errf = 1;
			}
			CHKY10(size, wfrp1->net, size);
			/*  擪̍݌ɈBnetvZ̏ڍ       zhi[1] */
			azhi = wfrp1->topzhi2;           CHKA10(-1, azhi, g.zhi.n);
			if( wfrp1->net < wfrp1->size )   CHKA10(0, azhi, g.zhi.n);
			size = 0.0;
			for( ; azhi >= 0; azhi = g.zhi[azhi].nextnyuko ) {
				CHKB10(i, g.zhi[azhi].mrp1, i);
				CHKB10(2, g.zhi[azhi].otyp, 2);
				size += g.zhi[azhi].size;
			}
			size = wfrp1->size - size;  /* GR -  */
			CHKY10(size, wfrp1->net, size);
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfrp2 VbveqoQibg܂Ƃߌj̃`FbN
********************************************************/
static int zchkfrp2(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		afsh, alsz, oyodm, atrp1, idx, erridx;
	double	size, esize;
	frp2_td	*wfrp2, *efrp2;
	trp1_td	*wtrp1;

	for( afsh = 0; afsh < g.fsh.n; ++afsh ) {
		erridx = -1;
		esize  = 0.0; //add NT140612 warning C4701 
		for( i = g.fsh.v[afsh].topfrp2due; i >= 0; i = wfrp2->duenext ) {  CHKA10(0, i, g.frp2.n);
			wfrp2 = &g.frp2(i);
			CHKB10(afsh, wfrp2->fsh, afsh);
			CHKA10(0, wfrp2->odm, g.odm.n);          /*  \ odm[] */
			CHKY10(UNIT, wfrp2->size, wfrp2->size);  /*  v   */
			CHKB10(wfrp2->bgn, wfrp2->due, g.endtd); /*  [     */
			CHKB10(0, wfrp2->bgn, wfrp2->due);       /*       */
			CHKB10(wfrp2->planbgn, wfrp2->plandue, g.endtd); /*  H\     */
			CHKB10(0, wfrp2->planbgn, wfrp2->plandue);       /*  \     */
			/*  쐬ԏBI[_           opo[]or-1 */
			oyodm = wfrp2->oyodm;    CHKA10(-1, oyodm, g.odm.n);
			if( oyodm >= 0 ) {   CHKB10(oyodm, wfrp2->odm, oyodm);
				CHKB10(4, g.odm.v[oyodm].odm_typ, 4);
				idx = g.odm.v[oyodm].index; CHKA10(0, idx, g.opo.n);
				CHKY10(wfrp2->size, g.opo.v[idx].size, wfrp2->size);  /*  v   */
				CHKB10(wfrp2->due, g.opo.v[idx].due, wfrp2->due);     /*  [     */
				CHKB10(-1, wfrp2->topoylsz3, -1);
			} else {
				CHKB10(-1, oyodm, -1);
				/*  elqo ΂           lsz[3]or-1 */
				alsz = wfrp2->topoylsz3; CHKA10(0, alsz, g.lsz.n);
				size = 0.0;
				for( ; alsz >= 0; alsz = g.lsz[alsz].nextoy ) {
					CHKB10(i, g.lsz[alsz].komrp, i);
					CHKB10(3, g.lsz[alsz].zhi_typ, 3);
					size += g.lsz[alsz].size;
					if( ( rc = zchklsz_1(g, alsz, 1)) != 0 ) errf = 1;
				}
				if( size > wfrp2->size ) { CHKY10(size, wfrp2->size, size); }
				else if( size < wfrp2->size ) {
					if( erridx < 0 ) { erridx = i; esize = size; }
					else {
						efrp2 = &g.frp2(erridx);
						if( efrp2->due > wfrp2->due ) { /* ÕG[f[^̔[x */
							CHKY10(size, wfrp2->size, size);
						} else if( efrp2->due < wfrp2->due ) { /* ÕG[f[^̔[ */
							CHKY10(esize, efrp2->size, esize);
							erridx = i;  esize = size;
						} else if( erridx > i ) {
							CHKY10(size, wfrp2->size, size);
						} else {
							CHKY10(esize, efrp2->size, esize);
							erridx = i;  esize = size;
						}
					}
				}
			}
			CHKB10(0, wfrp2->expstopflg, 1);    /*  qmrpWJXgbvtO 1:WJȂ 0:WJ */
			if( wfrp2->expstopflg ) CHKB10(-1, wfrp2->topkotrp1, -1);
			/*  qlqo P΂ (qi)        frp2[]or-1 */
			for( atrp1 = wfrp2->topkotrp1; atrp1 >= 0; atrp1 = wtrp1->nextko ) {
				wtrp1 = &g.trp1(atrp1);
				CHKB10(i, wtrp1->oyfrp2, i);
			}
		}
		for( i = g.fsh.v[afsh].topfrp2bgn; i >= 0; i = wfrp2->bgnnext ) {
			wfrp2 = &g.frp2(i);  CHKA10(0, i, g.frp2.n);
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zdchkrec	vZʂ̃`FbN
********************************************************/
int zdchkrec(ZMRP &g)
{
	int		rc, errf = 0;

	if( ( rc = zchkrrod(g)) != 0 ) errf = rc;
	if( ( rc = zchkrpln(g)) != 0 ) errf = rc;
	if( ( rc = zchkrfto(g)) != 0 ) errf = rc;
	if( ( rc = zchkropo(g)) != 0 ) errf = rc;
	if( ( rc = zchkzhi(g))  != 0 ) errf = rc;
	if( ( rc = zchktrp1(g)) != 0 ) errf = rc;
	if( ( rc = zchktrp2(g)) != 0 ) errf = rc;
	if( ( rc = zchkdrp1(g)) != 0 ) errf = rc;
	if( ( rc = zchkdrp2(g)) != 0 ) errf = rc;
	if( ( rc = zchkfrp1(g)) != 0 ) errf = rc;
	if( ( rc = zchkfrp2(g)) != 0 ) errf = rc;
	rc = errf;
//	if( rc > 0 ) rc = -1;  Ƃ肠Rg
	return( rc );
}
