/*
 * FILE      : zdchktbl.cpp	̓f[^̃`FbN
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : ̓f[^̃`FbN
 * AUTHOR    : H.Yamagiwa  2004.09.21
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include	<stdio.h>
#include "z1mrp.h"

/*	ID_zchkorg	gD}X^ org[]̃`FbN
********************************************************/
static int zchkorg(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();

	for( i = 0; i < g.org.n; ++i ) {
		CHKB10(101, g.org.v[i].yendmd, 1231); /*  Nxt */
		CHKB10(1, g.org.v[i].kaisu, 12);      /*   */
		CHKB10(1, g.org.v[i].org_typ, 2);     /*  gD 1:Г 2:ЊO */
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkitm	iڃ}X^ itm[]̃`FbN
********************************************************/
static int zchkitm(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		abom, aubm, afsh, atsh, aigm;
	itm_td *witm;
	for( i = 0; i < g.itm.n; ++i ) {
		witm = &g.itm.v[i];
		CHKB10(0, witm->unuse_flg, 1);    /*  tOB1:B  NT041104add */
		if( witm->unuse_flg ) continue;
		CHKB10(0, witm->round, 99);       /*  ʂ܂ߌ  0: >=1:_nʂɂ܂߂ */
		CHKB10(0, witm->rnd_typ, 2);      /*  ʂ܂ߎʁ@0:؏グ 1:ľܓ 2:؎̂   */
		CHKB10(0, witm->prty, 999999999); /*  tD揇                               */
		CHKB10(0, witm->lotfc_flg, 1);    /*  bg܂Ƃߗ}~tO 0:ɂȂ 1:ɂ */
		CHKB10(1, witm->yukodays, g.endtd);  /*  gp  Pʂ͓B */
		/* i\`FbN */
		for( abom = witm->topkobm; abom >= 0; abom = g.bom.v[abom].nextko ) {  CHKA10(0, abom, g.bom.n);
			CHKB10(i, g.bom.v[abom].oyitm, i );
		}
		for( abom = witm->topoybm; abom >= 0; abom = g.bom.v[abom].nextoy ) { CHKA10(0, abom, g.bom.n);
			CHKB10(i, g.bom.v[abom].koitm, i );
		}
		/* [XAbvi\ */
		for( aubm = witm->topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew ) {  CHKA10(0, aubm, g.ubm.n);
			CHKB10(i, g.ubm.v[aubm].olditm, i );
			CHKB10(-1, g.ubm.v[aubm].shm, -1 );
		}
		for( aubm = witm->topoldubm; aubm >= 0; aubm = g.ubm.v[aubm].nextold ) {  CHKA10(0, aubm, g.ubm.n);
			CHKB10(i, g.ubm.v[aubm].newitm, i );
			CHKB10(-1, g.ubm.v[aubm].shm, -1 );
		}
		/*  擪̋Vbv                 fsh[] */
		for( afsh = witm->topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext) {  CHKA10(0, afsh, g.fsh.n);
			CHKB10(i, g.fsh.v[afsh].itm, i );
		}
		/*  擪̎gpVbv                   tsh[] */
		for( atsh = witm->toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext) {  CHKA10(0, atsh, g.tsh.n);
			CHKB10(i, g.tsh.v[atsh].itm, i );
		}
		/*  擪̕iڃO[v                   igm[]or-1 */
		for( aigm = witm->topigm; aigm >= 0; aigm = g.igm.v[aigm].itmnext) {  CHKA10(0, aigm, g.igm.n);
			CHKB10(i, g.igm.v[aigm].itm, i );
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkshm	Vbv}X^ shm[]̃`FbN
********************************************************/
static int zchkshm(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		afsh, atsh, atpm, asgm;
	shm_td *wshm;
	for( i = 0; i < g.shm.n; ++i ) {
		wshm = &g.shm.v[i];
		CHKB10(0, wshm->unuse_flg, 1);    /*  tOB1:B  NT041104add */
		if( wshm->unuse_flg ) continue;
		CHKB10(1, wshm->shm_typ, 3);     /*  Vbv敪 */
		if( wshm->shm_typ == 3 )  CHKB10(-1, wshm->toptsh, -1);
		CHKB10(0, wshm->kuzusi, 2);      /*  R   0:Ȃ 1:l 2:Ol        */
		CHKB10(0, wshm->bom_typ, 1);     /*  al敪 Vbvŵal 0: 1:L    */
		if( wshm->bom_typ == 1 )  CHKB10(1, wshm->shm_typ, 1);
		CHKB10(101, wshm->yendmd, 1231); /*  Nxt                                     */
		CHKB10(1, wshm->kaisu, 12);      /*                                         */
		CHKB10(0, wshm->ngdays, g.endtd); /*  O|֎~                                 */
		CHKB10(0, wshm->warikomi, 2);    /*  ݉\       0:ȍ~ł      */
		if( g.kimatu.n <= 0 ) {
			CHKB10(0, wshm->kimatubgn, 0);   /*  ̔z̊Jnʒu */
			CHKB10(-1, wshm->kimatuend, -1); /*  ̔z̏Iʒu */
		} else {
			CHKA10(0, wshm->kimatubgn, g.kimatu.n);   /*  ̔z̊Jnʒu */
			CHKA10(wshm->kimatubgn-1, wshm->kimatuend, g.kimatu.n);   /*  ̔z̏Iʒu */
		}
		CHKB10(1, wshm->org_typ, 2);     /*  gD 1:Г 2:ЊO                         */
		CHKA10(0, wshm->clm, g.clm.n);   /*  J_R[h clm[] */
		CHKA10(-1, wshm->cpm, g.cpm.n);  /*  \̓R[h cpm[]or-1 */
		/*  擪̋Vbv fsh[]or-1 */
		for( afsh = wshm->topfsh; afsh >= 0; afsh = g.fsh.v[afsh].shmnext) {  CHKA10(0, afsh, g.fsh.n);
			CHKB10(i, g.fsh.v[afsh].shm, i);
		}
		/*  擪̎gpVbv tsh[]or-1 */
		for( atsh = wshm->toptsh; atsh >= 0; atsh = g.tsh.v[atsh].shmnext) {  CHKA10(0, atsh, g.tsh.n);
			CHKB10(i, g.tsh.v[atsh].shm, i);
		}
		/*  擪̋A}X^(̃Vbvgp) tpm[]or-1 */
		for( atpm = wshm->topfrtpm; atpm >= 0; atpm = g.tpm.v[atpm].nextfr) {  CHKA10(0, atpm, g.tpm.n);
			CHKB10(i, g.tpm.v[atpm].toshm, i);
		}
		/*  擪̎gpA}X^(̃Vbv) tpm[]or-1 */
		for( atpm = wshm->toptotpm; atpm >= 0; atpm = g.tpm.v[atpm].nextto) {  CHKA10(0, atpm, g.tpm.n);
			CHKB10(i, g.tpm.v[atpm].frshm, i);
		}
		/*  擪̃VbvO[v  sgm[]or-1 */
		for( asgm = wshm->topsgm; asgm>= 0; asgm = g.sgm.v[asgm].shmnext) {  CHKA10(0, asgm, g.sgm.n);
			CHKB10(i, g.sgm.v[asgm].shm, i);
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfsh2_1	Vbv(ԕ) fsh2[]1R[h`FbN
********************************************************/
static int zchkfsh2_1(ZMRP &g, fsh2_td *pfsh2, int shm_typ)
{
	int 	rc = 0, chkn = ssc_get_chk();

    CHKX10(0.0, pfsh2->badr, 100.0);             /*  sǗ  0sǗ100  */
    CHKY10(0.0, pfsh2->lt, pfsh2->lt);           /*  WLT  Pʂ͓B  */
    CHKY10(0.0, pfsh2->hendo, pfsh2->hendo);     /*  ϓLT  Pʂ͓B  */
    CHKB10(0, pfsh2->lt_typ, 1);                 /*  WLT  0:tx[X 1:ғx[X  */
	CHKA10(0, pfsh2->lt_clm, g.clm.n);           /*  WLTŎgpJ_  */
    CHKB10(0, pfsh2->lt_rtyp, 2);     /*  WLT܂ߎ  0:؏グ 1:ľܓ 2:؎̂ 3:܂߂Ȃ */
    CHKY10(0.0, pfsh2->st, pfsh2->st);           /*  WƎ    Pʂ͕B */
    CHKY10(0.0, pfsh2->ct, pfsh2->ct);           /*  TCN^C  Pʂ͕B */
    CHKY10(UNIT, pfsh2->utsize, pfsh2->utsize);  /*  Pʌ(׌vZŎgp)  */
    CHKB10(0, pfsh2->komv_typ, 2);               /*  qiڗv */
    CHKB10(0, pfsh2->maetaosi, pfsh2->maetaosi); /*  O|\ Pʂ͉ғx[Xł̓B */
    /*  /oI[(񐻑Vbv̂) 0: 1:ô 2:̂ */
	if( shm_typ == 2 ) { CHKB10(0, pfsh2->io_typ, 2); }
	else               { CHKB10(0, pfsh2->io_typ, 0); }
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfshtsh	Vbv fsh[]̊֘AgpVbv݃`FbN
********************************************************/
static int zchkfshtsh(ZMRP &g, int ashm, int aitm )
{
	int 	rc = 0;
	int		atsh;

	for( atsh = g.itm.v[aitm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext ) {
		if( g.tsh.v[atsh].shm == ashm ) break;
	}
	rc = atsh;
	return( rc );
}
/*	ID_zchkfsh	Vbv fsh[]̃`FbN
********************************************************/
static int zchkfsh(ZMRP &g)
{
	int 	i, afsh2, pred, eday, fant, rc = 0, errf = 0;
	int		aitm, ashm, afls, asaf, adlm, abom, arod, apln, aopo, aonh, atsh, koitm, io_typ;
	int 	chkn = ssc_get_chk();
	fsh_td	*wfsh;
	fsh2_td	*wfsh2;

	for( i = 0; i < g.fsh.n; ++i ) {
		wfsh = &g.fsh.v[i];
		CHKB10(0, wfsh->unuse_flg, 1);    /*  tOB1:B  NT041104add */
		if( wfsh->unuse_flg ) continue;
		pred = -1;
		fant = -1; //add NT140612 warning C4701 
		aitm = wfsh->itm;       CHKA10(0, aitm, g.itm.n);
		ashm = wfsh->shm;       CHKA10(0, ashm, g.shm.n);
		afsh2 = wfsh->topfsh2;  CHKA10(0, afsh2, g.fsh2.n);
		if(        g.shm.v[ashm].shm_typ == 1 ) {  /* Vbv */
			if( g.shm.v[ashm].bom_typ == 1 ) {
				for( abom = wfsh->topkobm; abom >= 0; abom = g.bom.v[abom].nextko ) {
					koitm = g.bom.v[abom].koitm;
					atsh = zchkfshtsh(g, ashm, koitm ); CHKA10(0, atsh, g.tsh.n);
					if( atsh < 0 ) {
						Esprintf( g.ermes, "zdchktbl.cpp 0010 (%s) (%s) (%s)" CR,
											g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[koitm].itm_cd );
						Eprintf10( g.ermes );
						if( g.jmf ) {
							Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)̎qi(%s)̓Vbv̎gpVbv񂪑݂܂B" CR,
											g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[koitm].itm_cd );
							Eprintf(g.ermes);
						}
						errf = 1;
					}
				}
			} else {
				for( abom = g.itm.v[aitm].topkobm; abom >= 0; abom = g.bom.v[abom].nextko ) {
					koitm = g.bom.v[abom].koitm;
					atsh = zchkfshtsh(g, ashm, koitm ); CHKA10(0, atsh, g.tsh.n);
					if( atsh < 0 ) {
						Esprintf( g.ermes, "zdchktbl.cpp 0020 (%s) (%s) (%s)" CR,
											g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[koitm].itm_cd );
						Eprintf10( g.ermes );
						if( g.jmf ) {
							Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)̎qi(%s)̓Vbv̎gpVbv񂪑݂܂B" CR,
											g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[koitm].itm_cd );
							Eprintf(g.ermes);
						}
						errf = 1;
					}
				}
			}
		} else if( g.shm.v[ashm].shm_typ == 2 ) {  /* 񐻑Vbv */
			if ( afsh2 >= 0 ) {
				io_typ = g.fsh2.v[afsh2].io_typ;
				atsh = zchkfshtsh(g, ashm, aitm );
				if( atsh < 0 && io_typ != 1 ) { /*  /oI[ 0: 1:ô 2:̂ */
					Esprintf( g.ermes, "zdchktbl.cpp 0030 (%s) (%s) (%d) (%d)" CR,
									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[ashm].shm_typ, io_typ );
					Eprintf10( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)Vbv敪(%d)/oI[(%d)̓Vbv̎gpVbv񂪑݂܂B" CR,
										g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[ashm].shm_typ, io_typ );
						Eprintf(g.ermes);
					}
					errf = 1;
				} else if( atsh >= 0 && io_typ == 1 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0040 (%s) (%s) (%d) (%d: )" CR,
									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[ashm].shm_typ, io_typ );
					Eprintf10( g.ermes );
					errf = 1;
					if( g.jmf ) {
						Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)Vbv敪(%d)/oI[(%d:oI[)̓Vbv̎gpVbv񂪑݂܂B" CR,
										g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[ashm].shm_typ, io_typ );
						Eprintf(g.ermes);
					}
				}
			}
		}
		for( ; afsh2 >= 0; pred = afsh2, afsh2 = wfsh2->fshnext ) {
			wfsh2 = &g.fsh2.v[afsh2];   CHKB10(i, wfsh2->fsh, i);
			/* ԕʏ̃`FbN */
			CHKB10(pred, wfsh2->fshpred, pred);
			if( pred < 0 ) {
				CHKB10(0, wfsh2->bgnday, 0);
				if( wfsh2->bgnday > 0 ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0050 (%s) (%s) (%s..%s) " CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(0), ST(wfsh2->bgnday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)̗L[%s`%s]̃f[^Ă܂B" CR,
								g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(0), ST(wfsh2->bgnday-1) );
						Eprintf(g.ermes);
					}
					}}
				}
				fant = wfsh2->fant;
			} else {
			    CHKB10(afsh2, g.fsh2.v[pred].fshnext, afsh2);
				CHKB10(fant, wfsh2->fant, fant);
				eday = g.fsh2.v[pred].endday+1;
				CHKB10(eday, wfsh2->bgnday, eday);
				if( wfsh2->bgnday > eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0060 (%s) (%s) (%s..%s)" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(eday), ST(wfsh2->bgnday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)̗L[%s`%s]̃f[^Ă܂B" CR,
								g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(eday), ST(wfsh2->bgnday-1) );
						Eprintf(g.ermes);
					}
					}}
				}
				if( wfsh2->bgnday < eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0070 (%s) (%s) (%s..%s)" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(wfsh2->bgnday), ST(g.fsh2.v[pred].endday) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)̗L[%s`%s]̃f[^dĂ܂B" CR,
								g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(wfsh2->bgnday), ST(g.fsh2.v[pred].endday) );
						Eprintf(g.ermes);
					}
					}}
				}
			}
			if( wfsh2->fshnext < 0 ) {
				CHKB10(g.endtd, wfsh2->endday, g.endtd);
				if( wfsh2->endday < g.endtd ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0080 (%s) (%s) (%s..%s)" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(wfsh2->endday+1), ST(g.endtd) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "Vbv̕i(%s)Vbv(%s)̗L[%s`%s]̃f[^Ă܂B" CR,
								g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(wfsh2->endday+1), ST(g.endtd) );
						Eprintf(g.ermes);
					}
					}}
				}
			}
			if( zchkfsh2_1( g, wfsh2, g.shm.v[ashm].shm_typ ) != 0 ) errf = 1;
		}
		CHKB10(0, wfsh->bunkatuflg, 1);  /*  ܂胍bgwtO 0: 1:s */
		/*  bg܂Ƃߏ fls[] */
		afls = wfsh->fls;  CHKA10(-1, afls, g.fls.n);
		if( afls >= 0 )    CHKB10(i, g.fls.v[afls].fsh, i);
		/*  S݌ɏ     saf[]or-1 */
		asaf = wfsh->saf;  CHKA10(-1, asaf, g.saf.n);
		if( asaf >= 0 ) {
			CHKB10(i, g.saf.v[asaf].fsh, i);
			CHKB10(-1, g.saf.v[asaf].tsh, -1);
		}
		/*  擪̋}X^ dlm[] */
		for( adlm = wfsh->topdlm; adlm >= 0; adlm = g.dlm.v[adlm].fshnext ) { CHKA10(0, adlm, g.dlm.n);
			CHKB10(i, g.dlm.v[adlm].fsh, i);
			CHKB10(aitm, g.dlm.v[adlm].itm, aitm);
		}
		/* i\`FbN */
		abom = wfsh->topkobm;    CHKA10(-1, abom, g.bom.n);
		if( g.shm.v[ashm].bom_typ == 1 ) CHKA10(0, abom, g.bom.n);
		if( abom >= 0 )          CHKB10(1, g.shm.v[ashm].bom_typ, 1);
		for( ; abom >= 0; abom = g.bom.v[abom].nextko ) {  CHKA10(0, abom, g.bom.n);
			CHKB10(aitm, g.bom.v[abom].oyitm, aitm);
			CHKB10(ashm, g.bom.v[abom].shm, ashm);
		}
		/*  擪̎󒍃I[_([) rod[]or-1 */
		for( arod = wfsh->toprod; arod >= 0; arod = g.rod.v[arod].fshnext ) { CHKA10(0, arod, g.rod.n);
			CHKB10(i, g.rod.v[arod].fsh, i);
		}
		/*  擪̌ݐY(MPS)([) pln[]or-1 */
		for( apln = wfsh->toppln; apln >= 0; apln= g.pln.v[apln].fshnext ) { CHKA10(0, apln, g.pln.n);
			CHKB10(i, g.pln.v[apln].fsh, i);
		}
		/*  擪̐I[_([) opo[]or-1 */
		for( aopo = wfsh->topopo; aopo >= 0; aopo = g.opo.v[aopo].nextdue ) { CHKA10(0, aopo, g.opo.n);
			CHKB10(i, g.opo.v[aopo].fsh, i);
		}
		/*  擪̍݌  onh[]or-1 */
		for( aonh = wfsh->toponh; aonh >= 0; aonh = g.onh.v[aonh].next ) { CHKA10(0, aonh, g.onh.n);
			CHKB10(i, g.onh.v[aonh].fsh, i);
			CHKB10(-1, g.onh.v[aonh].tsh, -1);
		}
			
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchktshfsh	gpVbv tsh[]̊֘AVbv݃`FbN
********************************************************/
static int zchktshfsh(ZMRP &g, int ashm, int aitm )
{
	int 	rc = 0;
	int		afsh;

	for( afsh = g.itm.v[aitm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext ) {
		if( g.fsh.v[afsh].shm == ashm ) break;
	}
	rc = afsh;
	return( rc );
}
/*	ID_zchktsh	gpVbv tsh[]̃`FbN
********************************************************/
static int zchktsh(ZMRP &g)
{
	int 	i, rc = 0, errf = 0;
	int		aitm, ashm, asaf, adlm, abom, afto, aubm, aonh, oyitm, afsh, oyari, afsh2, io_typ;
	int 	chkn = ssc_get_chk();
	tsh_td	*wtsh;

	for( i = 0; i < g.tsh.n; ++i ) {
		wtsh = &g.tsh.v[i];
		CHKB10(0, wtsh->unuse_flg, 1);    /*  tOB1:B  NT041104add */
		if( wtsh->unuse_flg ) continue;
		aitm = wtsh->itm;       CHKA10(0, aitm, g.itm.n);
		ashm = wtsh->shm;       CHKA10(0, ashm, g.shm.n);

		if( g.shm.v[ashm].shm_typ == 1 ) {  /* Vbv */
			if( g.shm.v[ashm].bom_typ == 1 ) {
				abom = wtsh->topoybm;  CHKA10(-1, abom, g.bom.n);
				if( abom >= 0 ) {
					oyari = 0;
					for( ; abom >= 0; abom = g.bom.v[abom].nextoy ) {
						oyitm = g.bom.v[abom].oyitm;
						afsh = zchktshfsh(g, ashm, oyitm ); CHKA10(-1, afsh, g.fsh.n);
						if( afsh < 0 ) continue;
						++oyari;
					}
					if( oyari <= 0 ) {
						Esprintf( g.ermes, "zdchktbl.cpp 0090 (%s) (%s)" CR,
//									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[oyitm].itm_cd );
									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd ); //chg NT140612
						Eprintf10( g.ermes );
						if( g.jmf ) {
							Esprintf( g.ermes, "gpVbv̕i(%s)Vbv(%s)̐eiڂ̓Vbv̋Vbv񂪂P݂܂B" CR,
//									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[oyitm].itm_cd );
									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd ); //chg NT140612 
							Eprintf(g.ermes);
						}
						errf = 1;
					}
				}
			} else {
				abom = g.itm.v[aitm].topoybm;  CHKA10(-1, abom, g.bom.n);
				if( abom >= 0 ) {
					oyari = 0;
					for( ; abom >= 0; abom = g.bom.v[abom].nextoy ) {
						oyitm = g.bom.v[abom].oyitm;
						afsh = zchktshfsh(g, ashm, oyitm ); CHKA10(-1, afsh, g.fsh.n);
						if( afsh < 0 ) continue;
						++oyari;
					}
					if( oyari <= 0 ) {
						Esprintf( g.ermes, "zdchktbl.cpp 0100 (%s) (%s)" CR,
//									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[oyitm].itm_cd );
									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd ); //chg NT140612
						Eprintf10( g.ermes );
						if( g.jmf ) {
							Esprintf( g.ermes, "gpVbv̕i(%s)Vbv(%s)̐eiڂ̓Vbv̋Vbv񂪂P݂܂B" CR,
//									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.itm.v[oyitm].itm_cd );
									g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd ); //chg NT140612
							Eprintf(g.ermes);
						}
						errf = 1;
					}
				}
			}
		} else if( g.shm.v[ashm].shm_typ == 2 ) {  /* 񐻑Vbv */
			afsh = zchktshfsh(g, ashm, aitm ); CHKA10(-1, afsh, g.fsh.n);
			if( afsh >= 0 ) {
				afsh2 = g.fsh.v[afsh].topfsh2; CHKA10(0, afsh2, g.fsh2.n);
				if ( afsh2 >= 0 ) {
					io_typ = g.fsh2.v[afsh2].io_typ; CHKB10(0, io_typ, 2);
					if( io_typ == 1 ) {
						Esprintf( g.ermes, "zdchktbl.cpp 0110 (%s) (%s) (%d) (%d: )" CR,
										g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[ashm].shm_typ, io_typ );
						Eprintf10( g.ermes );
						if( g.jmf ) {
							Esprintf( g.ermes, "i(%s)Vbv(%s)Vbv敪(%d)/oI[(%d:oI[)̎gpVbv񂪑݂܂B" CR,
										g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[ashm].shm_typ, io_typ );
							Eprintf(g.ermes);
						}
						errf = 1;
					}
				}
			}
		} else { CHKB10(1, g.shm.v[ashm].shm_typ, 2); }

		/*  S݌ɏ     saf[]or-1 */
		asaf = wtsh->saf;  CHKA10(-1, asaf, g.saf.n);
		if( asaf >= 0 ) {
			CHKB10(i, g.saf.v[asaf].tsh, i);
			CHKB10(-1, g.saf.v[asaf].fsh, -1);
		}
		/*  擪̋}X^ dlm[] */
		for( adlm = wtsh->topdlm; adlm >= 0; adlm = g.dlm.v[adlm].tshnext ) { CHKA10(0, adlm, g.dlm.n);
			CHKB10(i, g.dlm.v[adlm].tsh, i);
			CHKB10(aitm, g.dlm.v[adlm].itm, aitm);
		}
		/* i\`FbN */
		abom = wtsh->topoybm;            CHKA10(-1, abom, g.bom.n);
		if( abom >= 0 )                  CHKB10(1, g.shm.v[ashm].bom_typ, 1);
		for( ; abom >= 0; abom = g.bom.v[abom].nextoy ) {  CHKA10(0, abom, g.bom.n);
			CHKB10(aitm, g.bom.v[abom].koitm, aitm);
			CHKB10(ashm, g.bom.v[abom].shm, ashm);
		}
		/*  擪̓oɗ\ fto[]or-1 */
		for( afto = wtsh->topfto; afto >= 0; afto = g.fto.v[afto].tshnext ) { CHKA10(0, afto, g.fto.n);
			CHKB10(i, g.fto.v[afto].tsh, i);
		}
		/* [XAbvi\ */
		for( aubm = wtsh->topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew ) {  CHKA10(0, aubm, g.ubm.n);
			CHKB10(aitm, g.ubm.v[aubm].olditm, aitm );
			CHKB10(ashm, g.ubm.v[aubm].shm, ashm );
		}
		for( aubm = wtsh->topoldubm; aubm >= 0; aubm = g.ubm.v[aubm].nextold ) {  CHKA10(0, aubm, g.ubm.n);
			CHKB10(aitm, g.ubm.v[aubm].newitm, aitm );
			CHKB10(ashm, g.ubm.v[aubm].shm, ashm );
		}
		/*  擪̍݌  onh[]or-1 */
		for( aonh = wtsh->toponh; aonh >= 0; aonh = g.onh.v[aonh].next ) { CHKA10(0, aonh, g.onh.n);
			CHKB10(i, g.onh.v[aonh].tsh, i);
			CHKB10(-1, g.onh.v[aonh].fsh, -1);
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdlm2_1	}X^(ԕ) dlm2[]1R[h`FbN
********************************************************/
static int zchkdlm2_1(ZMRP &g, dlm2_td *pdlm2)
{
	int 	rc = 0, chkn = ssc_get_chk();

    CHKY10(0.0, pdlm2->haibun, 100.0);        /*  z  */
	CHKB10(0, pdlm2->spas.lotsep_flg, 1);     /*  bg 0:Ȃ 1: */
	CHKB10(0, pdlm2->spas.cap_flg, 1);        /*  Vbv\͍l 0:Ȃ 1: */
	CHKB10(0, pdlm2->spas.maxsz_flg, 1);      /*  ő働bgTCYL 0:Ȃ 1: */
	CHKB10(0, pdlm2->spas.avlinv_flg, 1);     /*  ]݌ɂl 0:Ȃ 1: */
    CHKB10(0, pdlm2->spas.hai_typ, 1);        /*  z 0:D揇ɏLKŔz 1:zŔz */
    CHKY10(0.0, pdlm2->total, pdlm2->total);  /*  ݌v */
    CHKX10(0.0, pdlm2->badr, 100.0);          /*  ɌsǗ   0sǗ100   */
    CHKB10(0, pdlm2->nyult, pdlm2->nyult);    /*  ɏLTBiϓksgƖj */
    if( pdlm2->nlt_typ == 0 ) {    CHKB10(0, pdlm2->nlt_clm, 0); } /*  0:tx[X */
	else if( pdlm2->nlt_typ == 2 ) ;          /*  2:ғx[Xigp̃J_j */
	else                           CHKB10(0, pdlm2->nlt_typ, 0);
	CHKA10(0, pdlm2->nlt_clm, g.clm.n);       /*  ɏksŎgpJ_ */
    CHKB10(0, pdlm2->nlt_uni, 0);             /*  ɏksP 0:t 1: 2: 3:b */
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdlm3_1	}X^(ԕ) dlm3[]1R[h`FbN
********************************************************/
static int zchkdlm3_1(ZMRP &g, dlm3_td *pdlm3)
{
	int 	rc = 0, chkn = ssc_get_chk();

    CHKY10(0.0, pdlm3->haibun, 100.0);        /*  z  */
	CHKB10(0, pdlm3->spas.lotsep_flg, 1);     /*  bg 0:Ȃ 1: */
	CHKB10(0, pdlm3->spas.cap_flg, 1);        /*  Vbv\͍l 0:Ȃ 1: */
	CHKB10(0, pdlm3->spas.maxsz_flg, 1);      /*  ő働bgTCYL 0:Ȃ 1: */
	CHKB10(0, pdlm3->spas.avlinv_flg, 1);     /*  ]݌ɂl 0:Ȃ 1: */
    CHKB10(0, pdlm3->spas.hai_typ, 1);        /*  z 0:D揇ɏLKŔz 1:zŔz */
    CHKY10(0.0, pdlm3->total, pdlm3->total);  /*  ݌v */
    CHKX10(0.0, pdlm3->badr, 100.0);          /*  ɌsǗ   0sǗ100   */
    CHKB10(0, pdlm3->nyult, pdlm3->nyult);    /*  ɏLTBiϓksgƖj */
    if( pdlm3->nlt_typ == 0 ) {    CHKB10(0, pdlm3->nlt_clm, 0); } /*  0:tx[X */
	else if( pdlm3->nlt_typ == 2 ) ;          /*  2:ғx[Xigp̃J_j */
	else                           CHKB10(0, pdlm3->nlt_typ, 0);
	CHKA10(0, pdlm3->nlt_clm, g.clm.n);       /*  ɏksŎgpJ_ */
    CHKB10(0, pdlm3->nlt_uni, 0);             /*  ɏksP 0:t 1: 2: 3:b */
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdlm	}X^ dlm[]̃`FbN
********************************************************/
static int zchkdlm(ZMRP &g)
{
	int 	i, rc = 0, errf = 0;
	int		aitm, afsh, atsh, adls, afto, adlm2, adlm3, pred;
	int		ashm, bshm, eday;
	int 	chkn = ssc_get_chk();
	dlm_td	*wdlm;
	dlm2_td	*wdlm2;

	for( i = 0; i < g.dlm.n; ++i ) {
		wdlm = &g.dlm.v[i];
		aitm = wdlm->itm;       CHKA10(0, aitm, g.itm.n);
		afsh = wdlm->fsh;       CHKA10(0, afsh, g.fsh.n);
		atsh = wdlm->tsh;       CHKA10(0, atsh, g.tsh.n);
		ashm = g.tsh.v[atsh].shm;  CHKA10(0, ashm, g.shm.n);
		bshm = g.fsh.v[afsh].shm;  CHKA10(0, bshm, g.shm.n);
		/*  bg܂Ƃߏ dls[]or-1 */
		adls = wdlm->dls;  CHKA10(-1, adls, g.dls.n);
		if( adls >= 0 )    CHKB10(i, g.dls.v[adls].dlm, i);
		/* oɗ\ */
		for( afto = wdlm->topfto; afto >= 0; afto = g.fto.v[afto].dlmnext ) { CHKA10(0, afto, g.fto.n );
			CHKB10(i, g.fto.v[afto].dlm, i);
		}
		adlm2 = wdlm->topdlm2;  CHKA10(-1, adlm2, g.dlm2.n);
		adlm3 = wdlm->topdlm3;  CHKA10(-1, adlm3, g.dlm3.n);
		if( adlm2 < 0 ) CHKA10(0, adlm3, g.dlm3.n);
		if( adlm3 < 0 ) CHKA10(0, adlm2, g.dlm2.n);
		/* ԕʏ̃`FbN */
		pred = -1;
		for( ; adlm2 >= 0; pred = adlm2, adlm2 = wdlm2->dlmnext ) { CHKA10(0, adlm2, g.dlm2.n);
			wdlm2 = &g.dlm2.v[adlm2];   CHKB10(i, wdlm2->dlm, i);
			CHKB10(pred, wdlm2->dlmpred, pred);
			CHKB10(i, wdlm2->dlm, i);
			if( pred >= 0 ) {  CHKA10(0, pred, g.dlm2.n);
			    CHKB10(adlm2, g.dlm2.v[pred].dlmnext, adlm2);
				eday = g.dlm2.v[pred].endday+1;
				CHKB10(eday, wdlm2->bgnday, g.endtd);
				if( wdlm2->bgnday < eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0120 (%s) (%s) (%s) (%s..%s)" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[bshm].shm_cd,ST(wdlm2->bgnday), ST(eday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "}X^̕i(%s)gpVbv(%s)Vbv(%s)̗L[%s`%s]̃f[^dĂ܂B" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[bshm].shm_cd,ST(wdlm2->bgnday), ST(eday-1) );
						Eprintf(g.ermes);
					}
					}}
				}
			}
			if( zchkdlm2_1( g, wdlm2 ) != 0 ) errf = 1;
		}
		/* ԕʏ̃`FbN */
		for( ; adlm3 >= 0; pred = adlm3, adlm3 = g.dlm3.v[adlm3].dlmnext ) { CHKA10(0, adlm3, g.dlm3.n);
			CHKB10(i, g.dlm3.v[adlm3].dlm, i);
			CHKA10(0, g.dlm3.v[adlm3].odm, g.odm.n);
			if( zchkdlm3_1( g, &g.dlm3.v[adlm3] ) != 0 ) errf = 1;
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfls2_1	bg܂Ƃߏ(ԕ) fls2[]1R[h`FbN
********************************************************/
static int zchkfls2_1(ZMRP &g, fls2_td *pfls2)
{
	int 	rc = 0, chkn = ssc_get_chk(); //, errf = 0

	ltsz_td	*pltsz = &pfls2->ltsz;        /*  bgTCWÕp[^       NT041104add */
    CHKB10(0, pltsz->lotdays, pltsz->lotdays);   /*  bg܂Ƃߓ  */
    CHKB10(0, pltsz->day_typ, 1);                /*  bg܂Ƃߓ  0:tx[X 1:ғx[X */
	CHKA10(0, pltsz->day_clm, g.clm.n);          /*  bg܂ƂߓŎgpJ_  */
    CHKY10(0.0, pltsz->lotsize, pltsz->lotsize); /*  bg܂ƂߒPʐ  */
    CHKY10(0.0, pltsz->lotmin, pltsz->lotmin);   /*  bg܂Ƃߍŏ  */
	/*  bg܂Ƃߍő吔                           */
	if( pltsz->lotmax > 0.0 ) { CHKY10(pltsz->lotmin, pltsz->lotmax, pltsz->lotmax); }
	else                      { CHKY10(0.0, pltsz->lotmax, pltsz->lotmax); }
	/*  bg܂Ƃߊ^Cv M:t J:{ W:j R:v */
	CHKB(0, pltsz->base_typ, 4);
	if( pltsz->base_typ == 1 ) {      CHKB10(1, pltsz->base_day, 31); }
	else if( pltsz->base_typ == 3 ) { CHKB10(1, pltsz->base_day, 7); }
	else                            { CHKB10(0, pltsz->base_day, 0); }
    CHKB10(0, pltsz->tehai_typ, 1);   /*  bgz 0:ΏۊԂ̐擪 1:ŏ̏v */
    CHKB10(0, pltsz->yend_typ, 1);    /*  ܂Ƃߎ   0:܂Ƃ߂ 1:܂Ƃ߂Ȃ       */
    CHKB10(0, pltsz->yend_rtyp, 1);   /*  ؏グ   0:؏グ 1:؏グȂ       */
    CHKB10(0, pltsz->kintols_flg, 1); /*  ϓtO   0:ϓɕȂ 1:ϓɕ */
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfls	bg܂Ƃߏ fls[]̃`FbN
********************************************************/
static int zchkfls(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		aitm, afsh, afls2, pred;
	int		ashm, eday;
	fls2_td	*wfls2;

	for( i = 0; i < g.fls.n; ++i ) {
		afsh = g.fls.v[i].fsh;      CHKA10(0, afsh, g.fsh.n);
		aitm = g.fsh.v[afsh].itm;   CHKA10(0, aitm, g.itm.n);
		ashm = g.fsh.v[afsh].shm;   CHKA10(0, ashm, g.shm.n);
		/* ԕʏ̃`FbN */
		pred = -1;
		for( afls2 = g.fls.v[i].topfls2; afls2 >= 0; pred = afls2, afls2 = wfls2->flsnext ) { CHKA10(0, afls2, g.fls2.n);
			wfls2 = &g.fls2.v[afls2];
			CHKB10(pred, wfls2->flspred, pred);
			CHKB10(i, wfls2->fls, i);
			if( pred >= 0 ) {  CHKA10(0, pred, g.fls2.n);
			    CHKB10(afls2, g.fls2.v[pred].flsnext, afls2);
				eday = g.fls2.v[pred].endday+1;
				CHKB10(eday, wfls2->bgnday, g.endtd);
				if( wfls2->bgnday < eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0130 (%s) (%s) (%s..%s)" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(wfls2->bgnday), ST(eday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "bg܂Ƃ߂̕i(%s)Vbv(%s)̗L[%s`%s]̃f[^dĂ܂B" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, ST(wfls2->bgnday), ST(eday-1) );
						Eprintf(g.ermes);
					}
					}}
				}
			}
			if( zchkfls2_1( g, wfls2 ) != 0 ) errf = 1;
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdls2_1	׃bg܂Ƃߏ(ԕ) dls2[]1R[h`FbN
********************************************************/
static int zchkdls2_1(ZMRP &g, dls2_td *pdls2)
{
	int 	rc = 0, chkn = ssc_get_chk(); //, errf = 0

	ltsz_td	*pltsz = &pdls2->ltsz;        /*  bgTCWÕp[^       NT041104add */
    CHKB10(0, pltsz->lotdays, pltsz->lotdays);   /*  bg܂Ƃߓ  */
	/*  bg܂Ƃߓ  0:tx[X 2:ғx[XQ igpj */
	if( pltsz->day_typ == 0 ) { CHKB10(0, pltsz->day_clm, 0); }
	else if( pltsz->day_typ == 2 ) ;
	else { CHKA10(0, pltsz->day_typ, pltsz->day_typ); }
	CHKA10(0, pltsz->day_clm, g.clm.n);          /*  bg܂ƂߓŎgpJ_  */
    CHKY10(0.0, pltsz->lotsize, pltsz->lotsize); /*  bg܂ƂߒPʐ  */
    CHKY10(0.0, pltsz->lotmin, pltsz->lotmin);   /*  bg܂Ƃߍŏ  */
	/*  bg܂Ƃߍő吔                           */
	if( pltsz->lotmax > 0.0 ) { CHKY10(pltsz->lotmin, pltsz->lotmax, pltsz->lotmax); }
	else                      { CHKY10(0.0, pltsz->lotmax, pltsz->lotmax); }
	/*  bg܂Ƃߊ^Cv M:t J:{ W:j R:v */
	CHKB(0, pltsz->base_typ, 4);
	if( pltsz->base_typ == 1 ) {      CHKB10(1, pltsz->base_day, 31); }
	else if( pltsz->base_typ == 3 ) { CHKB10(1, pltsz->base_day, 7); }
	else                            { CHKB10(0, pltsz->base_day, 0); }
    CHKB10(0, pltsz->tehai_typ, 1);   /*  bgz 0:ΏۊԂ̐擪 1:ŏ̏v */
    CHKB10(0, pltsz->yend_typ, 1);    /*  ܂Ƃߎ   0:܂Ƃ߂ 1:܂Ƃ߂Ȃ       */
    CHKB10(0, pltsz->yend_rtyp, 1);   /*  ؏グ   0:؏グ 1:؏グȂ       */
    CHKB10(0, pltsz->kintols_flg, 1); /*  ϓtO   0:ϓɕȂ 1:ϓɕ */
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkdls	׃bg܂Ƃߏ dls[]̃`FbN
********************************************************/
static int zchkdls(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		aitm, afsh, atsh, adls2, pred, ashm, bshm, adlm, eday;
	dls2_td	*wdls2;

	for( i = 0; i < g.dls.n; ++i ) {
		adlm = g.dls.v[i].dlm;      CHKA10(0, adlm, g.dlm.n);
		aitm = g.dlm.v[adlm].itm;   CHKA10(0, aitm, g.itm.n);
		afsh = g.dlm.v[adlm].fsh;   CHKA10(0, afsh, g.fsh.n);
		atsh = g.dlm.v[adlm].tsh;   CHKA10(0, atsh, g.tsh.n);
		ashm = g.tsh.v[atsh].shm;   CHKA10(0, ashm, g.shm.n);
		bshm = g.fsh.v[afsh].shm;   CHKA10(0, bshm, g.shm.n);
		/* ԕʏ̃`FbN */
		pred = -1;
		for( adls2 = g.dls.v[i].topdls2; adls2 >= 0; pred = adls2, adls2 = wdls2->dlsnext ) { CHKA10(0, adls2, g.dls2.n);
			wdls2 = &g.dls2.v[adls2];
			CHKB10(pred, wdls2->dlspred, pred);
			CHKB10(i, wdls2->dls, i);
			if( pred >= 0 ) {  CHKA10(0, pred, g.dls2.n);
			    CHKB10(adls2, g.dls2.v[pred].dlsnext, adls2);
				eday = g.dls2.v[pred].endday+1;
				CHKB10(eday, wdls2->bgnday, g.endtd);
				if( wdls2->bgnday < eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0140 (%s) (%s) (%s) (%s..%s)" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[bshm].shm_cd,ST(wdls2->bgnday), ST(eday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) {
						Esprintf( g.ermes, "׃bg܂Ƃ߂̕i(%s)gpVbv(%s)Vbv(%s)̗L[%s`%s]̃f[^dĂ܂B" CR,
							g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd, g.shm.v[bshm].shm_cd,ST(wdls2->bgnday), ST(eday-1) );
						Eprintf(g.ermes);
					}
					}}
				}
			}
			if( zchkdls2_1( g, wdls2 ) != 0 ) errf = 1;
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkcap_1	\ cap[]1R[h`FbN
********************************************************/
static int zchkcap_1(ZMRP &g, cap_td *pcap)
{
	int 	rc = 0, chkn = ssc_get_chk();
    CHKY10(0.0, pcap->cp_fixtm, 1440.0);    /*  莞\ */
    CHKY10(0.0, pcap->cp_ovrtm, 1440.0);    /*  cƔ\ */
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkcpm	\̓R[hMST cpm[]̃`FbN
********************************************************/
static int zchkcpm(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		acap, pred, eday;

	for( i = 0; i < g.cpm.n; ++i ) {
		pred = -1;
		/* \ iԕʁj̃`FbN */
		for( acap = g.cpm.v[i].topcap; acap >= 0; pred = acap, acap = g.cap.v[acap].cpmnext ) { CHKA10(0, acap, g.cap.n);
			CHKB10(i, g.cap.v[acap].cpm, i);
			CHKB10(pred, g.cap.v[acap].cpmpred, pred);
			if( pred >= 0 ) {  CHKA10(0, pred, g.cap.n);
			    CHKB10(acap, g.cap.v[pred].cpmnext, acap);
				eday = g.cap.v[pred].endday+1;
				CHKB10(eday,  g.cap.v[acap].bgnday, g.endtd);
				if( g.cap.v[acap].bgnday > eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0150 (%s) (%s..%s)" CR,
							g.cpm.v[i].cpm_cd, ST(eday), ST(g.cap.v[acap].bgnday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) { Esprintf( g.ermes, "\̓}X^̔\̓R[h(%s)̗L[%s`%s]̃f[^Ă܂B" CR, g.cpm.v[i].cpm_cd, ST(eday), ST(g.cap.v[acap].bgnday-1) ); Eprintf(g.ermes);
					}
					}}
				}
				if( g.cap.v[acap].bgnday < eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0160 (%s) (%s..%s)" CR,
							g.cpm.v[i].cpm_cd,ST(g.cap.v[acap].bgnday), ST(eday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) { Esprintf( g.ermes, "\̓}X^̔\̓R[h(%s)̗L[%s`%s]̃f[^dĂ܂B" CR, g.cpm.v[i].cpm_cd,ST(g.cap.v[acap].bgnday), ST(eday-1) );
						Eprintf(g.ermes); }
					}}
				}
			} else { //del NT140609 CHKB10(0, g.cap.v[acap].bgnday, 0);
				if( g.cap.v[acap].bgnday > 0 ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0170 (%s) (%s..%s)" CR,
							g.cpm.v[i].cpm_cd, ST(0), ST(g.cap.v[acap].bgnday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) { Esprintf( g.ermes, "\̓}X^̔\̓R[h(%s)̗L[%s`%s]̃f[^Ă܂B" CR, g.cpm.v[i].cpm_cd, ST(0), ST(g.cap.v[acap].bgnday-1) ); Eprintf(g.ermes); }
					}}
				}
			}
			if( g.cap.v[acap].cpmnext < 0 ) { //del NT140609 CHKB10(g.endtd, g.cap.v[acap].endday, g.endtd);
				if( g.cap.v[acap].endday < g.endtd ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0180 (%s) (%s..%s)" CR,
							g.cpm.v[i].cpm_cd, ST(g.cap.v[acap].endday+1), ST(g.endtd) );
					Eprintf( g.ermes );
					if( g.jmf ) { Esprintf( g.ermes, "\̓}X^̔\̓R[h(%s)̗L[%s`%s]̃f[^Ă܂B" CR, g.cpm.v[i].cpm_cd, ST(g.cap.v[acap].endday+1), ST(g.endtd) ); Eprintf(g.ermes); }
					}}
				}
			}

			if( zchkcap_1( g, &g.cap.v[acap] ) != 0 ) errf = 1;
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchktpm2_1	A}X^iԕʁj tpm2[]1R[h`FbN
********************************************************/
static int zchktpm2_1(ZMRP &g, tpm2_td *ptpm2)
{
	int 	rc = 0, chkn = ssc_get_chk();

	CHKB10(0, ptpm2->ylt, ptpm2->ylt);  /*  ALT */
    CHKB10(0, ptpm2->ylt_uni, 0);       /*  AksP 0:t 1: 2: 3:b ʂÔ */
	CHKA10(0, ptpm2->ylt_clm, g.clm.n); /*  AksŎgpJ_               clm[] */
	/*  Aks */
    if( ptpm2->ylt_typ == 0 ) { CHKB10(0, ptpm2->ylt_clm, 0); } /*  0:tx[X */
    else if( ptpm2->ylt_typ == 2 ) ; /* 2:ғx[Xigp̃J_j */
    else if( ptpm2->ylt_typ == 3 ) ; /* 3:ғx[XĩJ_j */
	else                        CHKA10(0, ptpm2->ylt_typ, 0);
    CHKB10(0, ptpm2->buylt, ptpm2->buylt); /*  wLT */
    CHKB10(0, ptpm2->blt_uni, 0);          /*  wksP 0:t 1: 2: 3:b ʂÔ */
	CHKA10(0, ptpm2->blt_clm, g.clm.n);    /*  wksŎgpJ_               clm[] */
	/*  wks */
    if( ptpm2->blt_typ == 0 ) { CHKB10(0, ptpm2->blt_clm, 0); } /*  0:tx[X */
    else if( ptpm2->blt_typ == 2 ) ;     /* 2:ғx[Xigp̃J_j */
	else                        CHKA10(0, ptpm2->blt_typ, 0);
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchktpm	A}X^ tpm[]̃`FbN
********************************************************/
static int zchktpm(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		atpm2, ashm, bshm, pred, eday;
	tpm2_td	*wtpm2;

	for( i = 0; i < g.tpm.n; ++i ) {
		ashm = g.tpm.v[i].toshm;  CHKA10(0, ashm, g.shm.n);
		bshm = g.tpm.v[i].frshm;  CHKA10(0, bshm, g.shm.n);
		pred = -1;
		/* A}X^ iԕʁj̃`FbN */
		for( atpm2 = g.tpm.v[i].toptpm2; atpm2 >= 0; pred = atpm2, atpm2 = wtpm2->tpmnext ) { CHKA10(0, atpm2, g.tpm2.n);
			wtpm2 = &g.tpm2.v[atpm2];    CHKB10(i, wtpm2->tpm, i);
			CHKB10(pred, wtpm2->tpmpred, pred);
			if( pred >= 0 ) {  CHKA10(0, pred, g.tpm2.n);
			    CHKB10(atpm2, g.tpm2.v[pred].tpmnext, atpm2);
				eday = g.tpm2.v[pred].endday+1;
				CHKB10(eday, wtpm2->bgnday, g.endtd);
				if( wtpm2->bgnday < eday ) {
					errf = 1;
					{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
					Esprintf( g.ermes, "zdchktbl.cpp 0190 (%s) (%s) (%s..%s)" CR,
							g.shm.v[ashm].shm_cd,g.shm.v[bshm].shm_cd,ST(wtpm2->bgnday), ST(eday-1) );
					Eprintf( g.ermes );
					if( g.jmf ) { Esprintf( g.ermes, "A}X^̎gpVbv(%s)Vbv(%s)̗L[%s`%s]̃f[^dĂ܂B" CR,	g.shm.v[ashm].shm_cd,g.shm.v[bshm].shm_cd,ST(wtpm2->bgnday), ST(eday-1) ); Eprintf(g.ermes); }
					}}
				}
			}
			if( zchktpm2_1( g, wtpm2 ) > 0 ) errf = 1;
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkgrm	O[v}X^ grm[]̃`FbN
********************************************************/
static int zchkgrm(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		aigm, asgm;

	for( i = 0; i < g.grm.n; ++i ) {
		CHKB10(0, g.grm.v[i].grp_typ, 0);     /*  O[v 0:VbvtɎgp */
		CHKB10(0, g.grm.v[i].warituke, 1);    /*  ׊t 0:D揇ɏt܂Ŋt 1:ϓɊt */
		CHKB10(0, g.grm.v[i].kuzusi, 1);      /*  R   0:l 1:Ol */
		for( aigm = g.grm.v[i].topigm; aigm >= 0; aigm = g.igm.v[aigm].grmnext ) { CHKA10(0, aigm, g.igm.n);
			CHKB10(i, g.igm.v[aigm].grm, i);
		}
		for( asgm = g.grm.v[i].topsgm; asgm >= 0; asgm = g.sgm.v[asgm].grmnext ) { CHKA10(0, asgm, g.sgm.n);
			CHKB10(i, g.sgm.v[asgm].grm, i);
		}
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkigm	iڃO[v}X^ igm[]̃`FbN
********************************************************/
static int zchkigm(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		aitm, agrm, aisg;

	for( i = 0; i < g.igm.n; ++i ) {
		aitm = g.igm.v[i].itm;    CHKA10(0, aitm, g.itm.n);
		agrm = g.igm.v[i].grm;    CHKA10(0, agrm, g.grm.n);
		CHKB10(0, g.igm.v[i].prty, 9999999);        /*  Dx   0:ŗD */
		for( aisg = g.igm.v[i].topisg; aisg >= 0; aisg = g.isg.v[aisg].igmnext ) { CHKA10(0, aisg, g.isg.n);
			CHKB10(i, g.isg.v[aisg].igm, i);
			CHKB10(agrm, g.isg.v[aisg].grm, agrm);
			CHKB10(aitm, g.isg.v[aisg].itm, aitm);
		}
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchksgm	VbvO[v}X^ sgm[]̃`FbN
********************************************************/
static int zchksgm(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		ashm, agrm, aisg;

	for( i = 0; i < g.sgm.n; ++i ) {
		ashm = g.sgm.v[i].shm;    CHKA10(0, ashm, g.shm.n);
		agrm = g.sgm.v[i].grm;    CHKA10(0, agrm, g.grm.n);
		CHKB10(0, g.sgm.v[i].prty, 9999999);        /*  Dx   0:ŗD */
		for( aisg = g.sgm.v[i].topisg; aisg >= 0; aisg = g.isg.v[aisg].sgmnext ) { CHKA10(0, aisg, g.isg.n);
			CHKB10(i, g.isg.v[aisg].sgm, i);
			CHKB10(agrm, g.isg.v[aisg].grm, agrm);
			CHKB10(ashm, g.isg.v[aisg].shm, ashm);
		}
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkisg	iڃVbvO[v isg[]̃`FbN
********************************************************/
static int zchkisg(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	for( i = 0; i < g.isg.n; ++i ) {
		CHKA10(0, g.isg.v[i].itm, g.itm.n);
		CHKA10(0, g.isg.v[i].shm, g.shm.n);
		CHKA10(0, g.isg.v[i].grm, g.grm.n);
		CHKA10(0, g.isg.v[i].sgm, g.sgm.n);
		CHKA10(0, g.isg.v[i].igm, g.igm.n);
		CHKB10(0, g.isg.v[i].prty, 9999999);        /*  Dx   0:ŗD */
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkubm	[XAbvi\ ubm[]̃`FbN
********************************************************/
static int zchkubm(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		aitm, ashm, atsh, btsh;

	for( i = 0; i < g.ubm.n; ++i ) {
		CHKB10(0, g.ubm.v[i].unuse_flg, 1);    /*  tOB1:B  NT041104add */
		if( g.ubm.v[i].unuse_flg ) continue;
		CHKA10(-1, g.ubm.v[i].shm, g.shm.n);
		CHKA10(0, g.ubm.v[i].newitm, g.itm.n);
		CHKA10(0, g.ubm.v[i].olditm, g.itm.n);
		CHKY10(UNIT, g.ubm.v[i].size, g.ubm.v[i].size);
		CHKB10(0, g.ubm.v[i].tehai_typ, 0);   /*  iڎz 0: 1: 2: 0ȊO͖T|[g */
		if( g.ubm.v[i].shm < 0 ) {
			aitm = g.ubm.v[i].olditm;
			for( atsh = g.itm.v[aitm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext ) {
				ashm = g.tsh.v[atsh].shm;  CHKA10(0, ashm, g.shm.n);
				if( g.shm.v[ashm].shm_typ != 1 ) continue;  /* Vbv̂ */
				for( btsh = g.shm.v[ashm].toptsh; btsh >= 0; btsh = g.tsh.v[btsh].shmnext ) {
					if( g.tsh.v[btsh].itm == g.ubm.v[i].newitm ) break;
				}           CHKA10(0, btsh, g.tsh.n);
			}
		}
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkmv_tim	i\̎Ԃ炵`FbN
********************************************************/
static int zchkmv_tim(ZMRP &g, int afsh, int koitm, int oyitm, int mv_tim, int bgntd )
{
	int 	rc = 0, errf = 0, chkn = ssc_get_chk();
	int		afsh2, ashm;

	ashm = g.fsh.v[afsh].shm;   CHKA10(0, ashm, g.shm.n);
	for( afsh2 = g.fsh.v[afsh].topfsh2; afsh2 >= 0; afsh2 = g.fsh2.v[afsh2].fshnext ) {
		if( g.fsh2.v[afsh2].endday >= bgntd ) break;
	}   CHKA10(0, afsh2, g.fsh2.n);
	if( afsh2 >= 0 ) {
		if( g.fsh2.v[afsh2].bgnday <= bgntd ) {
			if( mv_tim > g.fsh2.v[afsh2].lt ) {
				errf = 1;
				{ static int maxmes = MAX_CHK_CNT; if( --maxmes >= 0 ) {
				Esprintf( g.ermes, "zdchktbl.cpp 0200 (%s) (%d) (%s) (%s) (%g)" CR,
						g.itm.v[koitm].itm_cd,mv_tim,g.itm.v[oyitm].itm_cd,g.shm.v[ashm].shm_cd,g.fsh2.v[afsh2].lt);
				Eprintf( g.ermes );
				if( g.jmf ) {
					Esprintf( g.ermes, "i\̎qi(%s)̎Ԃ炵(%d)͐ei(%s)Vbv(%s)̃[h^C(%g)𒴂Ă܂" CR,
						g.itm.v[koitm].itm_cd,mv_tim,g.itm.v[oyitm].itm_cd,g.shm.v[ashm].shm_cd,g.fsh2.v[afsh2].lt);
					Eprintf(g.ermes);
				}
				}}
			}
		} else { CHKA10(0, g.fsh2.v[afsh2].bgnday, bgntd); }
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkbom	i\ bom[]̃`FbN
********************************************************/
static int zchkbom(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		ashm, atsh, afsh, oyitm, koitm;

	for( i = 0; i < g.bom.n; ++i ) {
		CHKB10(0, g.bom.v[i].unuse_flg, 1);    /*  tOB1:B  NT041104add */
		if( g.bom.v[i].unuse_flg ) continue;
//KS140701chg		ashm = g.bom.v[i].shm;    CHKA10(-1, ashm, g.bom.n); /* KVbvR[h  */
		ashm = g.bom.v[i].shm;    CHKA10(-1, ashm, g.shm.n); /* KVbvR[h  */
		oyitm = g.bom.v[i].oyitm; CHKA10(0, oyitm, g.itm.n);                /* KeiڃR[h    */
		koitm = g.bom.v[i].koitm; CHKA10(0, koitm, g.itm.n); /* KqiڃR[h    */
		CHKY10(UNIT, g.bom.v[i].size, g.bom.v[i].size);  /*    */
		CHKX10(0.0, g.bom.v[i].kobadr, 100.0);      /*  qiڕsǗ   0sǗ100  */
		CHKB10(0, g.bom.v[i].mv_typ, 1);            /*  Ԃ炵 0:tx[X 1:ғx[X */
		CHKB10(0, g.bom.v[i].mv_uni, 0);            /*  Ԃ炵P 0:t 1: 2: 3:b */
		CHKB10(0, g.bom.v[i].bgnday, g.bom.v[i].endday);       /* KLJn */
		CHKB10(g.bom.v[i].bgnday, g.bom.v[i].endday, g.endtd); /*  LI  */
		CHKB10(0, g.bom.v[i].kouseup, 1);           /*  qiڃ[XAbvi 1:ł 0:łȂ */
		if( ashm >= 0) {
			CHKB10(1, g.shm.v[ashm].bom_typ, 1);
			atsh = zfGetTsh(g, koitm, ashm, -1); CHKA(0, atsh, g.tsh.n);
			if( g.bom.v[i].mv_tim > 0 ) {
				afsh = zfGetFsh(g, oyitm, ashm, -1); CHKA(0, afsh, g.fsh.n);
				if( zchkmv_tim( g, afsh, koitm, oyitm, g.bom.v[i].mv_tim, g.bom.v[i].bgnday ) != 0 ) errf = 1;
			}
			if( g.bom.v[i].kouseup == 1 ) {
				CHKA10(0, g.tsh.v[atsh].topnewubm, g.ubm.n);
			} else {
				CHKB10(-1, g.tsh.v[atsh].topnewubm, -1);
			}
		} else {
			if( g.bom.v[i].mv_tim > 0 ) {
				for( afsh = g.itm.v[oyitm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext ) {
					if( zchkmv_tim( g, afsh, koitm, oyitm, g.bom.v[i].mv_tim, g.bom.v[i].bgnday ) != 0 ) errf = 1;
				}
			}
			if( g.bom.v[i].kouseup == 1 ) {
				CHKA10(0, g.itm.v[koitm].topnewubm, g.ubm.n);
			} else {
				CHKB10(-1, g.itm.v[koitm].topnewubm, -1);
			}
		}
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkonh	݌ onh[]̃`FbN
********************************************************/
static int zchkonh(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		atsh, afsh;

	for( i = 0; i < g.onh.n; ++i ) {
		atsh = g.onh.v[i].tsh;  CHKA10(-1, atsh, g.tsh.n);  /*  gpVbv */
		afsh = g.onh.v[i].fsh;  CHKA10(-1, afsh, g.fsh.n);  /*  Vbv */
		if( atsh >= 0 ) { CHKB10(-1, afsh, -1); }
		else            { CHKA10(0, afsh, g.fsh.n); }
		CHKB10(0, g.onh.v[i].yukoday, g.endtd);                   /*  gp */
		CHKY10(UNIT, g.onh.v[i].size, g.onh.v[i].size);           /*  ݌ɗ */
		CHKY10(g.onh.v[i].size, g.onh.v[i].zan, g.onh.v[i].size); /*  ̎c */
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchksaf	S݌ saf[]̃`FbN
********************************************************/
static int zchksaf(ZMRP &g)
{
	int 	i, rc = 0, chkn = ssc_get_chk();
	int		atsh, afsh;

	for( i = 0; i < g.saf.n; ++i ) {
		atsh = g.saf.v[i].tsh;  CHKA10(-1, atsh, g.tsh.n);  /*  gpVbv */
		afsh = g.saf.v[i].fsh;  CHKA10(-1, afsh, g.fsh.n);  /*  Vbv */
		if( atsh >= 0 ) { CHKB10(-1, afsh, -1); }
		else            { CHKA10(0, afsh, g.fsh.n); }
		CHKB10(1, g.saf.v[i].saf_typ, 2);           /*  S݌ɕ[ 1:sx 2:_   */
		CHKB10(0, g.saf.v[i].mv_days, g.saf.v[i].mv_days); /*  [MPS炵 */
		CHKA10(0, g.saf.v[i].mv_clm, g.clm.n);             /*  [MPS炵ŎgpJ_ */
		CHKB10(0, g.saf.v[i].mv_typ, 1);                   /*  [MPS炵ғl */
		if( g.saf.v[i].mv_typ == 0 ) CHKB10(0, g.saf.v[i].mv_clm, 0);
		CHKY10(UNIT, g.saf.v[i].safesize, g.saf.v[i].safesize); /*  S݌ɗ */
	}
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkodm	ԁ^I[_No}X^ odm[]̃`FbN
********************************************************/
static int zchkodm(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		odm_typ, index, prty, dlm_typ;

	for( i = 0; i < g.odm.n; ++i ) {
		odm_typ = g.odm.v[i].odm_typ;   CHKB10(-1, odm_typ, 4);
		index   = g.odm.v[i].index;
		prty    = g.odm.v[i].prty;        /*  D揇  1,2̓t@C͒l 3,40:ŗDݒ */
		dlm_typ = g.odm.v[i].dlm_typ;     /*  }X^ ݒʂɐԎw肪 1: 0: NT040907add */
		if ( odm_typ == -1 ) {       CHKB10(-1, index, -1);
		} else if( odm_typ == 1 ) {  CHKA10(0, index, g.rod.n);
			CHKB10(0, prty, 9999999);
			CHKB10(0, dlm_typ, 1);
		} else if( odm_typ == 2 ) {  CHKA10(0, index, g.pln.n);
			CHKB10(0, prty, 9999999);
			CHKB10(0, dlm_typ, 1);
		} else if( odm_typ == 3 ) {  CHKA10(0, index, g.fto.n);
			CHKB10(0, prty, 0);
			CHKB10(0, dlm_typ, 0);
		} else if( odm_typ == 4 ) {  CHKA10(0, index, g.opo.n);
			CHKB10(0, prty, 0);
			CHKB10(0, dlm_typ, 0);
		} else                      CHKA10(0, odm_typ, odm_typ);
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkrod	󒍃I[_ rod[]̃`FbN
********************************************************/
static int zchkrod(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		aodm, afsh;

	for( i = 0; i < g.rod.n; ++i ) {
		aodm = g.rod.v[i].odm;    CHKA10(0, aodm, g.odm.n);
		afsh = g.rod.v[i].fsh;    CHKA10(0, afsh, g.fsh.n);
		CHKB10(i, g.odm.v[aodm].index, i);
		CHKB10(1, g.odm.v[aodm].odm_typ, 1);
		CHKY10(UNIT, g.rod.v[i].size, g.rod.v[i].size);
		CHKB10(0, g.rod.v[i].due, g.endtd);
		CHKB10(g.rod.v[i].prty, g.odm.v[aodm].prty, g.rod.v[i].prty);
		CHKB10(g.rod.v[i].dlmuse_flg, g.odm.v[aodm].dlm_typ, g.rod.v[i].dlmuse_flg);
		CHKB10(0, g.rod.v[i].lotng_flg, 1);   /*  bg܂Ƃߗ}~tO 0:bg܂ƂߑΏۂɂ 1:ΏۂɂȂ */
		CHKB10(0, g.rod.v[i].kanryo_flg, 0);  /*  tO 1: 0:                       */
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkpln	ݐY(MPS)  pln[]̃`FbN
********************************************************/
static int zchkpln(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		aodm, afsh;

	for( i = 0; i < g.pln.n; ++i ) {
		aodm = g.pln.v[i].odm;    CHKA10(0, aodm, g.odm.n);
		afsh = g.pln.v[i].fsh;    CHKA10(0, afsh, g.fsh.n);
		CHKB10(i, g.odm.v[aodm].index, i);
		CHKB10(2, g.odm.v[aodm].odm_typ, 2);
		CHKY10(UNIT, g.pln.v[i].size, g.pln.v[i].size);
		CHKB10(0, g.pln.v[i].due, g.endtd);
		CHKB10(g.pln.v[i].due, g.pln.v[i].yukoday, g.endtd);
		CHKB10(g.pln.v[i].prty, g.odm.v[aodm].prty, g.pln.v[i].prty);
		CHKB10(g.pln.v[i].dlmuse_flg, g.odm.v[aodm].dlm_typ, g.pln.v[i].dlmuse_flg);
		CHKB10(0, g.pln.v[i].kanryo_flg, 0);  /*  tO 1: 0:                       */
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkfto	oɗ\ fto[]̃`FbN
********************************************************/
static int zchkfto(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		aodm, atsh, adlm;

	for( i = 0; i < g.fto.n; ++i ) {
		aodm = g.fto.v[i].odm;    CHKA10(0, aodm, g.odm.n);
		atsh = g.fto.v[i].tsh;    CHKA10(0, atsh, g.tsh.n);
		adlm = g.fto.v[i].dlm;    CHKA10(0, adlm, g.dlm.n);
		CHKB10(i, g.odm.v[aodm].index, i);
		CHKB10(3, g.odm.v[aodm].odm_typ, 3);
		CHKY10(UNIT, g.fto.v[i].size, g.fto.v[i].size);
		CHKB10(0, g.fto.v[i].inday, g.endtd);
		CHKB10(g.fto.v[i].outday, g.fto.v[i].inday, g.endtd);
		CHKB10(-1, g.fto.v[i].outday, g.fto.v[i].inday);
		CHKB10(g.fto.v[i].inday+1, g.fto.v[i].yukoday, g.endtd);
		CHKB10(0, g.odm.v[aodm].prty, 0);
		CHKB10(0, g.odm.v[aodm].dlm_typ, 0);
		CHKB10(0, g.fto.v[i].kanryo_flg, 0);  /*  tO 1: 0:                       */
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zchkopo	I[_ opo[]̃`FbN
********************************************************/
static int zchkopo(ZMRP &g)
{
	int 	i, rc = 0, errf = 0, chkn = ssc_get_chk();
	int		aodm, afsh;

	for( i = 0; i < g.opo.n; ++i ) {
		aodm = g.opo.v[i].odm;    CHKA10(0, aodm, g.odm.n);
		afsh = g.opo.v[i].fsh;    CHKA10(0, afsh, g.fsh.n);
		CHKB10(i, g.odm.v[aodm].index, i);
		CHKB10(4, g.odm.v[aodm].odm_typ, 4);
		CHKY10(UNIT, g.opo.v[i].size, g.opo.v[i].size);
		CHKB10(0, g.opo.v[i].due, g.endtd);
		CHKB10(g.opo.v[i].bgn, g.opo.v[i].due, g.endtd);
		CHKB10(-1, g.opo.v[i].bgn, g.opo.v[i].due);
		CHKB10(0, g.opo.v[i].plandue, g.endtd);
		CHKB10(0, g.opo.v[i].planduetm, 1440);  /* 24h * 60 */
		CHKB10(g.opo.v[i].planbgn, g.opo.v[i].plandue, g.endtd);
		CHKB10(-1, g.opo.v[i].planbgn, g.opo.v[i].plandue);
		CHKB10(0, g.opo.v[i].planbgntm, 1440);  /* 24h * 60 */
		if( g.opo.v[i].planbgn < 0 ) CHKB10(0, g.opo.v[i].planbgntm, 0);
		CHKB10(g.opo.v[i].plandue+1, g.opo.v[i].yukoday, g.endtd);
		CHKB10(0, g.odm.v[aodm].prty, 0);
		CHKB10(0, g.odm.v[aodm].dlm_typ, 0);
		CHKB10(0, g.opo.v[i].kanryo_flg, 0);  /*  tO 1: 0: */
	}
	rc = errf;
	if( ssc_get_chk() > chkn ) rc = 1;
	return( rc );
}
/*	ID_zdchktbl	z̃`FbN
********************************************************/
int zdchktbl(ZMRP &g)
{
	int		rc, errf = 0;

	if( ( rc = zchkorg(g)) != 0 ) errf = rc;
	if( ( rc = zchkitm(g)) != 0 ) errf = rc;
	if( ( rc = zchkshm(g)) != 0 ) errf = rc;
	if( ( rc = zchkfsh(g)) != 0 ) errf = rc;
	if( ( rc = zchktsh(g)) != 0 ) errf = rc;
	if( ( rc = zchkdlm(g)) != 0 ) errf = rc;
	if( ( rc = zchkfls(g)) != 0 ) errf = rc;
	if( ( rc = zchkdls(g)) != 0 ) errf = rc;
	if( ( rc = zchkcpm(g)) != 0 ) errf = rc;
	if( ( rc = zchktpm(g)) != 0 ) errf = rc;
	if( ( rc = zchkgrm(g)) != 0 ) errf = rc;
	if( ( rc = zchkigm(g)) != 0 ) errf = rc;
	if( ( rc = zchksgm(g)) != 0 ) errf = rc;
	if( ( rc = zchkisg(g)) != 0 ) errf = rc;
	if( ( rc = zchkubm(g)) != 0 ) errf = rc;
	if( ( rc = zchkbom(g)) != 0 ) errf = rc;
	if( ( rc = zchkonh(g)) != 0 ) errf = rc;
	if( ( rc = zchksaf(g)) != 0 ) errf = rc;
	if( ( rc = zchkodm(g)) != 0 ) errf = rc;
	if( ( rc = zchkrod(g)) != 0 ) errf = rc;
	if( ( rc = zchkpln(g)) != 0 ) errf = rc;
	if( ( rc = zchkfto(g)) != 0 ) errf = rc;
	if( ( rc = zchkopo(g)) != 0 ) errf = rc;

	rc = errf;
//	if( rc > 0 ) rc = -1;  Ƃ肠Rg
	return( rc );
}
