/***************************************************************************
 * FILE      : chash3g.cpp	nbV@ɂAȃe[usB
 * Copyright (C) 2004 Sogen System Co., Ltd
 * AUTHOR    : N.Tsuchiya 1992.04.27
	NT20040827  C++̃NXB֐̃o֐Bhashopen()hashadd()hashkey()̍폜
 * REFERENCE :
 * FUNCTION  : nbV@ɂAȃe[usB
***************************************************************************/
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include	<stdlib.h>
#include	<string.h>

#if 1   /* NT990529 */
#  include "zchardif.h"
#  include "chash3g.h"
#  define CHKA(x,y,z)
#  define Dprintf(x)
#else
//#  include	"ssc.h"
//extern int chk_ab(int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz);
//extern int Dprintf(char *fmt,...);
#  define Dprintf printf
#  define Eprintf printf
  int 	chk_, chk_rc;
#  define 	CHKA(x,y,z)	(chk_+=chk_rc=((x)<=(y)&&(y)< (z))?0:\
	(Dprintf("*** CHKA x(%ld)y(%ld)z(%ld) in %s(%d)\n",\
	(long)(x),(long)(y),(long)(z),__FILE__,__LINE__),1),chk_rc)
#  define 	CHKB(x,y,z)	(chk_+=chk_rc=((x)<=(y)&&(y)<=(z))?0:\
	(Dprintf("*** CHKB x(%ld)y(%ld)z(%ld) in %s(%d)\n",\
	(long)(x),(long)(y),(long)(z),__FILE__,__LINE__),1),chk_rc)
#endif
//#define HASH_TEST

#define Malloc	malloc
#define Free	free
/**************************************************************************/
/* nbV֐̑I */
#define Hashfunc	Hashfunc_1

static long	prim[] = {3, /*1, 3, 5, 7, 13, 19, */ 8179, 16381, 32749, 65371, 131059, 524309, 1000003
                       , 4000037, 8388587, 16776989}; /*prime number list */
static int 	x_prim = sizeof(prim) / sizeof(prim[0]); /* prim[]̗vf */
static int pointsize;     //=4
static int pointmask;     //=0xfffffffc

HASH_CSCOPE HASH_CNAME()
{
	this->Hashinit();
}
//HASH_CSCOPE ~HASH_CNAME(){}
HASH_CSCOPE TIL_HASH_CNAME() { //fRXgN^ '~'gȂnr̂
	hashclose();
}
/******************************************** nhbuf_add() *****************/
//unsigned char *HASH_CSCOPE nhbuf_add()
HEADER * HASH_CSCOPE nhbuf_add(
	long val,
	unsigned char *key,
	int len)        /* '\0'܂ޑSf[^ ő255 */
{
//	register unsigned char	*ofs = NULL;
	register HEADER	*ofs = 0;
	struct hbuf_s	*hbf;
	struct hbuf_s	*bnext;

//	this->n_buf = (this->n_buf + 3) & ~0x03 ;
//	this->n_buf = (this->n_buf + 3) & 0xfffffffc ; //SoCgEɐ؂グ
	this->n_buf = (this->n_buf + pointsize - 1) & pointmask ; //|C^oCgEɐ؂グ
//	if( this->n_buf + len + 10 > BYTE_MAX  || this->hbuf == NULL ) {}
	if( this->n_buf + len + sizeof(HEADER) > BYTE_MAX  || this->hbuf == NULL ) {
		if( this->hbuf_b != NULL ) { /* 󂫃ubNL */
			hbf = this->hbuf_b;
			bnext = hbf->next;
			memset( hbf, 0, sizeof(*hbf) ); /*hbuf0ŏ */
			hbf->next = this->hbuf;
			this->hbuf = hbf;
			this->n_buf = 0;
			this->hbuf_b = bnext;	 /* 󂫃ubN̐擪XV */
		} else {
			if( (hbf = (struct hbuf_s*)Malloc(sizeof(*hbf))) == NULL ) {
//				Dprintf( "**** hash.c lbuf()GAmۂłȂB\n");
				goto                                       quit;
			}
			memset( hbf, 0, sizeof(*hbf) ); /*hbuf0ŏ */
			hbf->next = this->hbuf;
			this->hbuf = hbf;
			this->n_buf = 0;
		}
	}
//	ofs = this->hbuf->buf + this->n_buf;
	ofs = (HEADER*)(this->hbuf->buf + this->n_buf);
/*NT	memcpy( ofs+4, &val, 4 ); */
//	*(long*)(ofs+4) = val;
	ofs->val = val;
//	*(ofs+8) = (unsigned char)len;
	ofs->len = (unsigned char)len;
//	memcpy( ofs+10, key, len );
	memcpy( ofs+1, key, len );
//	this->n_buf += len + 10;	/* 󂫃|C^i */
	this->n_buf += len + sizeof(HEADER);	/* 󂫃|C^i */
quit:
	return( ofs );
}
/***********************************************************************
 * Hashfunxxx() : nbV֐B
 **********************************************************************/
/******************************************** Hashfun_ini() *****************/
void HASH_CSCOPE Hashfun_ini( /* nbV֐ */
	long p )           /* f */
{
	int 	i;
	unsigned long	*b = this->b;  /* key % p vZ邽߂̔z */
	b[0] = this->b0[0] = 1;
	this->b1[0] = 0;
	for( i = 1; i < 256 ; ++i ) {
/*		b[i] = ( b[i-1] * 251 ) % p ; asciî݂̏ꍇ */
		b[i] = ( b[i-1] << 8 ) % p ;
		this->b0[0] = (unsigned short)b[i];
		this->b1[0] = (unsigned short)(b[i] >> 16);
	}
}
/******************************************** Hashfunc_1() *****************/
long HASH_CSCOPE Hashfunc_1(  /* nbV֐BI[otE */
	unsigned char *pkey,
	register int len)
{
	register unsigned long	hashf = 0, *b = this->b;
	register unsigned char	*key = (unsigned char *)pkey;
	unsigned long	sav;
	sav = b[len];
	b[len] = 0; /* while[v̔ԕB̂ */
	while( *b ) {
/*		hashf += (*key++ - 32)* *b++;  asciî݂̏ꍇ */
		hashf += *key++ * *b++;
	}
/*	this->b[len] = sav; */
	*b = sav;
	hashf = hashf % this->x_htbl;
	return( hashf );
}
/******************************************** Hashfunc_2() *****************/
long HASH_CSCOPE Hashfunc_2(  /* nbV֐BI[otE */
	register unsigned char *pkey,      /*Hashfunc_1100{邩AoO */
	int len)		/*ꐳ] */
{
	register unsigned long	hash0, hash1;
	unsigned long	hashf, hash2;
	register unsigned short	*b0 = this->b0, *b1 = this->b1;
	register unsigned char	*key = (unsigned char *)pkey;
	register int 	j;
	hashf = hash0 = hash1 = 0;
	for(  j = 0 ; j < len ; ++j ) {
/*		hashf += (*key++ - 32)* *b++;  asciî݂̏ꍇ */
		hash0 += *key   * *b0++; /* this->b[]̉ʂPUrbg */
		hash1 += *key++ * *b1++; /* this->b[]̏ʂPUrbg */
	}
	hash1 += (hash0>>16);
	hash0 &= 0xffff;
	hash2  = (hash1>>16);
	hash1 &= 0xffff;
	hashf = hash0
		 + (hash1 & 0xff) * this->b[2] + (hash1 >> 8) * this->b[3]
		 + (hash2 & 0xff) * this->b[4] + (hash2 >> 8) * this->b[5];
	hashf = hashf % this->x_htbl;
	return( hashf );
}
/******************************************** Hashfunc_3() *****************/
long HASH_CSCOPE Hashfunc_3(  /* UNIXŌ */
	register unsigned char *pkey,
	int len)
{
	register unsigned char	*end = (unsigned char*)pkey+len-2 ;
	register long	rc = 0;
	unsigned char	*key = (unsigned char *)pkey;
	while( key < end )
		rc = (((((((rc<<7) ^ *key++) << 7) ^ *key++) << 7) ^ *key++)
			 ^ (rc>>3) ^ (rc>>10) ^ (rc>>17)) & 0x0ffffff;
	switch( (int)(end-key) ) {
	case 0:
		rc = (((((rc<<7) ^ *key++) << 7) ^ *key++)
			 ^ (rc>>10) ^ (rc>>17)) & 0x0ffffff;
		break;
	case -1:
		rc = ((rc<<7) ^ *key++ ^ (rc>>17)) & 0x0ffffff;
		break;
	case -2:
		break;
	default:                CHKA(0,end-key,0);
	}
	return( rc % this->x_htbl );
}
/***********************************************************************
 * mHxxx() : ֐
 **********************************************************************/
/******************************************** Hashinit() *****************/
int HASH_CSCOPE Hashinit ()
{
	this->htbl   = 0;    /* hash table , pointer to hbuf[] */
	this->x_htbl = 0;    /* capacity of htbl */
	this->n_htbl = 0;    /* number of keys in hash table */
	this->n_prim = 0;    /* current index of prim[] */
	this->n_buf  = 0;    /* ŏIobt@̕B */
	this->hbuf   = 0;    /* ݎgp̕obt@B */
	this->hbuf_b = 0;    /* 擪̋󂫕obt@ hbuf_b->nextŋ󂫕obt@̃N */
	this->hid    = -1;   /* 0:I[v -1:N[Y */
	pointsize = sizeof(void*);
	if       ( pointsize <=  4 ) { pointsize =  4; pointmask = 0xfffffffc;
	} else if( pointsize <=  8 ) { pointsize =  8; pointmask = 0xfffffff8;
	} else if( pointsize <= 16 ) { pointsize = 16; pointmask = 0xfffffff0;
	} else {                       pointsize = 32; pointmask = 0xffffffe0;
	}
	return( 0 ) ;
}
/******************************************** HashOpenOnly() *****************/
int HASH_CSCOPE HashOpenOnly(
	long hsize)
{
	int		newprim;

	this->hid = -1;
	for( this->n_prim = 0; this->n_prim < x_prim; ++this->n_prim )
		if( hsize <= prim[this->n_prim] ) break;
	if( this->n_prim >= x_prim )                      return( -4 );
	newprim = (int)prim[this->n_prim];
//	if( (this->htbl=(unsigned char**)Malloc(newprim * sizeof(*this->htbl))) == NULL ) return( -11);
	if( (this->htbl=(HEADER**)Malloc(newprim * sizeof(*this->htbl))) == NULL ) return( -11);
	memset( this->htbl, 0, newprim * sizeof(*this->htbl) ); /*hashe[u0ŏ */
	this->hid = 1;
	this->x_htbl = newprim ;
	Hashfun_ini( this->x_htbl );
	return( 0 ) ;
}
/******************************************** HashClear() ****************/
int HASH_CSCOPE HashClear()	/* SK20031022 nbVe[ũNA */
{
	struct hbuf_s	*hbf, *next;

	this->hid = -1;
	memset( this->htbl, 0, this->x_htbl * sizeof(*this->htbl) ); /*hashe[u0ŏ */
	this->n_htbl = 0;
	/* obt@󂫕obtAֈړ */
	 /* obt@̃NA͎gpɍs */
	if( this->hbuf_b == NULL ) { this->hbuf_b = this->hbuf;
	} else {
		/* 󂫕obt@̍ŌT */
		for( hbf = this->hbuf_b ; hbf ; hbf = next ) {
			next = hbf->next;
			if( next == NULL ) break;
		}
		hbf->next = this->hbuf;
	}
	this->n_buf = 0;
	this->hbuf  = NULL;
	return( 0 ) ;
}
/******************************************** HashSearch() ***************/
long HASH_CSCOPE HashSearch( /* hashe[üʒu(htbl[]Y) */
	unsigned char *key,      /* i  */
	int len,                 /* i  */
//	unsigned char **bufaddr /*  o */  /*o^keyR[h̐擪 or NULL */
	HEADER **bufaddr) /*  o */  /*o^keyR[h̐擪 or NULL */
{
	register long	pos; //, x_htbl = this->x_htbl;
//	unsigned char	*ofs;
	HEADER	*ofs;
	pos = Hashfunc( key, len );
//	if( (ofs = (unsigned char *)this->htbl[pos]) == 0 ) {}  /*posʒuhash\󂢂Ă */
	if( (ofs = this->htbl[pos]) == 0 ) {  /*posʒuhash\󂢂Ă */
		*bufaddr = NULL;
		return( pos );
	}
	/*rootLink++; */
	while (ofs) {  /*hbufnextǂkeyo^Ă邩ׂ */
//		if( *(ofs+8) == len ) {}
		if( ofs->len == len ) {
//			if (memcmp(key, ofs+10, len) == 0) break;
			if (memcmp(key, (char*)ofs+sizeof(HEADER), len) == 0) break;
		}
//		memcpy(&ofs, ofs, 4); NT040928chg
		ofs = ofs->next;
	}
	*bufaddr = ofs;
	return( pos );
}
/******************************************** hRehash() *******************/
int HASH_CSCOPE hRehash( /*struct hash_s *h */ )
{
	register long	j, pos; //, oldad;
//	register unsigned char	*ofs;
	register HEADER	*ofs, *next, *oldad;
	int 	len, rc, oldh_x_htbl;
//	unsigned char **oldh_htbl;    /* hash table , pointer to hbuf[] */
	HEADER **oldh_htbl;    /* hash table , pointer to hbuf[] */
//	long next;

	oldh_x_htbl = this->x_htbl;
	oldh_htbl   = this->htbl;
	if( this->n_prim+1 >= x_prim )                    return( -4 );
	if( (rc = HashOpenOnly( prim[this->n_prim+1] )) < 0 ) return( rc );
	for( j = 0 ; j < oldh_x_htbl ; ++j ) {
//		if( (oldad = (long)oldh_htbl[j]) == 0 )      continue;
		if( (oldad = oldh_htbl[j]) == 0 )      continue;
//		ofs = (unsigned char *)oldad;
		ofs = oldad;
		while (ofs) {
//			memcpy(&next, ofs, 4);
			next = ofs->next;
//			len = *(ofs+8);
			len = ofs->len;
//			pos = Hashfunc( ofs+10, len);
			pos = Hashfunc( (unsigned char*)(ofs+1), len);
//			memcpy(ofs, &this->htbl[pos], 4);  /*N */
			ofs->next = this->htbl[pos];  /*N */
			this->htbl[pos] = ofs;  /*htbl[pos]ɂhbuf::buf[]ւ̃|C^ */
//			ofs = (unsigned char *)next;
			ofs = next;
		}
	}
	if( oldh_htbl ) Free( oldh_htbl );
	return( 0 ) ;
}
/***********************************************************************
 * hashxxx() : OJ֐Q
 **********************************************************************/
/******************************************** hashclose() ***************/
int HASH_CSCOPE hashclose()
{
	struct hbuf_s	*hbf, *next;

	for( hbf = this->hbuf ; hbf ; hbf = next ) {
		next = hbf->next;
		Free( hbf );
	}
	/* 󂫕obt@free */
	for( hbf = this->hbuf_b ; hbf ; hbf = next ) {
		next = hbf->next;
		Free( hbf );
	}
	if( this->htbl ) Free( this->htbl );
	Hashinit();
	return( 0 ) ;
}
/******************************************** hashopen2() ****************/
int HASH_CSCOPE hashopen2(
	long yosou)
{
	int    rc;

	if( (rc = Hashinit()) < 0 )                 return( rc );
	return( HashOpenOnly( yosou * 2 ) );
}
/******************************************** hashopen() ****************/
int HASH_CSCOPE hashopen()
{
	int    rc;

	if( (rc = Hashinit()) < 0 )                 return( rc );
	return( HashOpenOnly( prim[0] ) ) ;
}
/******************************************** hashreopen() ****************/
int HASH_CSCOPE hashreopen()	/* SK20031022 gpς݃nbVe[uNAėp */
{
	int    rc;

	if( (rc = HashClear()) < 0 )                      return( rc );
	this->hid = 1;
	return( 0 );
}
/******************************************** hashaddr() *****************/
int HASH_CSCOPE hashaddr(
	void *pkey,
	int len,
	long val,
	char **adr)    /* o  Ɋi[L[ւ̃|C^ */
{
	unsigned char	*key = (unsigned char*)pkey; //, *bufaddr, *ofs;
	register long	pos;
	int 	rc;
	HEADER	*ofs, *bufaddr;

	if( this->hid < 0 ) { *adr = ""; return( -3 ); }
	if( val == -1L )                                    { *adr = ""; return( -3 ); }
	if( (this->n_htbl << 1) >= this->x_htbl ) {
		if( (rc = hRehash()) < 0 )                  { *adr = ""; return( rc ); }
	}
	if( len <= 0 ) len = strlen( (char*)key ) + 1;
	if( len > 255 )                                     { *adr = ""; return( -3 ); }
	pos = HashSearch( key, len, &bufaddr);
	if( (this->htbl[pos] != 0) && (bufaddr != NULL))       { *adr = ""; return( -2 ); }
//	if( (ofs = nhbuf_add( val, key, len)) == NULL ) { *adr = ""; return( -11 );}
	if( (ofs = nhbuf_add( val, key, len)) == 0 ) { *adr = ""; return( -11 );}
//	*adr = (char *)ofs+10;
	*adr = (char *)(ofs+1);
/*NT	memcpy(ofs, &this->htbl[pos], 4);	+*N𒣂 */
//	*(long*)ofs = (long)this->htbl[pos];
	ofs->next = this->htbl[pos];
//	this->htbl[pos] = ofs;  /*htbl[pos]ɂhbuf::buf[]ւ̃|C^ */
	this->htbl[pos] = ofs;  /*htbl[pos]ɂhbuf::buf[]ւ̃|C^ */
	this->n_htbl++ ;  /*o^key+1 */
	rc = 0;
	return (rc);  /*R[hkeÿʒuԂ */
}
/******************************************* hashfind() *****************/
long HASH_CSCOPE hashfind(
	void *pkey,
	int len)
{
	unsigned char	*key = (unsigned char*)pkey; //, *bufaddr;
	register long	pos;
	long	lrc;
	HEADER	*bufaddr;

	if( this->hid < 0 ) return( -3L );
	if( len <= 0 ) len = strlen( (char*)key ) + 1;
	if( len > 255 )                                 return( -3L );
	pos = HashSearch(key, len, &bufaddr);
//	if( (this->htbl[pos] == 0) || (bufaddr == NULL))   return( -1L );
	if( (this->htbl[pos] == 0) || (bufaddr == NULL))   return( -1L );
//	memcpy( &lrc, bufaddr+4, 4 ) ;
	lrc = bufaddr->val ;
	return( lrc ) ;
}
/******************************************* hashfindva() *****************/
long HASH_CSCOPE hashfindva(
	void *pkey,
	int len,
	long **pval)
{
	unsigned char	*key = (unsigned char*)pkey; //*bufaddr, 
	register long	pos;
	long	lrc;
	HEADER	*bufaddr;

	if( this->hid < 0 ) return( -3L );
	if( len <= 0 ) len = strlen( (char*)key ) + 1;
	pos = HashSearch(key, len, &bufaddr);
	if( (this->htbl[pos] == 0) || (bufaddr == NULL))   return( -1L );
	memcpy( &lrc, bufaddr+4, 4 ) ;
	*pval = (long*)(bufaddr + 4);
	return( lrc ) ;
}
/******************************************** hashmem() *****************/
int HASH_CSCOPE hashmem(           /* gp[ʂ̕ */
	int *num,    /*  o gpGg */
	int *max,    /*  o mۃGg */
	int *byte)   /*  o mۃoCg */
{
	struct hbuf_s	*next;    /* (gpς)obt@ւ̃|C^B */

	*num = *max = *byte = 0;
	if( this->hid < 0 ) return 0;
	*num  += this->n_htbl;
	*max  += this->x_htbl;
	*byte += this->x_htbl * sizeof(long);
	if( this->hbuf != NULL ) {
		*byte += sizeof(*(this->hbuf));
		for( next = this->hbuf->next; next != NULL; next = next->next ) {
			*byte += sizeof(*next);
		}
	}
	if( this->hbuf_b != NULL ) {
		*byte += sizeof(*(this->hbuf_b));
		for( next = this->hbuf_b->next; next != NULL; next = next->next ) {
			*byte += sizeof(*next);
		}
	}
	*byte += sizeof(HASH_CNAME);
	return( 0 );
}
/******************************************** main() *****************/

#ifdef HASH_TEST //SK20031022
#include	<stdio.h>
#if ! defined CR
#if defined(_WIN32)
#  define CR "\n"
#else
#  define CR "??/n"
#endif //defined(_WIN32)
#endif //! defined CR

#define SSCVECT_ALSO         //sscvect.h̓eXg
#if defined (SSCVECT_ALSO)   //sscvect.h̓eXg

#  include "sscvect.h"

struct aaa {
	int a, b, c;
	void prt(char *t){printf("%s a(%d)b(%d)c(%d)" CR, t, a, b, c); return;}
};

testvect()
{
	int i;
	sscvect<int> itbl;
	sscvect<aaa> atbl;
	aaa		wka, *aptr;

	printf("testvect start" CR); fflush(stdout);
	wka.a = 1;
	wka.b = 2;
	wka.c = 3;
	i = atbl.push_back(wka);
	i = atbl.push_back(wka);

	atbl[0].prt("atbl[0]");
	atbl[1].prt("atbl[1]");

	atbl[1].b = 9;
	atbl[1].prt("atbl[1]");

	aptr = &atbl[1];
	aptr = atbl.peep(0);
	aptr->prt("aptr->");

	atbl[1] = atbl[0];
	atbl[1].prt("atbl[1]");

//	fprintf(stderr, "Press Enter key"); fflush(stderr);
//	scanf("%c", &i);
	return 0;
}
#endif // (SSCVECT_ALSO)   sscvect.h̓eXg

main( int argc, char **argv )
{
	int i,j,l;
	int rc,rc1;
	char key[256], *okey;
	HASH_CNAME hl[20];
	int num, max;
	int byte;

	for( l=0; l<3; l++ ) {
		if( l == 0 ) {		//open, open2
			printf("open(%d) ----------------->" CR, l);
			for( i=0; i<10; i++ ) { //open
				rc = hl[i].hashopen();
				if( rc < 0 ) printf("rc1(%d)=hl[%d].hashopen()" CR, rc, i );
			}
			printf("open2(%d) ----------------->" CR, l);
			for( i=10; i<20; i++ ) { //open2
				rc = hl[i].hashopen2( 32767 );
				if( rc < 0 ) printf("rc(%d)=hl[%d].hashopen2(32767)" CR, rc, i );
			}
		} else if( l >= 1 ) { //reopen
			printf("reopen(%d) ----------------->" CR, l);
			for( i=0; i<20; i++ ) {
				rc = hl[i].hashreopen();
				if( rc < 0 ) printf("rc(%d)=hl[%d].hashreopen()" CR,rc, i );
			}
		}
		//addr,add
		for( i=0; i<20; i++ ) {
			for( j=0; j<256; j++ ) {
				sprintf( key, "test%d",j);
				rc1 = hl[i].hashaddr( key, 0, j, &okey );
				if( rc1 < 0 ) printf("rc2(%d)=hl[%d].hashaddr( key(%s)len(0)val(%d)okey(%s) )" CR, rc1, i,key,j,okey );
				else { if( strcmp( key, okey ) != 0 ) printf("error1"); }
			}
		}
		//find
		for( i=0; i<20; i++ ) {
			for( j=0; j<256; j++ ) {
				sprintf( key, "test%d",j);
				rc1 = hl[i].hashfind( key, 0 );
				if( rc1 < 0 )
					printf("rc1(%d)=hl[%d].hashfind( key(%s)len(0) )" CR,rc1, i, key );
				else { if( rc1 != j ) printf("error3"); }
			}
		}
		for( i=0; i<20; i++ ) {
			hl[i].hashmem( &num, &max, &byte);
			printf("hl[i:%d] num(%d)max(%d)byte(%ld)" CR,i, num, max, byte);
		}
	} //l
	//close
	for( i=0; i<20; i++ ) {
		hl[i].hashclose();
	}
#if defined (SSCVECT_ALSO)   //sscvect.h̓eXg
	testvect();
#endif // (SSCVECT_ALSO)  sscvect.h̓eXg
#if defined(_DEBUG)
	fprintf(stderr, "Press Enter key"); fflush(stderr);
	scanf("%c", &rc);
#endif
	return 0;
}
#endif
