/***************************************************************************
 * FILE      : cxheap.cpp	q[v̊Ǘ
 * AUTHOR    : F.Sasaki 2004.11.12
 * REFERENCE :
 * FUNCTION  : q[v̊Ǘ
***************************************************************************/
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */

#include    <stdio.h>
//#include	<stdlib.h>
//#include	<string.h>
#include	"zchardif.h" // FS041116del NT041203ikasu 
#include "zmrpssc.h"
#include "cxheap.h"

/**************************************************************************/
//#define CHKA(x,y,z)
//#define CHKB(x,y,z)
//#define Dprintf(x)
//#  include	"ssc.h"
//extern int chk_ab(int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz);
//extern int Dprintf(char *fmt,...);
/*	ID_dflt_comp	ftHg̔r֐
********************************************************/
static int dflt_comp(const int a, const int b)
{ return a - b; }
/*	ID_CXHEAP_CLASS	RXgN^
********************************************************/
CXHEAP_SCOPE CXHEAP_CLASS()
{comp = dflt_comp; heap.clear();}
/*	ID_CXHEAP_CLASS	RXgN^
********************************************************/
CXHEAP_SCOPE CXHEAP_CLASS( CXHEAP_TYPE( comp_p) )
{comp = comp_p; heap.clear();}
/*	ID_~HEAP_CNAME	fXgN^
********************************************************/
CXHEAP_SCOPE TIL_CXHEAP_CLASS() //fXgN^ '~'gȂnr̂
{}
/*	ID_top	擪vfԂ
********************************************************/
int CXHEAP_SCOPE top(void)
{return (heap.size() > 0) ? heap.v[0] : -1;}
/*	ID_clear	q[vɂ
********************************************************/
void CXHEAP_SCOPE clear(void)
{heap.clear();}
/*	ID_push	q[vւ̒ǉ
********************************************************/
int CXHEAP_SCOPE  push(int nod)
{
	int oy, ko, rc;
	if( (rc = heap.push_back(nod)) < 0 ) goto quit;
	ko = rc++;     //rc:vf
//	printf("ko(%d) nod(%d)" CR, ko, nod);
	while( ko >= 1 ) {
		oy = (ko - 1) >> 1;            CHKA(0, oy, ko);
//		printf("oy(%d) ko(%d)" CR, oy, ko);
		if(comp(heap.v[oy], nod ) <= 0 ) break;
		heap.v[ko] = heap.v[oy];
		ko = oy;
	}	                                CHKB(0, ko, rc);
	heap.v[ko] = nod;
	rc = 0;
quit:
	return rc;
}
/*	ID_pop	擪vfP폜
********************************************************/
void CXHEAP_SCOPE pop(void)
{
	int h, oy, ko, nod;
	
	h = heap.size() - 1;         //폜̗vf
	if( h < 0 ) goto                   quit;
	nod = heap.v[h];       //̗vf
//	rc  = heap.v[0];       /* q[v̐擪m[hԍ擾 */
	oy  = 0;
	heap.pop_back();       //Ō̗vf
	while( (ko = (oy << 1) + 1) < h ) {
		if( ko + 1 < h ) {
			if(comp(heap.v[ko], heap.v[ko+1]) > 0 ) ++ko;
		}
		if(comp(nod, heap.v[ko]) <= 0 ) break;
		heap.v[oy] = heap.v[ko];
		oy = ko;
	}
	heap.v[oy] = nod;
//	printf(" pop nord(%d) rc(%d)" CR, nord, rc);
quit:
	return ;
}

/******************************************** main() *****************/
//#define XHEAP_TEST

#ifdef XHEAP_TEST
#include	<stdio.h>

int tcomp(const int a, const int b)
{
	int rtc = b - a;
	rtc = ( a > b ) ? -1 : 1; //傫D
	return rtc;
}
int testcxheap()
{
	int size, i;
	CXHEAP_CLASS a(tcomp);
	a.set_func(tcomp); 
#if 1
	a.clear();
	a.push(2);
	a.push(1);
	a.push(33);
	a.push(44);
	a.pop();
	a.pop();
	a.pop();
	a.push(21);
	a.push(20);
	int rtc;
	rtc = a.top();
	printf("top =%d size(%d)" CR, rtc, a.size());
	size = a.size();
	for(i = 0; i < size + 1; a.pop(), i++) {
		printf("%4d %d" CR, i, a.top());
	}

	a.clear();
	a.push(2);
	a.push(1);
	a.push(33);
//	a.pop();
//	a.pop();
	a.push(21);
//	a.push(20);
	size = a.size();
	printf("top %d size(%d)" CR, a.top(), size);
	for(i = 0; ! a.empty(); a.pop(), i++) {
		printf("%4d %d" CR, i, a.top());
	}
#else
	int v = 20;
	for(i = 0; i < 660; i++) {
		v = v*v -3;
		if(v > 200) v -= v%200;
		v += i;
		a.push( v );
	}
	size = a.size();
	printf("top %d size(%d)" CR, a.top(), size);
	FILE *fp = fopen("ggg.txt", "w");
	for(i = 0; i < size; a.pop(), i++) {
		fprintf(fp, "%4d %d" CR, i, a.top());
	}
	fclose(fp);
#endif
	return 1;
}

main( int argc, char **argv )
{
	int rc;

	testcxheap();
#if defined(_DEBUG)
	fprintf(stderr, "Press Enter key"); fflush(stderr);
	scanf("%c", &rc);
#endif
	return 0;
}
#endif // XHEAP_TEST
