/*
 * FILE      : zmrpssc.cpp	ׂc[
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : ׂc[
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>  //keta_marume().fmod()

#include "zmrpssc.h"
#include "zchardif.h"

/*	ID_basenm	t@CfBNg폜
*******************************************************************/
static char *basenm(char *file)
{
	char	*p = file;
	for( p = file; *file; ++file )
//		if( *file == '\\' ) p = file + 1;
		if( *file == CYEN || *file == '/' ) p = file + 1;
	return p;
}
/*	ID_resetjmp	G[ɖ߂邽߂ɃX^bNNA NT040325add
*******************************************************************/
int zssc_resetjmp  ()
{
     /* G[ɖ߂邽߂ɃX^bNNA */
	memset( &zssc_mark, 0, sizeof(zssc_mark) );
	zssc_mark_set_flag = 0;  /* setjmp( zssc_mark )LtO */
	return 0;
}
/*	ID_chk_ab	CHKA()ACHKB()}Nňُ펞̃bZ[WóBQOOĂ΂Ǝs~
*******************************************************************/
int zssc_chk_ab  (int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz )
{
	/* CHKG[QOO 0:I 1:Ȃ(o͂) 2:Ȃ(100so)NT030304add */
	if( zssc_chk_ <= 200 || g_ssc.continue_200_chk != 1 )
		Dprintf("*** CHK%c error <== %8s(%d) %s(%ld) %s(%ld) %s(%ld)" CR,
			t?'B':'A', basenm(file), line, sx, lx, sy, ly, sz, lz ) ;
	if( zssc_chk_ > 200 && g_ssc.continue_200_chk == 0) {
		if( zssc_mark_set_flag ) longjmp( zssc_mark, -1 ); /* setjmp()Ăяoʒu-1Ŗ߂ NT020223 */
/*		zssc_free(); exit(99); NT020223 */
	}
	return(1);
}
/*	ID_chk_xy	CHKX()ACHKY()}Nňُ펞̃bZ[WóBQOOĂ΂Ǝs~
*******************************************************************/
int zssc_chk_xy  (int t,double lx,double ly,double lz,char *file,int line,char *sx,char *sy,char *sz )
{
	/* CHKG[QOO 0:I 1:Ȃ(o͂) 2:Ȃ(100so)NT030304add */
	if( zssc_chk_ <= 200 || g_ssc.continue_200_chk != 1 )
		Dprintf("*** CHK%c error <== %8s(%d) %s(%.19e) %s(%.19e) %s(%.19e)" CR,
			t?'Y':'X', basenm(file), line, sx, lx, sy, ly, sz, lz ) ;
	if( zssc_chk_ > 200 && g_ssc.continue_200_chk == 0) {
		if( zssc_mark_set_flag ) longjmp( zssc_mark, -1 ); /* setjmp()Ăяoʒu-1Ŗ߂ NT020223 */
/*		zssc_free(); exit(99); NT020223 */
	}
	return(1);
}
/*	ID_ssc_get_chk	CHKG[̎擾
*******************************************************************/
int ssc_get_chk(void)
{
	return(zssc_chk_);
}
/*	ID_ssc_get_chk	CHKG[̐ݒ
*******************************************************************/
int ssc_set_chk(int chk)
{
	zssc_chk_ = chk;
	return 0;
}
/*	ID_trace_ab	֐g[X̃bZ[WóB
*******************************************************************/
int zssc_trace_ab (int type,char *file,int line,int xx )
{
	static char	*arc[] = {" ==>", " -- ", "<== "};
	Dprintf("%s %-8s(%3d) %s", arc[type], basenm(file), line, xx?CR:" ") ;
	return(0);
}
/*	ID_sscfree	mۂ̉iDLLłł͏ʂŊmۂDLLł͉oȂj
*******************************************************************/
int sscfree( void **ptr, char *mes, char *fname, int line)
{
	if( *ptr ) {
		free(*ptr);
		*ptr = NULL;
	}
	return(0);
}

#define KETAMAX 9
/*	ID_keta_marume	ۂ
*******************************************************************/
#if 1
int keta_marume(
	double inum,    // i  ۂߑO̒l
	double *onum,   //  o ۂߌ̒l
	int keta,       // i  ۂߌBۂߌ̏_ȉ̌Bւ̊ۂ߂͂Ow
	int type,       // i  ۂߎʁB0:؂グ 1:ľܓ 2:؂̂
	double epsi)    
{
	static int second = 0;
	int		rc = -1, k, i10;
	static double	marume_fact[KETAMAX+1];
	double	fact, amari;
	                                    CHKB(0, type, 2); CHKB(-9, keta, 9);
	*onum = inum;
	if( keta > KETAMAX || keta < -KETAMAX ) goto                        quit;
	if( second == 0 ) {
	    second = 1;
	    for( k = 0, i10 = 1; k <= KETAMAX; ++k, i10 *= 10 ) {
	        marume_fact[k] = i10;
		}
	}
	if( keta == 0 ) {               //keta = 0 ւ̊ۂ
	    if( type == 0 ) {                   /* ؂グ */
	        *onum = ceil(inum - epsi);
		} else if( type == 1 ) {            /* ľܓ */
	        *onum = floor(inum + 0.5);
		} else if( type == 2 ) {            /* ؂̂ */
	        *onum = floor(inum + epsi);
		}
	} else if( type == 0 ) {                   /* ؂グ */
		if( keta > 0 ) {
		    fact = marume_fact[keta];
			amari = ceil( inum * fact - epsi);
			*onum = amari / fact;
		} else {
		    fact = marume_fact[-keta];
			amari = ceil( inum / fact - epsi);
			*onum = amari * fact;
		}
	} else if( type == 1 ) {            /* ľܓ */
		if( keta > 0 ) {
		    fact = 1.0 / marume_fact[keta];
		} else {
		    fact = marume_fact[-keta];
		}
		amari = fmod( inum, fact );
		if( amari * 2.0 >= fact ) {
			*onum = inum + (fact - amari);
		} else {
			*onum = inum - amari;
		}
	} else if( type == 2 ) {            /* ؂̂ */
		if( keta > 0 ) {
		    fact = marume_fact[keta];
			amari = floor( inum * fact + epsi);
			*onum = amari / fact;
		} else {
		    fact = marume_fact[-keta];
			amari = floor( inum / fact + epsi);
			*onum = amari * fact;
		}
//		amari = fmod( inum + delta, fact ) - delta;
//		*onum = inum - amari;
	}
	//`FbNpiQsOɂȂȂB10**(-18)̒lƂȂj
//	amari = fmod( *onum, 1e-8 ); CHKY(0.0, amari, 0.0);
//	amari = fmod( 0.1, 1e-8 ); CHKY(0.0, amari, 0.0);
	rc = 0;
quit:
	return rc;
}
#else
int keta_marume(
	double inum,    // i  ۂߑO̒l
	double *onum,   //  o ۂߌ̒l
	int keta,       // i  ۂߌBۂߌ̏_ȉ̌Bւ̊ۂ߂͂Ow
	int type,       // i  ۂߎʁB0:؂グ 1:ľܓ 2:؂̂
	double epsi)    
{
	static int second = 0;
	int		rc = -1, k;
	static double	marume_fact[KETAMAX+1];
	static double	marume_fact2[KETAMAX+1];
	double	fact, amari, delta;
	                                    CHKB(0, type, 2);
	if( second == 0 ) {
	    second = 1;
	    for( k = 0, fact = 1.0; k <= KETAMAX; ++k, fact *= 10.0 ) {
	        marume_fact[k] = fact;
	        marume_fact2[k] = 1.0 / fact;
		}
	}
	*onum = inum;
	if( keta > KETAMAX || keta < -KETAMAX ) goto                        quit;
	if( keta > 0 ) {
	    fact = marume_fact2[keta];
	} else if( keta < 0 ) {
	    fact = marume_fact[-keta];
	} else {                        //keta = 0 ւ̊ۂ
	    if( type == 0 ) {                   /* ؂グ */
	        *onum = ceil(inum - epsi);
		} else if( type == 1 ) {            /* ľܓ */
	        *onum = floor(inum + 0.5);
		} else if( type == 2 ) {            /* ؂̂ */
	        *onum = floor(inum + epsi);
		}
	    rc = 0;
	    goto                                                quit;
	}
	delta = epsi * fact;
	if( type == 0 ) {                   /* ؂グ */
		amari = fmod( inum - delta, fact ) + delta;
		*onum = inum + (fact - amari);
	} else if( type == 1 ) {            /* ľܓ */
		amari = fmod( inum, fact );
		if( amari * 2.0 >= fact ) {
			*onum = inum + (fact - amari);
		} else {
			*onum = inum - amari;
		}
	} else if( type == 2 ) {            /* ؂̂ */
		amari = fmod( inum + delta, fact ) - delta;
		*onum = inum - amari;
	}
	rc = 0;
quit:
	return rc;
}
#endif
/*************************************************************************/
/*  file_X    : cdbgin.c                                                 */
/*  system    : SSC COMMON                                               */
/*  function  : read debug flag DBGFLAG[]                                */
/*  corded by : N.Tsuchiya   1990. 3.29                                  */
/*************************************************************************/
#define 	DBGFLAG zdbgf
//#define 	Dprintf	printf
static char	*fname = "ZMRPDBG.FLG";

/*	ID_zdbgin	fobOtO̓ǂݍ
*******************************************************************/
int zdbgin()
{
	FILE	*fp ;
	int 	i, ng, ch;

	ng = sizeof( DBGFLAG ) / sizeof( DBGFLAG[0] );
    for ( i = 0 ; i < ng ; i++ ) DBGFLAG[i] = 0 ;

	if( (fp = fopen(fname,"r")) != NULL ) {
		for( i = 0 ; (ch = getc(fp)) != EOF && i < ng; )
			if( ch >= '0' && ch <= '9' )  DBGFLAG[i++] = ch - '0' ;
		fclose(fp);
	}
/* print DBGFLAG[] if flags are nat all 0 */
	for( i = 0 ; i < ng ; i++ ) if( DBGFLAG[i] ) break;
	if( i >= ng ) goto                           quit;
	Dprintf(CR "DBGFLAG() = ") ;
	for( i = 0 ; i < ng ; i++ )  {
		Dprintf( "%d", DBGFLAG[i] );
		if     ( i%50 ==49 ) Dprintf( CR "        ");
		else if( i%10 == 9 ) Dprintf( " " );
	}
	Dprintf( CR);
	fflush( stdout );
quit:
	return(0);
}
/*	ID_lrand48	(0,0x7fffffff)Ԃ̈li@j
*******************************************************************/
static unsigned long   X[3] = { 0x5555, 0x5555, 0x5555 }; /* l */
static unsigned short  A[3] = { 0x0005, 0xDEEC, 0xE66D }; /* 搔l */
static unsigned short  C[3] = { 0x0000, 0x0000, 0x000B }; /* l */
long lrand48() /* NT031022add */
{
    unsigned long 	lrc;
	register unsigned long	z0, z1, z2, *xx = X, smask = 0xffff; /*, smask = 0x7fffffff; */
	register unsigned short  *aa = A;
    do {
    	z2  = xx[2]*aa[2] + C[2];
		z1  = (z2 >> 16) + xx[2]*aa[1] + xx[1]*aa[2];
	    z0  = (z1 >> 16) + xx[0]*aa[2] + xx[1]*aa[1] + xx[2]*aa[0];
		xx[2] = z2 & smask;
		xx[1] = z1 & smask;
		xx[0] = z0 & smask;
        lrc = (xx[1] << 16) + xx[2];
    } while( lrc == 0xFFFFFFFF );
    return( lrc & 0x7FFFFFFF );
}

/* 
 * FILE_X     : dprintf.cpp
 * AUTHOR   : N.Tsuchiya 1999.06.23
 * SYSTEM   : nVXeWCu
 * FUNCTION : 
 * PROTTYPES:
*/

#if 1 || !defined(Dprintf) //NT040113add 1 ||

#include	<stdarg.h>    /* MSVC, MSVC++, HP-UX CC, HP-UX cc -Aa */
static int	fclose_every_time = 1; /* Win3.1 Win95 MSDOSł͂Pǂ */
static char *s_dbgfn = ""; /*  */
static FILE	*s_dfp = NULL;
static int 	second = 0;

/* ID_dbgopen	t@CI[v
********************************************************************/
static int dbgopen( char *mode )
{
	if( s_dfp ) return 0;
#if defined(stdout)
	if( s_dbgfn[0] == 0 ) s_dfp = stdout;
	else                     s_dfp = fopen( s_dbgfn, mode );
#else  /* DLLŕWostdoutgȂƂ */
	if( s_dbgfn[0] == 0 ) s_dbgfn = "dprintf.dbg";
	s_dfp = fopen( s_dbgfn, mode );
#endif
	return( (s_dfp == NULL) ? -1 : 0 );
}
/* ID_dbgclose	t@C̃N[Y
********************************************************************/
static int dbgclose()
{
#if defined(stdout)
	if( s_dfp && s_dfp != stdout ) { fclose( s_dfp ); s_dfp = NULL; }
#else  /* DLLŕWostdoutgȂƂ */
	if( s_dfp  ) { fclose( s_dfp ); s_dfp = NULL; }
#endif
	return(0);
}
/* ID_Dchange_dbgfn	t@C̕ύX
********************************************************************/
int Dchange_dbgfn(char *fname)
{
	if( fname == NULL ) s_dbgfn = "";
	else                s_dbgfn = fname;
	return 0;
}
/* ID_Dopen	t@CI[v
********************************************************************/
int zssc_Dopen(char *fname)
{
	int		rc;
	dbgclose();
	if( s_dbgfn[0] == 0 )   /* NT030227 add */
		s_dbgfn = fname;
	if( fname == NULL ) s_dbgfn = "";
	if( second ) rc = dbgopen( "a" );
	else         rc = dbgopen( "w" );
	if( rc >= 0 ) second = 1;
	else          s_dbgfn = "";
	return( rc );
}
/* ID_Dclose	t@C̃N[Y
********************************************************************/
int zssc_Dclose()
{
	dbgclose();
	second = 0;
	return(0);
}
/* ID_Dstdout_end	Wo͂̏ꍇ݂̂̃Zbg
********************************************************************/
int zssc_Dstdout_end(void)
{
	if( s_dfp == stdout ) {
		second = 0;
		s_dfp = NULL;
	}
	return(0);
}
/* ID_Dprintf	t@Cւ̃vg(vprintf)
********************************************************************/
int zssc_Dprintf( char *szFormat, ... )
{
	int		rc;
	va_list args;
	va_start(args, szFormat);

	if( s_dfp == NULL ) dbgopen( "a" );
	if( s_dfp == NULL ) return( 0 );
	rc = vfprintf( s_dfp, szFormat, args ) ;
	va_end( args ) ;
	if( fclose_every_time ) dbgclose();
	else                    fflush(s_dfp);
	return( rc ) ;
}
char	*errfnm = "ZMRPERR.TXT";

int zsscEprintfClear()
{
//	char	*errfnm = "zmrperr.txt";
	FILE	*errfp = NULL;
	g_ssc.errcnt = 0;
	errfp = fopen( errfnm, "w" );
	if( errfp ) {fclose( errfp ); errfp = NULL;}
	return 0;
}
int zssc_Eprintf( char *errmes )
{
	static int 	second = 0;
	FILE	*errfp = NULL;
//	char	*errfnm = "zmrperr.txt";

	++g_ssc.errcnt;
	if( second ) {
		errfp = fopen( errfnm, "a" );
	} else {
		second = 1;
		errfp = fopen( errfnm, "w" );
	}
	if( errfp == NULL ) {
		fprintf( stderr, "%s", errmes );
	} else {
		fprintf( errfp, "%s", errmes );
		fclose( errfp ); errfp = NULL;
	}
	return( zssc_Dprintf( "*** %s", errmes ) ) ;
}
/* dummy_printf	t@Cւ̃vg(vprintf)
********************************************************************/
int dummy_printf_UNUSED( char *szFormat, ... )
{
	return( 0 ) ;
}

#endif		/* Dprintf */

/*
 * FILE      : xset.cpp
 * SYSTEM    : 
 * FUNCTION  : YW
 * AUTHOR    : N.Tsuchiya  2005.02.17
 */
//static char	*__file =__FILE__;  /* should be copied into all .c files   */
//#include <stdio.h>
//#include <stdlib.h>
//#include <memory.h>
//#include "xset.h"

/*	ID_XSET_CLASS	RXgN^
********************************************************/
XSET_SCOPE XSET_CLASS()
{nowf = x_elem = 0; clear();}
/*	ID_~HEAP_CNAME	fXgN^
********************************************************/
XSET_SCOPE TIL_XSET_CLASS() //fXgN^ '~'gȂnr̂
{}
/*	ID_clear	YWɂ
/*******************************************************************/
void XSET_SCOPE clear( void )
{
	if( nowf > 999999999 ) {
		nowf = 0;
		memset( usef.v, 0, x_elem * sizeof(int) );
	}
	++nowf;
	top_idx = las_idx = -1;
	nz = 0;
	return ;
}
/*	ID_empty	YW̎PAłȂOԂ
/*******************************************************************/
int XSET_SCOPE empty( void )
{
	return (top_idx < 0);
}
/*	ID_resize	YW̔z̊g
/*******************************************************************/
int XSET_SCOPE resize( int size )
{
	int rc;
	if( x_elem < size ) {
		if( (rc = next.resize(size)) < 0 ) goto quit;
		if( (rc = usef.resize(size)) < 0 ) goto quit;
		while( x_elem < size ) usef[x_elem++] = 0;
	}
	rc = 0;
quit:
	return rc;
}
/*	ID_push	YWւ̒ǉB0:vf 1:ǉ <0:gs
/*******************************************************************/
int XSET_SCOPE push( int index )
{
	int rc, size;
	if( x_elem <= index ) {
		size = x_elem * 2;
		if( size <= index ) size = index + 1;
		if( size < 100 ) size = 100;
		if( (rc = resize(size)) < 0 ) goto quit;
	}
	if( usef.v[index] != nowf ) {
		if( las_idx < 0 ) {
			top_idx = index;
		} else {
			next.v[las_idx] = index;
		}
		next.v[index] = -1;
		las_idx = index;
		usef.v[index] = nowf;
		++nz;
		rc = 1;
	} else rc = 0;
quit:
	return rc;
}
/*	ID_top	YW̐擪vfԂ
/*******************************************************************/
int XSET_SCOPE top( void )
{
	return top_idx;
}
/*	ID_pop	YW̐擪vfP폜
/*******************************************************************/
void XSET_SCOPE pop( void )
{
	if( top_idx >= 0 ) {
		--nz;
		if( (top_idx = next.v[top_idx]) < 0 ) las_idx = -1;
	}
}
/*	ID_size	YW̗vfԂ
/*******************************************************************/
int XSET_SCOPE size( void )
{
	return nz;
}
/*	ID_reserved	YW̊mۍϐԂ
/*******************************************************************/
int XSET_SCOPE reserved( void )
{
	return x_elem;
}
