/*
 * FILE      : zfdabgn.cpp	S̊JnvZm[h
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : S̊JnvZm[h
 * AUTHOR    : T.Kurokawa  2004.10.18
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"
/*	ID_zGetSt  VbvATCYAgpƎԎZo
********************************************************/
int zGetSt( ZMRP &g, int afsh, int afsh2, double size, int td, double *st) /* rc >=0: <0:ُ */
{
	double sizewk;

					CHKA(0, afsh, g.fsh.n); CHKA(-1, afsh2, g.fsh2.n); CHKX(0.0, 0.0, size); CHKB(0, td, g.endtd);
	*st = 0.0;  //ZoƎԃNA
	if (afsh2 >= 0) {
		if( afsh2 < g.fsh2.n ) {
			if ((g.fsh2.v[afsh2].fsh != afsh) || 
				 ((td < g.fsh2.v[afsh2].bgnday) || (td > g.fsh2.v[afsh2].endday))) //fshs܂͎wL͈͊OH
				 afsh2 = -1;
		} else {
			 afsh2 = -1;
		}
	}
	if (afsh2 < 0)  {
		for (afsh2 = g.fsh.v[afsh].topfsh2; afsh2>=0; afsh2 = g.fsh2.v[afsh2].fshnext)  { CHKA(0,afsh2,g.fsh2.n);
			//wLJnƗLI͈͓̔H
			if ((g.fsh2.v[afsh2].bgnday <= td) && (td <= g.fsh2.v[afsh2].endday))  
				break;
		}
	}
	if (afsh2 < 0) goto                                                 quit;
	/*I[_[̈ƎԎZo */  CHKX(0.0, 0.0, g.fsh2.v[afsh2].utsize);				
	sizewk = ceil((size - EPSI) / g.fsh2.v[afsh2].utsize); //sizewk=[N/Pʌ]:؂グ
	*st = g.fsh2.v[afsh2].st + g.fsh2.v[afsh2].ct * sizewk;          //ƎԎZo
quit:
	return(afsh2);
}
/*	ID_ShpCapaCal	Vbv}X^capaʔ\͔zɓo^
********************************************************/
int zShpCapaCal(ZMRP &g, int ashm, int acpm,int aclm, int mode)
{
	int rc=0, td;
    int acap;
					CHKA(0,ashm,g.shm.n);CHKA(0,acpm,g.cpm.n); CHKA(0,aclm,g.clm.n);CHKB(1, mode, 2);
    /*\̓R[hiԕʁj */
	for (acap = g.cpm.v[acpm].topcap; acap >= 0; acap = g.cap.v[acap].cpmnext) { CHKA(0,acap,g.cap.n); 
		                                CHKB(0, g.cap.v[acap].bgnday, g.cap.v[acap].endday);
		                                CHKB(0, g.cap.v[acap].endday, g.endtd);
		for (td = g.cap.v[acap].bgnday; td <= g.cap.v[acap].endday; td++) {  //\̓R[h̗LJn`I
			if (g.clm.v[aclm].cal[td] == 1) {//ғH
				if( mode == 1 ) {
					g.shm.v[ashm].capa[td] = g.cap.v[acap].cp_fixtm;//ʔ\́i莞jɓo^
				} else if( mode ==2 ) {
					g.shm.v[ashm].capa[td] = g.cap.v[acap].cp_fixtm + g.cap.v[acap].cp_ovrtm;//ʔ\́i莞{cƁjɓo^
				} 
			} else {
				g.shm.v[ashm].capa[td] = 0.0; //ғȊÓA\=0.0ݒ
			}
		}
	}
	return(rc);
}
/*  ID_zfFukaChkSet	\̓`FbNAאݒ菈
********************************************************/
int zfFukaChkSet(ZMRP &g,   //rc: [x >0:[x <=0:[xꖳ
	int ashm,       // i  Vbv
	double *psize,  // io RςݕחʁAςݎcח
	int *pbgntd,    // io Rς݊Jn
	int *pendtd,    // io RςݏI
	int muriyari,   // i  Iȍ~ 0:ς܂Ȃ 1:Qς
	int honban)     // i  0:Rς 1:{ԎRς
{
	int rc, td, bgntd, endtd;
	double  size, yoryoku, capa;
		               CHKA(0, ashm, g.shm.n); CHKB(0, muriyari, 1); CHKB(0, honban, 1);
	size  = *psize;
	bgntd = *pbgntd;
	if( muriyari ) endtd = g.endtd;
	else           endtd = *pendtd;
	for (td = bgntd; td <= endtd; td++) { //אݒJn`אݒI
		capa = g.shm.v[ashm].capa[td];
		if (capa <= 0.0) continue;     //\͖
		yoryoku = capa - g.shm.v[ashm].fuka[td];
		if( yoryoku > EPSI ) break;
	}
	*pbgntd = td;
	for (; td <= endtd; td++) { //אݒJn`אݒI
		capa = g.shm.v[ashm].capa[td];
		if (capa <= 0.0) continue;     //\͖
		yoryoku = capa - g.shm.v[ashm].fuka[td];
		/*\͗L */                     CHKY(0.0, yoryoku, capa);
//		if (size >= yoryoku) {}       //Ǝ>=(\́|)	<== ̎AsizeM = 0.0ƂȂ̂ŁAs
		if (size > yoryoku + EPSI) {  //Ǝ > (\́|)
			if( honban ) g.shm.v[ashm].fuka[td] = capa; // += (\́|)
			size -= yoryoku;           //ƎԍXV
		} else {                        CHKY(0.0, size, yoryoku);
			if( honban ) {
				if (size > yoryoku - EPSI) //Ǝ = (\́|)
					g.shm.v[ashm].fuka[td] = capa;
				else
					g.shm.v[ashm].fuka[td] += size; //c̍Ǝԁ˕
			}
			size = 0.0;
			break;
		}
	}
	rc = td - *pendtd;  //[x
	*pendtd = td;
	*psize  = size ;
	return rc;
}
/*	ID_ShpFukaCal	Vbv}X^fuka׎Rϔzɓo^
********************************************************/
int zShpFukaCal(ZMRP &g, int ashm)
{
	int i, rc=0, aopo, afsh;
	double opo_size;
	double opo_sizeM;
	int opobgn, opodue, opoodm;
								
	                                    CHKA(0, ashm, g.shm.n);
	zSortOpoBgn(g,ashm); //I[_\[gi\ijˍH\ij\[gj
    g.shm.v[ashm].lastdue = -1; //I[_[ŒxH\
	for( i = 0; i < g.sortw.n; i++ ) {
		aopo = g.sortw.v[i];            CHKA(0, aopo, g.opo.n); //\[ǵAI[_擾
		opo_size = g.opo.v[aopo].size;	CHKY(0.0, 0.0, opo_size);
		opobgn = g.opo.v[aopo].planbgn;  //I[_[\擾
		opodue = g.opo.v[aopo].due;      //I[_[[擾
		opoodm  = g.opo.v[aopo].odm;     //I[_[No.擾 
		afsh = g.opo.v[aopo].fsh;       CHKA(0, afsh, g.fsh.n); //Vbv擾
		if( opobgn < g.today ) opobgn = g.today; //NT041108add
		if (opo_size == 0.0) continue;
		//I[_[0łȂ
		if (zGetSt(g, afsh , -1, opo_size, opobgn, &opo_sizeM) < 0) continue;
 															CHKB(0, opobgn, g.endtd);
#if 1
		rc = zfFukaChkSet(g, ashm, &opo_sizeM, &opobgn, &opodue, 1, 1); CHKB(0, opodue, g.endtd);
		if( ! ISPLUS(opo_sizeM) && g.shm.v[ashm].lastdue < opodue )
			g.shm.v[ashm].lastdue = opodue;  //I[_̍ŒxH\ݒ
#else
		for (td = opobgn; td <= g.endtd; td++) { //I[_[\`J_[Ō㖘
			if (g.shm.v[ashm].capa[td] == 0.0) continue;
			//\͗L
			set_size = g.shm.v[ashm].capa[td] - g.shm.v[ashm].fuka[td];//\́|ݒϕ																								
																CHKY(0.0, 0.0, set_size);
//			if (opo_sizeM >= set_size) {}  //Ǝ>=(\́|)						
			if (opo_sizeM > set_size) {  //Ǝ>=(\́|)						
				opo_sizeM -= set_size;  //ƎԍXV 
				g.shm.v[ashm].fuka[td] += set_size; // += (\́|)
			} else {                    CHKY(0.0, opo_sizeM, set_size);
				g.shm.v[ashm].fuka[td] += opo_sizeM; //c̍Ǝԁ˕
				opo_sizeM = 0.0;
				if (g.shm.v[ashm].lastdue < td) g.shm.v[ashm].lastdue = td;  //I[_̍ŒxH\ݒ
				break;
			}                           CHKY(0.0, g.shm.v[ashm].fuka[td], g.shm.v[ashm].capa[td]);
		}
#endif
		if( ISPLUS(opo_sizeM) ) {
			int wshm = g.fsh.v[afsh].shm;     CHKA(0, wshm, g.shm.n);	
			Esprintf(g.ermes, "zfdabgn.cpp 0010 (opoNo:%d)(%s)(%0.1f)" CR,opoodm, g.shm.v[wshm].shm_cd, opo_size);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "I[_[\͕sG[(opoNo: %d)(VbvF%s)(F%0.1f)" CR,opoodm, g.shm.v[wshm].shm_cd, opo_size); Eprintf(g.ermes); }
		}
	}
	rc = 0;
//quit:
	return(rc);
}
/*	ID_zfDABGN	S̊JnvZm[h
********************************************************/
int zfDABGN( ZMRP &g, int nodtyp, int ashm) /* rc 0: <0:ُ */
{
	int		rc = 0;

	if(zdbgf[99]) {Dprintf("zfDABGN nodtyp(%d) ashm(%d)" CR, nodtyp, ashm); goto quit;}
	if(zdbgf[99]) {TRACEA(0); Dprintf("zfDABGN nodtyp(%d) ashm(%d)" CR, nodtyp, ashm);}
//	                                    CHKA(0, ashm, g.shm.n);
	//SVbv̔\̓R[hLi񐻑Vbv܂ށj
	for (ashm = 0; ashm < g.shm.n; ashm++) {
		if (g.shm.v[ashm].cpm < 0) continue; //\̓R[h
		//\̓R[hL
		zShpCapaCal(g, ashm, g.shm.v[ashm].cpm, g.shm.v[ashm].clm, 1); //W\͌vZ˃Vbv}X^capaʔ\͔zɓo^
		zShpFukaCal(g, ashm);   //\͕׌vZ˃Vbv}X^fuka׎Rϔzɓo^

		if(zdbgf[109]==8) {  //fobO\
			Dprintf("zfDABGN (capa):(fuka) shm=%d"CR,ashm);
			Dprintf("td=000 ");
			for (int td = 0; td <= g.endtd; td++) {
				Dprintf("(%d):(%d) ", (int)g.shm.v[ashm].capa[td], (int)g.shm.v[ashm].fuka[td]);
				if (td%10==9) 	{Dprintf(CR);Dprintf("td=%03d ",td+1);}
			}
			Dprintf(CR);
		}
	}
	rc = 0;
quit:
	if(zdbgf[99]) {TRACEC(0); Dprintf("zfDABGN rc(%d)" CR, rc);}
	return( rc );
}
