/*
 * FILE      : zfsmuasa2.cpp	tvZ(gpVbvATCYɂ銄t)
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : tvZ(gpVbvATCYɂ銄t)
 * AUTHOR    : T.Kurokawa  2004.09.24
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

/*  ID_zfASA_SizeUpdate	ő吔ʍXV
********************************************************/
static int zfASA_SizeUpdate(ZMRP &g, int atsh,int cuday)
{
	int		rc = 0, adlm;
	int		adlm2, afsh, ashm;
	                                    CHKA(0, atsh, g.tsh.n); CHKB(0, cuday, g.endtd);
	if ( atsh < 0 || atsh >= g.tsh.n ) goto                     quit;
	for (adlm = g.tsh.v[atsh].topdlm; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n); //}X^	
		if ( adlm >= g.dlm.n ) goto                             quit;
		afsh  = g.dlm.v[adlm].fsh;      CHKA(0, afsh, g.fsh.n);    //}X^̋Vbv擾
		if ( afsh < 0 || afsh >= g.fsh.n ) continue;
		ashm  = g.fsh.v[afsh].shm;      CHKA(0, ashm, g.shm.n);    //Vbv񂩂Vbv}X^擾
 		if ( ashm < 0 || ashm >= g.shm.n ) continue;
        adlm2 = g.shm.v[ashm].iwk1;     CHKA(-1, adlm2, g.dlm2.n); //Vbv}X^ۑdlm2擾
//		if (adlm2 >= 0) { }              
		if (adlm2 >= 0 && adlm2 < g.dlm2.n )  {               
			                            CHKB(0, cuday, g.dlm2.v[adlm2].endday);
			if (cuday >= g.dlm2.v[adlm2].bgnday) { //ʊԂLJnÍ͈H
				g.shm.v[ashm].dwk2 = g.dlm2.v[adlm2].maxsize;  //ő吔ʁ˃Vbv}X^̃[Nɐݒ
								        CHKX(0.0, g.dlm2.v[adlm2].badr, 100.0);     
				g.shm.v[ashm].dwk1 = 100.0 / (100.0 - g.dlm2.v[adlm2].badr); //ΏۋVbv̗Ǖit擾˃Vbv}X^̃[Nɐݒ
			} else g.shm.v[ashm].dwk2 = 0.0;   //ő吔0.0ݒ
		} else     g.shm.v[ashm].dwk2 = 0.0;   //ő吔0.0ݒ
	}
	rc = 0;
quit:
	return( rc );
}
/*  ID_zfASA_Size	ԕʁ@ʊt
********************************************************/
int zfASA_Size( ZMRP &g, int nodtyp, int atsh) /* rc 0: <0:ُ */
{
	int		rc = 0, aitm, ashm, afsh, atrp2, adlm, adlm2, aodm, iday, lastusetd;
	double	size, dwk2;
	drp1_td	wdrp1;
	trp2_td	*wtrp2;
	int     comstday, comedday;         //ʊJnAʏI
	int     cuday, pre_cuday;           //Ytiړj
	double  maxsize, trp2size;          //ő吔
    int     save_adlm;                  //ő吔ʈȉ̋}X^
//	int     drp1mkflg;                  //DRP1R[h쐬LtO
	char    trp2due[10];
	                                    CHKA(0, atsh, g.tsh.n);
	if ( atsh < 0 || atsh >= g.tsh.n ) goto                     quit;
	aitm = g.tsh.v[atsh].itm;           CHKA(0, aitm, g.itm.n);
	//Vbv}X^iwk1ɁA}X^̐擪dlm2ݒ
	adlm = g.tsh.v[atsh].topdlm;        CHKA(0, adlm, g.dlm.n);   //KS041101
	for ( ; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n);
		if ( adlm >= g.dlm.n ) goto                             quit;
		afsh = g.dlm.v[adlm].fsh;       CHKA(0, afsh, g.fsh.n); //}X^̋Vbv擾
		if ( afsh < 0 || afsh >= g.fsh.n ) continue;
		ashm = g.fsh.v[afsh].shm;       CHKA(0, ashm, g.shm.n); //Vbv񂩂Vbv}X^擾
 		if ( ashm < 0 || ashm >= g.shm.n ) continue;
		adlm2 = g.dlm.v[adlm].topdlm2;  CHKA(0, adlm2, g.dlm2.n);
		g.shm.v[ashm].iwk1 = adlm2;           //}X^̊e擪dlm2==>Vbv}X^Workɕۑ
	}
	zSortTrp2(g, atsh); // vŃ\[g
	comstday = 0;
	comedday = -1;              //ʊJnAʏI
	pre_cuday= 0;       //`FbNp
	//trp2o
	for( atrp2 = g.tsh.v[atsh].toptrp2; atrp2 >= 0; atrp2 = g.trp2[atrp2].daynext ) { CHKA(0, atrp2, g.trp2.n);
		if ( atrp2 >= g.trp2.n ) goto                           quit;
		cuday = g.trp2[atrp2].due;      CHKB(pre_cuday, cuday, g.endtd);
		pre_cuday = cuday;              //`FbNp
		//trp2size = g.trp2[atrp2].size;  CHKY(0.0, EPSI, trp2size);
		trp2size = g.trp2[atrp2].zansize;  CHKY(0.0, EPSI, trp2size);//Change TK041203
		if ((comstday > cuday) || (comedday < cuday)) {  //ړʊԊOH
			//LʊԍXV
			zfASA_ComDayUpdate(g, atsh, cuday, &comstday, &comedday); CHKB(0, comstday, g.endtd); CHKB(0, comedday, g.endtd);
			//ő吔ʍXV
			zfASA_SizeUpdate(g, atsh, cuday);
		}        CHKB(comstday, cuday, comedday);//ړʊԊOI
		save_adlm = -1;
		maxsize = -1.0;
		//}X^Aő吔ʁtrp2vTCYłŏ̍ő吔ʂT
		for (adlm = g.tsh.v[atsh].topdlm; adlm >= 0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n);
			if ( adlm >= g.dlm.n ) goto                         quit;
			afsh  = g.dlm.v[adlm].fsh;  CHKA(0, afsh, g.fsh.n);    //}X^̋Vbv擾
			if ( afsh < 0 || afsh >= g.fsh.n ) continue;
			ashm  = g.fsh.v[afsh].shm;  CHKA(0, ashm, g.shm.n);    //Vbv񂩂Vbv}X^擾
 			if ( ashm < 0 || ashm >= g.shm.n ) continue;
			//##@ô݂̔񐻑VbvH
			if ( zfASA_IsONMShp( g, ashm, afsh, cuday)==1 ) continue;//##@ô݂̔񐻑Vbv̎
            adlm2 = g.shm.v[ashm].iwk1;   CHKA(-1, adlm2, g.dlm2.n); //Vbv}X^ۑdlm2擾
 			if ( adlm2 < 0 || adlm2 >= g.dlm2.n ) continue;
//			if (adlm2 < 0) continue;
			if( cuday < g.dlm2.v[adlm2].bgnday ) continue;  //ԋ}X^̗LJn NT041110add
			dwk2 = g.shm.v[ashm].dwk2;  //ő吔ʂo
			if (dwk2 == 0.0) {          //ő吔=0.0 ͖
				if (save_adlm == -1)    //Ȃ
					save_adlm = adlm;   //AAmaxsize = -1.0 ̂܂
			} else if (dwk2 >= trp2size) { //ő吔 >= trp2vTCY̋}X^A
				if (maxsize > dwk2) {   //ȑO̍ő吔ʂ菬ő吔
					save_adlm = adlm;
					maxsize = dwk2;
				} else if (maxsize == -1.0) { //ő吔ʖݒ̎i܂͍ő吔ʂj
					save_adlm = adlm;
					maxsize = dwk2;
				}
			}
		}                               CHKA(0, atrp2, g.trp2.n);
		//### drp1ǉ
		wtrp2 = &g.trp2[atrp2];
		adlm  = save_adlm;              CHKA(-1, adlm, g.dlm.n);  //size<ő吔 }X^ݒ
		if (adlm >= 0) {
			afsh  = g.dlm.v[adlm].fsh;  CHKA(0, afsh, g.fsh.n);    //}X^̋Vbv擾
			ashm  = g.fsh.v[afsh].shm;  CHKA(0, ashm, g.shm.n);    //Vbv񂩂Vbv}X^擾
			adlm2 = g.shm.v[ashm].iwk1; CHKA(0, adlm2, g.dlm2.n);  //Vbv}X^ۑdlm2擾
//			     CHKB(0, g.dlm2.v[adlm2].bgnday, comstday);  CHKB(comstday, comedday, g.dlm2.v[adlm2].endday);    //KS041101
			// ʐݒiTCY~Ǖitj
			//keta_marume(wtrp2->size * g.shm.v[ashm].dwk1),
			keta_marume((wtrp2->zansize * g.shm.v[ashm].dwk1),
				                     &size, g.itm.v[aitm].round, g.itm.v[aitm].rnd_typ); //Change TK041203
			aodm = wtrp2->odm;          CHKA(-1, aodm, g.odm.n); /*  \ */
			iday = wtrp2->due;          CHKB(0, iday, g.endtd);  /*  v   */
			lastusetd = wtrp2->lastusetd; CHKB(0, lastusetd, g.endtd);  /*  ŏIgp\  */
			/* Drp1R[hǉ */
			if( (rc = zfAddDrp1(g, wdrp1, aodm, adlm, size, iday, atrp2, lastusetd)) < 0 ) goto quit;
		} else { //DRP1R[h쐬itj
			zmd_td2str(g, trp2due, g.trp2[atrp2].due); CHKA(0, atrp2, g.trp2.n);
			ashm = g.tsh.v[atsh].shm;   CHKA(0, ashm, g.shm.n);	
			if ( ashm < 0 || ashm >= g.shm.n ) continue;
			Esprintf(g.ermes, "zfsmuasa2.cpp 0010 (%s) (%s) (%s)" CR, g.shm.v[ashm].shm_cd, g.itm.v[aitm].itm_cd, trp2due);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "ΏۊtVbv(gpVbvF%s)i(%s)(vF%s)܂ł" CR, g.shm.v[ashm].shm_cd, g.itm.v[aitm].itm_cd, trp2due); Eprintf(g.ermes); }
		}
	}//trp2oI
	rc = 0;
quit:
	return( rc );
}
