/*
 * FILE      : zfsmuasa4.cpp	tvZ(]݌ɍlɂ銄t)
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : tvZ(]݌ɍlɂ銄t)
 * AUTHOR    : T.Kurokawa  2004.11.24
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

/*  ID_zfASA_ONH_Hiki ݌Ɉ(OK:1,݌ɖ:0,NG:-1)
************************************************************************/
static int zfASA_ONH_Hiki( ZMRP &g, int afsh, int adlm, double *size_onh )
{
	int rc = 0;
	int aonh, afto, adrp1;
														CHKA(0, afsh, g.fsh.n); CHKA(0, adlm, g.dlm.n);

	for( aonh = g.fsh.v[afsh].toponh; aonh >= 0 ; aonh = g.onh.v[aonh].next ) {	CHKA(0, aonh, g.onh.n);
		if( aonh >= g.onh.n ) goto                                      error;
		if ( ISZERO( g.onh.v[aonh].size ) ) continue;
														CHKY(0.0, g.onh.v[aonh].size, g.onh.v[aonh].size);
		(*size_onh) = g.onh.v[aonh].size;  //݌ɗʎ擾
		//݌ɂoɗ\
		for (afto = g.dlm.v[adlm].topfto; afto>=0; afto = g.fto.v[afto].dlmnext) { CHKA(0, afto, g.fto.n); 
														CHKY(0.0, g.fto.v[afto].size, g.fto.v[afto].size);
			(*size_onh) = ISPLUS((*size_onh) - g.fto.v[afto].size) ?  (*size_onh) - g.fto.v[afto].size : 0.0;
		}
		//݌ɂ쐬Drp1
		for (adrp1 = g.dlm.v[adlm].topdrp1o; adrp1>=0; adrp1 = g.drp1[adrp1].dlmodaynext) { CHKA(0, adrp1, g.drp1.n);
														CHKY(0.0, g.drp1[adrp1].size, g.drp1[adrp1].size);
			(*size_onh) = ISPLUS((*size_onh) - g.drp1[adrp1].size) ?  (*size_onh) - g.drp1[adrp1].size : 0.0; 
		}
				CHKB(-1,g.onh.v[aonh].next,-1);
		break;
	}
	if ( ISZERO((*size_onh)) ) rc = 0;
	else	rc = 1;
quit:
	return( rc );
error:
	rc = -1;
	goto  quit;
}
/*  ID_zfASA_Onh	]݌ɍlɂ銄t
********************************************************/
int zfASA_Onh( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh) /* rc 0: <0:ُ */
{
	int		rc = 0, afsh, atrp2, adlm, adlm2, aodm, iday, lastusetd;
	double	size, size_onh;
	drp1_td	wdrp1;
	trp2_td	*wtrp2;
	int     comstday, comedday;               //ʊJnAʏI
	int     cuday, pre_cuday;                 //Ytiړj
	double  trp2size, mkdrp1size;	//
	int     drp1mkflg;                        //DRP1R[h쐬LtO
	char    trp2due[10];
	                                    CHKA(0, ashm, g.shm.n); CHKA(0, aitm, g.itm.n); CHKA(0, atsh, g.tsh.n);
	if ( atsh < 0 || atsh >= g.tsh.n || aitm < 0 || aitm >= g.itm.n ) goto                     quit;
	
	//Vbv}X^iwk1ɁA}X^̐擪dlm2ݒ
	adlm = g.tsh.v[atsh].topdlm;        CHKA(0, adlm, g.dlm.n);

	for ( ; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n);
		if ( adlm >= g.dlm.n ) goto                     quit;
		afsh = g.dlm.v[adlm].fsh;       CHKA(0, afsh, g.fsh.n);  //}X^̋Vbv擾
		if ( afsh < 0 || afsh >= g.fsh.n ) continue;
		ashm = g.fsh.v[afsh].shm;       CHKA(0, ashm, g.shm.n);  //Vbv񂩂Vbv}X^擾
		if ( ashm < 0 || ashm >= g.shm.n ) continue;
		adlm2 = g.dlm.v[adlm].topdlm2;  CHKA(0, adlm2, g.dlm2.n);
		g.shm.v[ashm].iwk1 = adlm2;           //}X^̊e擪dlm2==>Vbv}X^Workɕۑ
	}

	zSortTrp2(g, atsh); // vŃ\[g
	comstday = 0;
	comedday = -1;      //ʊJnAʏI
	pre_cuday= 0;       //`FbNp
	drp1mkflg = 0;
	size_onh = 0.0;     //݌ɐI

	//}X^@݌Ɂ|ioɗ\+drp1j
	for (adlm = g.tsh.v[atsh].topdlm; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n);
		if ( adlm >= g.dlm.n ) goto                    quit;
		afsh = g.dlm.v[adlm].fsh;   CHKA(0, afsh, g.fsh.n);    //}X^̋Vbv擾
		if ( afsh < 0 || afsh >= g.fsh.n ) continue;
		ashm = g.fsh.v[afsh].shm;   CHKA(0, ashm, g.shm.n);    //Vbv񂩂Vbv}X^擾
		if ( ashm < 0 || ashm >= g.shm.n ) continue;
		g.shm.v[ashm].dwk3 = -1.0;
		if ( zfASA_ONH_Hiki( g, afsh, adlm, &size_onh )==0) { //##@݌ɋyѓoɗ\荷
			g.shm.v[ashm].dwk3 = 0.0;
			continue;
		} else { g.shm.v[ashm].dwk3 = size_onh; } //݌ɗʕۑ
	}
	//trp2o
	for( atrp2 = g.tsh.v[atsh].toptrp2; atrp2 >= 0; atrp2 = g.trp2[atrp2].daynext ) { CHKA(0, atrp2, g.trp2.n);
		if ( atrp2 >= g.trp2.n ) goto                    quit;
		cuday = g.trp2[atrp2].due;      CHKB(pre_cuday, cuday, g.endtd);
		pre_cuday = cuday;              //`FbNp
		trp2size = g.trp2[atrp2].size;  //trp2v擾I

		if( ! ISPLUS(trp2size) ) continue;
		if ((comstday > cuday) || (comedday < cuday)) {  //ړʊԊOH
			//LʊԍXV
			zfASA_ComDayUpdate(g, atsh, cuday, &comstday, &comedday); CHKB(0, comstday, g.endtd); CHKB(0, comedday, g.endtd);
			//D揇ʍXV
			zfASA_PrtyUpdate(g, atsh, cuday);
			//##D揇ʏɋ}X^\[g
			if( (rc = zsortdlmp(g, atsh)) < 0 ) goto                    quit;
			if(zdbgf[109]==9) {  //fobO\
				for ( adlm = g.tsh.v[atsh].topdlm; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) {
					afsh = g.dlm.v[adlm].fsh; ashm = g.fsh.v[afsh].shm; adlm2 = g.shm.v[ashm].iwk1;
					double xx = g.dlm2.v[adlm2].haibun;
					double yy = g.shm.v[ashm].dwk2;
					Dprintf("zfASA_Onh g.dlm2.v(%d).haibun: %f"CR,adlm2, xx);
					Dprintf("zfASA_Onh  g.shm.v(%d).dwk2  : %f"CR,ashm, yy);
				}
			}
		}                               CHKB(comstday, cuday, comedday); //ړʊԊOI
		//}X^
		for (adlm = g.tsh.v[atsh].topdlm; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n);
			if ( adlm >= g.dlm.n ) goto                    quit;
			afsh = g.dlm.v[adlm].fsh;   CHKA(0, afsh, g.fsh.n);    //}X^̋Vbv擾
			if ( afsh < 0 || afsh >= g.fsh.n ) continue;
			ashm = g.fsh.v[afsh].shm;   CHKA(0, ashm, g.shm.n);    //Vbv񂩂Vbv}X^擾
			if ( ashm < 0 || ashm >= g.shm.n ) continue;
			adlm2 = g.shm.v[ashm].iwk1;   CHKA(-1, adlm2, g.dlm2.n); //Vbv}X^ۑdlm2擾
			if (adlm2 < 0 || adlm2 >= g.dlm2.n ) continue;
			if( cuday < g.dlm2.v[adlm2].bgnday ) continue;  //ԋ}X^̗LJn

			if ( zfASA_IsONMShp( g, ashm, afsh, cuday)==0 ) continue; //ô݂̔񐻑Vbvł͖
														CHKY(0.0, 0.0, g.shm.v[ashm].dwk3);
			if ( ISZERO(g.shm.v[ashm].dwk3) ) continue; //݌ɗʂO
			size_onh = g.shm.v[ashm].dwk3;  CHKX(0.0, 0.0, g.shm.v[ashm].dwk3);
			if ( ISPLUS( trp2size - size_onh ) ) {
					trp2size -= size_onh;
					mkdrp1size = size_onh;
					size_onh = 0.0;
			} else {
					size_onh -= trp2size;
					mkdrp1size = trp2size;
					trp2size = 0.0;
			}
			g.shm.v[ashm].dwk3 = size_onh; CHKY(0.0, 0.0, g.shm.v[ashm].dwk3); CHKY(0.0, 0.0, trp2size);
			g.trp2[atrp2].zansize =  trp2size;  //trp2.zansize <--- tcvʐݒI
			if ( ISPLUS(mkdrp1size) ) {
				wtrp2 = &g.trp2[atrp2];
				//adlm = save_adlm;           CHKA(0, adlm, g.dlm.n);  // }X^ݒ
				afsh  = g.dlm.v[adlm].fsh;  CHKA(0, afsh, g.fsh.n);   //}X^̋Vbv擾
				ashm  = g.fsh.v[afsh].shm;  CHKA(0, ashm, g.shm.n);   //Vbv񂩂Vbv}X^擾
				adlm2 = g.shm.v[ashm].iwk1; CHKA(0, adlm2, g.dlm2.n); //Vbv}X^ۑdlm2擾
											CHKB(0, g.dlm2.v[adlm2].bgnday, cuday);
				// ʐݒiTCY~Ǖitj
											CHKY(1.0, g.shm.v[ashm].dwk1, 10.0);
				keta_marume((mkdrp1size * g.shm.v[ashm].dwk1),
										&size,g.itm.v[aitm].round, g.itm.v[aitm].rnd_typ);
				aodm = wtrp2->odm;          CHKA(-1, aodm, g.odm.n); /* \ */
				iday = wtrp2->due;          CHKB(0, iday, g.endtd);  /* v   */
				lastusetd = wtrp2->lastusetd; CHKB(0, lastusetd, g.endtd);  /*  ŏIgp\  */
				/* Drp1R[hǉ */
				if ((rc = zfAddDrp1(g, wdrp1, aodm, adlm, size, iday, atrp2, lastusetd)) < 0 ) goto quit;
			} else  {                        //CHKA(0, atrp2, g.trp2.n);
				zmd_td2str(g, trp2due, g.trp2[atrp2].due);
				int wtsh = g.trp2[atrp2].tsh;   CHKA(0, wtsh, g.tsh.n);
				if ( wtsh < 0 || wtsh >= g.tsh.n ) continue;
				int wshm = g.tsh.v[wtsh].shm;     CHKA(0, wshm, g.shm.n);	
				if ( wshm < 0 || wshm >= g.shm.n ) continue;
				Esprintf(g.ermes, "zfsmuasa4.cpp 0010 (%s) (%s)" CR, g.shm.v[wshm].shm_cd, trp2due);
				Eprintf(g.ermes);
				if( g.jmf ) {
					Esprintf(g.ermes, "ΏۊtVbv(gpVbvF%s)(vF%s)܂ł" CR,g.shm.v[wshm].shm_cd,trp2due);
					Eprintf(g.ermes);
				}
			}
			if ( ISZERO(size_onh) ) continue;  //݌ɖ--->̋Vbv
			else  break;  //̃bg
		} //}X^
	}//trp2oI
	rc = 0;
quit:
	return( rc );
}
