/*
 * FILE     : zgcall.cpp	m[h쐬f[^i[
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * FUNCTION	: m[h쐬f[^i[
 * AUTHOR   : 2004.08.02 s.kobayashi
 */
static char *__file = (char*)__FILE__ ;
#include			"zg.h"
#include			"zgsscp.h"
/* _~[̋@\W[ */
int fSSOAA1(int type, int ptm, int shp, int bgntd, int endtd)
{
	const char	*typenm = "", *typecmt = "" ;
	                                    CHKA(0, type, zg.n.ft);
	if( type >= 0 && type < zg.n.ft ) {
		if( zg.ft[type].typenm ) typenm = zg.ft[type].typenm;
		if( zg.ft[type].typecmt ) typecmt = zg.ft[type].typecmt;
	}
	Dprintf("fSSOAA1: ptm(%3d) shp(%3d) type(%2d %-8s %s) " CR, ptm, shp, type, typenm, typecmt);
	fprintf(zg.lfp, "fSSOAA1: ptm(%3d) shp(%3d) type(%2d %-8s %s) " CR, ptm, shp, type, typenm, typecmt);
	return( 0 );
}
int zgcall_func(ZMRP &g, int inod, int tdbgn, int tdend )
{
	int		rc = 0, nodtyp, aitm, ashm, atsh, afsh, bgntd, endtd;
	struct nod_s *wnod ;
										   CHKA(0, inod, zg.n.snod);
	if(DBG[30]>1) TRACEA(0), Dprintf("zgcall_func: inod(%d) tdbgn(%d) tdend(%d) " CR, inod, tdbgn, tdend) ;
	if( inod >= zg.n.snod ) goto err1;
	bgntd  = tdbgn;
	endtd  = tdend;
	wnod   = ZG_SNOD(inod) ;
	nodtyp = wnod->type;				CHKA(0, nodtyp, MAX_NODE_TYPE);
	aitm   = wnod->ptm;
	ashm   = wnod->shp;
	atsh = afsh = -1;

//	clock_t start = clock();
#if 1 ||!defined(ZGUNIT_TEST)
	/* nodtyp̎(SSOAA1)zgdef.hŒ`Ă */
	if       ( nodtyp == SMSDMA1 ) { rc = zfSMSDMA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSGMA1 ) { rc = zfSMSGMA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSGOA1 ) { rc = zfSMSGOA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSGPA1 ) { rc = zfSMSGPA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSGRA1 ) { rc = zfSMSGRA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSLAA1 ) { rc = zfSMSLAA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSLOA1 ) { rc = zfSMSLOA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSLSA1 ) { rc = zfSMSLSA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSNEA1 ) { rc = zfSMSNEA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSNMA1 ) { rc = zfSMSNMA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSTLA1 ) { rc = zfSMSTLA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SMSTOA1 ) { rc = zfSMSTOA1( g, nodtyp, ashm, aitm, afsh);

	} else if( nodtyp == SMUASA1 ) { rc = zfSMUASA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SMUBMA1 ) { rc = zfSMUBMA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SMULSA1 ) { rc = zfSMULSA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SMUNEA1 ) { rc = zfSMUNEA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SMUTLA1 ) { rc = zfSMUTLA1( g, nodtyp, ashm, aitm, afsh);

	} else if( nodtyp == SWSDMA1 ) { rc = zfSWSDMA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSGMA1 ) { rc = zfSWSGMA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSGOA1 ) { rc = zfSWSGOA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSGRA1 ) { rc = zfSWSGRA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSLAA1 ) { rc = zfSWSLAA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSLOA1 ) { rc = zfSWSLOA1( g, nodtyp, ashm, aitm, afsh);

	} else if( nodtyp == SWSNMA1 ) { rc = zfSWSNMA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSGPA1 ) { rc = zfSWSGPA1( g, nodtyp, ashm, aitm, afsh);
	
	} else if( nodtyp == SWSLSA1 ) { rc = zfSWSLSA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSNEA1 ) { rc = zfSWSNEA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSTLA1 ) { rc = zfSWSTLA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWSTOA1 ) { rc = zfSWSTOA1( g, nodtyp, ashm, aitm, afsh);
	} else if( nodtyp == SWUASA1 ) { rc = zfSWUASA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SWUBMA1 ) { rc = zfSWUBMA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SWUDMA1 ) { rc = zfSWUDMA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SWULSA1 ) { rc = zfSWULSA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SWUNEA1 ) { rc = zfSWUNEA1( g, nodtyp, ashm, aitm, atsh);
	} else if( nodtyp == SWUTLA1 ) { rc = zfSWUTLA1( g, nodtyp, ashm, aitm, afsh);

	} else if( nodtyp == CMSSLA1 ) { rc = zfCMSSLA1( g, nodtyp, ashm, aitm=-1, afsh);
	} else if( nodtyp == DABGN   ) { rc = zfDABGN( g, nodtyp, ashm);  //ŠvZJn_~[m[h ##ChangeByKuro041018
	} else if( nodtyp == DPBGN   ) { rc = 0;	//iڌvZJn_~[m[h
	} else if( nodtyp == DPEND1  ) { rc = 0;	//iڒPvZI_~[m[h
	} else if( nodtyp == DPEND2  ) { rc = 0;	//iڕvZI_~[m[h
	} else if( nodtyp == DWOEND  ) { rc = 0;	//oɉ\ʏI_~[m[h
	} else if( nodtyp == DUEND   ) { rc = 0;	//iڂ̎gpVbvvZI_~[m[h
	} else if( nodtyp == DWABGN  ) { rc = 0;	// iڂ̑qɃVbvvZJn_~[m[h
	} else if( nodtyp == DW1BGN  ) { rc = 0;	// iڂ̂P̑qɃVbvvZJn_~[m[h
	} else if( nodtyp == DWAEND  ) { rc = 0;	// iڂ̑qɃVbvvZI_~[m[h NT040906add
	} else if( nodtyp == DSBGN   ) { rc = 0;	//iڂ̋VbvvZJn_~[m[h
	} else if( nodtyp == DAEND   ) { rc = 0;	//ŠvZI_~[m[h
	} else { 
		if( g.jmf ) Dprintf("*** zgcall_func: m[h^Cv(%d)s" CR, nodtyp );
		else        Dprintf("*** zgcall_func: unknown node type(%d)" CR, nodtyp );
	}
#endif
quit : //990707
//	tfp = fopen("./time.log","a");
//	fprintf(tfp,"*\t%-8s,%3d,%3d,%d ms" CR,	//*͏WvΏ
//		zg.ft[type].typenm, aitm, ashm, ((int)clock()-start)/1000 );
//	fclose(tfp);
	return( rc );
err1 :
	Esprintf(g.ermes, "inod(%d) >= zg.n.snod(%d)" CR, inod, zg.n.snod ) ;
	Eprintf(g.ermes);
	rc = -1 ; goto quit ;
}
