/*
 * FILE      : zgdmaccess.cpp	f[^₢킹֐Q
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : f[^₢킹֐Q
 * AUTHOR    : T.Kurokawa  2004.09.03
 */
static char __file[] = __FILE__ ;

#if ! defined(ZGUNIT_TEST)
/*+++++++++++++++++++++++++++ {ԗp ++++++++++++++++++++++++++++ */

#include            <stdlib.h>
#include            <memory.h>
#include            <string.h>

#include "z1mrp.h"

/*	ID_zgDumpInt	z̃_v
********************************************************/
static int zgDumpInt(int num, int *ary, char *title)
{
	int i;
	char *ch = CR;
	for( i = 0; i < num; ++i ) {
		Dprintf("%d", ary[i] );
		if( (i % 20) == 0 && i > 0 ) ch = CR;
		else ch = " ";
		Dprintf("%s", ch);
	}
	if( *ch == ' ' ) Dprintf(CR);
	return 0;
}
/*	ID_zfGetTsh	iځAVbvgpVbvԂ
********************************************************/
static int zgGetTsh( ZMRP &g, int aitm, int ashm, int atsh) /* rc 0: <0:ُ */
{
		        CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if( atsh >= 0 ) {
		if( atsh >= g.tsh.n ) {                  CHKA(0, atsh, g.tsh.n);
			atsh = -1;
		} else {
			CHKB(aitm, g.tsh.v[atsh].itm, aitm); CHKB(ashm, g.tsh.v[atsh].shm, ashm);
			if     ( aitm != g.tsh.v[atsh].itm ) atsh = -1;
			else if( ashm != g.tsh.v[atsh].shm ) atsh = -1;
		}
		if( atsh >= 0 ) goto                      quit;
	}
	if( atsh < 0 ) {
		for( atsh = g.itm.v[aitm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext )
			if( ashm == g.tsh.v[atsh].shm ) break;
	}
quit:
	return atsh;
}
#if 0
/*	ID_zfGetFsh	iځAVbv狟VbvԂ
********************************************************/
static int zgGetFsh_UNUSED( ZMRP &g,   /* rc 0: <0:ُ */
	int aitm,          /* i  iڔԍ */
	int ashm,
	int afsh)
{
		        CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if( afsh >= 0 ) {
		if( afsh >= g.fsh.n ) {                  CHKA(0, afsh, g.fsh.n);
			afsh = -1;
		} else {
			CHKB(aitm, g.fsh.v[afsh].itm, aitm); CHKB(ashm, g.fsh.v[afsh].shm, ashm);
			if     ( aitm != g.fsh.v[afsh].itm ) afsh = -1;
			else if( ashm != g.fsh.v[afsh].shm ) afsh = -1;
		}
		if( afsh >= 0 ) goto                      quit;
	}
	if( afsh < 0 ) {
		for( afsh = g.itm.v[aitm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext )
			if( ashm == g.fsh.v[afsh].shm ) break;
	}
quit:
	return afsh;
}
#endif //0
/*	ID_GetPtmNum	iڑ̎擾  0: !=0:G[
***********************************************************************/
int GetPtmNum (ZMRP &g, int *num )
 { 
 	*num = g.itm.n ; 
	if(zdbgf[98]) Dprintf("GetPtmNum num(%d) " CR, *num);
 	return(0) ;
 }
/*	ID_GetUbmNum	U.Uiڑ̎擾  0: !=0:G[
***********************************************************************/
int GetUbmNum (ZMRP &g, int *num )
 { 
 	*num = g.ubm.n ; 
	if(zdbgf[98]) Dprintf("GetUbmNum num(%d) " CR, *num);
 	return(0) ;
 }
/*	ID_GetShpNum	Vbv̑擾  0: !=0:G[
***********************************************************************/
int GetShpNum (ZMRP &g, int *num )
 { 
 	*num = g.shm.n ; 
	if(zdbgf[98]) Dprintf("GetShpNum num(%d) " CR, *num);
 	return(0) ; 
 }
 
/*	ID_GetPtmKo	wiڂ̎qiڂ̏W擾  0: !=0:G[
	́FidxPtm : wi
	      maxAry : o͔zőmې
	óFnumAry : qiڐ
	      aryKo  : qiڔz
***********************************************************************/
int GetPtmKo  (ZMRP &g, int iptm, int maxA, int *numA, int *aKo  )
 {
    int abom, oyitm, koitm, rc;
	*numA = 0;                                    CHKA(0, iptm, g.itm.n);
	int afsh; //AddByKuro040928

	//Vbvw薳̕iڂ̎qiڏW
	g.idxset.clear();
	for( abom = g.itm.v[iptm].topkobm; abom >= 0; abom = g.bom.v[abom].nextko ) { CHKA(0, abom, g.bom.n); 
		oyitm = g.bom.v[abom].oyitm;    CHKB(iptm, oyitm, iptm);
		koitm = g.bom.v[abom].koitm;    CHKA(0, koitm, g.itm.n);
		if( (rc=g.idxset.push(koitm)) < 0 ) goto                       quit;
//		if( *numA < maxA ) aKo[*numA] = koitm;
//		(*numA)++;
	}
	
	//VbvwL̕iڂ̎qiڏW
	for (afsh = g.itm.v[iptm].topfsh;afsh >= 0;afsh = g.fsh.v[afsh].itmnext) { CHKA(0, afsh, g.fsh.n); //AddByKuro040930--->
		if ( g.fsh.v[afsh].topkobm != -1) {
			for ( abom = g.fsh.v[afsh].topkobm; abom>= 0 ; abom = g.bom.v[abom].nextko) {CHKA(0, abom, g.bom.n);
				oyitm = g.bom.v[abom].oyitm;    CHKB(iptm, oyitm, iptm);
				koitm = g.bom.v[abom].koitm;    CHKA(0, koitm, g.itm.n);
				if( (rc=g.idxset.push(koitm)) < 0 ) goto                       quit;
//				if( *numA < maxA ) aKo[*numA] = koitm;
//				(*numA)++;
			}
		}   
	} // <----- AddByKuro040930

	while( (koitm = g.idxset.top()) >= 0 ) {
		g.idxset.pop();
		if( *numA < maxA ) aKo[*numA] = koitm;
		(*numA)++;
	}
	if( *numA > maxA ) { CHKB(0, *numA, maxA); *numA = maxA;}
	rc = 0;
quit:
	if(zdbgf[98]) Dprintf("GetPtmKo iptm(%d) num(%d) " CR, iptm, *numA);
	if(zdbgf[98]>1) {zgDumpInt( *numA, aKo, "GetPtmKo" );}
    return( rc );
 }
#if UNUSED
 /*	GetPtmOya	eiڂ̗LigpHj  0: !=0:G[
***********************************************************************/
int GetPtmOya (ZMRP &g, int iptm, int maxA, int *numA, int *aOya )
{   int i;                                        CHKA(0, iptm, g.itm.n);
	for(*numA=i=0; i<n_bom; ++i) 
        if(bom[i].ko == iptm && *numA < maxA ) aOya[(*numA)++] =bom[i].oya;
    return(0);
}
#endif
/*	ID_GetPtmUshp	wiڂ̎gpVbv̏W擾 0: !=0:G[
	́FidxPtm : wi
	     maxAry : o͔zőmې
	óFnumAry : gpVbv
	     aryUshp: gpVbvz
***********************************************************************/
int GetPtmUshp(ZMRP &g, int iptm, int maxA, int *numA, int *aUshp )
{   int atsh, ashm;
	*numA = 0;                                    CHKA(0, iptm, g.itm.n);
	for( atsh = g.itm.v[iptm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext ) { CHKA(0, atsh, g.tsh.n);
		ashm = g.tsh.v[atsh].shm;       CHKA(0, ashm, g.shm.n);
		if( *numA < maxA ) aUshp[*numA] = ashm;
		(*numA)++;
	}
	if( *numA > maxA ) { CHKB(0, *numA, maxA); *numA = maxA;}
	if(zdbgf[98]) {Dprintf("GetPtmUshp iptm(%d) num(%d) " CR, iptm, *numA);}
	if(zdbgf[98]>1) {zgDumpInt( *numA, aUshp, "GetPtmUshp" );}
    return(0);
}
/*	ID_GetPtmSshp	wiڂ̋Vbv̏W擾 0: !=0:G[
	́FidxPtm : wi
	      maxAry : o͔zőmې
	óFnumAry : Vbv
	      aryKo  : Vbvz
***********************************************************************/
int GetPtmSshp (ZMRP &g, int iptm, int maxA, int *numA, int *aSshp )
{   int afsh, ashm;
	*numA = 0;                                    CHKA(0, iptm, g.itm.n);
	for( afsh = g.itm.v[iptm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext ) { CHKA(0, afsh, g.fsh.n);
		ashm= g.fsh.v[afsh].shm;        CHKA(0, ashm, g.shm.n);
		if( *numA < maxA ) aSshp[*numA] = ashm;
		(*numA)++;
	}
	if( *numA > maxA ) { CHKB(0, *numA, maxA); *numA = maxA;}
	if(zdbgf[98]) {Dprintf("GetPtmSshp iptm(%d) num(%d) " CR, iptm, *numA);}
	if(zdbgf[98]>1) {zgDumpInt( *numA, aSshp, "GetPtmSshp" );}
    return(0);
}
/*	ID_GetPtmOrder	wiڂ̊tDx擾 0: !=0:G[
	 ́FidxPtm : wi
	 óForder  : tDxiݖT|[ĝߑS'0'j
***********************************************************************/
int GetPtmOrder(ZMRP &g, int iptm, int *order )   /* ́AOtŊtDxKvȂ̂H NT040903 */
{	                                              CHKA(0, iptm, g.itm.n);
	*order = g.itm.v[iptm].prty  /*tD揇ʂǗǂ̂ȁH NT040903 */ ; 
	if(zdbgf[98]) {Dprintf("GetPtmOrder iptm(%d) order(%d) " CR, iptm, *order);}
	return(0) ; 
}
/*	ID_GetShpType	wVbṽVbv敪擾 0: !=0:G[
	 ́FidxShp : wANeBreB
	 óFflgType: Vbv敪 qɂ 1:Vbv 2:񐻑Vbv 3:x_Vbv
**********************************************************************/
int GetShpType (ZMRP &g, int ishp, int *fType )
{ 	                                              CHKA(0, ishp, g.shm.n); 
//	*fType = (g.shm[ishp].shm_typ == 2); /*NT040906chg  Vbv敪  1:Vbv 2:񐻑Vbv  */
	/* 1:Vbv 2:񐻑Vbv 3:x_Vbv */
    *fType = g.shm[ishp].shm_typ;                 CHKB(1, *fType, 3);
	if(zdbgf[98]) {Dprintf("GetPtmSshp ishp(%d) fType(%d) " CR, ishp, *fType);}
	return(0) ; 
 }
/*	ID_IsUnusePtm	wiڂ̗L^\擾 0:L 1:
	 ́FidxPtm : wi
**********************************************************************/
int IsUnusePtm(ZMRP &g, int idxPtm) // FS041216A
{
	                                    CHKA(0, idxPtm, g.itm.n);
	return(g.itm.v[idxPtm].unuse_flg);
}
/*	ID_IsHikiate	wiڂƎwVbvtΏۂ̔ 0: !=0:G[
	 ́FidxPtm : wi
	       idxShp : wVbv
	 óFblnHikiate : ]݌ɂ̈֌W(0:Ȃ,1:Ă)
**********************************************************************/
int IsHikiate  (ZMRP &g, int iptm, int ishp, int *blnHikiate ) 
{
	                      CHKA(0, iptm, g.itm.n); CHKA(0, ishp, g.shm.n);
	*blnHikiate = 0 ; /* Vbvoɉ\ʂ̌vZm[h 1: 0:Ȃ */
	if(zdbgf[98]) {Dprintf("IsHikiate iptm(%d) ishp(%d) blnHikiate(%d) " CR, iptm, ishp, *blnHikiate);}
	return(0) ; 
}
/*	ID_IsPhant2	wiڂƃVbvŃt@gw擾 0: !=0:G[
	 ́Fiptm : wi
	       ishp : wVbv
	 óFfPh : t@gtOH
**********************************************************************/
int IsPhant2  (ZMRP &g, int iptm, int ishp, int *fPh)
{
    *fPh = 0 ;            CHKA(0, iptm, g.itm.n); CHKA(0, ishp, g.shm.n);
	//Vbvԍ
#if 0 //
	int afsh, afsh2 ;
	afsh = zgGetFsh( g, iptm, ishp, -1);          CHKA(0, afsh, g.fsh.n);
    if( afsh >= 0 ) {
		afsh2 = g.fsh.v[afsh].topfsh2;            CHKA(0, afsh2, g.fsh2.n);
		if( afsh2 >= 0 ) {
			*fPh = (g.fsh2.v[afsh2].fant == 1) ;
			return 0 ;
		}
	}
#endif //
/* => add NT001215 */
//    for( i=0 ; i<n_ksp ; i++ ) {    //t@gԕi̎AgpVbvVbv̂͂    
//        if( ksp[i].ptm == iptm && ksp[i].spm == ishp ) break ;
//    }
//    if( i<n_ksp ) { *fPh = ksp[i].phant ; return 0 ; }
/* <= add NT001215 */
	if(zdbgf[98]) {Dprintf("IsPhant2 iptm(%d) ishp(%d) fPh(%d) " CR, iptm, ishp, *fPh);}
    return( 0 ) ;
}
/*	ID_IsRc	iڂU.Ui? 0: !=0:G[
**********************************************************************/
int IsRc(ZMRP &g, int iptm, int ishp )
{
	                      
    int rc=0,atsh,aubm; //AddByKuro040930
									CHKA(0, iptm, g.itm.n); CHKA(0, ishp, g.shm.n);

	//Vbvw薳̏ꍇ  ##AddBykuro041001
	for( aubm = g.itm.v[iptm].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew ) { CHKA(0, aubm, g.ubm.n); 
		if (iptm == g.ubm.v[aubm].olditm) {rc = 1; break;}
	}

	//gpVbvԍ AddByKuro040930---->
	atsh = zgGetTsh( g, iptm, ishp, -1);          CHKA(0, atsh, g.tsh.n);
	for( aubm = g.tsh.v[atsh].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew ) { CHKA(0, aubm, g.ubm.n);
		if (iptm == g.ubm.v[aubm].olditm) {rc = 1; break;}
	} //AddByKuro040930--->

	if(zdbgf[98]) {Dprintf("IsRc iptm(%d) ishp(%d) rc(%d) " CR, iptm, ishp, 0);}
    return( rc ) ;
}
/*	ID_IsKuzusi	Vbvɔ\͗L聕R? 0: !=0:G[
**********************************************************************/
int IsKuzusi(ZMRP &g, int iptm, int ishp )
{
	                      
    int rc=0; 
									CHKA(0, iptm, g.itm.n); CHKA(0, ishp, g.shm.n);
	if (( g.shm.v[ishp].cpm >= 0) && (g.shm.v[ishp].kuzusi > 0)) {rc = 1;}

	if(zdbgf[98]) {Dprintf("IsKuzusi iptm(%d) ishp(%d) rc(%d) " CR, iptm, ishp, 0);}
    return( rc ) ;
}
/*	ID_GetFromSoko	qɃVbvishpfromqɂ̃VbvR[h߂ 0: !=0:G[
	 ́Fiptm : wi
	       ishp : wVbv
	 óFary : qɃVbvishpfromqɂ̃Vbvԍz
**********************************************************************/
int GetFromSoko(ZMRP &g, int iptm, int ishp, int maxary, int *numary, int *ary ) 
{	int ashm, atsh, afsh, adlm, shm_typ ;
	*numary = 0;          CHKA(0, iptm, g.itm.n); CHKA(0, ishp, g.shm.n);
	//gpVbvԍ
	atsh = zgGetTsh(g, iptm, ishp, -1);           CHKA(-1, atsh, g.tsh.n);
    if( atsh < 0 ) return 0;
	for( adlm = g.tsh.v[atsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].tshnext ) { CHKA(0, adlm, g.dlm.n);
		afsh = g.dlm.v[adlm].fsh;                 CHKA(0, afsh, g.fsh.n);
		ashm = g.fsh.v[afsh].shm;                 CHKA(0, ashm, g.shm.n);
		shm_typ = g.shm[ashm].shm_typ;            CHKB(1, shm_typ, 3);
		if( shm_typ == 2 ) { /*  Vbv敪  1:Vbv 2:񐻑Vbv  */
            if( *numary < maxary ) ary[*numary] = ashm ;
			(*numary)++;
		}
	}
	if( *numary > maxary ) { CHKB(0, *numary, maxary); *numary = maxary;}
	if(zdbgf[98]) {Dprintf("GetFromSoko iptm(%d) ishp(%d) num(%d) " CR, iptm, ishp, *numary);}
	if(zdbgf[98]>1) {zgDumpInt( *numary, ary, "GetFromSoko" );}
    return 0 ;
}
/*	ID_GetPtmShpNum	iڂƂ́igpVbvAqɁAVbvǰSiڂŏWv 0: !=0:G[
**********************************************************************/
int GetPtmShpNum(ZMRP &g, int *num_ptmshp )
{ 
//	*num_ptmshp = n_ksp+n_osp ; 
	*num_ptmshp = g.fsh.n + g.tsh.n ; 
	if(zdbgf[98]) {Dprintf("GetPtmShpNum  num(%d) " CR, *num_ptmshp);}
	return 0 ;
}
/*	ID_GetPtmRc	gpVbvishp̕iiptmU.Uiڂ̎AViڂ̕iڔԍԂ 0: !=0:G[
**********************************************************************/
int GetPtmRc(ZMRP &g, int iptm, int ishp, int maxary, int *numary, int *ary )
{	int atsh, aubm, newitm;
    *numary = 0 ;          CHKA(0, iptm, g.itm.n); CHKA(-1, ishp, g.shm.n);

	if (ishp==-1)  {//Vbvw薳̏ꍇ  ##AddBykuro041001
		for( aubm = g.itm.v[iptm].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew ) { CHKA(0, aubm, g.ubm.n); 
			newitm = g.ubm.v[aubm].newitm ;           CHKA(0, newitm, g.itm.n);
			if( *numary < maxary ) ary[*numary] = newitm ;
			(*numary)++;
		}
	}
	else { //Vbvw̏ꍇ
		//gpVbvԍ
		atsh = zgGetTsh( g, iptm, ishp, -1);          CHKA(0, atsh, g.tsh.n);
		if (atsh >= 0) {
			for( aubm = g.tsh.v[atsh].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew ) { CHKA(0, aubm, g.ubm.n);
				newitm = g.ubm.v[aubm].newitm ;           CHKA(0, newitm, g.itm.n);
				if( *numary < maxary ) ary[*numary] = newitm ;
				(*numary)++;
			}
		}
	}
	if( *numary > maxary ) { CHKB(0, *numary, maxary); *numary = maxary;}
	if(zdbgf[98]) {Dprintf("GetPtmRc iptm(%d) ishp(%d) num(%d) " CR, iptm, ishp, *numary);}
	if(zdbgf[98]>1) {zgDumpInt( *numary, ary, "GetPtmRc" );}
    return 0 ;
}
/*	ID_GetFromShp	Vbv̋Vbv擾 0: !=0:G[
**********************************************************************/
int GetFromShp(ZMRP &g, int iptm, int to_shp, int maxary, int *numary, int *ary )
{	int ashm, atsh, afsh, adlm ;
	*numary = 0;          CHKA(0, iptm, g.itm.n); CHKA(0, to_shp, g.shm.n);
	//gpVbvԍ
	atsh = zgGetTsh(g, iptm, to_shp, -1);         CHKA(0, atsh, g.tsh.n);
    if( atsh < 0 ) return 0;
	for( adlm = g.tsh.v[atsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].tshnext ) { CHKA(0, adlm, g.dlm.n);
		afsh = g.dlm.v[adlm].fsh;                 CHKA(0, afsh, g.fsh.n);
		ashm = g.fsh.v[afsh].shm;                 CHKA(0, ashm, g.shm.n);
//		if( g.shm[ishp].shm_typ == 2 ) { /*  Vbv敪  1:Vbv 2:񐻑Vbv  */
            if( *numary < maxary ) ary[*numary] = ashm ;
			(*numary)++;
//		}
	}
	if( *numary > maxary ) { CHKB(0, *numary, maxary); *numary = maxary;}
	if(zdbgf[98]) {Dprintf("GetFromShp iptm(%d) ishp(%d) num(%d) " CR, iptm, to_shp, *numary);}
	if(zdbgf[98]>1) {zgDumpInt( *numary, ary, "GetFromShp" );}
    return 0 ;
}
#else //! defined(ZGUNIT_TEST)
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*+++++++++++++++++++++++++++ P̃eXgp ++++++++++++++++++++++++++++ */
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

#include            <stdlib.h>
#include            <memory.h>
#include            <string.h>
#include            "zg.h"
#include            "zgsscp.h"
#include			"zgdummy.h"

/*	GetPtmNum iڑ̎擾  0: !=0:G[
***********************************************************************/
int GetPtmNum (ZMRP &g,  int *num )
 { 
 	*num = n_ptm ; 
 	return(0) ;
 }

/*	GetShpNum Vbv̑擾  0: !=0:G[
***********************************************************************/
int GetShpNum (ZMRP &g,  int *num )
 { 
 	*num = n_spm ; 
 	return(0) ; 
 }
 
 /*	GetPtmKo wiڂ̎qiڂ̏W擾  0: !=0:G[
	́FidxPtm : wi
	      maxAry : o͔zőmې
	óFnumAry : qiڐ
	      aryKo  : qiڔz
***********************************************************************/
int GetPtmKo  (ZMRP &g,  int iptm, int maxA, int *numA, int *aKo  )
 {
    int i; CHKA(0, iptm, n_ptm);
    for(*numA=i=0; i<n_bom; ++i)
        if(bom[i].oya == iptm && *numA < maxA ) aKo[(*numA)++] =bom[i].ko;
    return(0);
 }
 /*	GetPtmOya eiڂ̗LigpHj  0: !=0:G[
***********************************************************************/
int GetPtmOya (ZMRP &g,  int iptm, int maxA, int *numA, int *aOya )
{   int i; CHKA(0, iptm, n_ptm);
    for(*numA=i=0; i<n_bom; ++i)
        if(bom[i].ko == iptm && *numA < maxA ) aOya[(*numA)++] =bom[i].oya;
    return(0);
}
 /*	GetPtmUshp wiڂ̎gpVbv̏W擾 0: !=0:G[
	́FidxPtm : wi
	     maxAry : o͔zőmې
	óFnumAry : gpVbv
	     aryUshp: gpVbvz
***********************************************************************/
int GetPtmUshp(ZMRP &g,  int iptm, int maxA, int *numA, int *aUshp )
{   int i; CHKA(0, iptm, n_ptm);
    for(*numA=i=0; i<n_osp; ++i) 
        if(osp[i].ptm==iptm && *numA < maxA ) aUshp[(*numA)++] =osp[i].spm;
    return(0);
}
 /*	GetPtmSshpwiڂ̋Vbv̏W擾 0: !=0:G[
	́FidxPtm : wi
	      maxAry : o͔zőmې
	óFnumAry : Vbv
	      aryKo  : Vbvz
***********************************************************************/
int GetPtmSshp (ZMRP &g,  int iptm, int maxA, int *numA, int *aSshp )
{   int i; CHKA(0, iptm, n_ptm);
    for(*numA=i=0; i<n_ksp; ++i) 
        if(ksp[i].ptm==iptm && *numA < maxA ) aSshp[(*numA)++] =ksp[i].spm;
    return(0);
}
 /*	GetPtmOrder wiڂ̊tDx擾 0: !=0:G[
	 ́FidxPtm : wi
	 óForder  : tDxiݖT|[ĝߑS'0'j
***********************************************************************/
int GetPtmOrder(ZMRP &g,  int iptm, int *order ) 
{ 
	CHKA(0, iptm, n_ptm); 
	*order = ptm[iptm].prty/*sk */ ; 
	return(0) ; 
}
/*	GetShpType wVbṽVbv敪擾 0: !=0:G[
	 ́FidxShp : wANeBreB
	 óFflgType: Vbv敪
**********************************************************************/
int GetShpType (ZMRP &g,  int ishp, int *fType )
 { 
 	CHKA(0, ishp, n_spm); 
 	*fType = spm[ishp].soko; return(0) ; 
 }
/*	IsHikiate wiڂƎwVbvtΏۂ̔ 0: !=0:G[
	 ́FidxPtm : wi
	       idxShp : wVbv
	 óFblnHikiate : ]݌ɂ̈֌W(0:Ȃ,1:Ă)
**********************************************************************/
int IsHikiate  (ZMRP &g,  int iptm, int ishp, int *blnHikiate ) 
{ 
	*blnHikiate = 1 ; 
	return(0) ; 
}
/*	IsPhant2 wiڂƃVbvŃt@gw擾 0: !=0:G[
	 ́Fiptm : wi
	       ishp : wVbv
	 óFfPh : t@gtOH
**********************************************************************/
int IsPhant2  (ZMRP &g,  int iptm, int ishp, int *fPh)
{   int i ;
    for( i=0 ; i<n_osp ; i++ ) {
        if( osp[i].ptm == iptm && osp[i].spm == ishp ) break ;
    }
    if( i<n_osp ) { *fPh = osp[i].phant ; return 0 ; }
/* => add NT001215 */
    for( i=0 ; i<n_ksp ; i++ ) {    //t@gԕi̎AgpVbvVbv̂͂    
        if( ksp[i].ptm == iptm && ksp[i].spm == ishp ) break ;
    }
    if( i<n_ksp ) { *fPh = ksp[i].phant ; return 0 ; }
    *fPh = 0 ;
/* <= add NT001215 */
    return( -1 ) ;
}
/*	IsRc iڂjO`FWi? 0: !=0:G[
**********************************************************************/
int IsRc(ZMRP &g,  int iptm, int ishp )
{

    return( 0 ) ;
}
/*	GetFromSoko qɃVbvishpfromqɂ̃VbvR[h߂ 0: !=0:G[
	 ́Fiptm : wi
	       ishp : wVbv
	 óFary : qɃVbvishpfromqɂ̃Vbvԍz
**********************************************************************/
int GetFromSoko(ZMRP &g,  int iptm, int ishp, int maxary, int *numary, int *ary ) 
{
    int i ;
    int from_shp;
    *numary = 0 ;
    if( n_sbm > 0 ) { //020123
        for( i=0 ; i<n_sbm ; i++ ) {
            if( sbm[i].to_shp == ishp && sbm[i].ptm == iptm ) {
                from_shp = sbm[i].from_shp ;
                if( spm[from_shp].soko != 1 ) continue ;
                ary[(*numary)++] = sbm[i].from_shp ;
            }
        }
    } else {
        for( i=0 ; i<n_osp ; i++ ) {
            if( osp[i].ptm == iptm && osp[i].spm == ishp ) break ;
        }
        if( i < n_osp ) { //gpVbv̑qɁ@-> Vbv̑qɂ
            for( i=0 ; i<n_ksp ; i++ ) {
                if( ksp[i].ptm == iptm ) {
                    if( spm[ksp[i].spm].soko == 1 ) {
                        if( ksp[i].spm == ishp ) continue ; //
                        if( *numary < maxary ) ary[(*numary)++] = ksp[i].spm ;
                    }
                }
            }
        }
    }   
    return 0 ;
}
/*	GetPtmShpNum iڂƂ́igpVbvAqɁAVbvǰSiڂŏWv 0: !=0:G[
**********************************************************************/
int GetPtmShpNum(ZMRP &g,  int *num_ptmshp )
{ 
	*num_ptmshp = n_ksp+n_osp ; 
	return 0 ;
}
/*	GetPtmRc gpVbvishp̕iiptmjO`FWiڂ̎AViڂ̕iڔԍԂ 0: !=0:G[
**********************************************************************/
int GetPtmRc(ZMRP &g,  int iptm, int ishp, int maxary, int *numary, int *ary )
{
    *numary = 0 ;

    return 0 ;
}
/*	GetFromShp Vbv̋Vbv擾 0: !=0:G[
**********************************************************************/
int GetFromShp(ZMRP &g,  int iptm, int to_shp, int maxary, int *numary, int *ary )
{
    int i ;
    *numary = 0 ;
    if( n_sbm > 0 ) { //020123
        for( i=0 ; i<n_sbm ; i++ ) {
            if( sbm[i].to_shp == to_shp && sbm[i].ptm == iptm ) ary[(*numary)++] = sbm[i].from_shp ;
        }
    } else {
        if( *numary <= 0 ) {
            for( i=0 ; i<n_osp ; i++ ) {
                if( osp[i].ptm == iptm && osp[i].spm == to_shp ) break ;
            }
            if( i < n_osp ) { //gpVbv̑qɁ@-> Vbv̑qɂ
                for( i=0 ; i<n_ksp ; i++ ) {
                    if( ksp[i].ptm == iptm ) {
                        if( spm[ksp[i].spm].soko == 1 ) {
                            if( ksp[i].spm == to_shp ) continue ;   //
                            if( *numary < maxary ) ary[(*numary)++] = ksp[i].spm ;
                        }
                    }
                }
                if( *numary <= 0 ) { //Vbv
                    for( i=0 ; i<n_ksp ; i++ ) {
                        if( ksp[i].ptm == iptm ) {
                            if( spm[ksp[i].spm].soko != 1 ) {
                                if( ksp[i].spm == to_shp ) continue ;   //
                                if( *numary < maxary ) ary[(*numary)++] = ksp[i].spm ;
                            }
                        }
                    }
                }
            }
        }
    }
    return 0 ;
}
int zfCMSSLA1( ZMRP &g, int nodtyp, int ashm)
{	Dprintf("63.zfCMSSLA1 nodtyp(%d) ashm(%d)" CR, nodtyp, ashm); return 0;}
int zfSMSDMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("42.zfSMSDMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSGMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("46.zfSMSGMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSGOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("44.zfSMSGOA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSGPA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("48.zfSMSGPA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSGRA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("43.zfSMSGRA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSLAA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("52.zfSMSLAA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSLOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("41.zfSMSLOA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSLSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("51.zfSMSLSA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("49.zfSMSNEA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSNMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("47.zfSMSNMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMSTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("53.zfSMSTLA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMUASA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf("10.zfSMUASA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMUBMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf(" 4.zfSMUBMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMULSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf(" 8.zfSMULSA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSMUNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf(" 5.zfSMUNEA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSDMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("22.zfSWSDMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSGMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("25.zfSWSGMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSGOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("24.zfSWSGOA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSGRA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("23.zfSWSGRA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSLAA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("30.zfSWSLAA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSLOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf(" 20.zfSWSLOA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSNMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("26.zfSWSNMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSGPA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("27.zfSWSGPA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}

int zfSWSLSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("29.zfSWSLSA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("28.zfSWSNEA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("31.zfSWSTLA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWSTOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh)
{	Dprintf("21.zfSWSTOA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWUASA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf("37.zfSWUASA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWUBMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf("33.zfSWUBMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWUDMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf("32.zfSWUDMA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWULSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf("35.zfSWULSA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}
int zfSWUNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh)
{	Dprintf("34.zfSWUNEA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); return 0;}

#endif //! defined(ZGUNIT_TEST)
