/****************************************************************************************************
 * FILE     : zgnode.cpp	m[h쐬
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * FUNCTION	: m[h쐬
 * AUTHOR   : 2004.08.02 s.kobayashi
 * Editor   : 2004.08.31 T.Kurokawa
 ****************************************************************************************************/
static char __file[] = __FILE__ ;
#include			<memory.h>
#include			"zg.h"
#include			"zgsscp.h"


/*	zgnode: m[h쐬
*/
int  zgnode(ZMRP &g, int graphtype )
{
	int rc=0, iptm, iusp, isok, issp ;
	int j, fPhantomPtm;
	
	if(DBG[12]) TRACEA(0), Dprintf("zgnode:graphtype(%d)" CR,graphtype) ;
	if( graphtype != NGRAPH_SIMPLE ) goto /* Pȏꍇ̃m[h쐬 */    quit;
/* ݌ɗ(ư)̎擾 */
	zg.n.snod = 0 ; 
	zg.n.sedg = 0 ;
	/* ŠvZJn/I_~[m[h */
	if( (zg.g.nDABGN = nod_apd(g, DABGN, -1, -1 )) < 0 ) goto err_nod;	/* DABGN */
//	if( (zg.g.nDNBGN = nod_apd(g, DNBGN, -1, -1 )) < 0 ) goto err_nod;	/* DNBGN */ //##DeleteByKuro
	if( (zg.g.nDAEND = nod_apd(g, DAEND, -1, -1 )) < 0 ) goto err_nod;	/* DAEND */

	zg.g.ebomlnktop = -1 ;	//m[h̕iԃN̐擪edg[]

	/* iڌvZJn/I_~[m[ho^ */
	for( iptm = 0 ; iptm < zg.n.ptm ; iptm++ ) {  //iږɊJnEI_~[m[ho^
		if(IsUnusePtm(g, iptm)) continue; // FS041216A
		if( (zg.ptm[iptm].nDPBGN  = nod_apd(g, DPBGN , iptm, -1 )) < 0 ) goto err_nod ;	/* DPBGN  */
		if( (zg.ptm[iptm].nDPEND2  = nod_apd(g, DPEND2 , iptm, -1 )) < 0 ) goto err_nod ;	//##ChangeByKuro nDPEND->nDPEND2
        if( (zg.ptm[iptm].nDPEND1  = nod_apd(g, DPEND1 , iptm, -1 )) < 0 ) goto err_nod ;	//##AddByKuro040902 DPEND3m[ho^@OK?

        if( edg_apd(g, zg.ptm[iptm].nDPEND1, zg.ptm[iptm].nDPEND2  ) < 0 ) goto err_edg ; //##AddByKuro040902

		fPhantomPtm = 0 ;
		if( zg.ptm[iptm].usptop >= 0 ) { //gpVbv
			for( j=zg.ptm[iptm].usptop ; j>=0 ; j=zg.usp[j].ptmnext ) {
				if( zg.usp[j].fPhantom == 0 ) break ;
			}
			if( j < 0 ) fPhantomPtm = 1 ;	//ׂĂt@g
		} else { //Vbv
			for( j=zg.ptm[iptm].ssptop ; j>=0 ; j=zg.ssp[j].ptmnext ) {
				if( zg.ssp[j].fPhantom == 0 ) break ;
			}
			if( j < 0 )  fPhantomPtm = 2 ;	//ׂĂt@g
		}
#ifdef SUMICHAN //DeleteByKuro
		if( (zg.ptm[iptm].nNPBDA1 = nod_apd(g, NPBDA1, iptm, -1 )) < 0 ) goto err_nod ;	/* altύXm[h  */
#endif SUMICHAN
        //gpVbvvZI_~[m[hVbvvZI_~[m[ho^
		if( (zg.ptm[iptm].nDUEND  = nod_apd(g, DUEND , iptm, -1 )) < 0 ) goto err_nod ;	/* DUEND gpVbvvZI_~[m[ho^ */
		if( (zg.ptm[iptm].nDSBGN  = nod_apd(g, DSBGN , iptm, -1 )) < 0 ) goto err_nod ;	/* DSBGN VbvvZI_~[m[ho^ */
		if( (zg.ptm[iptm].nDWABGN = nod_apd(g, DWABGN, iptm, -1 )) < 0 ) goto err_nod ;	//##AddByKuro040902 DWABGNm[ho^@OK?
		if( (zg.ptm[iptm].nDWAEND = nod_apd(g, DWAEND, iptm, -1 )) < 0 ) goto err_nod ;	//##AddByKuro040902 DWABGNm[ho^@OK?@

		if( edg_apd(g, zg.ptm[iptm].nDUEND, zg.ptm[iptm].nDWABGN  ) < 0 ) goto err_edg ; //##AddByKuro040902
		if( edg_apd(g, zg.ptm[iptm].nDWABGN, zg.ptm[iptm].nDWAEND  ) < 0 ) goto err_edg ; //##AddByKuro040902
		if( edg_apd(g, zg.ptm[iptm].nDWAEND, zg.ptm[iptm].nDSBGN  ) < 0 ) goto err_edg ; //##AddByKuro040902


//		if( edg_apd(g, zg.ptm[iptm].nNPBDA1, zg.ptm[iptm].nDPBGN  ) < 0 ) goto err_edg ;  //##DeleteByKuro

#ifdef SUMICHAN //DeleteByKuro #############################################################################################################
		if( fPhantomPtm == 0 ) {
			if( (zg.ptm[iptm].nSPOASA1 = nod_apd(g, SPOASA1, iptm, -1 )) < 0 ) goto err_nod ;	/* SOASA1 */ 
			if( edg_apd(g, zg.ptm[iptm].nDPBGN , zg.ptm[iptm].nSPOASA1 ) < 0 ) goto err_edg ;
			if( edg_apd(g, zg.ptm[iptm].nSPOASA1, zg.ptm[iptm].nDUEND ) < 0 ) goto err_edg ;           /* NT990417 nDPEND   ; */
		} else if ( fPhantomPtm == 2 ) {
			if( edg_apd(g, zg.ptm[iptm].nDPBGN , zg.ptm[iptm].nDUEND ) < 0 ) goto err_edg ;
		}
#endif //SUMICHAN 폜OK?ByKuro@#######################################################################################################

		if( zg.ptm[iptm].usptop >= 0 ) {   //gpVbvLH
			if( (rc = zgnode_simple_avail(g, iptm )) < 0 ) goto quit ; /* oɉ\ʌvZOtCall !!! */
		}

		/* gpVbvvZOt */
		if( zg.ptm[iptm].usptop >= 0 ) {  //gpVbvLH
			for( iusp = zg.ptm[iptm].usptop; iusp >= 0; iusp = zg.usp[iusp].ptmnext ) {
				if( zg.usp[iusp].fPhantom == 1 ) { //P10FC0/*iځ{gpVbvt@g̏ꍇ */
					if( (rc = zgnode_simple_phantom( iusp )) < 0 ) goto quit ;	/*CHKB(0, 0, rc); */
				} else {
					if( (rc = zgnode_simple_user(g, iusp )) < 0 ) goto quit;		/*CHKB(0, 0, rc); */ //gpVbvvZOt쐬Call!!!
				}
			}
		} else {  /* gpVbv */
			if( edg_apd(g, zg.ptm[iptm].nDPBGN, zg.ptm[iptm].nDUEND  ) < 0 ) goto err_edg ;
		}


		/* qɃVbvvZOt */
		if( zg.ptm[iptm].soktop >= 0 ) {  /* qɃVbvLH */
            /* toq->fromqɃN쐬 */
			//##AddByKuro040901 DWBGN->DW1BGN
			for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) {  //qɃVbvLH
				if( (zg.sok[isok].nDW1BGN = nod_apd(g, DW1BGN, iptm, zg.sok[isok].shp )) < 0 ) goto err_nod ; /*--DW1BGNo^! */ //##ChangeByKuro040901 DWBGN->DW1BGN
			}
			for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) {
				if( (rc = zgnode_simple_soko(g, isok )) < 0 ) goto quit ;   /*CHKB(0, 0, rc); */ //񐻑VbvvZOt쐬Call!!!
			}

			//DWABGNDW1BGNւ̎}쐬
			for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) {
				if( zg.ptm[iptm].nDWABGN < 0 ) continue;         //##ChangeByKuro040902 DWBGN->DWABGN
				if( ZG_SNOD(zg.sok[isok].nDW1BGN)->edgoya < 0 )  //##ChangeByKuro040902 DWBGN->DWABGN
					if( edg_apd(g, zg.ptm[iptm].nDWABGN, zg.sok[isok].nDW1BGN ) < 0 ) goto err_edg ;
			}
			//qɂĂDSBGNɃNȂꍇîݑqɂ̂݁j //##DeleteByKuro040902 DWBGN->DWABGN
			//if( ZG_SNOD(zg.ptm[iptm].nDSBGN)->edgoya < 0 ) {       
			//	if( edg_apd(g, zg.ptm[iptm].nDUEND, zg.ptm[iptm].nDSBGN  ) < 0 ) goto err_edg ;
			//}
		} else {  /* qɃVbv */
			// if( edg_apd(g, zg.ptm[iptm].nDUEND, zg.ptm[iptm].nDSBGN  ) < 0 ) goto err_edg ; //##DeleteByKuro040902 DWBGN->DWABGN
		}


		/* VbvvZOt */
		if( zg.ptm[iptm].ssptop >= 0 ) { /* VbvLH */
			for( issp = zg.ptm[iptm].ssptop; issp >= 0; issp = zg.ssp[issp].ptmnext ) {
				if( zg.ssp[issp].fPhantom == 1 ) {	//ŏʕĩt@g
					if( zg.ptm[iptm].usptop >= 0 ) continue ;
					if( (rc = zgnode_simple_phantom_suply( issp )) < 0 ) goto quit ;   /*CHKB(0, 0, rc); */
				} else {
					if( (rc = zgnode_simple_suply(g, issp )) < 0 ) goto quit;	 /*CHKB(0, 0, rc); */ /* Vbv@Pȏꍇ̌vZOt쐬 Call!! */
				}
			}
			if( ZG_SNOD(zg.ptm[iptm].nDSBGN)->edgko < 0 ) 	//DSBGÑN悪ȂDPEND 
				if( edg_apd(g, zg.ptm[iptm].nDSBGN, zg.ptm[iptm].nDPEND1  ) < 0 ) goto err_edg ;  //##ChangeByKuro nDPEND->nDPEND2
		} else {  /* Vbv */
			/* if( fPhantomPtm != 1 ) Ƃedg_apd()CHKoȂ͂ */
			if( edg_apd(g, zg.ptm[iptm].nDSBGN, zg.ptm[iptm].nDPEND1  ) < 0 ) goto err_edg ;//DSBGN->DPEND  //##ChangeByKuro nDPEND->nDPEND2
		}
	}
	if ((rc = zgnode_simple_bom(g)) < 0 ) goto quit ; /* ChangeByKuro041101 */

	rc = zgnode_complex(g);  //AddByKuro041101
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode:rc(%d)" CR,rc) ;
	return( rc ) ;
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
}

/************************************************************************************************
 * zgnode_simple_avail:	oɉ\ʌvZOt
 *               @@@@                    int iptm:iڔzԍ
*************************************************************************************************/
int  zgnode_simple_avail(ZMRP &g, int iptm ) /* oɉ\ʌvZOt */
{
	int rc=0 ;
	int ishp, isok, issp ;
	//int nodOA1 ; //##DeleteByKuro
	int cot=0;
	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_avail:" CR) ;

	/*	DPBGN->DWOEND܂łLink쐬Jn ========================> */
	if( (zg.ptm[iptm].nDWOEND = nod_apd(g, DWOEND, iptm, -1 )) < 0 ) goto err_nod ;	/* DWOEND oɉ\ʏI_~[m[ho^ */

	for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) { //qɃVbvo^
		if( zg.sok[isok].hikflg == 0 ) continue ;             /* oɉ\ʈΏۂłȂi0:ȂA1:j */
		ishp = zg.sok[isok].shp;                              /* qɃVbvzԍ擾 */
		//if( (nodOA1 = nod_apd(g, SWSOAA1, iptm, ishp )) < 0 ) goto err_nod ;  //##DeleteByKuro
		//if( edg_apd(g, zg.ptm[iptm].nDPBGN, nodOA1 ) < 0 ) goto err_edg ;	  /* DABGN->SSOAA1 */ //##DeleteByKuro
		if( edg_apd(g, zg.ptm[iptm].nDPBGN, zg.ptm[iptm].nDWOEND ) < 0 ) goto err_edg ;	/* DPBGN-->DWOEND(q) */ //##ChangeByKuro
		cot++;
	}

	for( issp = zg.ptm[iptm].ssptop; issp >= 0; issp = zg.ssp[issp].ptmnext ) { //Vbvo^
		if( zg.ssp[issp].hikflg == 0 ) continue ;							/* oɉ\ʈΏۂłȂ */
		if( zg.ssp[issp].fPhantom == 1 ) continue ;                         /* t@giځH */
		ishp = zg.ssp[issp].shp;                                            /* Vbvzԍ擾 */
		//if( (nodOA1 = nod_apd(g, SMSOAA1, iptm, ishp )) < 0 ) goto err_nod ;  //##EditByKuro SPSOAA1->SMSOAA1 */ //##DeleteByKuro
		//if( edg_apd(g, zg.ptm[iptm].nDPBGN, nodOA1 ) < 0 ) goto err_edg ;		/* DABGN->SSOAA1 */ //##DeleteByKuro
		if( edg_apd(g, zg.ptm[iptm].nDPBGN, zg.ptm[iptm].nDWOEND ) < 0 ) goto err_edg ;	/* DPBGN-->DWOEND(q) */ //##ChangeByKuro
		cot++;
	}

	if( cot <= 0 ) //oɉ\@qorVbvLH
		if( edg_apd(g, zg.ptm[iptm].nDPBGN, zg.ptm[iptm].nDWOEND ) < 0 ) goto err_edg ;  /* DPBGN-->DWOEND(q) */

	if( edg_apd(g, zg.ptm[iptm].nDWOEND, zg.ptm[iptm].nDUEND ) < 0 ) goto err_edg ;      /* DWOEND-->DUEND */
	
/*	܂łDPBGN->DWOEND܂łLink쐬I <======================== */
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_avail:rc(%d)" CR,rc) ;
	return( rc ) ;
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
}

/************************************************************************************
 * zgnode_simple_user:	Pȏꍇ̎gpVbvvZOt쐬
+***********************************************************************************/
int  zgnode_simple_user(ZMRP &g, int iusp )
{
	int rc=0, fRc ;
	int iptm, ishp;
	//int nSUBMA1, nSUNEA1, nSUKIA1, nSUNKA1, nSULSA1, nSUASA1, nSUDMA1; //##DeleteByKuro040901
	int nSUBMA1, nSUNEA1, nSULSA1, nSUASA1, nSUTLA1;   //##AddBykuro040901

	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_user:" CR) ;

/****	gpVbv ***/
	iptm = zg.usp[iusp].ptm;  //iڔzԍ
	ishp = zg.usp[iusp].shp;  //Vbvzԍ

  //--------------
	//##DeleteByKuro040901 ---(3).SMUDMA1͍񖢃T|[g
	//if( (nSMUDMA1 = nod_apd(g, SMUDMA1, iptm, ishp )) < 0 ) goto err_nod ;	/* lqo^CvPȉ폜(gpVbv) */ //##EditByKuro SPUDMA1->SMUDMA1
	//---4.SMUBMA1@m[ho^I
	if( (nSUBMA1 = nod_apd(g, SMUBMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[[PgWJP]alWJ  q(TRP1)<==eiFRP2j */ //##EditByKuro SPUBMA1->SMUBMA1
	
  //vZ-------------
    //---5.SMUNEA1@m[ho^I
	if( (nSUNEA1 = nod_apd(g, SMUNEA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgP]vʂvZ (TRP1).ʁ|(݌Ɂ{ɗ\) */ //##EditByKuro SPUNEA1->SMUNEA1
	
	//##DeleteByKuro040901 ---(6).SMUKIA1,(7).SMUNKA1͍񖢃T|[g
	//if( (nSUKIA1 = nod_apd(g, SMUKIA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgP]iڂ`AgpVbvP̉ɗ\𐶐 */ //##EditByKuro SPUKIA1->SMUKIA1
	//if( (nSUNKA1 = nod_apd(g, SMUNKA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgP]iڂ`AgpVbvPł̐vNR2vZ */ //##EditByKuro SPUNKA1->SMUNKA1
	
	//---8.SMULSA1@m[ho^I
	if( (nSULSA1 = nod_apd(g, SMULSA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgP]bgvZ (TRP2)܂Ƃ߃bg<==iTRP1j */ //##EditByKuro SPULSA1->SMULSA1
	//---9.SMUASA1@m[ho^I
	if( (nSUASA1 = nod_apd(g, SMUASA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgtP]tvZ iDRP1j<==iTRP2j */ //##EditByKuro SPUASA1->SMUASA1
    //---10.SMUTLA1@m[ho^I
	if( (nSUTLA1 = nod_apd(g, SMUTLA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgskP][h^CvZ */ //##AddByKuro040907

	//ɗ\ύXlbg`FW
#ifdef SUMICHAN //##DeleteByKuro i񖢎gpj
	if( (nNUOHA1 = nod_apd(g, NPUOHA1, iptm, ishp )) < 0 ) goto err_nod ;	/* ɗ\ύX(gpVbv) */
	zg.usp[iusp].nNUOHA1  = nNUOHA1 ;  /* ɗ\ύX(gpVbv)  */
#endif //SUMICHAN
    //gpVbv}쐬
	if( edg_apd(g, zg.ptm[iptm].nDPBGN,	nSUBMA1	 ) < 0 )			goto err_edg ;  /* DPBGN-->4.SMUBMA1 */  //##ChangeByKuro040901 nSUDMA1->nSUBMA1
	//if( edg_apd(g, nSUDMA1,				nSUBMA1 ) < 0 )				goto err_edg ;  //##DeleteByKuro040901
	if( edg_apd(g, nSUBMA1,				nSUNEA1 ) < 0 )				goto err_edg ;  /* 4.SMUBMA1-->5.SMUNEA1 */
	//if( edg_apd(g, nSUNEA1,				nSUKIA1 ) < 0 )				goto err_edg ;  //##DeleteByKuro 040901
	//if( edg_apd(g, nSUKIA1,				nSUNKA1 ) < 0 )				goto err_edg ;  //##DeleteByKuro 040901
	if( edg_apd(g, nSUNEA1,				nSULSA1 ) < 0 )				goto err_edg ;  /* 5.SMUNEA1-->8.SMULSA1 */ //##ChangeBykuro040901 nSUNKA1->nSUNEA1
	if( edg_apd(g, nSULSA1,				nSUASA1 ) < 0 )				goto err_edg ;  /* 8.SMULSA1-->9.SMUASA1 */
	if( edg_apd(g, nSUASA1,				nSUTLA1 ) < 0 )				goto err_edg ;  /* 9.SMUASA1-->10.SMUTLA1 */  //##ChangeByKuro040907
	if( edg_apd(g, nSUTLA1,				zg.ptm[iptm].nDUEND ) < 0 )	goto err_edg ;  /* 10.SMUTLA1-->DUEND */      //##AddByKuro040907
	//if( edg_apd(g, zg.ptm[iptm].nDWOEND,	nSUKIA1 ) < 0 )				goto err_edg ; //##DeleteByKuro 040901
	//jO`FWȉꍇ if( edg_apd(g, nNUOHA1,				nSUNEA1 ) < 0 )				goto err_edg ;

	fRc = 0;

#ifdef SUMICHAN //DeleteByKuro
	/*	jO`FWiڂ̎ASURCA1쐬 */
	if( zg.ptm[iptm].fRc == 1 ) {
		fRc =  IsRc( iptm, ishp );
	}
	if( fRc == 1 ) {	//jO`FWi
		if( (nSURCA1 = nod_apd(g, SPURCA1, iptm, ishp )) < 0 ) goto err_nod ;	/* [PgRCWJP]iڂ`AgpVbvPł̃jO`FWiWJ */
		if( edg_apd(g, nSUDMA1, nSURCA1 ) < 0 )				goto err_edg ;
		if( edg_apd(g, nSURCA1, nSUNEA1 ) < 0 )				goto err_edg ;
		//jO`FWȉꍇ́Albg`FWJnm[hSUDMA1
		if( edg_apd(g, nNUOHA1, nSUDMA1 ) < 0 )				goto err_edg ;
	} else {
		//jO`FWiŖꍇ́Albg`FWJnm[hSUNEA1
		if( edg_apd(g, nNUOHA1, nSUNEA1 ) < 0 )				goto err_edg ;
	}
#endif //SUMICHAN

/*********	܂łDPBGN->DUEND̃NI ********/
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_user:rc(%d)" CR,rc) ;
	return( rc ) ;
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
}
/*******************************************************************************************
 *zgnode_simple:	Vbv@Pȏꍇ̌vZOt쐬
+*******************************************************************************************/
int  zgnode_simple_suply(ZMRP &g, int issp )
{
	int rc=0 ;
	int iptm, ishp ;
	int	nSSLOA1, nSSTOA1,nSSDMA1, nSSGRA1, nSSGOA1, nSSGMA1, nSSNMA1, nSSNEA1, nSSGPA1, nSSLSA1, nSSTLA1, nSSLAA1;  //##ChangeBykuro040903
	//int /*nNSOHA1, */nNSMPA1; DeleteByKuro040903

	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_suply:" CR) ;
	/* Vbv */
	iptm = zg.ssp[issp].ptm;
	ishp = zg.ssp[issp].shp;
   
   //-----------------------------
	if( (nSSLOA1 = nod_apd(g, SMSLOA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PoP]oɃbg܂Ƃ߃m[h */ //##EditByKuro SPSLOA1->SMSLOA1     //##---40.SMSLOA1 o^
	if( (nSSTOA1 = nod_apd(g, SMSTOA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PsnP]A[h^CvZm[h */ //##AddByKuro040907 //##---41.SMSTOA1 o^
	if( (nSSDMA1 = nod_apd(g, SMSDMA1, iptm, ishp )) < 0 ) goto err_nod ;	/* [PMRP폜P]MRP(FRP1)ȉ폜m[h */ //##EditByKuro SPSDMA1->SMSDMA1 //##---42.SMSDMA1 o^
	if( (nSSGRA1 = nod_apd(g, SMSGRA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP](DRP2)瑍vʃR[h쐬 */ //##EditByKuro SPSGRA1->SMSGRA1 //##---43.SMSGRA1 o^
	if( (nSSGOA1 = nod_apd(g, SMSGOA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PoP]oɗ\肩瑍vʃR[h쐬 */ //##EditByKuro SPSGOA1->SMSGOA1 //##---44.SMSGOA1 o^
	if( (nSSGMA1 = nod_apd(g, SMSGMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP]󒍃I[_瑍vʃR[h쐬 */ //##EditByKuro SPSGMA1->SMSGMA1 //##---46.SMSGMA1 o^
	
   //vZ----------------------------
	if( (nSSNMA1 = nod_apd(g, SMSNMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP]vʂvZm[h */  //##EditByKuro SPSNEA1->SMSNMA1 //##---47.SMSNMA1 o^
	if( (nSSGPA1 = nod_apd(g, SMSGPA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP]Y񂩂瑍vʃR[h쐬 */  //##EditByKuro SPSLSA1->SMSGPA1 //##---48.SMSGPA1 o^
    if( (nSSNEA1 = nod_apd(g, SMSNEA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP]vʂvZm[h  */  //##AddByKuro040902 SMSNEA1 //##---49.SMSNEA1 o^
    if( (nSSLSA1 = nod_apd(g, SMSLSA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP]Ybg܂Ƃ߂vZm[h */  //##AddByKuro040902 SMSLSA1 //##---51.SMSLSA1 o^
    if( (nSSLAA1 = nod_apd(g, SMSLAA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PIP]I[_܂Ƃ߃bgɒǉ */  //##AddByKuro040902 //##---52.SMSLAA1 o^ ChangeBykuro040913
	if( (nSSTLA1 = nod_apd(g, SMSTLA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PskP][h^CvZm[h */  //##AddByKuro040902 SMSTLA1 //##---53.SMSTLA1 o^ ChangeBykuro040913
	

//	if( (nSSLMA1 = nod_apd(g, SPSLMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PP]iڂ`AVbvRł݂̌lor̂lqo쐬 */  //##DeleteByKuro
//	if( (nSSLTA1 = nod_apd(g, SPSLTA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PksP]iڂ`AVbvRł̃[h^CvZ */          //##DeleteByKuro
	//WMPSύXlbg`FW
	//if( (nNSOHA1 = nod_apd(g, NPSOHA1, iptm, ishp )) < 0 ) goto err_nod ;	/* ɗ\ύX(VbvA݂lor) */

#ifdef SUMICHAN //DeleteByKuro
	if( (nNSMPA1 = nod_apd(g, NPSMPA1, iptm, ishp )) < 0 ) goto err_nod ;	/* oׂlorύX(Vbv) */
	zg.ssp[issp].nNSMPA1 = nNSMPA1;
#endif //SUMICHAN

	//Vbv}쐬
	if( edg_apd(g, zg.ptm[iptm].nDSBGN, nSSLOA1 ) < 0 ) goto err_edg ;
	//if( edg_apd(g, zg.ptm[iptm].nDSBGN, nSSDMA1 ) < 0 ) goto err_edg ; //##DeleteByKuro 040902

	if( edg_apd(g, nSSLOA1, nSSTOA1 ) < 0 ) goto err_edg ; /* 40.SMSLOA1-->41.SMSTOA1 */  //##ChangeBykuro040907
	if( edg_apd(g, nSSTOA1, nSSDMA1 ) < 0 ) goto err_edg ; /* 41.SMSTOA1-->42.SMSDMA1 */  //##AddBykuro040907
	if( edg_apd(g, nSSDMA1, nSSGRA1 ) < 0 ) goto err_edg ; /* 42.SMSDMA1-->43.SMSGRA  */
	if( edg_apd(g, nSSGRA1, nSSGOA1 ) < 0 ) goto err_edg ; /* 43.SMSGRA1-->44.SMSGOA1 */  //##ChangeBykuro040902
	if( edg_apd(g, nSSGOA1, nSSGMA1 ) < 0 ) goto err_edg ; /* 44.SMSGOA1-->46.SMSGMA1 */  //##ChangeBykuro040902

	if( edg_apd(g, nSSGMA1, nSSNMA1 ) < 0 ) goto err_edg ; /* 46.SMSGMA1-->47.SMSNMA1 */  //##ChangeBykuro040902
	if( edg_apd(g, nSSNMA1, nSSGPA1 ) < 0 ) goto err_edg ; /* 47.SMSNMA1-->48.SMSGPA1 */  //##ChangeBykuro040902
	if( edg_apd(g, nSSGPA1, nSSNEA1 ) < 0 ) goto err_edg ; /* 48.SMSGPA1-->49.SMSNEA1 */  //##ChangeBykuro040902

	if( edg_apd(g, nSSNEA1, nSSLSA1 ) < 0 ) goto err_edg ; /* 49.SMSNEA1-->51.SMSLSA1 */
	if( edg_apd(g, nSSLSA1, nSSLAA1 ) < 0 ) goto err_edg ; /* 51.SMSLSA1-->52.SMSLAA1 */  //##ChangeBykuro040902 ChangeBykuro040913
	if( edg_apd(g, nSSLAA1, nSSTLA1 ) < 0 ) goto err_edg ; /* 52.SMSLAA1-->53.SMSTLA1 */  //##AddBykuro040903    ChangeBykuro040913

	//if( edg_apd(g, nSSLMA1, nSSLTA1 ) < 0 ) goto err_edg ; //##DeleteBykuro040902
	if( edg_apd(g, nSSTLA1, zg.ptm[iptm].nDPEND1 ) < 0 ) goto err_edg ; /* 53.SMSTLA1-->DPEND2 */ //##ChangeByKuro040903 ChangeBykuro040913


	//if( edg_apd(g, nNSMPA1, nSSDMA1 ) < 0 ) goto err_edg ;  //##DeleteBykuro040902
	//if( edg_apd(g, nNSOHA1, nSSNEA1 ) < 0 ) goto err_edg ;


/*		܂łDSBGN->DPEND̃NI */
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_suply:rc(%d)" CR,rc) ;
	return( rc ) ;
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
}
/*************************************************************************************
 * zgnode_simple:	񐻑Vbv@Pȏꍇ̌vZOt쐬
+************************************************************************************/
int  zgnode_simple_soko(ZMRP &g, int isok )
{
	int rc=0 ;
	int iptm, ishp, j, ifsok ;
	int nSWNEA1, nSWNMA1, nSWGPA1, nSWLOA1,  nSWTOA1, nSWGRA1, nSWGOA1, nSWGMA1, nSWTLA1, nSWDMA1, nSWLSA1, nSWLAA1; //##ChangeByKuro 040903
	int nUWDMA1, nUWBMA1, nUWNEA1, nUWLSA1, nUWASA1, nUWTLA1; //##ChangeByKuro 040907
	int nstart ;

	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_soko: isok(%d)" CR,isok) ;

	iptm = zg.sok[isok].ptm;
	ishp = zg.sok[isok].shp;
	nstart  = zg.sok[isok].nDW1BGN;  //##ChangeByKuro 040901 nDWBGN->nDW1BGN

	if( (zg.sok[isok].usflg & SOKO_S) == SOKO_S ) {	//񐻑Vbv@m[ho^II
		//
		if( (nSWLOA1 = nod_apd(g, SWSLOA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟃oP]oɃbg܂Ƃ߂vZ */ //##---20.SWSLOA1@o^
        if( (nSWTOA1 = nod_apd(g, SWSTOA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟂snP]oɃ[h^CvZ */ //##---21.SWSTOA1@o^
		if( (nSWDMA1 = nod_apd(g, SWSDMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PMRP폜P]FRP1ȉ폜 */        //##---22.SWSDMA1@o^
		if( (nSWGRA1 = nod_apd(g, SWSGRA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟑P](DRP2)瑍vʃR[h쐬 */ //##---23.SWSGRA1 o^
		if( (nSWGOA1 = nod_apd(g, SWSGOA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟑oP]oɗ\肩瑍vʃR[h쐬 */ //##---24.SWSGOA1 o^
		if( (nSWGMA1 = nod_apd(g, SWSGMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟑P]󒍃I[_瑍vʃR[h쐬 */ //##---25.SWSGMA1 o^
		
		//vZ
        if( (nSWNMA1 = nod_apd(g, SWSNMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟐P]vʂvZ|ݐY */ //##---26.SWSNMA1 o^ //##AddByKuro041001
		if( (nSWGPA1 = nod_apd(g, SWSGPA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟑P]Y񂩂瑍vʃR[h쐬 */  //##---27.SWSGPA1 o^ //##AddByKuro041001

		if( (nSWNEA1 = nod_apd(g, SWSNEA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟐P]vʂvZ|ƍ݌ɁEI[_[ */ //##---28.SWSNEA1 o^
        if( (nSWLSA1 = nod_apd(g, SWSLSA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟃oP]oɃbgvZ */ //##---29.SWSLSA1 o^ //##AddByKuro 040901
		if( (nSWLAA1 = nod_apd(g, SWSLAA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟃IP]ƃI[_܂Ƃ߃bgɒǉ */ //##---30.SWSLAA1 o^ //##AddByKuro040903 
		if( (nSWTLA1 = nod_apd(g, SWSTLA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[P񋟂skP][h^CvZ (FRP2)ד */    //##---31.SWSTLA1 o^
		
		
#ifdef SUMICHAN //DeleteByKuro@i񖢃T|[gj
		//oMPSύXlbg`FW
		if( (nNWMPA1 = nod_apd(g, NWSMPA1, iptm, ishp )) < 0 ) goto err_nod ;	/* oׂlorύX(qɃVbv) */
		zg.sok[isok].nNWMPA1 = nNWMPA1 ;
#endif //SUMICHAN //DeleteByKuro

        //-----񐻑Vbv@}쐬II
		if( edg_apd(g, nstart,  nSWLOA1 ) < 0 ) goto err_edg ;    //##---DW1BGN-->20.SWSLOA1
		//if( edg_apd(g, nstart,  nSWDMA1 ) < 0 ) goto err_edg ;  //##DeleteByKuro 040901
		if( edg_apd(g, nSWLOA1, nSWTOA1 ) < 0 ) goto err_edg ;    //##---20.SWSLOA1-->21.SWSTOA1  //##ChangeByKuro 040902
        if( edg_apd(g, nSWTOA1, nSWDMA1 ) < 0 ) goto err_edg ;    //##---21.SWSTOA1-->22.SWSDMA1  //##AddByKuro 040902
		if( edg_apd(g, nSWDMA1, nSWGRA1 ) < 0 ) goto err_edg ;    //##---22.SWSDMA1-->23.SWSGRA1
		
		if( edg_apd(g, nSWGRA1, nSWGOA1 ) < 0 ) goto err_edg ;    //##---23.SWSGRA1-->24.SWSGOA1  //##ChangeByKuro 040901 
        if( edg_apd(g, nSWGOA1, nSWGMA1 ) < 0 ) goto err_edg ;    //##---24.SWSGOA1-->25.SWSGMA1  //##ChangeByKuro 040901 
		
		//if( edg_apd(g, nSWGMA1, nSWNEA1 ) < 0 ) goto err_edg ;    //##---25.SWSGMA1-->26.SWSNEA1

		if( edg_apd(g, nSWGMA1, nSWNMA1 ) < 0 ) goto err_edg ;    //##---25.SWSGMA1-->26.SWSNMA1
		if( edg_apd(g, nSWNMA1, nSWGPA1 ) < 0 ) goto err_edg ;    //##---26.SWSNMA1-->27.SWSGPA1
		if( edg_apd(g, nSWGPA1, nSWNEA1 ) < 0 ) goto err_edg ;    //##---27.SWSGPA1-->28.SWSNEA1
		
		if( edg_apd(g, nSWNEA1, nSWLSA1 ) < 0 ) goto err_edg ;    //##---28.SWSNEA1-->29.SWSLSA1  //##AddByKuro 040901
		if( edg_apd(g, nSWLSA1, nSWLAA1 ) < 0 ) goto err_edg ;    //##---29.SWSLSA1-->30.SWSLAA1  //##ChangeByKuro 040917
		if( edg_apd(g, nSWLAA1, nSWTLA1 ) < 0 ) goto err_edg ;    //##---30.SWSLAA1-->31.SWSTLA1  //##AddByKuro 040917

		nstart = nSWTLA1; //##ChangeByKuro 040917
		//if( edg_apd(g, nNWMPA1, nSWDMA1 ) < 0 ) goto err_edg ;  //##DeleteByKuro 040901

		if( zg.sok[isok].usflg == SOKO_S ) { //̂ݑq->񐻑Vbv
			//if( edg_apd(g, nSWTLA1, zg.g.nDAEND ) < 0 ) goto err_edg ;
			if( edg_apd(g, nSWTLA1, zg.ptm[iptm].nDWAEND ) < 0 ) goto err_edg ; //Change TK041203
			nstart = -1;
		}
	}

	if( (zg.sok[isok].usflg & SOKO_U) == SOKO_U ) {	//gp񐻑Vbv@m[ho^II
		//
		if( (nUWDMA1 = nod_apd(g, SWUDMA1, iptm, ishp )) < 0 ) goto err_nod ;	/* [PgMRP폜P]MRP(TRP1)ȉ폜m[h */ //##---32.SWUDMA1 o^
		if( (nUWBMA1 = nod_apd(g, SWUBMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgWJP]vʃR[h쐬 (TRP1)<==(FRP2) */ //##---33.SWUBMA1 o^
		
		//vZ
		if( (nUWNEA1 = nod_apd(g, SWUNEA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgP]vʂvZ */ //##EditByKuro SWUOEA1->SWUNEA1 //##---34.SWUNEA1 o^
		if( (nUWLSA1 = nod_apd(g, SWULSA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgP]bgvZ */ //##---35.SWULSA1 o^
		if( (nUWASA1 = nod_apd(g, SWUASA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgtP]tvZm[h */ //##---36.SWUASA1 o^
		if( (nUWTLA1 = nod_apd(g, SWUTLA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[PgskP][h^CvZ */ //##---37.SWUTLA1 o^ //##AddByKuro040907

#ifdef SUMICHAN //DeleteByKuro
		//ɗ\ύXlbg`FW
		if( (nNUOHA1 = nod_apd(g, NWUOHA1, iptm, ishp )) < 0 ) goto err_nod ;	/* ɗ\ύX(qɃVbv) */
		zg.sok[isok].nNWOHA1 = nNUOHA1 ;
#endif //SUMICHAN		

		//-----gp񐻑Vbv@}쐬II
		if( edg_apd(g, nstart, nUWDMA1 ) < 0 ) goto err_edg ;   //##---29.SWSLSA1-->32.SWUDMA1
		if( edg_apd(g, nUWDMA1, nUWBMA1 ) < 0 ) goto err_edg ;  //##---32.SWUDMA1-->33.SWUBMA1
		if( edg_apd(g, nUWBMA1, nUWNEA1 ) < 0 ) goto err_edg ;  //##---33.SWUBMA1-->34.SWUNEA1  //##ChangeByKuro 040901
		if( edg_apd(g, nUWNEA1, nUWLSA1 ) < 0 ) goto err_edg ;  //##---34.SWUNEA1-->35.SWULSA1  //##ChangeByKuro 040901
		if( edg_apd(g, nUWLSA1, nUWASA1 ) < 0 ) goto err_edg ;  //##---35.SWULSA1-->36.SWUASA1
		if( edg_apd(g, nUWASA1, nUWTLA1 ) < 0 ) goto err_edg ;  //##---36.SWUASA1-->37.SWUTLA1  //##AddByKuro040907
		nstart = nUWTLA1; //##ChangeByKuro 040901
		
		//if( edg_apd(g, nNUOHA1, nUWDMA1 ) < 0 ) goto err_edg ;  //##DeleteByKuro 040901
	}

	//̃N쐬 ##########`FbNvII############# ByKuro
	if( nstart >= 0 ) {
		/*	toq->fromqɂɃN */
			CHKB(0,zg.n.shp,zg.x.arshp) ;
		rc =  GetFromSoko(g, iptm, ishp, zg.n.shp, &zg.n.arshp, zg.arshp ) ;  CHKB(0, 0, rc);
		if( rc < 0 )	goto quit ;
		for( j=0 ; j<zg.n.arshp ; j++ ) {
				CHKA(0,zg.arshp[j],zg.n.shp) ;
			ifsok = find_sok2( isok, iptm, zg.arshp[j] ) ;
			if( ifsok < 0 ) { //tȏqɂfromqɂƂȂĂ!!!!!
				CHKB(0,ifsok,zg.n.sok) ;
			} else {
				if( edg_apd(g, nstart, zg.sok[ifsok].nDW1BGN ) < 0 )	goto err_edg ; //##ChangeByKuro 040901
			}
		}
		//fromȂꍇDSBGN
		if( zg.n.arshp <= 0 )
			if( edg_apd(g, nstart, zg.ptm[iptm].nDWAEND ) < 0 )					goto err_edg ; //##ChangeByKuro 040901
	}
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_soko:rc(%d)" CR,rc) ;
	return( rc ) ;
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
}
/***********************************************************************************************
 *zgnode_simple:	Pȏꍇ̌vZOt쐬it@giڂԕiA[ij
+***********************************************************************************************/
int  zgnode_simple_phantom( int iusp )
{
	int rc=0 ;
	int iptm, ishp;
//	int nFUDMA1, nFUBMA1, nFUASA1, nFUGRA1 ; //##DeleteByKuro
	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_phantom:" CR) ;
/*		gpVbv */
	iptm = zg.usp[iusp].ptm;
	ishp = zg.usp[iusp].shp;

/*t@giڂ̏ꍇ */
#ifdef SUMICHAN //DeleteByKuro
	//
	if( (nFUDMA1 = nod_apd(g, FPUDMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.lqo^CvPȉ폜(t@giڂ̎gpVbv) */
	if( (nFUBMA1 = nod_apd(g, FPUBMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[tgWJP]t@giڂ`AgpVbvPł̂alWJ */
	//vZ
	if( (nFUASA1 = nod_apd(g, FPUASA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[tgtP]t@giڂ`AgpVbvPNR2ANeBreBɊt */
	if( (nFUGRA1 = nod_apd(g, FPUGRA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[tgP]iڂ`AgpVbvPŁi^CvQj瑍vʃR[h쐬 */

//	if( edg_apd(g, zg.ptm[iptm].nDPBGN, nFPUBMA1 ) < 0 ) goto err_edg ;
	if( edg_apd(g, zg.ptm[iptm].nDPBGN, nFUDMA1 ) < 0 ) goto err_edg ;
	if( edg_apd(g, nFUDMA1, nFUBMA1 ) < 0 ) goto err_edg ;
	if( edg_apd(g, nFUBMA1, nFUASA1 ) < 0 ) goto err_edg ;

//	if( edg_apd(g, nFUASA1, nFUGRA1 ) < 0 ) goto err_edg ;
	if( edg_apd(g, nFUASA1, zg.ptm[iptm].nDUEND ) < 0 )		goto err_edg ; //DUEND,DSBGNɃNꂽ
	if( zg.ptm[iptm].ssptop < 0 ) { //ŉʕi
		if( edg_apd(g, zg.ptm[iptm].nDSBGN, zg.ptm[iptm].nDPEND2 ) < 0 )	goto err_edg ; //DSBGN->DPEND //##ChangeByKuro nDPEND->nDPEND2
	} else {						//ԕi̎At@giڂ̎gpVbvƋVbv͂
		if( edg_apd(g, zg.ptm[iptm].nDSBGN, nFUGRA1 ) < 0 )	goto err_edg ;
		if( edg_apd(g, nFUGRA1, zg.ptm[iptm].nDPEND2 ) < 0 )				goto err_edg ; //##ChangeByKuro nDPEND->nDPEND2
	}
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_phantom:rc(%d)" CR,rc) ;
#endif //SUMICHAN
	return( rc ) ;

#ifdef SUMICHAN //DeleteByKuro
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
#endif //SUMICHAN
}
/*	zgnode_simple_phantom_suply:Pȏꍇ̌vZOt쐬(t@giڂŏIiF̂)
+**/
int  zgnode_simple_phantom_suply( int issp )
{
	int rc=0 ;
	int iptm, ishp;
	//int nBGNNOD, nENDNOD ;
	//int nFSDMA1, nFSLMA1 ; //##DeleteByKuro
	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_phantom_suply:" CR) ;
	/*		Vbv */
	iptm = zg.ssp[issp].ptm;
	ishp = zg.ssp[issp].shp;
	//nBGNNOD = zg.ptm[iptm].nDSBGN; /* Jnm[h */
	//nENDNOD = zg.ptm[iptm].nDPEND; /* Im[h */

	/*t@giڂ̏ꍇ */
	//
#ifdef SUMICHAN //DeleteByKuro
	if( (nFSDMA1 = nod_apd(g, FPSDMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.lqo^CvR폜(t@giڂ̋Vbv) */
	//vZ
	if( (nFSLMA1 = nod_apd(g, FPSLMA1, iptm, ishp )) < 0 ) goto err_nod ;	/*.[tP]iڂ`AVbvRł݂̌lor̂lqo쐬 */


	if( edg_apd(g, zg.ptm[iptm].nDSBGN, nFSDMA1 ) < 0 ) goto err_edg ;
	if( edg_apd(g, nFSDMA1, nFSLMA1 ) < 0 ) goto err_edg ;
	if( edg_apd(g, nFSLMA1, zg.ptm[iptm].nDPEND1 ) < 0 ) goto err_edg ; //##ChangeByKuro nDPEND->nDPEND2
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_phantom_suply:rc(%d)" CR,rc) ;
#endif //SUMICHAN
	return( rc ) ;

#ifdef SUMICHAN //DeleteByKuro
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
#endif //SUMICHAN
}
/**************************************************************************************************
 *zgnode_simple:	Pȏꍇ̌vZOt쐬
+*					qi̒ǉA폜̃lbg`FWꍇAiԃNč쐬邽
+*					̊֐Ăяo
+**************************************************************************************************/
int  zgnode_simple_bom(ZMRP &g)
{
	int rc=0, iptm, j, i, k ;
	int koptm ;
	int	oyalink ;
	if(DBG[12]) TRACEA(0), Dprintf("zgnode_simple_bom:" CR) ;

	/*	BM̒ǉA폜ɂ镔iԃN̍č쐬 */
	if( zg.g.ebomlnktop >= 0 ) {
		for( i=0 ; i<zg.g.numptm ; i++ ) {
			if( (k=zg.ptm[i].nDPEND2) >= 0 ) { //##ChangeByKuro nDPEND->nDPEND2
				struct nod_s *wnod = ZG_SNOD(k) ;
				if( wnod->edgko >= 0 ) {
						CHKA(zg.g.ebomlnktop, wnod->edgko, zg.n.sedg) ;
					wnod->edgko = -1 ;
				}
			}
		}
		ZG_SNOD(zg.g.nDAEND)->edgko = -1 ;
		ZG_SNOD(zg.g.nDABGN)->edgko = -1 ;
		zg.n.sedg = zg.g.ebomlnktop ;	//iԃN̐擪zɖ߂
	}
		CHKB(-1,ZG_SNOD(zg.g.nDAEND)->edgko,-1) ;
		CHKB(-1,ZG_SNOD(zg.g.nDABGN)->edgko,-1) ;
	zg.g.ebomlnktop = zg.n.sedg ;	//zg.g.ebomlnktopedg[]ǉĂ䂭

/*	eiڐONA */
	for( iptm = 0 ; iptm < zg.g.numptm ; iptm++ ) {
		zg.ptm[iptm].oyanum = 0;
	}
/*	eq֌W */
	for( iptm = 0 ; iptm < zg.g.numptm ; iptm++ ) {
		if(IsUnusePtm(g, iptm)) continue; // FS041216A
		oyalink = 0 ;
		/* qiڂ̃N */
		rc =  GetPtmKo(g, iptm, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
		if( rc < 0 ) goto                                                 quit;
		zg.ptm[iptm].konum = zg.n.arptm;
		if( zg.n.arptm > 0 ) { /* qiڂLƂ */
			for( j = 0 ; j < zg.n.arptm ; j++ ) {
				koptm = zg.arptm[j];            CHKA(0, koptm, zg.n.ptm);
				if( koptm < 0 || koptm >= zg.n.ptm ) continue;
				if( koptm == iptm ) { CHKA(0, koptm, iptm); continue; }
				++zg.ptm[koptm].oyanum;
				if( edg_apd(g, zg.ptm[iptm].nDPEND2, zg.ptm[koptm].nDPBGN ) < 0 ) goto err_edg ;	/* SWTA1->SWAA1 */ //##ChangeByKuro nDPEND->nDPEND2
				oyalink = 1 ;
			}
		}
		if( zg.ptm[iptm].fRc == 1 ) {	/* jO`FWi */
			if( (rc=zgnode_rc(g, iptm, &oyalink )) < 0 ) goto quit ;
		}
		if( oyalink == 0 ) {
			if( edg_apd(g, zg.ptm[iptm].nDPEND2, zg.g.nDAEND ) < 0 ) goto err_edg ;		/* SWTA1->SWAA1 */  //##ChangeByKuro nDPEND->nDPEND2
			//if( edg_apd(g, zg.ptm[iptm].nDPEND3, zg.g.nDAEND ) < 0 ) goto err_edg ;				//##AddByKuro040902
		}
	}
	/* ŏIiS̊Jnm[hɐڑ */
	for( iptm = 0 ; iptm < zg.g.numptm ; iptm++ ) {
		if(IsUnusePtm(g, iptm)) continue; // FS041216A
		if( zg.ptm[iptm].oyanum > 0 ) continue;
		if( edg_apd(g, zg.g.nDABGN, zg.ptm[iptm].nDPBGN ) < 0 )		goto err_edg ;					/* SWTA1->SWAA1 */
	}
quit :
	if(DBG[12]) TRACEC(0), Dprintf("zgnode_simple_bom:rc(%d)" CR,rc) ;
//	zgdebug_nod(), zgdebug_edg() ;
	return( rc ) ;
err_edg :
	rc = -1;	goto quit;
}
//
//	jO`FWiiptmViڂɃN͂
//
int  zgnode_rc(ZMRP &g, int iptm, int *linkflag )
{
	int j, k, l, kptm ;
	int rc=0 ;
	
	//*linkflag = 0 ;
	for( j=zg.ptm[iptm].usptop ; j>=0 ; j=zg.usp[j].ptmnext ) {
		rc =  GetPtmRc(g, iptm, zg.usp[j].shp, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
		if( zg.n.arptm <= 0 ) continue ;
		/*	ViڂɓgpVbv邩 */
		for( k=0 ; k<zg.n.arptm ; k++ ) {
			kptm = zg.arptm[k] ;
			if( (l=find_usp(kptm, zg.usp[j].shp )) < 0 ) continue ;							/* ViڂɓgpVbvȂ */
			if( edg_apd(g, zg.ptm[iptm].nDPEND2, zg.ptm[kptm].nDPBGN ) < 0 ) goto err_edg ;	/* iDPEND->ViDPBGN */ //##ChangeByKuro nDPEND->nDPEND2
			*linkflag = 1 ;
		}
	}
    //Vbvw薳̏ꍇ ##AddByKuro041001
	rc =  GetPtmRc(g, iptm, -1, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
	if( zg.n.arptm <= 0 ) goto quit ;

	for( k=0 ; k<zg.n.arptm ; k++ ) {
		kptm = zg.arptm[k] ;
		if( edg_apd(g, zg.ptm[iptm].nDPEND2, zg.ptm[kptm].nDPBGN ) < 0 ) goto err_edg ;	/* iDPEND->ViDPBGN */ //##ChangeByKuro nDPEND->nDPEND2
		*linkflag = 1 ;
	}
quit :
	return( rc ) ;
err_edg :
	rc = -1;	goto quit;
}
/**************************************************************************************************
 *zgnode_scomplex:	Gȏꍇ̌vZOt쐬
+*					
+**************************************************************************************************/
int  zgnode_complex(ZMRP &g)
{
	int rc=0, iptm, ishp;
	int jssp, jshm;

	for( ishp = 0 ; ishp < zg.n.shp ; ishp++ ) {
		if( zg.shp[ishp].topssp < 0 ) continue ;
        memset(zg.arptm,0,zg.n.ptm*sizeof(zg.arptm[0]));
		//Vbv
		for( jssp=zg.shp[ishp].topssp ; jssp>=0 ; jssp=zg.ssp[jssp].shpnext ) { CHKA(0, jssp, zg.n.ssp);
			jshm = zg.ssp[jssp].shp; CHKA(0, jshm, zg.n.shp);
			iptm = zg.ssp[jssp].ptm; CHKA(0, iptm, zg.n.ptm);
			if (IsKuzusi(g,iptm,jshm)!=1) continue;	
			//\́RwL
			if (zg.shp[jshm].nCMSSLA1==-1)   //Rm[ho^ρH
			    if( (zg.shp[jshm].nCMSSLA1  = nod_apd(g, CMSSLA1 , iptm, jshm)) < 0 ) goto err_nod ;
			if ( zg.arptm[iptm] != 1) {
				if( edg_apd(g,zg.ptm[iptm].nDPEND1, zg.shp[jshm].nCMSSLA1  ) < 0 ) goto err_edg ; //DPEND1->CMSSLA1
				if( edg_apd(g,zg.shp[jshm].nCMSSLA1, zg.ptm[iptm].nDPEND2  ) < 0 ) goto err_edg ; //CMSSLA1->DPEND2
				zg.arptm[iptm] = 1;
			}
		}
	}
	

quit :
	return( rc ) ;
err_nod :
	rc = -1;	goto quit;
err_edg :
	rc = -1;	goto quit;
}
