/*
 * FILE     : zgsortpl.cpp	i\̔WD揇lăg|WJ\[gBm[hԍ͂On܂ŘAĂ邱ƁB
 * Copyright (C) 2004 Sogen System Co., Ltd
 * FUNCTION : i\̔WD揇lăg|WJ\[gB
			  m[hԍ͂On܂ŘAĂ邱ƁB
 * PROTTYPE : extern int tsortp(int,int arc[][2],int,int order[],int(*comp)(int,int),int);
*/
static char __file[] = __FILE__ ;
#include	<stdio.h>
#include    <stdlib.h>
//#include    <malloc.h>
#include    <memory.h>

#ifdef TEST	/* for UNIT TEST */
#define 
int  tsortpl(int narc, int arc[][2], int nnode, int order[]/*, int (*)(int, int) */, int mode) ;
//int  tsDeleteLoop_ed( int,	int[][2], int, struct node_st*,int*, int ) ;
//int tsDeleteLoop_ed(ZMRP &g, int, int[][2], int, struct node_st*,int*, char *, int ) ;
static int  tsDeleteLoop_ed(ZMRP &g,int narc,int (*arc)[2],int nnode,struct node_st *node,int *nxed,char *iged,int mode);
//int	 tsSTEP1_2( int nnode, struct node_st *node, int narc, int arc[][2], int *nxed, int mode, struct arc_st2 *wka2 )  ;
int  tsDmpLoopError( int from_no,	int to_no,int *lstack,int	*nerr) ;
void  tsDebugTB1( int idxF, int idxT, int nnode, struct node_st *node, int narc, int arc[][2], int *nxed ) ;
void  tsDebugStack( int n_stack, int *lstack ) ;
#define Dprintf printf
#define Eprintf printf
#define CHKA(x,y,z) (( (x)<=(y)&&(y)< (z)) ? 0 : \
	(Dprintf("***** %s(%ld) CHKA(%ld,%ld,%ld)" CR, __file, __LINE__,(long)x,(long)y,(long)z),1))
#define CHKB(x,y,z) (( (x)<=(y)&&(y)<=(z)) ? 0 : \
	(Dprintf("***** %s(%ld) CHKB(%ld,%ld,%ld)" CR, __file, __LINE__,(long)x,(long)y,(long)z),1))
#else
#include	"zg.h"
#include	"zgsscp.h"
#include	"zchardif.h"
static int tsDeleteLoop_ed(ZMRP &g,int narc,int (*arc)[2],int nnode,struct node_st *node,int *nxed,char *iged,int mode);
#endif	/* TEST */

struct	node_st{
	int		oya;		/*  em[h̐  */
	int		top;		/*  }B     nxed[],arc[]ʒu-1  */
	int 	ord;        /*  \[g̏ԍ(`FbNp)  */
};
#ifdef ZGUNIT_TEST
static	int	dbgf = 0;
#else
static	int	dbgf = 0;
#endif

/*	ID_HeapUp	q[vɂPR[hǉAq[vC
**********************************************************************/
int  HeapUp( /* order, h, nod, nord, comp  */
	int		order[],	/* IO o͗pz */
	int		h,			/* I  ڈʒu order[] */
	int		nod,		/* I  ǉm[hԍ */
	int		nord,		/* I  o͗pz order[]̗vf */
	/*int 	(*comp)( int, int ) +* I  r֐ */
	int		useFunc		/* 990623 1:r֐g */
	)
{
	int		rc1, oy, ko, rc = 0;
                               CHKA(0,h,nord);
	ko = h;
	while( ko >= 1 ) {
		oy = ( ko - 1 ) / 2;   CHKA(0,oy,ko);
		if( useFunc ) {
		/*	rc1 = (*comp)( order[oy], nod ); */
			rc1 = compPtm( order[oy], nod );
		} else rc1 = 0 ;		/* 990623 */
		if( rc1 > 0 || rc1 == 0 && order[oy] < nod ) break;
		order[ko] = order[oy];
		ko = oy;
	}
	                       CHKB(0,ko,h);
	order[ko] = nod;
	return( rc );
}
/*	ID_HeapDown	q[vPR[h폜Aq[vC
**********************************************************************/
int  HeapDown( /*order, h, comp  */
	int		order[],			/* IO o͗pz */
	int		h,					/* I  q[vɓo^ĂŌ̈ʒu order[] */
	/* int 	(*comp)( int, int ) +* I  r֐ */
	int		useFunc		/* 990623 1:r֐g */
	)
{
	int 	rc1, oy, ko, nod, rc = 0;

	rc = order[0];   /* q[v̐擪m[hԍ擾 */
	oy = 0;
	nod = order[h];
	while( ( ko = oy * 2 + 1 ) < h ) {
		if( ko + 1 < h ) {
			if( useFunc ) {
				/*	rc1 = (*comp)( order[ko], order[ko+1] ); */
				rc1 = compPtm( order[ko], order[ko+1] );
			} else	rc1 = 0 ;	/* 990623 */
			if( rc1 < 0 || rc1 == 0 && order[ko] > order[ko+1] ) ++ko;
		}
		if( useFunc ) {
			/*	rc1 = (*comp)( nod, order[ko] ); */
			rc1 = compPtm( nod, order[ko] );
		} else rc1 = 0 ;	/* 990623 */
		if( rc1 > 0 || rc1 == 0 && nod < order[ko] ) break;
		order[oy] = order[ko];
		oy = ko;
	}
	order[oy] = nod;
	return( rc );
}

/*	ID_tsortp	i\̔WD揇lăg|WJ\[gB
**********************************************************************/
int  tsortpl(/*narc, arc, nnode, order, comp, mode +* 0: -1:G[ -2:[v */
	ZMRP &g,
	int		narc,          /* i zarc[]̃f[^ */
	int 	(*arc)[2],      /* i LOtBm[hԍ arc[][0]:from arc[][1]:to */
						   /*   m[hԍ͂On܂nnode */
	int 	nnode,         /* i m[hBzorder[]̗vf */
	int 	*order,       /* o \[gʂ̔z */
	/* int 	(*comp)( int, int ),     +* i r֐ */
	int 	mode,          /* i 0:  1:t NT19930512 */
	int		useFunc		   /* 1:D揇ʗp̔r(r֐ĂяoȂ) 990623 */
	)
{
	int 	*nxed = NULL;		/*  ̎}B nxed[],arc[]ʒu-1  */
	struct node_st	*node = NULL;
	int		i, fr, to, p, q, rc, idxF = 0, idxT = 1, h, selfloop = 0;
	int		rc2=0 ;				/* 990601sk */
	char	*iged = NULL ;		/* 990601sk arc[]𖳎tO */

	if(dbgf)	Dprintf(" narc = (%d) nnode = (%d)" CR, narc, nnode);
	if(dbgf>1)	for( i = 0 ; i < narc ; ++i )
		Dprintf("(%d,%d)%s", arc[i][0], arc[i][1], ((i+1)%10)==0||(i+1)==narc ? CR:" " );
	/*   ̃`FbN   */
	rc = -1;
									CHKB(0, narc, narc); CHKB(0, nnode, nnode);
	if( narc < 0 || nnode < 0 ) goto								err1;
	/* Ɨ̈̊mۂƏ */
	if((node = (struct node_st*)malloc(nnode * sizeof(*node))) == NULL) goto err1;
	if((nxed = (int*)malloc(narc * sizeof(*nxed))) == NULL) goto	err1;
	for(i = 0; i < nnode; ++i) {
		node[i].oya = 0;
		node[i].top = -1;
		node[i].ord = -1;
	}
	if( mode ) {
		idxF = 1-idxF;
		idxT = 1-idxT;
	}
/*step1: +*   ȅWv@q̎oN̍쐬  */
	for(i = narc-1; i >= 0; --i) { /* KH981027 */
		nxed[i] = -1;              /* ADD NT950608 */
		fr = arc[i][idxF];				CHKA(0, fr, nnode);
		to = arc[i][idxT];				CHKA(0, to, nnode);
		if(fr < 0 || fr >= nnode || to < 0 || to >= nnode) goto		err1;
		if( fr == to ) { selfloop = 1; continue; }  /* ADD NT950608 */
		++node[to].oya;
		nxed[i] = node[fr].top;
		node[fr].top = i;
	}
/*	loopError`FbN */
	if((iged = (char*)malloc(narc * sizeof(*iged))) == NULL) goto	err1;
	rc2 = tsDeleteLoop_ed(g, narc, arc, nnode, node, nxed, iged, mode ) ;	/* iڊloopƂȂ}폜 990601sk */

	/*   \[gJn      */
	h = 0;
	/* eÕm[hԍq[vɒǉ */
	for(i = 0; i < nnode; ++i) {
		if(node[i].oya == 0) 
			/*	HeapUp( order, h++, i, nnode, comp ); +* o͗pz̐擪ǉ */
			HeapUp( order, h++, i, nnode/*, comp */, useFunc ); /* o͗pz̐擪ǉ 990623 */
	}
	p = nnode - 1;
	while( --h >= 0 ) {  CHKA(0,h,nnode);
/*step2:	+* 擪̃m[hԍ擾 */
		/*	i = HeapDown( order, h, comp );  CHKA(0, i, nnode); */
		i = HeapDown( order, h/*, comp */, useFunc );  CHKA(0, i, nnode); /* 990623 */

		                         		 CHKA(0, p, nnode);
		order[p] = i;     /* o͗pž납ǉ */
		node[i].ord = p--;
/*step3: */
		for(i = node[i].top; i >= 0; i = nxed[i]) {CHKA(0, i, narc);
			to = arc[i][idxT];			CHKA(0, to, nnode);
			--node[to].oya;
			if(node[to].oya == 0)
				/*	HeapUp( order, h++, to, nnode, comp ); */
				HeapUp( order, h++, to, nnode/*, comp */, useFunc ); /* 990623 */
		}
	}                                    CHKB(-1,p,-1);
	                                     CHKB(-1,h,-1);
/*step4: */ /* o^ĂȂm[horder[]ɋIɒǉB */
	q = p;
	if( q >= 0 ) {
		for( i = 0; i < nnode; ++i ) {
			if( node[i].ord >= 0 ) continue;
								  CHKA(0,q,nnode);
			if( q < 0 ) break;		/* [vȂ́Abreak */
			order[q] = i;			/* [vB */
			node[i].ord = q--;		/*    CHKA(i,i,i); o͂̂ł */
		}
	}
	if( q >= 0 ) goto                                   err2;
	/* o͗pzւ */
	for( fr = 0, to = nnode - 1; fr < to; ++fr, --to ) {
		i = order[fr];
		order[fr] = order[to];
		order[to] = i;
	}
	if( p >= 0 ) goto                                   err2 ;
/*==========>   \[gʂ̃`FbN ͍̕폜Ăǂ  */
	for(i = 0; i<narc; ++i) { 
		if( iged[i] ) continue ;		/* 990601sk */
		fr = arc[i][0]; to = arc[i][1];  /*KH981027 */
		if( fr != to ) {
/*			if (mode == 0) CHKA(0, node[fr].ord, node[to].ord);  +*HY납ǉ̂ߋt */
			if (mode == 1) CHKA(0, node[fr].ord, node[to].ord);  /*ADD KH981027 */
			else           CHKA(0, node[to].ord, node[fr].ord);
		}
	}
/*<==========   \[gʂ̃`FbNI ̕܂ō폜Ăǂ  */
	if( selfloop != 0 ) goto                              err2;
	if( (rc = rc2) < 0 ) goto quit ;	/* 990601sk */
	rc = 0;
quit:
	if( nxed ) free(nxed);
	if( node ) free(node);
	if( iged ) free(iged ) ;	/* 990601sk */
	if(dbgf>1)	for( i = 0 ; i < nnode ; ++i ) Dprintf("%d%s", order[i],
			((i+1)%10)==0||(i+1)==nnode ? CR:" " );
								/* CHKB(0,rc,0); */
//	if(dbgf)	Dprintf(" rc = (%d) p = (%d) q = (%d)" CR, rc, p, q);  del NT140612
	return(rc);
err1: rc = -1;
	goto															quit;
err2: rc = -2;
	goto															quit;
}

/* -------------------------------------------------> tsDeleteLoop_ed 990601sk */
/*	tsDeleteLoop_ed
+*	qǂ,qm[h㗬̃m[hƂȂ鎞AloopErrorƂB
+*	toloopError𔭌̎}N폜B
**********************************************************************/
#define	NO_CHILDF -9
#define NODE_ADD(X)   (nod2[X].stackno = n_stack, lstack[n_stack++] = X)
#define NODE_DEL(X)   (nod2[X].stackno = -1, (n_stack > 0 ? n_stack-- : 0) )
struct node_st2 {			/* m[hp\ */
	int  stackno ;			/* stackɊi[lstack[]̔zԍi[GA */
	char looper ;			/* loopError 1 */
} ;
/*	N폜Anode[], nxed[]쐬.({̂step_1Rs[ĕύX)
**********************************************************************/
int  tsSTEP1_2( /* nnode, node, narc, arc, nxed, iged, mode  */
	ZMRP &g,
	int nnode, 
	struct node_st *node, 
	int narc, 
	int arc[][2], 
	int *nxed, 
	char *iged,
	int mode 
	)
{
	int rc=0 ;
	int i, to, fr ;
	int idxF=0, idxT=1 ;
	if( mode ) {
		idxF = 1, idxT = 0 ;
	}
	/*	N̕ύX */
	for(i = 0; i < nnode; ++i) {
		node[i].oya = 0;
		node[i].top = -1;
		node[i].ord = -1;
	}
	/*	step1s */
	for(i = narc-1; i >= 0; --i) { /* KH981027 */
		nxed[i] = -1;              /* ADD NT950608 */
		if( iged[i] ) {
			Esprintf(g.ermes, "zgsortpl.cpp 0010 *** tsortpl : arc(%d)(%d,%d)" CR,i,arc[i][0],arc[i][1]) ;
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "*** tsortpl : arc[%d](%d,%d)loopErrořƂȂ̂œǂݍ݂܂" CR,i,arc[i][0],arc[i][1]) ; Eprintf(g.ermes); }
			continue ;	/* arc */
		}
		fr = arc[i][idxF];				CHKA(0, fr, nnode);
		to = arc[i][idxT];				CHKA(0, to, nnode);
		if(fr < 0 || fr >= nnode || to < 0 || to >= nnode) continue ;
		if( fr == to )                                     continue ;
		++node[to].oya;
		nxed[i] = node[fr].top;
		node[fr].top = i;
	}
	return( rc ) ;
}

static int  tsDeleteLoop_ed( /*narc, arc, nnode, node, nxed, iged, mode  */
	ZMRP &g,
	int		narc,          /* i zarc[]̃f[^ */
	int 	(*arc)[2],      /* i LOtBm[hԍ arc[][0]:from arc[][1]:to */
						   /*   m[hԍ͂On܂nnode */
	int 	nnode,         /* i m[hBzorder[]̗vf */
	struct	node_st *node,		   /* i/o m[h node[nnode]workz */
	int 	*nxed,		   /* i/o }     nxed[narc]workz */
	char	*iged,		   /* o  arc[]𖳎tO 990601sk */
	int 	mode           /* i 0:  1:t NT19930512 */
	)
{
	/*	loop`FbNpGA̗p */
	struct node_st2 *nod2 = NULL ;
	char *pased   = NULL ;		/* arc[]ʉߍς݃tO */
	int  *lstack  = NULL ;		/* loop`FbNpstack[] */
	int	 n_stack = 0, x_stack = 0 ;
	int  n_ernode = 0 ;			/* loopError̐ */

	int i, j ;
	int to, inode ;
	int rc = 0 ;
	int endf = 0 ;
	int idxF = 0, idxT = 1 ;	/*  */	

	if( mode == 1 ) {			/* t */
		idxF = 1; idxT = 0;
	}
	memset( iged, 0, narc * sizeof(*iged) ) ;

	if( dbgf>1 ) tsDebugTB1( idxF, idxT, nnode, node, narc, arc, nxed ) ;

	/* malloc */
	/* 990618	x_stack = (256<nnode?256:nnode) ; */
	x_stack = (nnode<256?nnode:256) ;	/* 990618 */
	if( (lstack = (int*)malloc( x_stack * sizeof(lstack[0]) )) == NULL ) goto err1 ;

	if( (nod2 = (struct node_st2*)malloc( nnode * sizeof(nod2[0]) )) == NULL ) goto err1 ;
	for( i=0 ; i<nnode ; i++ ) { nod2[i].stackno = -1 ; nod2[i].looper = 0 ; }
	
	if( (pased = (char*)malloc( narc * sizeof(pased[0]) )) == NULL ) goto err1 ;
	memset( pased, 0, narc * sizeof(pased[0]) ) ;
	
	/* oya=0Mask */
	for( i=0 ; i<nnode ; i++ ) {
		if( node[i].oya == 0 ) node[i].oya = NO_CHILDF ;
	}
	/* qD悵lstack[]Ɋi[ */
	for( i=0 ; i<nnode ; i++ ) {
		if( node[i].oya != NO_CHILDF ) continue ;
		/* eȂm[hJnm[hƂ */
		lstack[0] = i ;			/* Jn_i[ */
		n_stack = 1 ;
		while( n_stack > 0 ) {	/* iނׂarcI */
			endf = 0 ;
			j    = -1; //add NT140612 warning C4701 
			while ( n_stack > 0 && endf == 0 ) {
				to = lstack[n_stack-1] ;
				for( j = node[to].top ; j >= 0 ; j = nxed[j] ) {
					if( pased[j] ) continue ;				/* łɒʉߍς݂arc */
					inode = arc[j][idxT] ;
					if( node[inode].oya <= 0 ) continue ;	/* łɒʉߍς݂node */
					if( nod2[inode].looper == 0 ) {			/* loopErrorm[hłȂ */
						endf = 1 ;
						break ;
					}
				}
				if( j < 0 ) {								/* ݂̃m[hi߂qȂ */
					if( n_stack > 0 )	NODE_DEL(lstack[n_stack-1]) ;/* ʂ̃m[hɖ߂ */
				}
			}
			if( endf != 1 ) continue ; 
				CHKA(0,j,narc) ;

			/* lstackɒǉ */
			/*Ɉړ990618 if( !NEW_LSTACK )			goto err1 ; */
			inode = arc[j][idxT] ;
			node[inode].oya-- ;
			pased[j] = 1 ;						/* arc̒ʉߍς݃tO */

			if( nod2[inode].stackno >= 0 ) {	/* loopError łɐẽm[h  */
				nod2[inode].looper = 1 ;		/* nodeloopError */
				iged[j]    = 1 ;				/* arcɖtO */
				if( (rc = tsDmpLoopError(g, nod2[inode].stackno, n_stack-1, lstack, &n_ernode )) < 0 ) goto quit ;
			}
			else {								/* lstackɒǉ */
				if( n_stack >= x_stack ) {		/* ォړ 990618 */
					x_stack+=256 ;
					if( (lstack=(int*)realloc( lstack, x_stack * sizeof(lstack[0]))) == NULL ) goto err1 ;
				}
				NODE_ADD(inode) ;
				if( dbgf>1 ) tsDebugStack( n_stack, lstack ) ;
			}
		}
	}

	if( (rc = tsSTEP1_2(g, nnode, node, narc, arc, nxed, iged, mode )) < 0 ) goto quit ;
	rc = 0 ;
quit :
	if( n_ernode ) {	/* loopError */
		rc = -2 ;
		Esprintf(g.ermes, "zgsortpl.cpp 0020 *** tsortpl : LoopError %d" CR,n_ernode ) ;
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "*** tsortpl : LoopError@S%d" CR,n_ernode ) ; 	Eprintf(g.ermes); }
	}
	/* free */
	if( lstack )  free( lstack ) ;
	if( nod2 )    free( nod2 ) ;
	if( pased )	  free( pased ) ;
	if( dbgf>1 ) tsDebugTB1( idxF, idxT, nnode, node, narc, arc, nxed ) ;
	return( rc ) ;
err1 :
	rc = -1 ; goto quit ;
}
/*	loop̂m[hNDprintfo͂B
**********************************************************************/
int  tsDmpLoopError( /* from_no, to_no, lstack, nerr  */
	ZMRP &g,
	int from_no,
	int to_no,
	int *lstack,
	int	*nerr
	)
{
	int i, rc = 0 ;
	Esprintf(g.ermes, "*** tsortpl : loopError(%d) node(%d)",(*nerr)++,lstack[from_no] ) ;
	Eprintf(g.ermes);
	for( i=from_no ; i<=to_no ; i++ ) {
		Esprintf(g.ermes, "%d->",lstack[i]) ;	/* Ōloop̃m[h */
		Eprintf(g.ermes);
	}
	Esprintf(g.ermes, "%d" CR,lstack[from_no]) ;
	Eprintf(g.ermes);
	return( rc ) ;
}
/*	node[], nxed[], arc[]_v
**********************************************************************/
void  tsDebugTB1( /* idxF, idxT, nnode, node, narc, arc, nxed  */
	int idxF,
	int idxT,
	int nnode,
	struct node_st *node,
	int narc,
	int arc[][2],
	int *nxed
	)
{
	int i ;
	if(dbgf==0) return ;
	Dprintf( "nnode(%d)" CR, nnode ) ;
	for( i=0 ; i<nnode ; i++ ) 		Dprintf("node(%d) oya(%d) top(%d)" CR, i, node[i].oya, node[i].top ) ;
	Dprintf("narc(%d)" CR,narc) ;
	for( i=0 ; i<narc ; i++ ) 		Dprintf("arc(%d)(%d)(%d)->(%d)(%d)" CR, i,idxF,arc[i][idxF],idxT,arc[i][idxT]) ;
	for( i=0 ; i<narc ; i++ ) 		Dprintf("nxed(%d)(%d)" CR,i,nxed[i]) ;
	return ;
}
/*	lstack_v
**********************************************************************/
void  tsDebugStack( /* n_stack, lstack  */
	int n_stack,
	int *lstack
	)
{
	int j ;
	if(dbgf==0) return ;
	Dprintf("lstack(%d)Dump" CR,n_stack) ;
	for( j=0 ; j<n_stack ; j++ ) Dprintf("(%d)%d%s",j,lstack[j],(j%10 == 9?CR:" ")) ;
	Dprintf( CR) ;
	return ;
}
/* <------------------------------------------------- tsDeleteLoop_ed 990601sk */
