/*
 * FILE     : zgsscdbg.cpp	Debugp֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * FUNCTION	: Debugp֐
 * AUTHOR   : 2004.08.05 s.kobayashi
 */
/*	Ŝ extern "C" {   ... } ɂĉ܂܍쐬ł̂ȂƂ肠c++ō쐬
+**/
static char __file[] = __FILE__ ;
#define CLASS_DEF 

#include			<stdio.h>
#include			<string.h>
#include			"zgsscp.h"
#include			"zchardif.h"

#define			MAXCHK	1000		/* CHKx()̏o͉MAX */
#define			MAXLIST	2000000L		/* LIST̏oMAX */

#define			USE_LOCALE
#ifdef USE_LOCALE	/* TCHAR.Htprintf()n֐gpȂŎ͂ŊR[hݒ */
#include			<locale.h>
#endif
static int list_count=0 ;	/* o͂C */
static int err_count=0 ;	/* CHKo͂C */

#ifndef Dprintf
static FILE	*dbgFp   = 0 ;  /* stdout ; */
static int	dbgMode  = 0 ;	/* "w" */
static char	*dbgFname=NULL ;
#endif
#ifdef _DEBUG
//#define DBGF 1
static int DBGF = 1;  //chg NT140612  warning C4127 
#else
//#define DBGF 0
static int DBGF = 0;
#endif

#ifndef Dprintf //move NT140612
/*	basenm:
+**/
static char *CLASS_DEF basenm( char *s )
{
	char	*r = s;
//	for( ; *s; ++s ) if( *s == '\\' || *s == '/' ) r = s+1;
	for( ; *s; ++s ) if( *s == CYEN || *s == '/' ) r = s+1;
	return( r );
}
/*	Dprintf:
+**/
//#ifndef Dprintf move NT140612
//#	ifdef __cplusplus
#		include			<stdarg.h>
#		if !defined(USE_LOCALE) 
#			include			<iostream.h>
#			include			<TCHAR.H>
#		endif
#		if !defined(_WIN32) /* UNIX ݊o[W */
//#			include <varargs.h>  //AS400Ή
#		endif
#if 1 || defined(_WIN32)
int Dprintf( const char *lpszFormat, ... )
#else	/* UNIX݊ */
int Dprintf( va_alist )
va_dcl
#endif
{
//#ifdef _DEBUG
	va_list args;
	int nBuf;
//#if !defined(USE_LOCALE)
//	TCHAR szBuffer[1024] ;
//#endif

	if( list_count >= MAXLIST ) return 0 ;

#if 1 || defined(_WIN32)
	va_start(args, lpszFormat);
#else	/* UNIX݊ */
	va_start(args);
#endif
	if( dbgMode == 1 && dbgFname ) dbgFp = fopen( dbgFname, "a" ) ;
	if( dbgFp ) {
#ifdef USE_LOCALE
			nBuf = vfprintf( dbgFp, lpszFormat, args ) ;
#else
//			nBuf = _vstprintf( szBuffer, lpszFormat, args ) ;	/* TCHARϊ */
//			szBuffer[1023] = '\0' ;
//			if( dbgfp == stdout )	cout << szBuffer ;			/* coutK̂ŎcĂ */
//			else 					fprintf( dbgFp, szBuffer ) ;
			nBuf = _vftprintf( dbgFp, lpszFormat, args ) ;		/* TCHAR(OK) */
#endif	/* USE_LOCALE */

			if( ++list_count >= MAXLIST ) {
				fprintf( dbgFp, "line count over(%ld) cannot more output" CR,MAXLIST ) ;
				if( g.jmf ) fprintf( dbgFp, "C%ld𒴂܂Bȍ~o͂܂B" CR,MAXLIST ) ;
				fflush( dbgFp ) ; }
			if( dbgMode == 1 && dbgFname && dbgFp != stdout ) { fclose( dbgFp ) ; dbgFp = NULL ; }
	}
	va_end( args ) ;
	return( 0 ) ;
}
/*	trace_ab:
*/
int CLASS_DEF trace_ab (int type,char *file,int line,int xx)
{
	static const char	*arc[] = {" ==>", " -- ", "<== ", "", "", "" };
	Dprintf("%s %-10s(%3d) %s", arc[type], basenm(file), line, xx?CR:" ") ;
	return(0);
}
/*	chk_ab:
*/
int CLASS_DEF chk_ab  (int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz)
{
	static const char	*arc[] = { "A", "B" };
	if( err_count < MAXCHK ) { 
		Dprintf("*** CHK%s error <== %8s(%d) %s(%ld) %s(%ld) %s(%ld)" CR,
			arc[t], basenm(file), line, sx, lx, sy, ly, sz, lz ) ;
		if( ++err_count >= MAXCHK) {
			Dprintf( "CHK count over(%d) cannot more output" CR, MAXCHK );
			if( g.jmf ) Dprintf( "CHK(%d)𒴂܂Bȍ~o͂܂B" CR, MAXCHK );
		}
	}
	return(1);
}
#endif		/* Dprintf */
/*	Dpintflag:	DBG[]ɃZbg
*/
int CLASS_DEF Dpinitflag( char *fname )
{	
	FILE	*fp ;
	int 	i, ng, ch;
	if(DBGF) TRACEA(0),Dprintf("Dinitflag:fname(%s)" CR,fname);
	ng = sizeof( DBG ) / sizeof( DBG[0] );
	memset( DBG, 0, sizeof(DBG[0]) * ng ) ;

	if( (fp = fopen( fname, "r" )) != NULL ) {
		for( i = 0 ; (ch = getc(fp)) != EOF && i < ng; )
			if( ch >= '0' && ch <= '9' )  DBG[i++] = (unsigned char)(ch - '0') ;
		fclose(fp);
	}
/*	print DBG[] if flags are not all 0 */
	for( i = 0 ; i < ng ; i++ ) if( DBG[i] ) break;
	if( i >= ng ) goto                           quit;
	if(DBGF) {
		Dprintf(CR "DBG[] = ") ;
		for( i = 0 ; i < ng ; i++ )  {
			Dprintf( "%d", DBG[i] );
			if     ( i%50 ==49 ) Dprintf( CR "        ");
			else if( i%10 == 9 ) Dprintf( " " );
		}
		Dprintf( CR);
	}
quit:
	if(DBGF) TRACEC(0),Dprintf("Dinitflag: rc(0)" CR);
	return(0);
}
/*	Dpopen:	 ŏɂPĂ
*/
int CLASS_DEF Dpopen( char *fname,	/*(i) fname :t@C̐擪AhX NULL̎Wo͂ɏo */
			int writeMode 	/*(i) writeMode 0:"w" , 1:"a"ŃI[v */
		   )
{
#ifndef Dprintf
	if(DBGF) TRACEA(0), Dprintf("Dpopen: fname(%s)writeMode(%d)" CR,fname,writeMode ) ;
#ifdef USE_LOCALE
	setlocale( LC_ALL, "Japanese" ) ;
#endif

	dbgFname = fname ;
	if( strlen( dbgFname ) <= 0 ) dbgFname = NULL ;
	dbgMode = writeMode ;
	if( dbgFp != stdout  ) {
		if( dbgFp != NULL ) fclose( dbgFp ) ;
		if( dbgFname == NULL ) dbgFp = stdout ;
//		else if( (dbgFp=fopen( dbgFname, "w" )) == NULL ) /* dbgFp = stdout ; */ {rc = -1; goto quit ;}
		else if( dbgMode == 0 ) {
			if( (dbgFp=fopen( dbgFname, "w" )) == NULL ) dbgFp = stdout ;
		}
		else if( dbgMode == 1 ) {
			if( (dbgFp=fopen( dbgFname, "a" )) == NULL ) dbgFp = stdout ;
		}
		if( dbgMode == 1 && dbgFname && dbgFp != stdout ) { fclose( dbgFp ) ; dbgFp = NULL ; }
	}
	if(DBGF) TRACEC(0), Dprintf("Dpopen: rc(0)" CR) ;
#endif
	return( 0 ) ;
}
/*	Dpclose:	I ŌɂPĂ
*/
int CLASS_DEF Dpclose( void )
{
	if(DBGF) TRACEA(0), Dprintf("Dpclose:" CR) ;
#ifndef Dprintf
	if( dbgFp != NULL && dbgFp != stdout ) { fclose( dbgFp ) ; dbgFp = stdout ; }
#endif
	if(DBGF) TRACEC(0), Dprintf("Dpclose:rc(0)" CR) ;
	return( 0 ) ;
}
