/***************************************************************************
 * FILE      : cxheap.h	q[v̋@\񋟂B
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * REFERENCE :
 * FUNCTION  : q[v̋@\񋟂B
 * AUTHOR    : F.Sasaki 2004.11.12
***************************************************************************/
#if ! defined(CXHEAP_H)
#define CXHEAP_H

#if ! defined CR
#  if defined(_WIN32)
#    define CR "\n"
#    define TIL_HASH_CNAME ~HASH_CNAME
#    define TIL_sscvect ~sscvect
#  else
#    define CR "??/n"
#    define TIL_HASH_CNAME ??-HASH_CNAME
#    define TIL_sscvect ??-sscvect
#  endif //defined(_WIN32)
#endif //! defined CR

#include "sscvect.h"

#define CXHEAP_TYPE(A)	int(*A)(const int,const int) /* heap()p */
#define CXHEAP_CLASS heap_s
#define CXHEAP_SCOPE heap_s::
#if ! defined(TIL_CXHEAP_CLASS)
#  define TIL_CXHEAP_CLASS  ??-CXHEAP_CLASS
#endif

struct CXHEAP_CLASS {
	/*********************** OJ֐Q ***********************************/
	void set_func(CXHEAP_TYPE( pcomp)){comp = pcomp;}
	void clear(void);      //q[vɂ
	int  empty(void){return (heap.n <= 0);} //q[v̎PAłȂOԂ
	int  push(int index);  //q[vւ̒ǉ
	int  top(void);        //擪vfԂ
	void pop(void);        //擪vfP폜
	int  size(){ return heap.size(); }
	int  reserved(){ return heap.reserved(); }
	int  resize(int size){int rc, n = heap.n; rc = heap.resize(size); heap.n = n; return rc;}
	int  capacity(){ return heap.x; }	//mۍϐ

	CXHEAP_CLASS();              //RXgN^
	CXHEAP_CLASS(CXHEAP_TYPE(comp));              //RXgN^
	TIL_CXHEAP_CLASS();          //fXgN^
private:
	sscvect<int> 	heap;         /*  */
	CXHEAP_TYPE(comp);
};
#endif //! defined(CXHEAP_H)
