/*
 * FILE      : zmrprec.h	MRP ֘A̍\̂`
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : MRP ֘A̍\̂`
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
#if ! defined(ZMRPRECpH)
#define ZMRPRECpH
#define EPSI 1e-4
#define ISZERO(x)  ((x)>-EPSI&&(x)<EPSI) 
#define ISPLUS(x)  ((x)>EPSI) 
#define ISPLorZ(x)  ((x)>-EPSI) 


struct zhi_td {         /* ݌Ɉڍ zhi v(Net)vZ̈ڍ */
    int     mrp1;        /*K vTRP1܂FRP1           trp1[],frp1[] */
    int     nyuko;       /*K ɑ          onh[], fto[], pln[], opo[] */
    double  size;        /*  ʁiOj                                 */
    int     nextmrp;     /*  ɎMRP                      zhi[]or-1 */
		                 /*  擪onh[].topzhi1, fto[].topzhi2, pln[].topzhi3, opo[].topzhi4 */
    int     nextnyuko;   /*  MRP̓ɑ                zhi[]or-1 */
		                 /*  擪trp1[].topzhi1, frp1[].topzhi2           */
//	char    zhi_typ;     /*  敪 0:TRP1-(fto+toh) 1:FRP1-pln 2:FRP1-(opo+foh) */
    char    otyp;        /*  oɑ 1:TRP1 2:FRP1  */
    char    ityp;        /*  ɑ 1:tonh 2:fto 3:pln 4:opo 5:fonh */
} ;                /* Ziki HIkiate */

struct lsz_td {         /* bg܂Ƃߏڍ lsz  */
    int     oymrp;       /*K ܂ƂߑO̐eMRP           trp1[],drp1[],frp1[] */
    int     komrp;       /*K ܂Ƃߌ̎qMRP           trp2[],drp2[],frp2[] */
    double  size;        /*  ʁiOj                                 */
    int     nextoy;      /*  qMRP̐eMRP                   lsz[]or-1 */
		                 /*  擪trp2[].topoylsz1, drp2[].topoylsz2, frp2[].topoylsz3 */
    int     nextko;      /*  eMRP̎qMRP                   lsz[]or-1 */
		                 /*  擪trp1[].topkolsz1, drp1[].topkolsz2, frp1[].topkolsz3 */
    char    zhi_typ;     /*  敪 1:TRP1-TRP2 2:DRP1-DRP2 3:FRP1-FRP2 */
} ;                /* Lop SiZing */

struct trp1_td {         /* gpVbvsqoPibg܂ƂߑOj */
    int     odm;         /*  \                                 odm[] */
    int     tsh;         /*  gpVbv                         tsh[] */
    double  size;        /*  v                                       */
    double  net;         /*  vʂP(=0͎̎q)                   */
    double  uunet;       /*  [XAbvvʂQinet+uunet=vʁj   */
    int     due;         /*  v                                         */
    int     lastusetd;   /*  ŏIgp\(eiFRP2̒\܂͒\) */
	                     /*  [x̏ꍇ͏ɒBȊO͎qiڗvIʂɂ */
		//񐻑Vbvł͎gpɕύX̂ŁAeiFRP2̍ŏIgp\Rs[
    int     bom;         /*  WJɎgalB-1:iuuNet -1:񐻑ł̃Rs[ bom[]or-1 */
    int     ubm;         /*  WJɎguualB-1:bomOȏ -1:񐻑ł̃Rs[ ubm[]or-1 */
    int     oyfrp2;      /*  elqo P΂(ei)         frp2[]or-1 */
    int     uuoldtrp1;   /*  iڂsqoP P΂(i)   trp1[]or-1 */
    int     topkolsz1;   /*  qlqo ΂                  lsz[]or-1 */
    int     topuunew;    /*  擪̐Vi P΂                 trp1[]or-1 */
    int     topzhi1;     /*  擪̍݌ɈBnetvZ̏ڍ    zhi[]     */
    int     nextko;      /*  e̎qTRP1                    trp1[]or-1 */
		                 /*  擪frp2[].topkotrp1                         */
    int     nextuunew;   /*  ꋌiڎ̐ViTRP1            trp1[]or-1 */
		                 /*  擪trp1[].topuunew                          */
    int     daynext;     /*  gpVbvTRP1(v)  trp1[]or-1 */
		                 /*  擪tsh[].toptrp1                            */
    int     daypred;     /*  gpVbvOTRP1(v)  trp1[]or-1 */
		                 /*  擪͖                                     */
	int     wpegnode;    /*  iڕʃyMOpm[h}X^ԍwpegnode[]or-1 */
	trp1_td(){topkolsz1 = topuunew = topzhi1 = -1;}
} ;               /* To shop mRP(1) */

struct trp2_td {         /* gpVbvsqoQibg܂Ƃߌj */
    int     odm;         /*  \                                 odm[] */
    int     tsh;         /*  gpVbv                         tsh[] */
    double  size;        /*                                             */
	double  zansize;     /*  ݌Ɉ̎c                               */
    int     due;         /*  v                                         */
    int     lastusetd;   /*  ŏIgp\i܂ƂߑΏۂTRP1̍ŏIgp\j */
    int     topoylsz1;   /*  elqo ΂                  lsz[]or-1 (-1͖̂ł́H) */
    int     topkodrp1;   /*  qlqo P΂                 drp1[]or-1 */
    int     daynext;     /*  ꏊvgpVbvTRP2  trp2[]or-1 */
		                 /*  擪tsh[].toptrp2                            */
    int     daypred;     /*  ꏊvgpVbvOTRP2      trp2[]or-1 */
		                 /*  擪͖                                     */
	int     wpegnode;    /*  iڕʃyMOpm[h}X^ԍwpegnode[]or-1 */
	trp2_td(){topoylsz1 = topkodrp1 = -1;}
} ;               /* To shop mRP(2) */

struct drp1_td {         /* zcqoPibg܂ƂߑOj */
    int     odm;         /*  \                                 odm[] */
    int     dlm;         /*  }X^                           dlm[] */
    double  size;        /*                                             */
    int     iday;        /*  v                                         */
    int     oday;        /*  ɓiv|ɂks|wksjl-1 */
    int     lastusetd;   /*  ŏIgp\iTRP2̓ڂ̒lj             */
    int     oytrp2;      /*  elqo P΂                     trp2[] */
    int     topkolsz2;   /*  qlqo ΂                 lsz[]or-1 (-1͖̂ł́H) */
    int     nextko;      /*  e̎qDRP1                    drp1[]or-1 */
		                 /*  擪trp2[].topkodrp1                         */
    int     dlmodaynext; /*  ꋟ}X^ɓDRP1      drp1[]or-1 */
		                 /*  擪dlm[].topdrp1o                           */
    int     dlmodaypred; /*  ꋟ}X^ɓODRP1      drp1[]or-1 */
		                 /*  擪dlm[].lasdrp1o                           */
    int     dlmidaynext; /*  ꋟ}X^vDRP1      drp1[]or-1 */
		                 /*  擪dlm[].topdrp1i                           */
    int     dlmidaypred; /*  ꋟ}X^vODRP1      drp1[]or-1 */
		                 /*  擪dlm[].lasdrp1i                           */
	int     wpegnode;    /*  iڕʃyMOpm[h}X^ԍwpegnode[]or-1 */
	drp1_td(){topkolsz2 = -1;}
} ;               /* Distribution mRP(1) */

struct drp2_td {         /* zcqoQibg܂Ƃߌj */
    int     odm;         /*  \                                 odm[] */
    int     dlm;         /*  }X^                           dlm[] */
    double  size;        /*                                             */
    int     iday;        /*  ɓ                                         */
    int     oday;        /*  oɓiɓ|Aksj l-1          */
    int     lastusetd;   /*  ŏIgp\i܂ƂߑΏۂDRP1̍ŏIgp\j */
    int     yukoday;     /*  gp                                       */
	int     wpegnode;    /*  iڕʃyMOpm[h}X^ԍwpegnode[]or-1 */
	int     pegoy;       /*  SiڃyMOpyMOe[uԍ peg[]or-1 */
	int     pegko;       /*  SiڃyMOpyMOe[uԍ peg[]or-1 */
	int		outseq;      /*  oɌvt@C̏o͍sԍPn܂iRgsj */
    int     kofrp1;      /*  qlqo O΂P                 frp1[]or-1 */
    int     topoylsz2;   /*  elqo ΂                     lsz[] */
    int     dlmodaynext; /*  ꋟ}X^oɓDRP2      drp2[]or-1 */
		                 /*  擪dlm[].topdrp2o                           */
    int     dlmodaypred; /*  ꋟ}X^oɓODRP2      drp2[]or-1 */
		                 /*  擪dlm[].lasdrp2o                           */
    int     dlmidaynext; /*  ꋟ}X^ɓDRP2      drp2[]or-1 */
		                 /*  擪dlm[].topdrp2i                           */
    int     dlmidaypred; /*  ꋟ}X^ɓODRP2      drp2[]or-1 */
		                 /*  擪dlm[].lasdrp2i                           */
	char	expstopflg;  /*  qmrpWJXgbvtO 1:WJȂ 0:WJ */
	drp2_td(){topoylsz2 = -1;}
} ;               /* Distribution mRP(2) */

struct frp1_td {         /* VbveqoPibg܂ƂߑOj */
    int     odm;         /*  \                                 odm[] */
    int     fsh;         /*  Vbv                         fsh[] */
    double  size;        /*  v                                       */
    double  net;         /*  v(size̐ݒƓɓlŏ) */
    int     due;         /*  oɓ                                         */
    int     lastusetd;   /*  ŏIgp\iDRP2̓ڂ̒lj             */
    int     oydrp2;      /*  elqo O΂P                 drp2[]or-1 */
    int     oyodm;       /*  쐬ԏB󒍁AoɁA     odm[]or-1 */
    int     topkolsz3;   /*  qlqo ΂                  lsz[]or-1 */
    int     topzhi2;     /*  擪̍݌ɈBnetvZ̏ڍ    zhi[]     */
    int     daynext;     /*  ꋟVbvFRP1(v)  frp1[]or-1 */
		                 /*  擪fsh[].topfrp1                            */
    int     daypred;     /*  ꋟVbvOFRP1(v)  frp1[]or-1 */
		                 /*  擪͖                                     */
	int     wpegnode;    /*  iڕʃyMOpm[h}X^ԍwpegnode[]or-1 */
	frp1_td(){topkolsz3 = topzhi2 = -1;}
} ;               /* From shop mRP(1) */

struct frp2_td {         /* VbveqoQibg܂Ƃߌj */
    int     odm;         /*  \                                 odm[] */
    int     fsh;         /*  Vbv                         fsh[] */
    double  size;        /*                                             */
    int     due;         /*  [ 0`g.endtd                              */
    int     bgn;         /*   -1`[   l-1                 */
	int		maetaosi;    /*  O|\B|O|\(ғ) NT041104add */
    int     lastusetd;   /*  ŏIgp\i܂ƂߑΏۂFRP1̍ŏIgp\j */
	int		yukobgn;     /*  gpl\BŏIgp\|gp() */
    int     plandue;     /*  H\(R) 0`g.endtd ksvZɔ[ */
    int     planbgn;     /*  \(R) -1`[ ksvZɒ */
    int     planduetm;   /*  H\莞(R) nƎOƂʎZ */
    int     planbgntm;   /*  \莞(R) nƎOƂʎZ */
    int     yukoday;     /*  gp                                       */
	int     wpegnode;    /*  iڕʃyMOpm[h}X^ԍwpegnode[]or-1 */
	int     pegoy;       /*  SiڃyMOpyMOe[uԍ peg[]or-1 */
	int     pegko;       /*  SiڃyMOpyMOe[uԍ peg[]or-1 */
	int		outseq;      /*  vt@C̏o͍sԍPn܂iRgsj */
	double	st;          /*  Ǝ      Pʂ͕                         */
    int     oyodm;       /*  쐬I[_Btopoylsz3Ɣr    odm[]or-1 move NT140616 */
    int     topoylsz3;   /*  elqo ΂BoyodmƔr    lsz[]or-1  */
    int     topkotrp1;   /*  qlqo P΂ (qi)        trp1[]or-1 */
    int     duenext;     /*  ꋟVbvFRP2([)  frp2[]or-1 */
		                 /*  擪fsh[].topfrp2due                         */
    int     duepred;     /*  ꋟVbvOFRP2([)  frp2[]or-1 */
		                 /*  擪fsh[].lasfrp2due                         */
    int     bgnnext;     /*  ꋟVbvFRP2()  frp2[]or-1 */
		                 /*  擪fsh[].topfrp2bgn                         */
    int     bgnpred;     /*  ꋟVbvOFRP2()  frp2[]or-1 */
		                 /*  擪fsh[].lasfrp2bgn                         */
	char	expstopflg;  /*  qmrpWJXgbvtO 1:WJȂ 0:WJ */
	frp2_td(){topoylsz3 = topkotrp1 = -1;}
} ;               /* From shop mRP(2) */

struct wmrp_td {         /* ׎Rςݗpbgz */
	int		mrp;         /* MRP                                  frp2[] */
	int		next;        /* bgz                        wmrp[]or -1 */
	int		pred;        /* Obgz                        wmrp[]or -1 */
	double	yoyu;        /* []Tij                                  */
	double	bgntm;       /* \莞                                    */
	double	duetm;       /* H\莞                                    */
	double	st;          /* Ǝ      Pʂ͕                          */
} ;
#endif //! defined(ZMRPRECpH)
