/*
 * FILE      : zprotf.h	֐̃vg^Cv
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : ֐̃vg^Cv
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
#if ! defined(ZPROTFpH)
#define ZPROTFpH
int getmatomekikan(ZMRP &g, int *mbgn, int *mend, int due, int ashm, int bgnday, int endday,ltsz_td	*pltsz);
int islotmatome(ZMRP &g, int aodm, int aitm);
int zflot_round( double lotsize, double lotmin, double lotmax, double size,double *lastsize);
int zfkinto_size(double size, int itm_round, double lotstep, double lotmin, double lotmax, double g_epsi, double *kinto_size);

int zssc_itobf(char *ermes, int pos, unsigned char dlm, int val);
int zssc_dtobf(char *ermes, int pos, unsigned char dlm, double val);
int zssc_stobf(char *ermes, int pos, unsigned char dlm, char *val);
int zfGetTsh( ZMRP &g, int aitm, int ashm, int atsh = -1);
int zfGetFsh( ZMRP &g,int aitm,int ashm,int afsh = -1);
int zfAddZhi( ZMRP &g, int ityp, int otyp, int iidx, int oidx, double su);
int zfAddLsz( ZMRP &g, int typ, int *topko, int *topoy, int oymrp, int komrp, double size);
int zfAddTrp1( ZMRP &g, trp1_td &wtrp1,int odm, int atsh, double size, int due, int bom, int ubm, int oyfrp2, int atrp1, int lastusetd);
int zfAddTrp2( ZMRP &g, trp2_td &wtrp2,int odm, int atsh, double size, int due, int lastusetd);
int zfAddDrp1( ZMRP &g, drp1_td &wdrp1,int aodm,int adlm, double size, int iday, int oytrp2, int lastusetd);
int zfAddDrp2( ZMRP &g, drp2_td &wdrp2,int aodm,int adlm, int iday, int oday,double size, int lastusetd );
int zfAddFrp1( ZMRP &g, frp1_td &wfrp1,int aodm, int afsh, double size, int due, int oydrp2, int oyodm, int lastusetd);
//int zfAddFrp2( ZMRP &g, frp2_td &wfrp2,int aodm, int afsh, double size, int due, int bgn,int oyodm); HY041014
int zfAddFrp2( ZMRP &g, frp2_td &wfrp2,int aodm, int afsh, double size,int due,int bgn,int maetaosi,int plandue,int planduetm,int planbgn,int planbgntm,int oyodm, int lastusetd, int yukoday);
int zfFukaChkSet(ZMRP &g,int ashm,double *psize,int *pbgntd,int *pendtd,int muriyari,int honban);

int zfCMSSLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1);
int zfDABGN( ZMRP &g, int nodtyp, int ashm); //##AddByKuro041018
int zfSMSDMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSGMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSGOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSGPA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSGRA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSLAA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSLOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSLOA1_proc( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh); // FS040930
int zfSMSLSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSLSA1_proc( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh); // FS040930
int zfSMSTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSNMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMSNMA1_proc( int dbg, ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );	//KT20041005A
int zfSMSTOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSMUASA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfASA_ComDayUpdate(ZMRP &g, int atsh,int cuday,int *comstday,int *comedday);
int zfASA1_proc(ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1); //##AddByKuro040916
int zfASA_Size( ZMRP &g, int nodtyp, int atsh);
int zfASA_Capa( ZMRP &g, int nodtyp, int atsh, char cap_flg=0);
int zfASA_PrtyUpdate(ZMRP &g, int atsh,int cuday);
int zfASA_Onh( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh);
int zfASA_IsONMShp( ZMRP &g, int ashm, int afsh, int cuday );
int zfSMUBMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSMULSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSMULSA1_proc( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh, int dbgf);
int zfSMUNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSMUNEA1_proc( int dbg, ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSMUTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );


int zfSWSDMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSGMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSGOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSGRA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSLAA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSLOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSLSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSTOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWSNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );

int zfSWSNMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 ); //##AddByKuro041001
int zfSWSGPA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 ); //##AddByKuro041001

int zfSWSNEA1_proc( int dbg, ZMRP &g, int nodtyp, int ashm, int aitm, int afsh = -1 );
int zfSWUASA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSWUBMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSWUDMA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSWULSA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSWUNEA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );
int zfSWUTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int atsh = -1 );

int zfCalcWLT( ZMRP &g, int ashm, int aitm, int atsh = -1 ); /* LTvZ HY040917 */
int zfCalcNLT( ZMRP &g, int ashm, int aitm, int atsh = -1 ); /* LTvZ HY040917 */
int zfCalcYLT( ZMRP &g, int ashm, int aitm, int atsh = -1 ); /* ALTvZ HY040917 */

/* yMO KT20041207A Start */
int zfPEGGING01( ZMRP &g );
int zwtPEGGING01(ZMRP &g, char *fname);
/* yMO KT20041207A End */
//int zfPEGGING02( ZMRP &g );	/* gp KT20050105A */

#endif //! defined(ZPROTFpH)
