/*
 * FILE		: zgdebug.cpp
 * SYSTEM   : MRP system
 * FUNCTION	: \zg̃_v
 * AUTHOR   : 2004.08.05 s.kobayashi
 */
static char __file[] = __FILE__ ;
#include			<memory.h>
#include			"zg.h"
#include			"zgsscp.h"


#ifdef NETCMD

#ifdef NC_SZCHAR_SET
#define PRN(X,Y) (Dprintf("%s(%s) ",Y,X))
#else
#define	PRN(X,Y) (memcpy(buf,X,sizeof(X)), buf[sizeof(X)]='\0', Dprintf("%s(%s) ",Y,buf) )
#endif
void zgdebug_NetchangeLog( struct NetchangeLog_st *wk )
{
	int type = wk->NetchangeType ;
#ifndef NC_SZCHAR_SET
	char	buf[256] ;
#endif
	struct	NC_ADD_DATA *ww1 = &wk->req.madd ;
	struct	NC_DEL_DATA *ww2 = &wk->req.mdel ;
	struct	NC_NCHG_DATA *ww3 = &wk->req.mnchg ;
	struct	NC_DCHG_DATA *ww4 = &wk->req.mdchg ;
	struct	NC_ALLCHG_DATA *ww5 = &wk->req.mall ;
	struct	NC_NYUKO_CHG *ww6 = &wk->req.ochg ;
	struct	NC_BOM_CHG *ww7 = &wk->req.bchg ; //990616
	
	if( !DBG[0] ) return ; 
	Dprintf("NetchageType(%d)(",type) ;
	switch( type ) {
	case MPS_ADD : //				1	/* MPS̒ǉv */
//		Dprintf("MPS̒ǉv)\n") ;
		Dprintf("MPS̒ǉv)" CR) ;
		//------------------------------------------------------------------------------
		// ǉv
		//------------------------------------------------------------------------------
		Dprintf("num(%lf) anum(%lf) haturei(%lf) priority(%d) ",
			ww1->num,					// Y
			ww1->anum,					// 󒍗
			ww1->haturei,				// ߐ
			ww1->priority) ;			// D揇	

		PRN(ww1->hin_cd,"hin_cd");				// iڃR[h
		PRN(ww1->shop_cd,"shop_cd") ;			// ANeBreB
		PRN(ww1->base_cd,"base_cd") ;			//base
		PRN(ww1->sakuban,"sakuban");			// 
		PRN(ww1->tounyu,"tounyu");				// 
		PRN(ww1->koukan,"koukan");				// H
		PRN(ww1->shitei,"shitei");				// wH

//		Dprintf("\n") ;
		Dprintf( CR) ;
		break ;

	case MPS_DEL : //				2	/* MPS̍폜v */
//		Dprintf("MPS̍폜v)\n") ;
		Dprintf("MPS̍폜v)" CR) ;
		//------------------------------------------------------------------------------
		// 폜v
		//------------------------------------------------------------------------------
//		Dprintf("mps(%d)\n",ww2->mps);					// Ώۂԍ
		Dprintf("mps(%d)" CR,ww2->mps);					// Ώۂԍ
		break ;
		
	case MPS_NUM_CHG : //			3	/* MPS̐Yʒv */
//		Dprintf("MPS̐Yʒv)\n") ;
		Dprintf("MPS̐Yʒv)" CR) ;
		//------------------------------------------------------------------------------
		// Yʒv
		//------------------------------------------------------------------------------
//		Dprintf("mps(%d)chg_num(%lf)\n",ww3->mps, ww3->chg_num) ;// ύX̐Y
		Dprintf("mps(%d)chg_num(%lf)" CR,ww3->mps, ww3->chg_num) ;// ύX̐Y
		break ;

	case MPS_DUE_CHG : //			4	/* MPS̍HύXv */
//		Dprintf("MPS̍HύXv)\n") ;
		Dprintf("MPS̍HύXv)" CR) ;
		//------------------------------------------------------------------------------
		// HύXv
		//------------------------------------------------------------------------------
		Dprintf("mps(%d)", ww4->mps ) ;
		PRN(ww4->chg_koukan,"chg_koukan");			// ύX̍H
//		Dprintf("\n") ;
		Dprintf( CR) ;
		break ;

	case MPS_ALL_CHG : //			5	/* MPS̈ꊇύXv */
//		Dprintf("MPS̈ꊇύXv)mode(%d:%s)\n",ww5->mode,
		Dprintf("MPS̈ꊇύXv)mode(%d:%s)" CR,ww5->mode,
			(ww5->mode==MODE_ALLCHG_ADD?"MPSǉ": \
			(ww5->mode==MODE_ALLCHG_DEL?"MPS폜": \
			(ww5->mode==MODE_ALLCHG_DCHG?"MPSHύX": \
			(ww5->mode==MODE_ALLCHG_NCHG?"MPSYʕύX": " "))))) ;

		//------------------------------------------------------------------------------
		// ꊇύXv
		//------------------------------------------------------------------------------
		if(ww5->mode==MODE_ALLCHG_ADD) {
			Dprintf("num(%lf) anum(%lf) haturei(%lf) priority(%d)",
				ww5->num,
				ww5->anum,
				ww5->haturei,
				ww5->priority);
			PRN(ww5->hin_cd,"hin_cd");				// iڃR[h
			PRN(ww5->shop_cd,"shop_cd");			// VbvR[h
			PRN(ww5->base_cd,"base_cd") ;			// base
			PRN(ww5->sakuban,"sakuban");			// 
			PRN(ww5->tounyu,"tounyu");				// 
			PRN(ww5->koukan,"koukan");				// H
			PRN(ww5->shitei,"shitei");				// wH
		} else {
			Dprintf("mps(%d) mode(%d)",ww5->mps,ww5->mode ) ;

			if (ww5->mode == MODE_ALLCHG_DEL) {
			} else if(ww5->mode == MODE_ALLCHG_DCHG) {
				PRN(ww5->ex_koukan,"ex_koukan");	// HiύXj
			} else if(ww5->mode==MODE_ALLCHG_NCHG) {
				Dprintf(" ex_num(%lf)",ww5->ex_num) ;
			} else {
				Dprintf("ȗv") ;
			}
		}
//		Dprintf("\n") ;
		Dprintf( CR) ;
		break ;
	case ONH_CHG : //				6	/* ɗ\ύXv */
//		Dprintf("OnHand Change-request)chg_flg(%d:%s)\n",ww6->chg_flg,(ww6->chg_flg==CHGFLG_ADD?"OnHand Add":"OnHand Modify")) ;
		Dprintf("OnHand Change-request)chg_flg(%d:%s)" CR,ww6->chg_flg,(ww6->chg_flg==CHGFLG_ADD?"OnHand Add":"OnHand Modify")) ;
		//------------------------------------------------------------------------------
		// ɗ\ύXv(ύXΏۍڂ͕ws)
		//------------------------------------------------------------------------------
		if(ww6->chg_flg==CHGFLG_ADD) {
			Dprintf("num(%lf) cyakka_num(%lf)",	ww6->num,ww6->cyakka_num) ; //990908
			PRN(ww6->hin_cd,"hin_cd");
			PRN(ww6->from_base_cd,"from_base_cd") ;	// base
			PRN(ww6->from_shop_cd,"from_shop_cd") ;	// ANeBreB
			PRN(ww6->to_base_cd,"to_base_cd") ;		// base
			PRN(ww6->to_shop_cd,"to_shop_cd") ;		// ANeBreB
			PRN(ww6->order,"order");				// 
			PRN(ww6->yotei,"yotei");				// ɗ\
			PRN(ww6->nouki,"nouki");				// v[
			PRN(ww6->tehai,"tehai");				// z
			PRN(ww6->tanto_cd,"tanto_cd");			// S҃R[h
			PRN(ww6->syukko,"syukko") ;				// oɓ 990908
			PRN(ww6->keiyaku,"keiyaku") ;			// _ 990908
			PRN(ww6->ukeki,"ukeki") ;				//  990908
			PRN(ww6->cyakka_bi,"cyakka_bi") ;		// ד 990908
			PRN(ww6->cyakka_yoteibi,"cyakka_yoteibi") ;		// ח\ 990908
		} else {
			Dprintf("idx(%d) chg_num(%lf) ",
			ww6->idx,
			ww6->chg_num
			) ;
			PRN(ww6->chg_yotei,"chg_yotei");			// ɗ\iύXjh|Ph
			PRN(ww6->chg_hin_cd,"chg_hin_cd");			// iڃR[hiύXjh|Ph
		}
//		Dprintf("\n") ;
		Dprintf( CR) ;
		break ;
	case BOM_CHG : //				7	/* BMύXv */
//		Dprintf("alύXv)mode(%d:%s)\n",ww7->mode,
		Dprintf("alύXv)mode(%d:%s)" CR,ww7->mode,
			(ww7->mode==MODE_BOM_ADD?"BMǉ": \
			(ww7->mode==MODE_BOM_DEL?"BM폜": \
			(ww7->mode==MODE_BOM_DCHG?"BMLJnIύX": \
			(ww7->mode==MODE_BOM_NCHG?"BM\ύX": " "))))) ;
		//------------------------------------------------------------------------------
		// BMύXv
		//------------------------------------------------------------------------------
		PRN(ww7->base_cd,"base_cd");				//_R[h
		PRN(ww7->oya_hin_cd,"oya_hin_cd");			//eiڃR[h
		PRN(ww7->ko_hin_cd,"ko_hin_cd");			//qiڃR[h
		if(ww7->mode==MODE_BOM_ADD) {
			PRN(ww7->start_date,"start_date");		// LJn
			PRN(ww7->end_date,"end_date");			// LI
			Dprintf("num(%lf) ", ww7->num);			// \
		} else if( ww7->mode==MODE_BOM_DEL) {
			Dprintf("idx(%d) ", ww7->idx ) ;		// idx
		} else if( ww7->mode==MODE_BOM_DCHG) {
			Dprintf("idx(%d) ", ww7->idx ) ;		// idx
			PRN(ww7->chg_start_date,"chg_start_date");	// LJn
			PRN(ww7->chg_end_date,"chg_end_date");		// LI
		} else if( ww7->mode==MODE_BOM_NCHG) {
			Dprintf("idx(%d) chg_num(%lf) ",			// \
			ww7->idx,
			ww7->chg_num
			) ;
		}
//		Dprintf("\n") ;
		Dprintf( CR) ;
		break ;

	default :
//		Dprintf(")YȂv\n") ;
		Dprintf(")YȂv" CR) ;
	}
	return ;
}

void zgdebug_netchange( struct netchange_s *wk )
{
	if( !DBG[0] ) return ; 
//	Dprintf("<<netchange_st_v>> type(%d)ptm(%d)shp(%d)\n",wk->type,wk->ptm,wk->shp) ;
	Dprintf("<<netchange_st_v>> type(%d)ptm(%d)shp(%d)" CR,wk->type,wk->ptm,wk->shp) ;
	return ;
}


#endif	//NETCMD