/*
 * FILE     : zgmain.c
 * SYSTEM   : MRPX
 * FUNCTION : _~[main
 * AUTHOR   : 2004.08.05 s.kobayashi
 * Edit     : 2004.08.27 T.Kurokawa
 */
static char __file[] = __FILE__ ;
#ifdef ZGUNIT_TEST
#include            <stdlib.h>
#include            <memory.h>
#include            <string.h>
#define	EXTERN2
#define EXTERN
#include            "zg.h"
#include            "zgsscp.h"
#define MAIN
#include			"zgdummy.h"

//####################### ȉAABYSpɏCvIII@Bykuro ==================================>
/* eXgf[^ */
/* PsǍ݁B'#'Ŏn܂sRgƂăXLbv */
static char *fgets_cs(char* bf,int sz,FILE *fp)
{   for(;;) if( fgets(bf, sz, fp) == NULL ) return NULL;
            else if( bf[0] == '\n' ) continue;  /* sXLbv */
            else if( bf[0] != '#' )  return bf; /* '#'Ŏn܂sXLbv */
}
static get_ptm( FILE *fp, char *bf )   //#### iڎ擾@byKuro
{   int     rc, i = 0, ch;
    if( (n_ptm = atoi(bf + 3)) < 0 ) { CHKA(0, 0, n_ptm); goto   quit; }
    else if ( n_ptm == 0 ) { bf[0] = '\0' ; goto                 quit ; }
    if( (ptm = (struct test_ptm_s*)calloc(n_ptm, sizeof(*ptm))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_ptm ) {
            rc = sscanf( bf, "%d %d %d %d", &ptm[i].phant, &ptm[i].prty, &ptm[i].fBackward, &ptm[i].pgm);
            ++i;                                        CHKB(4,rc,4);
        }
    }
quit: return( 0 );
}
static get_bom( FILE *fp, char *bf )  //#### i擾@byKuro
{
    int     rc, i = 0, ch;
    if( (n_bom = atoi(bf + 3)) < 0 ) goto quit;
//NT001215  else if ( n_bom == 0 ) { bf[0] = '\0' ; goto quit ; }

    if( (bom = (struct test_bom_s*)calloc(n_bom, sizeof(*bom))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_bom ) {
            rc = sscanf( bf, "%d %d %d %d %d", &bom[i].oya, &bom[i].ko, &bom[i].istart, &bom[i].iend, &bom[i].dnum);
            ++i;                                        CHKB(5, rc ,5);
        }
    }
    x_bom = n_bom ;
quit:
    return( 0 );
}
static get_spm( FILE *fp, char *bf )  //#### Vbv擾@byKuro
{
    int     rc, i = 0, ch;
    if( (n_spm = atoi(bf + 3)) < 0 ) { CHKA(0, 0, n_spm); goto   quit; }
    else if ( n_spm == 0 ) { bf[0] = '\0' ; goto quit ; }
    if( (spm = (struct test_spm_s*)calloc(n_spm, sizeof(*spm))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_spm ) {
            rc = sscanf( bf, "%d %d %d %d %d", &spm[i].soko, &spm[i].syubetu, &spm[i].fShosai, &spm[i].fForward, &spm[i].sgm); //020123 add syubetu VV020412 addfForward,sgm
            ++i;                                        CHKB(5,rc,5);
        }
    }
quit:
    return( 0 );
}
static get_osp( FILE *fp, char *bf )  //#### gpVbv擾@byKuro
{
    int     rc, i = 0, ch;
    if( (n_osp = atoi(bf + 3)) < 0 ) { CHKA(0, 0, n_osp); goto   quit; }
//NT001215  else if ( n_osp == 0 ) { bf[0] = '\0' ; goto quit ; }
    if( (osp = (struct test_osp_s*)calloc(n_osp, sizeof(*osp))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_osp ) {
            rc = sscanf( bf, "%d %d %d", &osp[i].ptm, &osp[i].spm, &osp[i].phant);//990630 add phant
            ++i;                                        CHKB(3, rc ,3);
        }
    }
quit:
    return( 0 );
}
static get_ksp( FILE *fp, char *bf ) //#### Vbv擾@byKuro
{
    int     rc, i = 0, ch;
    if( (n_ksp = atoi(bf + 3)) < 0 ) { CHKA(0, 0, n_ksp); goto   quit; }
    else if ( n_ksp == 0 ) { bf[0] = '\0' ; goto quit ; }
    if( (ksp = (struct test_ksp_s*)calloc(n_ksp, sizeof(*ksp))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_ksp ) {
            rc = sscanf( bf, "%d %d %d", &ksp[i].ptm, &ksp[i].spm, &ksp[i].phant); //990707
            ++i;                                        CHKB(3, rc ,3);
        }
    }
quit:
    return( 0 );
}
static get_kro( FILE *fp, char *bf )  //#### OivZpisvHj@byKuro
{
    int     rc, i = 0, ch;
    if( (n_kro = atoi(bf + 3)) < 0 ) { CHKA(0, 0, n_kro); goto   quit; }
    else if ( n_kro == 0 ) { bf[0] = '\0' ; goto quit ; }
    if( (kro = (struct test_kro_s*)calloc(n_kro, sizeof(*kro))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_kro ) {
            rc = sscanf( bf, "%d %d %d %d", &kro[i].spm, &kro[i].ptm, &kro[i].frkot, &kro[i].tokot);
            ++i;                                        CHKB(4, rc ,4);
        }
    }
quit:
    return( 0 );
}
static get_sbm( FILE *fp, char *bf )  //#### }X^擾@byKuro
{
    int     rc, i = 0, ch;
    if( (n_sbm = atoi(bf + 3)) < 0 ) { CHKA(0, 0, n_sbm); goto   quit; }
    else if ( n_sbm == 0 ) { bf[0] = '\0' ; goto quit ; }
    if( (sbm = (struct test_sbm_s*)calloc(n_sbm, sizeof(*sbm))) == NULL ) goto quit;
    while( fgets_cs(bf, 1024, fp) != NULL ) { ch = bf[0];
        if( ch >= 'a' && ch <= 'z' ) break;
        if( ch != ' ' && ch != '\t' ) continue;
        if( i < n_sbm ) {
            rc = sscanf( bf, "%d %d %d", &sbm[i].from_shp, &sbm[i].to_shp, &sbm[i].ptm);
            ++i;                                        CHKB(3,rc,3);
        }
    }
quit:
    return( 0 );
}

//#################### P̃eXgpf[^ݒ ################### Bykuro
static int  set_test_data()
{
    int     rc/*, i*/;
    char    bf[1024];
/*  char    base_cd[256], pcode[256], scode[256], buyer_cd[256] ; */
    FILE    *fp = NULL;

	//########## eXgf[^t@CI[vI #################### Bykuro
    if( (fp = fopen("zgin.dat", "r")) == NULL ) goto           quit ;
    testCase[0] = '\0'; /* eXgf[^̖̓ */
    n_ptm = n_spm = n_bom = n_osp = n_ksp = /*n_net =*/ n_kro = n_sbm = 0;
    /* Psǂ */
    if( fgets_cs(bf, sizeof(bf), fp) == NULL ) { CHKA(0,0,0); goto         quit; }
    while( bf[0] ) {
        if       ( memcmp(bf, "ptm",3) == 0 ) { rc = get_ptm( fp, bf );
        } else if( memcmp(bf, "spm",3) == 0 ) { rc = get_spm( fp, bf );
        } else if( memcmp(bf, "bom",3) == 0 ) { rc = get_bom( fp, bf );
        } else if( memcmp(bf, "osp",3) == 0 ) { rc = get_osp( fp, bf );
        } else if( memcmp(bf, "ksp",3) == 0 ) { rc = get_ksp( fp, bf );
        /*sv} else if( memcmp(bf, "net",3) == 0 ) { rc = get_net( fp, bf ); */
        } else if( memcmp(bf, "kro",3) == 0 ) { rc = get_kro( fp, bf ); //ƌoH NT001215
        } else if( memcmp(bf, "sbm",3) == 0 ) { rc = get_sbm( fp, bf ); //020123
        /*} else if( memcmp(bf, "tomo",4) == 0 ) { rc = get_tomo( fp, bf ); //20040622 ###### Delete bykuro ####*/
        } else if( memcmp(bf, "end",3) == 0 ) { break;
        } else if( memcmp(bf,"name",4) == 0 ) { strcpy( testCase, bf + 5 ); //add NT001215
            fgets_cs(bf, 1024, fp);
            Dprintf( "test_name : %s", testCase);
        } else { Dprintf( "*** set_test_data : bf=%s", bf );
            if( fgets_cs(bf, sizeof(bf), fp) == NULL ) break;
        }
		if( bf[0] == 0 ) {	//̍sǂsk
            if( fgets_cs(bf, sizeof(bf), fp) == NULL ) break;
		}
    }       
    x_mps = x_onh = 0 ;
quit:
    return( rc );
}

int main( /*int argc,   char *argv[]*/ )
{
    int rc=0;
    int tdbgn = 0, tdend = 123;
	ZMRP g;
	//eXgf[^pz񏉊
/*static int*/  n_saf = 0, x_saf = 0 ;
/*static int*/  n_ptm = 1;
/*static int*/  n_spm = 0 ;
/*static int*/  n_bom = 0, x_bom=0;
/*static int*/  n_osp = 0 ;
/*static int*/  n_ksp = 0 ;
/*static int*/  n_kro = 0 ;
///*static int*/  n_net = 0;
/*static int*/  n_sbm = 0;
/*static int*/  n_mps = 0, n_onh = 0, x_mps = 0, x_onh = 0 ;
/*static int*/  n_pip = 0, x_pip = 0 ;
/*static int*/  n_rpl = 0, x_rpl = 0 ;
/*static int*/  n_bok = 0, x_bok = 0 ;
/*static int*/  n_tomo = 0, x_tomo = 0;
	ptm = NULL;
	bom = NULL;
	spm = NULL;
	osp = NULL;
	ksp = NULL;
	kro = NULL;
	//net = NULL;

	mps = NULL;
	onh = NULL;
	saf = NULL;
	pip = NULL;
	rpl = NULL;
	bok = NULL;
	//eXgf[^
    rc = set_test_data();

//####################### ABYSpɏCvIII@Bykuro <==================================

	//############## vZOt쐬  #################### Bykuro
    rc = /*ZGINST*/ zgmake(g); 
    if( rc < 0 ) goto                                   quit ;
	//############## vZOt쐬  #################### Bykuro

	//############## WFlvZs #################### Bykuro
    rc = /*ZGINST*/ zgexec_regen(g, tdbgn, tdend); /* WFlvZs */
    if( rc < 0 ) goto                                   quit ;
	//############## WFlvZs #################### Bykuro

    rc = /*ZGINST*/ zgmake_shut(g);  /* Iij */
    if( rc < 0 ) goto                                   quit ;
quit :
	//_~[f[^̈J
	if( ptm ) { free(ptm); ptm = NULL; }
	if( bom ) { free(bom); bom = NULL; }
	if( spm ) { free(spm); spm = NULL; }
	if( osp ) { free(osp); osp = NULL; }
	if( ksp ) { free(ksp); ksp = NULL; }
	if( kro ) { free(kro); kro = NULL; }
	//if( net ) { free(net); net = NULL; }

	if( mps ) { free(mps); mps = NULL; }
	if( onh ) { free(onh); onh = NULL; }
	if( saf ) { free(saf); saf = NULL; }
	if( pip ) { free(pip); pip = NULL; }
	if( rpl ) { free(rpl); rpl = NULL; }
	if( bok ) { free(bok); bok = NULL; }
	//if( tomo ) { free(tomo); tomo = NULL; } ############ Delete bykuro
    exit(0);
    return( rc ) ;
} /* end of main() */
#endif //ZGUNIT_TEST