/*
 * FILE      : zdatard.cpp	et@Cǂݍ݊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : et@Cǂݍ݊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"
// #define HOME_PAGE    z[y[Wp@z1mrp.hֈړ
//char *lbuf_add(int id, char *str, int len ); //     i[AhXԂ

/*	ID_sscatoi	ϊƌ``FbN  0: !=0:G[
********************************************************/
int sscatoi(ZMRP &g, char *dat, int *val, int min, int max, int def, char *name)
{
	char	*pch;
	static int maxmes = 10;
	*val = atoi(dat);
	/* ̌``FbN */
	pch = dat;
	while( isspace(*pch) ) ++pch;             /* sXy[XXLbv */
	if( *pch == 0 ) {
		if( def < 0 ) {
			++g.errcnt_rd;
			if( --maxmes >= 0 ) {
				Esprintf(g.ermes, "zdatard.cpp 0010 (%s:%d) %s(%s)" CR, g.fname, g.rdseq, name, dat);
				Eprintf(g.ermes);
				if( g.jmf ) { Esprintf(g.ermes, "t@C(%s:%d)%s(%s)͏ȗł܂" CR, g.fname, g.rdseq, name, dat); Eprintf(g.ermes); }
			}
			return 1;
		} else {
			*val = def;           /* ȗftHg HY */
		}
	}
	if( *pch == '-' || *pch == '+' ) ++pch;
	while( isdigit(*pch) ) ++pch;
	while( isspace(*pch) ) ++pch;             /* 㑱Xy[XXLbv */
	if( *pch != 0 ) {
		++g.errcnt_rd;
		if( --maxmes >= 0 ) {
			Esprintf(g.ermes, "zdatard.cpp 0020 (%s:%d) %s(%s)" CR, g.fname, g.rdseq, name, dat);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "t@C(%s:%d)%s(%s)ł͂܂" CR, g.fname, g.rdseq, name, dat); Eprintf(g.ermes); }
		}
		return 1;
	} else if( *val < min || *val > max ) {
		++g.errcnt_rd;
		if( --maxmes >= 0 ) {
			Esprintf(g.ermes, "zdatard.cpp 0030 (%s:%d) %s(%s) (%d..%d)" CR, g.fname, g.rdseq, name, dat, min, max);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "t@C(%s:%d)%s(%s)̒l[%d`%d]͈̔͊Oł" CR, g.fname, g.rdseq, name, dat, min, max); Eprintf(g.ermes); }
		}
		return 1;
	}
//quit:
	return 0;
}
/*	ID_sscatof	ϊƌ``FbN  0: !=0:G[
********************************************************/
int sscatof(ZMRP &g, char *dat, double *val, double min, double def, char *name)
{
	char	*pch;
	static int maxmes = 10;
	*val = atof(dat);
	/* ̌``FbN */
	pch = dat;
	while( isspace(*pch) ) ++pch;             /* sXy[XXLbv */
	if( *pch == 0 ) {
		if( def < 0.0 ) {
			++g.errcnt_rd;
			if( --maxmes >= 0 ) {
				Esprintf(g.ermes, "zdatard.cpp 0040 (%s:%d) %s(%s)" CR, g.fname, g.rdseq, name, dat);
				Eprintf(g.ermes);
				if( g.jmf ) { Esprintf(g.ermes, "t@C(%s:%d)%s(%s)͏ȗł܂" CR, g.fname, g.rdseq, name, dat); Eprintf(g.ermes); }
			}
			return 1;
		} else {
			*val = def;           /* ȗftHg HY */
		}
	}
	if( *pch == '-' || *pch == '+' ) ++pch;
	while( isdigit(*pch) || *pch == '.' ) ++pch;
	while( isspace(*pch) ) ++pch;             /* 㑱Xy[XXLbv */
	if( *pch != 0 ) {
		++g.errcnt_rd;
		if( --maxmes >= 0 ) {
			Esprintf(g.ermes, "zdatard.cpp 0050 (%s:%d) %s(%s)" CR, g.fname, g.rdseq, name, dat);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "t@C(%s:%d)%s(%s)ł͂܂" CR, g.fname, g.rdseq, name, dat); Eprintf(g.ermes); }
		}
		return 1;
	} else if( *val < min ) {
		++g.errcnt_rd;
		if( --maxmes >= 0 ) {
			Esprintf(g.ermes, "zdatard.cpp 0060 (%s:%d) %s(%s) (%g)" CR, g.fname, g.rdseq, name, dat, min);
			Eprintf(g.ermes);
			if( g.jmf ) { Esprintf(g.ermes, "t@C(%s:%d)%s(%s)̒l(%g)ł" CR, g.fname, g.rdseq, name, dat, min); Eprintf(g.ermes); }
		}
		return 1;
	}
//quit:
	return 0;
}
/*	ID_vercheck	Psڂ̃o[WmF
********************************************************/
int vercheck(ZMRP &g, char *rdbf, char *ver)
{
	if( memcmp(rdbf, ver, strlen(ver)) != 0 ) {
		rdbf[strlen(ver)] = 0;
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatard.cpp 0070 (%s) (%s) (%s)" CR, g.fname, rdbf, ver);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "t@C(%s)̃o[W(%s)(%s)ł͂܂" CR, g.fname, rdbf, ver); Eprintf(g.ermes); }
		return 0;
	}
	return 1;
}
/*	ID_bunkatu_chk	؂蕶ł̕ƍڐmF
********************************************************/
int bunkatu_chk(
	ZMRP	&g,
	char	*buf,
	char	**dat,       /* *dat[] */
	int 	min,
	int 	max,
	int 	bflen)          /* buf[]̗eʁBlen܂ł'\0'ȂƃG[ */
{
	int		rc;
	int		ec = 0;
	rc = bunkatun(buf, dat, max, bflen, &ec);
	if( ec ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatard.cpp 0080 (%s) (%d)" CR, g.fname, g.rdseq);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "t@C(%s)̍sԍ(%d)ɕsR[h܂" CR, g.fname, g.rdseq); Eprintf(g.ermes); }
	}
	if( rc < min ) { //CHKB(min, rc, max);
		++g.errcnt_rd;
		if( min == max ) Esprintf(g.ermes, "zdatard.cpp 0090 (%s) (%d) (%d)" CR, g.fname, rc, max);
		else if( rc < min ) Esprintf(g.ermes, "zdatard.cpp 0100 (%s) (%d) (%d)" CR, g.fname, rc, min);
		Eprintf(g.ermes);
		if( g.jmf ) {
			if( min == max ) Esprintf(g.ermes, "t@C(%s)̍ڐ(%d)(%d)ł܂" CR, g.fname, rc, max);
			else if( rc < min ) Esprintf(g.ermes, "t@C(%s)̍ڐ(%d)(%d)ł" CR, g.fname, rc, min);
			Eprintf(g.ermes);
		}
		rc = 0;
	}
	return rc;
}
#define	ISLEAP(y) ((y)%4?0:(y)%100?1:(y)%400?0:1) /*邤N̔ */
static int	mday[13] =  { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
/*	ID_strtoymd	NNAAɕ`FbN
********************************************************/
int strtoymd(ZMRP &g, char *strymd, int *y, int *m, int *d, char *name)
{
	int		rc;
	rc = sscanf( strymd, "%04d%02d%02d", y, m, d ); CHKB(3, rc, 3);
	                                                CHKB(1, *m, 12);
													CHKB(2004, *y, 2200);
	if( *m <= 0 || *m > 12 ) { rc = -1; goto                         quit; }
	if( *m == 2 ) mday[*m] = 28 + ISLEAP(*y);
	                                                CHKB(1, *d, mday[*m]);
	if( *d <= 0 || *d > mday[*m] ) { rc = -1; goto                   quit; }
	if( *y < 2004 || *y > 2200 ) rc = -1;
quit:
	return( rc );
}
int zfshget(ZMRP &g, int aitm, int ashm, char *name, int errf )
{
	int		afsh;
	                                CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	for( afsh = g.itm.v[aitm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext )
		if( g.fsh.v[afsh].shm == ashm ) break;

	if( errf && afsh < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatard.cpp 0110 %s (%s:%d) (%s) (%s)" CR
				, name, g.fname, g.rdseq, g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "%st@C(%s:%d)̕iڃR[h(%s)VbvR[h(%s)̋Vbv񂪖o^ł" CR , name, g.fname, g.rdseq, g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd); Eprintf(g.ermes); }
	}
	return( afsh );
}
int ztshget(ZMRP &g, int aitm, int ashm, char *name, int errf )
{
	int		atsh;
	                                CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	for( atsh = g.itm.v[aitm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext )
		if( g.tsh.v[atsh].shm == ashm ) break;

	if( errf && atsh < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatard.cpp 0120 %s (%s:%d) (%s) (%s)" CR
				, name, g.fname, g.rdseq, g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd);
		Eprintf(g.ermes);
		if( g.jmf ) { Esprintf(g.ermes, "%st@C(%s:%d)̕iڃR[h(%s)VbvR[h(%s)̎gpVbv񂪖o^ł" CR , name, g.fname, g.rdseq, g.itm.v[aitm].itm_cd, g.shm.v[ashm].shm_cd); Eprintf(g.ermes); }
	}
	return( atsh );
}
int zdlmget(ZMRP &g, int afsh, int atsh, char *name, int errf )
{
	int		adlm, aitm, ashm, bshm;
	                                CHKA(0, afsh, g.fsh.n); CHKA(0, atsh, g.tsh.n);
	for( adlm = g.fsh.v[afsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].fshnext )
		if( g.dlm.v[adlm].tsh == atsh ) break;
	
	if( errf && adlm < 0 ) {
		++g.errcnt_rd;
		aitm = g.fsh.v[afsh].itm;  CHKA(0, aitm, g.itm.n);
		ashm = g.fsh.v[afsh].shm;  CHKA(0, ashm, g.shm.n);
		bshm = g.tsh.v[atsh].shm;  CHKA(0, bshm, g.shm.n);
		Esprintf(g.ermes, "zdatard.cpp 0130 %s (%s:%d) (%s) (%s) (%s)" CR
				, name, g.fname, g.rdseq, g.itm.v[aitm].itm_cd, g.shm.v[bshm].shm_cd, g.shm.v[ashm].shm_cd);
		Eprintf(g.ermes);
		if( g.jmf ) {
			Esprintf(g.ermes, "%st@C(%s:%d)̕iڃR[h(%s)gpVbv(%s)Vbv(%s)̋}X^񂪖o^ł" CR
					, name, g.fname, g.rdseq, g.itm.v[aitm].itm_cd, g.shm.v[bshm].shm_cd, g.shm.v[ashm].shm_cd);
			Eprintf(g.ermes);
		}
	}
	return( adlm );
}
static int zdatard_init(ZMRP &g)
{
	int		rc;
	if( (rc = g.h_clm.hashopen()) < 0 ) goto    quit;
	if( (rc = g.h_org.hashopen()) < 0 ) goto    quit;
	if( (rc = g.h_shm.hashopen()) < 0 ) goto    quit;
	if( (rc = g.h_itm.hashopen()) < 0 ) goto    quit;
	if( (rc = g.h_odm.hashopen()) < 0 ) goto    quit;
	if( (rc = g.h_cpm.hashopen()) < 0 ) goto    quit;
	if( (rc = g.h_grm.hashopen()) < 0 ) goto    quit;
quit:
	return rc;
}
static int zoutclear(ZMRP &g)
{
	int		rc = 0;
	FILE	*fp = NULL;

	sprintf( g.fname, "%s/%s", g.sys.dir_out, "PLANODER.TXT" );
	if( (fp = fopen(g.fname, "w")) == NULL ) goto                       err_op;
	fclose( fp );
	sprintf( g.fname, "%s/%s", g.sys.dir_out, "PLANFTOD.TXT" );
	if( (fp = fopen(g.fname, "w")) == NULL ) goto                       err_op;
	fclose( fp );
	sprintf( g.fname, "%s/%s", g.sys.dir_out, "PEGGING.TXT" );
	if( (fp = fopen(g.fname, "w")) == NULL ) goto                       err_op;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	return( rc );
err_op:
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatard.cpp 0140 (%s)" CR, g.fname);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "o̓t@C(%s)J܂" CR, g.fname); Eprintf(g.ermes); }
	goto                                                                quit;
}
static void out_kanri(ZMRP &g, char *fname)
{
	FILE *fp = 0;
	int    bflen;

	if( (fp = fopen(fname, "r")) != NULL ) {
		bflen = sizeof(g.rdbf);
		Dprintf("%s\n", fname);
		while( fgets(g.rdbf, bflen, fp) != NULL ) Dprintf("%s", g.rdbf);
		Dprintf("\n");
		fclose( fp );
	}
	return ;
}

/*	ID_zdatard	f[^t@C
********************************************************/
int zdatard(ZMRP &g)
{
	int		rc, errf = 0;
	g.errcnt_rd = 0;                   /* t@Cǂݍݎ̃G[ */
	rc = zdatard_init(g);               CHKB(0, rc, 0);
	if( rc < 0 ) errf = rc;  /* ^[R[hL */
	/* Ǘ */
	rc = zrdKANRI01(g, "KANRI.TXT");
	/* Ǘt@C̓eo *///KS140624 Cړ
	out_kanri(g, "KANRI.TXT");
	if( rc < 0 ) errf = rc;  /* ^[R[hL */
	/* o̓t@CAo̓tH_݃`FbN */
	rc = zoutclear(g);
	if( rc < 0 || errf < 0 ) goto                                       quit;
	/* ʎZ[NΉJ_e[u쐬 */
	if( (rc = zcalmak01(g)) < 0 ) goto                                  quit;
	/* iڃ}X^ */
	if( (rc = zrdPTM01(g, "PTM.TXT")) < 0 ) goto                        quit;
	/* gD}X^ */
	if( (rc = zrdSOSIKIM01(g, "SOSIKIM.TXT")) < 0 ) goto                quit;
	/* J_ */
	if( (rc = zrdCALEND01(g, "CALEND.TXT")) < 0 ) goto                  quit;
	/* \ */
	if( (rc = zrdCAPACITY01(g, "CAPACITY.TXT")) < 0 ) goto              quit;
	/* Vbv}X^ */
	if( (rc = zrdSHOPM01(g, "SHOPM.TXT")) < 0 ) goto                    quit;
	/* Vbv */
	if( (rc = zrdFRSHOP01(g, "FRSHOP.TXT")) < 0 ) goto                  quit;
	/* }X^ */
	if( (rc = zrdFROMTOM01(g, "FROMTOM.TXT")) < 0 ) goto                quit;
	/* i\ */
	if( (rc = zrdBOM01(g, "BOM.TXT")) < 0 ) goto                        quit;
	/* ݌ */
	if( (rc = zrdONH01(g, "ONH.TXT")) < 0 ) goto                        quit;
	/* S݌ */
	if( (rc = zrdSAFETY01(g, "SAFETY.TXT")) < 0 ) goto                  quit;
	/* A}X^ */
	if( (rc = zrdYUSOM01(g, "YUSOM.TXT")) < 0 ) goto                    quit;
	/* bg܂Ƃߏ */
	if( (rc = zrdMATOME01(g, "MATOME.TXT")) < 0 ) goto                  quit;
	/* ׃bg܂Ƃߏ */
	if( (rc = zrdFTMATOME01(g, "FTMATOME.TXT")) < 0 ) goto              quit;
	/* O[v}X^ */
	if( (rc = zrdGROUPM01(g, "GROUPM.TXT")) < 0 ) goto                  quit;
	/* iڃO[v */
	if( (rc = zrdGRPITEM01(g, "GRPITEM.TXT")) < 0 ) goto                quit;
	/* VbvO[v */
	if( (rc = zrdGRPSHOP01(g, "GRPSHOP.TXT")) < 0 ) goto                quit;
	/* iڃVbvO[v */
	if( (rc = zrdGRPDTL01(g, "GRPDTL.TXT")) < 0 ) goto                  quit;
	/* [XAbvi\ */
	if( (rc = zrdUSEUPBOM01(g, "USEUPBOM.TXT")) < 0 ) goto              quit;
	/* 󒍃I[_ */
	if( (rc = zrdREVORDER01(g, "REVORDER.TXT")) < 0 ) goto              quit;
	/* ݐY */
	if( (rc = zrdMPSPLAN01(g, "MPSPLAN.TXT")) < 0 ) goto                quit;
	/* I[_ */
	if( (rc = zrdOPENODER01(g, "OPENODER.TXT")) < 0 ) goto              quit;
	/* oɗ\ */
	if( (rc = zrdFTORDER01(g, "FTORDER.TXT")) < 0 ) goto                quit;

	if( g.rod.n <= 0 && g.pln.n <= 0 ) goto                             err1;
	if( g.errcnt_rd > 0 ) { rc = 1;  goto                               quit; }
#ifdef HOME_PAGE // z[y[Wp 2014 .06.27 Y.S
	if( g.rod.n > 100 )    goto                                        err2;
	if( g.pln.n > 100 )    goto                                        err3;
#endif
	rc = 0;
quit:
	return rc;
err1: rc = -1;
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatard.cpp 0150 " CR);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "󒍃I[_yьݐY̓̓f[^ɂÔ߁AvOI܂" CR); Eprintf(g.ermes); }
	goto                                                                quit;
#ifdef HOME_PAGE // z[y[Wp 2014 .06.27 Y.S
err2: rc = -1;
	++g.errcnt_rd;
	if( 1||g.jmf ) { Esprintf(g.ermes, "󒍃I[_̓̓f[^POO傫߁AvOI܂Bipł̐j" CR); Eprintf(g.ermes); }
	goto                                                                quit;
err3: rc = -1;
	++g.errcnt_rd;
	if( 1||g.jmf ) { Esprintf(g.ermes, "ݐY̓̓f[^POO傫߁AvOI܂Bipł̐j" CR); Eprintf(g.ermes); }
	goto                                                                quit;
#endif
}
