/*
 * FILE      : zdatardcal.cpp	J_t@C͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : J_t@C͊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"

/*	ID_zadCALEND01	J_1R[hǉ
********************************************************/
static int zadCALEND01(ZMRP &g, char *name)
{
	int		rc = 0, i, aclm;
	char	clmcd[128];
	clm_td 	wclm;                  /* J_}X^ clm */

	if(zdbgf[54]>1) {TRACEA(0); Dprintf("zadCALEND01 name(%s)endtd(%d)" CR, name, g.endtd);}
	if( name[0] == 0 ) strcpy( clmcd, "!DEFCLM" );
	else               strcpy( clmcd, name );
	aclm = g.h_clm.hashfind( clmcd, 0 );
	if( aclm < 0 ) {
		aclm = g.clm.n;     /* ǉf[^i[zY */
		if( (rc = g.h_clm.hashaddr( clmcd, 0, aclm, &wclm.clm_cd )) < 0 ) goto err_h;
		if( (rc = g.clm.push_back(wclm)) < 0 ) goto                     quit;
		if( ( g.clm.v[aclm].cal = (char*)malloc( g.endtd+1 * sizeof(char) )) == NULL ) goto err_m;
		for( i = 0; i <= g.endtd; ++i ) g.clm.v[aclm].cal[i] = 1;  /* Sғ */
		if( name[0] == 0 ) g.defclm = aclm;
	}
	rc = aclm;
quit:
	if(zdbgf[54]>1) {TRACEC(0); Dprintf("zadCALEND01 rc(%d)" CR, rc);}
	return( rc );
err_h:
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardcal.cpp 0010 " CR);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "J_R[h̃nbV\o^G[" CR); Eprintf(g.ermes); }
	goto                                                                quit;
err_m:
	rc = -1;
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardcal.cpp 0020 " CR);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "J_}X^e[ũ[mۃG[" CR); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zrdCALEND01	J_
********************************************************/
int zrdCALEND01(ZMRP &g, char *fname)
{
	int		rc = 0, bflen, td, iwk;
	char	*dat[100];
	FILE	*fp = NULL;

	if(zdbgf[54]) {TRACEA(0); Dprintf("zrdCALEND01 fname(%s)" CR, fname);}
	/* ̃J_ŏɍ쐬 */
	if( (rc = zadCALEND01( g, "!REKIJITU" )) < 0 ) goto           quit;
	                          CHKB(0, rc, 0);
	sprintf( g.fname, "%s/%s", g.sys.dir_in, fname );
	bflen = sizeof(g.rdbf);
	if( (fp = fopen(g.fname, "r")) == NULL ) goto                       err_op;
	g.rdseq = 0;
	/* Psڂ̃o[WmF */
	if( fgets(g.rdbf, bflen, fp) == NULL ) { rc = 0; goto               quit; }
	++g.rdseq;
	if( (rc = vercheck(g, g.rdbf, "!V01")) != 1 ) goto           quit;
	/* f[^s[v */
	for( g.rdbf[0] = 0; fgets(g.rdbf, bflen, fp) != NULL; g.rdbf[0] = 0 ) {
		++g.rdseq;
		if( g.rdbf[0] == '!' ) continue;  //RgsXLbv
		rc = bunkatu_chk(g, g.rdbf, dat, 6, 6, bflen); CHKB(6, rc, 6);
		rc = zmd_str2td( g,	dat[2], &td,  -1 );
		if( td < 0 || td > g.endtd ) continue;
		if( (rc = zadCALEND01( g, dat[0] )) < 0 ) goto                  quit;
//		sscatoi(g, dat[1], &iwk, 0, 1, 0, "");
		sscatoi(g, dat[1], &iwk, 0, 1, 0, (g.jmf ? "ʎq" : ""));
		g.clm.v[rc].cal[td] = iwk;
	}
	// ftHgJ_̐ݒ肪Ƃ́Aݒ肷 2014.06.16 Y.S
	if( g.defclm < 0 ) {
		if( (rc = zadCALEND01( g, "" )) < 0 ) goto           quit;
	}
	CHKB(0, g.defclm, g.defclm);
	rc = g.clm.n;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[54]) {TRACEC(0); Dprintf("zrdCALEND01 rc(%d)" CR, rc);}
	return rc;
err_op: rc = 0;
//	++g.errcnt_rd;
//	Esprintf(g.ermes, "K{̃J_}X^t@C(%s)J܂\n", g.fname);
//	Eprintf(g.ermes);
	// J_}X^t@ĆAK{łȂ߁AftHgJ_ݒ肷 2014.06.16 YS
	if( (rc = zadCALEND01( g, "" )) < 0 ) goto           quit;
	                         //CHKB(0, rc, 0);
	goto                                                                quit;
}
