/*
 * FILE      : zdatardcap.cpp	\̓t@C͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : \̓t@C͊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"

/*	ID_zadCAPACITY01	\1R[hǉ
********************************************************/
static int zadCAPACITY01(ZMRP &g, char **dat)
{
	int		rc = 0, acpm, bgntd, endtd;
	cpm_td	wcpm;
	cap_td	wcap;
	if(zdbgf[55]>1) {TRACEA(0); Dprintf("zadCAPACITY01 fname(%s)" CR, g.fname);}
	/* IuWFNg̏ RXgN^Ɉړ */
	wcpm.topcap = -1;      /*  擪̔\                               cap[] */
	/*  */
	/* \̓R[h */
	acpm = g.h_cpm.hashfind( dat[0], 0 );
	if( acpm < 0 ) {
		acpm = g.cpm.n;     /* ǉf[^i[zY */
		if( (rc = g.h_cpm.hashaddr( dat[0], 0, acpm, &wcpm.cpm_cd )) < 0 ) goto err_h;
		if( (rc = g.cpm.push_back(wcpm)) < 0 ) goto                     quit;
	}
    wcap.cpm = acpm;         /* K\̓R[h                               cpm[] */
	 /* KLJn */
	rc = zmd_str2td( g, dat[3], &bgntd, 0 );
	/*  LI */
	rc = zmd_str2td( g, dat[4], &endtd, g.endtd  );
	if( bgntd < 0 ) bgntd = 0;
	if( endtd > g.endtd ) endtd = g.endtd;
	if( bgntd > g.endtd || endtd < 0 ) goto                             err2;
	if( bgntd > endtd ) goto                                            err1;
	wcap.bgnday = bgntd;      /* KLJn */
	wcap.endday = endtd;      /*  LI */
	/*  莞\  */
//	sscatof(g, dat[1], &wcap.cp_fixtm, 0.0, 0.0, "");
	sscatof(g, dat[1], &wcap.cp_fixtm, 0.0, 0.0, (g.jmf ? "莞\" : ""));
	/*  cƔ\ */
//	sscatof(g, dat[2], &wcap.cp_ovrtm, 0.0, 0.0, "");
	sscatof(g, dat[2], &wcap.cp_ovrtm, 0.0, 0.0, (g.jmf ? "cƔ\" : ""));
    wcap.cpmnext = g.cpm.v[acpm].topcap; /*  \̓R[h̎̔\ cap[] */
    g.cpm.v[acpm].topcap = g.cap.n;      /*  擪̔\ cap[] */
	rc = g.cap.push_back(wcap);
quit:
	if(zdbgf[55]>1) {TRACEC(0); Dprintf("zadCAPACITY01 rc(%d)" CR, rc);}
	return( rc );
err_h:
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardcap.cpp 0010 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "\̓}X^t@C(%s:%d)̔\̓R[h(%s)̃nbV\o^G[" CR, g.fname,g.rdseq,dat[0]); Eprintf(g.ermes); }
	goto                                                                quit;
err1: rc = 0;
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardcap.cpp 0020 (%s:%d) (%s) (%s)" CR, g.fname,g.rdseq,dat[3],dat[4]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "\̓}X^t@C(%s:%d)̗LJn(%s)LI(%s)sł" CR, g.fname,g.rdseq,dat[3],dat[4]); Eprintf(g.ermes); }
	goto                                                                quit;
err2: rc = 0;
	Esprintf(g.ermes, "zdatardcap.cpp 0030 (%s:%d) (%s) (%s) " CR, g.fname,g.rdseq,dat[3],dat[4]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "\̓}X^t@C(%s:%d)̗LJn(%s)LI(%s)Ɍv͈͊Oł" CR, g.fname,g.rdseq,dat[3],dat[4]); Eprintf(g.ermes); 	}
	goto                                                                quit;
}
/*	ID_zrdCAPACITY01	\͓
********************************************************/
int zrdCAPACITY01(ZMRP &g, char *fname)
{
	int		rc = 0, bflen;
	char	*dat[100];
	FILE	*fp = NULL;

	if(zdbgf[55]) {TRACEA(0); Dprintf("zrdCAPACITY01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_in, fname );
	bflen = sizeof(g.rdbf);
	if( (fp = fopen(g.fname, "r")) == NULL ) goto                       err_op;
	g.rdseq = 0;
	/* Psڂ̃o[WmF */
	if( fgets(g.rdbf, bflen, fp) == NULL ) { rc = 0; goto               quit; }
	++g.rdseq;
	if( (rc = vercheck(g, g.rdbf, "!V01")) != 1 ) goto                  quit;
	/* f[^s[v */
	for( g.rdbf[0] = 0; fgets(g.rdbf, bflen, fp) != NULL; g.rdbf[0] = 0 ) {
		++g.rdseq;
		if( g.rdbf[0] == '!' ) continue;  //RgsXLbv
		rc = bunkatu_chk(g, g.rdbf, dat, 8, 8, bflen); CHKB(8, rc, 8);
		if( (rc = zadCAPACITY01( g, dat )) < 0 ) goto                   quit;
	}
	rc = g.cpm.n;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[55]) {TRACEC(0); Dprintf("zrdCAPACITY01 rc(%d)" CR, rc);}
	return rc;
err_op: rc = 0;
//	++g.errcnt_rd;
//	Esprintf(g.ermes, "K{̔\̓}X^t@C(%s)J܂\n", g.fname);
//	Eprintf(g.ermes);
	goto                                                                quit;
}
