/*
 * FILE      : zdatardgro.cpp	O[v}X^t@C͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : O[v}X^t@C͊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"

/*	ID_zadGROUPM01	O[v}X^PR[hǉ
********************************************************/
static int zadGROUPM01(ZMRP &g, char **dat)
{
	int		rc = 0, iwk;
	int		agrm;
	grm_td	wgrm;   /* O[v}X^ grm */

	if(zdbgf[64]>1) {TRACEA(0); Dprintf("zadGROUPM01 fname(%s)" CR, g.fname);}

    wgrm.topigm = -1;      /*  擪̕iڃO[v                       igm[] */
    wgrm.topsgm = -1;      /*  擪̃VbvO[v                   sgm[] */
	if( ( agrm = g.h_grm.hashfind( dat[0], 0 ) ) >= 0 ) goto            err1;
	agrm = g.grm.n;
	if( ( rc = g.h_grm.hashaddr( dat[0], 0, agrm, &wgrm.grp_cd )) < 0 ) goto err_h;
//	sscatoi(g, dat[1], &iwk, 0, 9, 0, "");
	sscatoi(g, dat[1], &iwk, 0, 9, 0, (g.jmf ? "O[v" : ""));
    wgrm.grp_typ = iwk;     /*  O[v 0:VbvtɎgp              */
//	sscatoi(g, dat[2], &iwk, 0, 1, 0, "");
	sscatoi(g, dat[2], &iwk, 0, 1, 0, (g.jmf ? "׊t" : ""));
    wgrm.warituke = iwk;    /*  ׊t 0:D揇ɏt܂Ŋt 1:ϓɊt */
//	sscatoi(g, dat[3], &iwk, 0, 1, 0, "");
	sscatoi(g, dat[3], &iwk, 0, 1, 0, (g.jmf ? "R" : ""));
    wgrm.kuzusi = iwk;      /*  R   0:l 1:Ol                 */
	rc = g.grm.push_back(wgrm);

quit:
	if(zdbgf[64]>1) {TRACEC(0); Dprintf("zadGROUPM01 rc(%d)" CR, rc);}
	return( rc );
err1:
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardgro.cpp 0010 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "O[v}X^t@C(%s:%d)̃O[vR[h(%s)dĂ܂" CR, g.fname,g.rdseq,dat[0]); Eprintf(g.ermes); }
	goto                                                                quit;
err_h:
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardgro.cpp 0020 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "O[v}X^t@C(%s:%d)̃O[vR[h(%s)̃nbV\o^G[" CR, g.fname,g.rdseq,dat[0]); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zrdGROUPM01	O[v}X^
********************************************************/
int zrdGROUPM01(ZMRP &g, char *fname)
{
	int		rc = 0, bflen;
	char	*dat[100];
	FILE	*fp = NULL;

	if(zdbgf[64]) {TRACEA(0); Dprintf("zrdGROUPM01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_in, fname );
	bflen = sizeof(g.rdbf);
	if( (fp = fopen(g.fname, "r")) == NULL ) goto                       quit;
	g.rdseq = 0;
	/* Psڂ̃o[WmF */
	if( fgets(g.rdbf, bflen, fp) == NULL ) { rc = 0; goto               quit; }
	++g.rdseq;
	if( (rc = vercheck(g, g.rdbf, "!V01")) != 1 ) goto                  quit;
	/* f[^s[v */
	for( g.rdbf[0] = 0; fgets(g.rdbf, bflen, fp) != NULL; g.rdbf[0] = 0 ) {
		++g.rdseq;
		if( g.rdbf[0] == '!' ) continue;  //RgsXLbv
		rc = bunkatu_chk(g, g.rdbf, dat, 7, 7, bflen); CHKB(7, rc, 7);
		if( (rc = zadGROUPM01( g, dat )) < 0 ) goto                     quit;
	}
	rc = g.grm.n;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[64]) {TRACEC(0); Dprintf("zrdGROUPM01 rc(%d)" CR, rc);}
	return rc;
}
