/*
 * FILE      : zdatardgrs.cpp	VbvO[v}X^t@C͊֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : VbvO[v}X^t@C͊֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <math.h>

#include "z1mrp.h"

/*	ID_zadGRPSHOP01	VbvO[v}X^PR[hǉ
********************************************************/
static int zadGRPSHOP01(ZMRP &g, char **dat)
{
	int		rc = 0;
	int		ashm, agrm, asgm;
	sgm_td	wsgm;   /* VbvO[v}X^ sgm */

	if(zdbgf[66]>1) {TRACEA(0); Dprintf("zadGRPSHOP01 fname(%s)" CR, g.fname);}

	wsgm.topisg = -1;      /*  擪̕iڃVbvO[v           isg[]or-1 */
	if( ( ashm = g.h_shm.hashfind( dat[0], 0 )) < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatardgrs.cpp 0010 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[0]);
		Eprintf(g.ermes);
		if( g.jmf ) {
			Esprintf(g.ermes, "VbvO[v}X^t@C(%s:%d)̃VbvR[h(%s)Vbv}X^ɖo^ł" CR, g.fname,g.rdseq,dat[0]);
			Eprintf(g.ermes);
		}
	}
	if( ( agrm = g.h_grm.hashfind( dat[1], 0 )) < 0 ) {
		++g.errcnt_rd;
		Esprintf(g.ermes, "zdatardgrs.cpp 0020 (%s:%d) (%s)" CR, g.fname,g.rdseq,dat[1]);
		Eprintf(g.ermes);
		if( g.jmf ) {
			Esprintf(g.ermes, "VbvO[v}X^t@C(%s:%d)̃O[vR[h(%s)O[v}X^ɖo^ł" CR, g.fname,g.rdseq,dat[1]);
			Eprintf(g.ermes);
		}
	}
	if( ashm < 0 || agrm < 0 ) goto                                     quit;
	for( asgm = g.shm.v[ashm].topsgm; asgm >= 0; asgm = g.sgm.v[asgm].shmnext )
		if( g.sgm.v[asgm].grm == agrm ) break;
	if( asgm >= 0 ) goto                                                err1;
	asgm = g.sgm.n;
    wsgm.shm = ashm;         /* KVbvR[h                           shm[] */
    wsgm.grm = agrm;         /* KO[vR[h                           grm[] */
	/*  Dx  */
	if( g.grm.v[agrm].warituke == 0 ) { /*  ׊t 0:D揇ɏt܂Ŋt 1:ϓɊt */
//		sscatoi(g, dat[2], &wsgm.prty, 0, 9999999, -1, ""); /* K{ */
		sscatoi(g, dat[2], &wsgm.prty, 0, 9999999, -1, (g.jmf ? "Dx" : "")); /* K{ */
	} else {
//		sscatoi(g, dat[2], &wsgm.prty, 0, 9999999, 9999999, ""); /* ȗ */
		sscatoi(g, dat[2], &wsgm.prty, 0, 9999999, 9999999, (g.jmf ? "Dx" : "")); /* ȗ */
	}
    wsgm.grmnext = g.grm.v[agrm].topsgm; /*  O[ṽVbvO[v     sgm[]or-1 */
    g.grm.v[agrm].topsgm = asgm;         /*  擪grm[].topsgm                             */
    wsgm.shmnext = g.shm.v[ashm].topsgm; /*  VbṽVbvO[v     sgm[]or-1 */
    g.shm.v[ashm].topsgm = asgm;         /*  擪shm[].topsgm                             */
	rc = g.sgm.push_back(wsgm);

quit:
	if(zdbgf[66]>1) {TRACEC(0); Dprintf("zadGRPSHOP01 rc(%d)" CR, rc);}
	return( rc );
err1:
	++g.errcnt_rd;
	Esprintf(g.ermes, "zdatardgrs.cpp 0030 (%s:%d) (%s) (%s)" CR, g.fname,g.rdseq,dat[0], dat[1]);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "VbvO[v}X^t@C(%s:%d)̃VbvR[h(%s)O[vR[h(%s)dĂ܂" CR, g.fname,g.rdseq,dat[0], dat[1]); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zrdGRPSHOP01	VbvO[v
********************************************************/
int zrdGRPSHOP01(ZMRP &g, char *fname)
{
	int		rc = 0, bflen;
	char	*dat[100];
	FILE	*fp = NULL;

	if(zdbgf[66]) {TRACEA(0); Dprintf("zrdGRPSHOP01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_in, fname );
	bflen = sizeof(g.rdbf);
	if( (fp = fopen(g.fname, "r")) == NULL ) goto                       quit;
	g.rdseq = 0;
	/* Psڂ̃o[WmF */
	if( fgets(g.rdbf, bflen, fp) == NULL ) { rc = 0; goto               quit; }
	++g.rdseq;
	if( (rc = vercheck(g, g.rdbf, "!V01")) != 1 ) goto                  quit;
	/* f[^s[v */
	for( g.rdbf[0] = 0; fgets(g.rdbf, bflen, fp) != NULL; g.rdbf[0] = 0 ) {
		++g.rdseq;
		if( g.rdbf[0] == '!' ) continue;  //RgsXLbv
		rc = bunkatu_chk(g, g.rdbf, dat, 6, 6, bflen); CHKB(6, rc, 6);
		if( (rc = zadGRPSHOP01( g, dat )) < 0 ) goto                    quit;
	}
	rc = g.sgm.n;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[66]) {TRACEC(0); Dprintf("zrdGRPSHOP01 rc(%d)" CR, rc);}
	return rc;
}
