/*
 * FILE      : z1main.cpp	lqoVXeC֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : lqoVXeC֐
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>
#include <time.h>   //for clock()
#define EXTERN
#define EXTERN2
#include "z1mrp.h"
#include "zg.h"
#include "zgsscp.h"
#include "zrireki.h"
int lbuf_allfree(void);
// #define HOME_PAGE    z[y[Wp@z1mrp.hֈړ

/*	ID_zfree	ĨAN[Y
********************************************************/
static int zfree(ZMRP &g)
{
	int aclm;
	lbuf_allfree();
	for( aclm = 0; aclm < g.clm.n; ++aclm ) {     /* ǉf[^i[zY */
		if( g.clm.v[aclm].cal ) free( g.clm.v[aclm].cal );
		g.clm.v[aclm].cal = 0;
	}
	return 0;
}
/*	ID_zmrpargs	N
********************************************************/
static int zmrpargs( ZMRP &g, int argc, char **argv ) /* rc 0: <0:ُ */
{
	int		i, rc = -1;
	char	*bf;

	if(zdbgf[101]) {TRACEA(0); Dprintf("zmrpargs argc(%d)" CR, argc );}
	for( i = 1; i < argc; ++i ) {
		bf = argv[i];
//KS140610chg		if( *bf == '/' || '-' ) {}  /* IvV */
		if( *bf == '/' || *bf == '-' ) {  /* IvV */
			if ( bf[1] == 'c' ) strcpy( g.fname, bf + 2 );
			else goto                                                   err1;
		}
	}
	rc = 0;
quit:
	if(zdbgf[101]) {TRACEC(0); Dprintf("zmrpargs rc(%d)" CR, rc);}
	return( rc );
err1:
	Esprintf( g.ermes, "z1main.cpp 0010 (%s)" CR, argv[i] );
	Eprintf( g.ermes );
	if( g.jmf ) { Esprintf( g.ermes, "NG[ (%s)" CR, argv[i] ); Eprintf(g.ermes); }
	goto                                                                quit;
}
/*	ID_zmrpinit	
********************************************************/
static int zmrpinit( ZMRP &g ) /* rc 0: ɂOԂ */
{
	int		rc = -1;

	if(zdbgf[101]) {TRACEA(0); Dprintf("zmrpinit " CR );}
	g.fname[0] = 0;
	g.baseyear = -1;   //zdatard().zrdKANRI01()Őݒ NT040917
	g.defclm   = -1;   /* ftHgJ_ "!DEFCLM" clm[] */
	memset( &g.sys, 0, sizeof(sys_td) );
	rc = 0;
/*quit: */
	if(zdbgf[101]) {TRACEC(0); Dprintf("zmrpinit rc(%d)" CR, rc);}
	return( rc );
}
/*	ID_zfukaini	ʎRσXg̈m
********************************************************/
static int zfukaini( ZMRP &g ) /* rc 0: <0:ُ */
{
	int		ashm, count = 0, top, rc;

	/* \̓R[hwL̃VbvJEg */
	for( ashm = 0; ashm < g.shm.n; ++ashm ) {
		if( g.shm.v[ashm].cpm < 0 ) continue;
		++count;
	}
	count *= g.cal.n;
	/* ʔ\̓Xg쐬 */
	if( (rc = g.capa.resize( count, 0.0 )) < 0 ) goto                   quit;
	/* ʎRσXg쐬 */
	if( (rc = g.fuka.resize( count, 0.0 )) < 0 ) goto                   quit;
	top = 0;
	for( ashm = 0; ashm < g.shm.n; ++ashm ) {
		if( g.shm.v[ashm].cpm < 0 ) continue;
		                            CHKA(0, top, count);
		g.shm.v[ashm].capa = &g.capa[top];
		g.shm.v[ashm].fuka = &g.fuka[top];
		top += g.cal.n;
	}
	rc = 0;
quit:
	return( rc );
}
static void trace_step(char *funcnm, int rc //, int *tim0)  //change int==>void NT140528
	, time_t *tim0)                          //chenge NT140528
{
	static int pflg = 1; //, cpu0 = 0;
	static time_t cpu0 = 0;
	time_t cpudif, cpu1 = clock(), timdif, tim1 = time(NULL);  //change int==>time_t NT140528
	cpudif = cpu1 - cpu0;
	timdif = tim1 - *tim0;
	if( pflg ) { if(sizeof(time_t)<=4) printf("%-10s() end with rc(%d) clock(%.3f) time(%d)" CR, funcnm, rc, cpudif / (double)CLOCKS_PER_SEC, timdif);
	             else                  printf("%-10s() end with rc(%d) clock(%.3f) time(%I64d)" CR, funcnm, rc, cpudif / (double)CLOCKS_PER_SEC, timdif);
	             fflush(stdout); }
	if(sizeof(time_t)<=4) Dprintf("%-10s() end with rc(%d) clock(%.3f) time(%d)" CR, funcnm, rc, cpudif / (double)CLOCKS_PER_SEC, timdif);
	else                  Dprintf("%-10s() end with rc(%d) clock(%.3f) time(%I64d)" CR, funcnm, rc, cpudif / (double)CLOCKS_PER_SEC, timdif);
	cpu0 = cpu1;
	*tim0 = tim1;
	return ;
}
static void out_param(ZMRP &g, int argc, char **argv, time_t tim0)
{
	int    i;
	struct tm *td;

	/* No */
	Dprintf("command:");
	for( i = 0; i < argc; ++i ) Dprintf(" %s", argv[i] ); 
	Dprintf("\n"); 
	//vO쐬
	Dprintf("build  : %s %s\n", __DATE__, __TIME__); 
	//s
	td = localtime( &tim0 );
	Dprintf("run    : %d/%02d/%02d %02d:%02d:%02d\n"
		, td->tm_year+1900, td->tm_mon+1, td->tm_mday, td->tm_hour, td->tm_min, td->tm_sec); 
	return ;
}
/*	ID_main	C֐
********************************************************/
int main(int argc, char **argv)
{
	int		rc; //, tim0;
	time_t	tim0;     //change NT140528
	ZMRP	g;


	tim0 = time(NULL);
	/* O */
	zsscEprintfClear();
	zssc_Dopen("ZMRPDBG.TXT");
	g.epsi = 1e-3;                    /* [Ƃ݂ȂlB1e-3 */
	g.jmf = 1;                        /* {ꃁbZ[Wo add 2014/06/10 Shioya*/
	/* fobOtO̓ǂݍ */
	zdbgin();

	if( (rc = zmrpinit(g)) < 0 ) goto                                   quit;
	/* N`FbNEݒ */
	if( ( rc = zmrpargs( g, argc, argv ) ) < 0 ) goto                   quit;
	trace_step("zmrpargs", rc, &tim0 );
#if 0 /* FS041228 sscvect3p */
	if(zdbgf[2]) {
		g.zhi.dumptb();         /* ݌Ɉڍ zhi v(Net)vZ̈ڍ */
		g.lsz.dumptb();         /* bg܂Ƃߏڍ lsz */
		g.trp1.dumptb();        /* gpVbvsqoPibg܂ƂߑOj */
		g.trp2.dumptb();        /* gpVbvsqoQibg܂Ƃߌj */
		g.drp1.dumptb();        /* zcqoPibg܂ƂߑOj */
		g.drp2.dumptb();        /* zcqoQibg܂Ƃߌj */
		g.frp1.dumptb();        /* VbveqoPibg܂ƂߑOj */
		g.frp2.dumptb();        /* VbveqoQibg܂Ƃߌj */
	}
#endif
#ifdef UNUSE // z[y[Wp 2014 .06.27 Y.S => ̐͂ȂA̐̂2014.07.02 YS
	{        //HOME_PAGE ̐͂ȂA̐Ȃ 2019/12/02 N.Tsuchiya
		int year,mon,day;
		struct tm *local;
		local = localtime(&tim0);   /* n̍\̂ɕϊ */

		year = local->tm_year + 1900;      /* N */
		mon = local->tm_mon + 1 ;          /*  */
		day = local->tm_mday ;             /*  */
		if( year*10000 + mon *100 + day > 20161231 ) {
			printf("gp(20161231)؂܂\n");
			if( 1||g.jmf ) { Esprintf(g.ermes, "gp(20161231)؂܂ipł̐j" CR); Eprintf(g.ermes); }
			goto quit;
		}
	}
#endif
	/* N̓eAo */
	out_param(g, argc, argv, tim0);
	/* f[^t@C */
	if( (rc = zdatard(g)) < 0 ) goto                                    quit;
	                                    CHKB(2000, 2000, g.baseyear);
	trace_step("zdatard", rc, &tim0 );
	/* ʎZNԂ */
	int y0, m0, d0;
	zmd_td2ymd1(g, 0, &y0, &m0, &d0);
	/* SNAAjԂB06ŁAjyj\B */
	g.yobi0 = zmd_dayyobi( y0 + g.baseyear, m0, d0);  /* ʎZO̗jB0:j`6:yj */

	/* ̔z */
	if( (rc = zmd_kimatu(g)) < 0 ) goto                                 quit;
	/* ̓f[^̗LJn\[gE݌ɂ̎gp\[g */
	if( (rc = zsortdt(g)) < 0 ) goto                                    quit;
	/* iڃ}X^̗L^tOݒ肷 */
	setunuse_flg(g); // FS041207
	/* ̓f[^̃`FbN */
	if( (rc = zdchktbl(g)) < 0 ) goto                                   quit;
	if(zdbgf[1])  zdumptbl1(g);
	trace_step("zdchktbl", rc, &tim0 );

	/* vZOt쐬 */
//	zdbgf[98] = 2;   //Ăяog[X̂
	if( (rc = zgmake(g)) < 0 ) goto                                     quit;
	trace_step("zgmake", rc, &tim0 );
	/* vZOt̃eXg[h̎͏I */
	if(zdbgf[99]) goto                                                  quit;
	/* ʎRσXg̈m */
	if( (rc = zfukaini(g)) < 0 ) goto                                   quit;
	trace_step("zfukaini", rc, &tim0 );
	/* WFlvZ */
//	zdbgf[99] = 1;   //zfXXXX()Ăяog[X̂
	if( (rc = zgexec_regen(g, 0, 9999)) < 0 ) goto                      quit;
	trace_step("zgexec_regen", rc, &tim0 );
	/* vZʂ̃`FbN */
	if( ( rc = zdchkrec(g)) < 0 ) goto                                  quit;
	if(zdbgf[2])  zdumprec1(g);
	trace_step("zdchkrec", rc, &tim0 );

//	/* Iij */
//	if( (rc = zgmake_shut(g)) < 0 ) goto                                quit;

	/* yMO */
	if( (rc = zfPEGGING01(g)) < 0 ) goto								quit;
	trace_step("zfPEGGING01", rc, &tim0 );

	/* ʃt@Co */
	if( (rc = zdataout(g)) < 0 ) goto                                   quit;
	trace_step("zdataout", rc, &tim0 );
quit:
	/* n */
	/* SĂ̔z̃TCYvg */
	zsizepr(g);
	zgdebug_memory(g);
	/* Iij */
	zgmake_shut(g);
	zfree(g);
	Dprintf("zmrp rc(%d)" CR, rc);
	trace_step("zgmake_shut", rc, &tim0 );
#if defined(_DEBUG)
	int dmy;
//	printf("CHK %d Eprintf %d" CR, zssc_chk_, g_ssc.errcnt);
	printf("CHK_su= %d Eprintf_su= %d" CR, zssc_chk_, g_ssc.errcnt);
	printf("Press Enter Key"); fflush(stdin); scanf("%c", &dmy);
#endif
	return rc;
}
