/*
 * FILE      : zdumptbl.cpp	̓f[^̃_v
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : ̓f[^̃_v
 * AUTHOR    : K.Tamura  2004.09.02
 */
#include	"z1mrp.h"

/* J_ */
int dmp_cal_td( ZMRP &g, struct cal_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	int		i = 0;
	struct cal_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "cal_td", TAB, pm);
	if( g.jmf ) Dprintf("ʎZ%sN%s%s" CR, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("(%3d)%s%d%s%d%s%d" CR, i++, TAB, pp->y, TAB, pp->m, TAB, pp->d);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}

int dmp_sys_td( ZMRP &g, struct sys_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct sys_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "sys_td", TAB, pm);
	if( g.jmf ) Dprintf("̓tH_%so̓tH_%sߋ%s%s%s^Cv%sNxt%s" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%s%s%d%s%d%s%d/%d/%d%s%d%s%d%s%d" CR,
		pp->dir_in, TAB, pp->dir_out, TAB, pp->pastdays, TAB, pp->futudays, TAB, pp->bday.y, pp->bday.m, pp->bday.d
		, TAB, pp->hiki_typ, TAB, pp->yendmd, TAB, pp->kaisu);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
int dmp_clm_td( ZMRP &g, struct clm_td *pp, int pm, int n )
{
	int		i, rc		= 0;		//߂l
	struct clm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "clm_td", TAB, pm);
	if( g.jmf ) Dprintf("KJ_R[h%sғAx" CR, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s" CR,pp->clm_cd);
		for( i = 0; i <= n; ++i ) {
			Dprintf("%2d%s",pp->cal[i], ((i+1) % 30) ? " ": CR);
		}
		Dprintf( CR);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
int dmp_org_td( ZMRP &g, struct org_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct org_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "org_td", TAB, pm);
	if( g.jmf ) Dprintf("KgDR[h%sgD%sNxt%s%sgD%s擪̃Vbv" CR, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%s%s%d%s%d%s%d%s%d" CR,
			pp->org_cd, TAB, pp->name, TAB, pp->yendmd, TAB, pp->kaisu, TAB, pp->org_typ, TAB, pp->topshm);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
int dmp_itm_td( ZMRP &g, struct itm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct itm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "itm_td", TAB, pm);
	if( g.jmf ) Dprintf("KiڃR[h%siږ%sʂ܂ߌ%sʂ܂ߎ%stD揇%sbg܂Ƃߗ}~tO%sgp%s擪̎qi\%s擪̐ei\%s擪̐Viڃ[XAbvi\%s擪̋iڃ[XAbvi\%s擪̋Vbv%s擪̎gpVbv" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%s%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->itm_cd, TAB, pp->name, TAB, pp->round, TAB, pp->rnd_typ, TAB, pp->prty, TAB, pp->lotfc_flg, TAB
			,pp->yukodays, TAB, pp->topkobm, TAB, pp->topoybm, TAB, pp->topnewubm, TAB, pp->topoldubm, TAB
			,pp->topfsh, TAB, pp->toptsh);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* i\ bom */
int dmp_bom_td( ZMRP &g, struct bom_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct bom_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "bom_td", TAB, pm);
	if( g.jmf ) Dprintf("KVbvR[h%sKeiڃR[h%sKqiڃR[h%s%sqiڕsǗ%sԂ炵%sԂ炵P%sԂ炵%sKLJn%sLI%sqiڃ[XAbvi%sVbvR[h{e̎̎qal%sVbvR[h{q̎̐eal" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%g%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->shm, TAB, pp->oyitm, TAB, pp->koitm, TAB, pp->size, TAB, pp->kobadr, TAB
			,pp->mv_typ, TAB, pp->mv_uni, TAB, pp->mv_tim, TAB, pp->bgnday, TAB
			,pp->endday, TAB, pp->kouseup, TAB, pp->nextko, TAB, pp->nextoy);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* Vbv}X^ shm                            */
int dmp_shm_td( ZMRP &g, struct shm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct shm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "shm_td", TAB, pm);
	if( g.jmf ) Dprintf("KVbvR[h%sVbv%sVbv敪%sR%sal敪%sNxt%s%sgD%sJ_R[h%s\̓R[h%s擪̋Vbv%s擪̎gpVbv%sgDVbv%s擪̋A}X^(̃Vbvgp)%s擪̎gpA}X^(̃Vbv)%s擪̃VbvO[v" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%s%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->shm_cd, TAB, pp->name, TAB, pp->shm_typ, TAB, pp->kuzusi, TAB, pp->bom_typ, TAB
			,pp->yendmd, TAB, pp->kaisu, TAB, pp->org_typ, TAB, pp->clm, TAB, pp->cpm, TAB, pp->topfsh, TAB
			,pp->toptsh, TAB, pp->orgnext, TAB, pp->topfrtpm, TAB, pp->toptotpm, TAB, pp->topsgm);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* Vbv fsh                        */
int dmp_fsh_td( ZMRP &g, struct fsh_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct fsh_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "fsh_td", TAB, pm);
	if( g.jmf ) Dprintf("KiڃR[h%sKVbvR[h%sbg܂Ƃߏ%sS݌ɏ%s擪̋}X^%s擪̎qi\%s擪̎󒍃I[_([)%s擪̌ݐY(MPS)([)%s擪̐I[_([)%s擪̍݌%siڎ̋Vbv%sꋟVbv̕i%s擪̋Vbviԕʁj%sʎZʐ擪FRP1%sʎZʐ擪FRP2" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->itm, TAB, pp->shm, TAB, pp->fls, TAB, pp->saf, TAB, pp->topdlm, TAB, pp->topkobm, TAB, pp->toprod, TAB
			,pp->toppln, TAB, pp->topopo, TAB,
			pp->toponh, TAB, pp->itmnext, TAB, pp->shmnext, TAB, pp->topfsh2, TAB, pp->topfrp1, TAB, pp->topfrp2due);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* Vbviԕʁj fsh2 */
int dmp_fsh2_td( ZMRP &g, struct fsh2_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct fsh2_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "fsh2_td", TAB, pm);
	if( g.jmf ) Dprintf("KVbv%sKLJn%sLI%st@giڎʃtO%ssǗ%sWLT%sϓLT%sWLT%sWLTŎgpJ_%sWLT܂ߎ%sWƎ%sTCN^C%sPʌ%sqiڗv%sO|\%sꋟVbv񎟂̊Jn" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%g%s%g%s%g%s%d%s%d%s%d%s%g%s%g%s%g%s%d%s%d%s%d" CR,
			pp->fsh, TAB, pp->bgnday, TAB, pp->endday, TAB, pp->fant, TAB, pp->badr, TAB
			,pp->lt, TAB, pp->hendo, TAB, pp->lt_typ, TAB, pp->lt_clm, TAB, pp->lt_rtyp, TAB
			,pp->st, TAB, pp->ct, TAB, pp->utsize, TAB, pp->komv_typ, TAB, pp->maetaosi, TAB, pp->fshnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* gpVbv tsh                       */
int dmp_tsh_td( ZMRP &g, struct tsh_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct tsh_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "tsh_td", TAB, pm);
	if( g.jmf ) Dprintf("KiڃR[h%sKgpVbvR[h%sS݌ɏ%s擪̋}X^%s擪̓oɗ\%sŌ̓oɗ\%s擪̐ei\%s擪̐Viڃ[XAbvi\%s擪̋iڃ[XAbvi\%s擪̍݌%siڎ̎gpVbv%sgpVbv̕i%sʎZʐ擪TRP1%sʎZʐ擪TRP2" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->itm, TAB, pp->shm, TAB, pp->saf, TAB, pp->topdlm, TAB, pp->topfto, TAB, pp->lastfto, TAB
			,pp->topoybm, TAB, pp->topnewubm, TAB,
			pp->topoldubm, TAB, pp->toponh, TAB, pp->itmnext, TAB, pp->shmnext, TAB, pp->toptrp1, TAB, pp->toptrp2);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* }X^ dlm                   */
int dmp_dlm_td( ZMRP &g, struct dlm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct dlm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "dlm_td", TAB, pm);
	if( g.jmf ) Dprintf("KiڃR[h%sKVbv%sKgpVbv%sbg܂Ƃߏ%si+Vbv̋}X^%si+gpVbv̋}X^%s擪̋}X^iԕʁj%s擪̋}X^iԕʁj%s擪̓oɗ\(oɓ)" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->itm, TAB, pp->fsh, TAB, pp->tsh, TAB, pp->dls, TAB
			,pp->fshnext, TAB, pp->tshnext, TAB, pp->topdlm2, TAB, pp->topdlm3, TAB, pp->topfto);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* }X^iԕʁjdlm2                      */
int dmp_dlm2_td( ZMRP &g, struct dlm2_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct dlm2_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "dlm2_td", TAB, pm);
	if( g.jmf ) Dprintf("K}X^%sKLJn%sLI%sz%sz%s݌v%sɌsǗ%sɏLT%sɏks%sɏksŎgpJ_%sɏksP%sꋟ}X^̊Jn" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%d%s%g%s%g%s%d%s%d%s%d%s%d%s%d" CR,
			pp->dlm, TAB, pp->bgnday, TAB, pp->endday, TAB, pp->haibun, TAB, pp->spas
			.hai_typ, TAB, pp->total, TAB, pp->badr, TAB, pp->nyult, TAB, pp->nlt_typ, TAB,
			pp->nlt_clm, TAB, pp->nlt_uni, TAB, pp->dlmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* }X^iԕʁj dlm3                     */
int dmp_dlm3_td( ZMRP &g, struct dlm3_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct dlm3_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "dlm3_td", TAB, pm);
	if( g.jmf ) Dprintf("K}X^%sKԁ^󒍃I[_m%sz%sz%s݌v%sɌsǗ%sɏLT%sɏks%sɏksŎgpJ_%sɏksP%sꋟ}X^̐" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%g%s%d%s%g%s%g%s%d%s%d%s%d%s%d%s%d" CR,
			pp->dlm, TAB, pp->odm, TAB, pp->haibun, TAB, pp->spas.hai_typ, TAB, pp->total, TAB
			, pp->badr, TAB, pp->nyult, TAB, pp->nlt_typ, TAB, pp->nlt_clm, TAB,
			pp->nlt_uni, TAB, pp->dlmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* bg܂Ƃߏ fls     */
int dmp_fls_td( ZMRP &g, struct fls_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct fls_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "fls_td", TAB, pm);
	if( g.jmf ) Dprintf("KVbv%s擪̐bg܂Ƃߏiԕʁj " CR, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d" CR,
			pp->fsh, TAB, pp->topfls2);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* bg܂Ƃߏiԕʁj fls2     */
int dmp_fls2_td( ZMRP &g, fls2_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	fls2_td *ep = 0;		//I|C^
	ltsz_td	*pltsz;        /*  bgTCWÕp[^       NT041104add */
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "fls2_td", TAB, pm);
	if( g.jmf ) Dprintf("Kbg܂Ƃߏ%sKLJn%sLI%sbg܂Ƃߓ%sbg܂Ƃߓ%sbg܂ƂߓŎgpJ_%sbg܂ƂߒPʐ%sbg܂Ƃߍŏ%sbg܂Ƃߍő吔%sbg܂Ƃߊ^Cv%sbg܂Ƃߊ%sbgz%s܂Ƃߎ%s؏グ%sꐻbg܂Ƃߏ񎟂̊Jn" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		pltsz = &pp->ltsz;        /*  bgTCWÕp[^       NT041104add */
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%g%s%g%s%g%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->fls, TAB, pp->bgnday, TAB, pp->endday, TAB, pltsz->lotdays, TAB, pltsz->day_typ, TAB
			, pltsz->day_clm, TAB, pltsz->lotsize, TAB, pltsz->lotmin, TAB
			, pltsz->lotmax, TAB, pltsz->base_typ, TAB, pltsz->base_day, TAB, pltsz->tehai_typ, TAB
			, pltsz->yend_typ, TAB, pltsz->yend_rtyp, TAB, pp->flsnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* ׃bg܂Ƃߏ dls     */
int dmp_dls_td( ZMRP &g, struct dls_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct dls_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "dls_td", TAB, pm);
	if( g.jmf ) Dprintf("K}X^%s擪̓׃bg܂Ƃߏiԕʁj " CR, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d" CR,
			pp->dlm, TAB, pp->topdls2);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* ׃bg܂Ƃߏiԕʁj dls2     */
int dmp_dls2_td( ZMRP &g, dls2_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	dls2_td *ep = 0;		//I|C^
	ltsz_td	*pltsz;        /*  bgTCWÕp[^       NT041104add */
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "dls2_td", TAB, pm);
	if( g.jmf ) Dprintf("K׃bg܂Ƃߏ%sKLJn%sLI%sbg܂Ƃߓ%sbg܂Ƃߓ%sbg܂ƂߓŎgpJ_%sbg܂ƂߒPʐ%sbg܂Ƃߍŏ%sbg܂Ƃߍő吔%sbg܂Ƃߊ^Cv%sbg܂Ƃߊ%sbgz%s܂Ƃߎ%s؏グ%s׃bg܂Ƃߏ񎟂̊Jn" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		pltsz = &pp->ltsz;        /*  bgTCWÕp[^       NT041104add */
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%g%s%g%s%g%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->dls, TAB, pp->bgnday, TAB, pp->endday, TAB, pltsz->lotdays, TAB, pltsz->day_typ, TAB
			, pltsz->day_clm, TAB, pltsz->lotsize, TAB, pltsz->lotmin, TAB
			, pltsz->lotmax, TAB, pltsz->base_typ, TAB, pltsz->base_day, TAB
			, pltsz->tehai_typ, TAB, pltsz->yend_typ, TAB, pltsz->yend_rtyp, TAB, pp->dlsnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* ԁ^I[_No}X^ odm                      */
int dmp_odm_td( ZMRP &g, struct odm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct odm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "odm_td", TAB, pm);
	if( g.jmf ) Dprintf("Kԁ^I[_No%s%sꂼ̔z񒆈ʒu%sD揇%sNo.w苟}X^L" CR, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%d%s%d%s%d%s%d" CR,
			pp->odm_cd, TAB, pp->odm_typ, TAB, pp->index, TAB, pp->prty, TAB, pp->dlm_typ);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* 󒍃I[_ rod                            */
int dmp_rod_td( ZMRP &g, struct rod_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct rod_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "rod_td", TAB, pm);
	if( g.jmf ) Dprintf("sԍ%sK󒍃I[_No%sVbv%s%s[%sD揇%sbg܂Ƃߗ}~tO%sNo.w苟}X^L%siځ{Vbv̎󒍃I[_" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%d%s%d%s%d%s%d%s%d" CR,
			pp->redseq, TAB, pp->odm, TAB, pp->fsh, TAB, pp->size, TAB, pp->due, TAB, pp->prty, TAB, pp->lotng_flg
			, TAB, pp->dlmuse_flg, TAB, pp->fshnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* ݐY(MPS)  pln               */
int dmp_pln_td( ZMRP &g, struct pln_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct pln_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "pln_td", TAB, pm);
	if( g.jmf ) Dprintf("sԍ%sK%sVbv%s%s[%sD揇%sbg܂Ƃߗ}~tO%sNo.w苟}X^L%sgp%sVbveqoP%s擪̍݌Ɉ%sꋟVbv̌ݐY([)" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->redseq, TAB, pp->odm, TAB, pp->fsh, TAB, pp->size, TAB, pp->due, TAB, pp->prty, TAB, pp->lotng_flg, TAB
			,pp->dlmuse_flg, TAB, pp->yukoday, TAB, pp->frp1, TAB, pp->topzhi3, TAB, pp->fshnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* oɗ\ fto           */
int dmp_fto_td( ZMRP &g, struct fto_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct fto_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "fto_td", TAB, pm);
	if( g.jmf ) Dprintf("sԍ%sKI[_No%s}X^%sgpVbv%s%s̎c%sgpɓ%soɓ%sgp%siځ{gpVbv̎̓oɗ\%siځ{gpVbv̑O̓oɗ\%s擪̍݌Ɉ%sꋟ}X^̓oɗ\" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%g%s%g%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->redseq, TAB, pp->odm, TAB, pp->dlm, TAB, pp->tsh, TAB, pp->size, TAB, pp->zan, TAB, pp->inday, TAB
			, pp->outday, TAB, pp->yukoday, TAB, pp->tshnext, TAB, pp->tshpred, TAB, pp->topzhi2, TAB, pp->dlmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* I[_ opo             */
int dmp_opo_td( ZMRP &g, struct opo_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct opo_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "opo_td", TAB, pm);
	if( g.jmf ) Dprintf("sԍ%sKI[_No%sVbv%s%s[%s%sH\%s\%sgp%s擪̍݌Ɉ%sꋟVbvI[_([)" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->redseq, TAB, pp->odm, TAB, pp->fsh, TAB, pp->size, TAB, pp->due, TAB, pp->bgn, TAB
			,pp->plandue, TAB, pp->planbgn, TAB, pp->yukoday, TAB, pp->topzhi4, TAB, pp->nextdue);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* ݌ onh                           */
int dmp_onh_td( ZMRP &g, struct onh_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct onh_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "onh_td", TAB, pm);
	if( g.jmf ) Dprintf("sԍ%sgpVbv%sVbv%sgp%s݌ɗ%s̎c%s擪̍݌Ɉ%siځ{Vbv̏݌" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%g%s%g%s%d%s%d" CR,
			pp->redseq, TAB, pp->tsh, TAB, pp->fsh, TAB, pp->yukoday, TAB, pp->size, TAB, pp->zan, TAB, pp->topzhi1, TAB, pp->next);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* S݌ saf                        */
int dmp_saf_td( ZMRP &g, struct saf_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct saf_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "saf_td", TAB, pm);
	if( g.jmf ) Dprintf("K1gpVbv%sK2Vbv%sS݌ɕ[%sS݌ɗ%s[MPS炵%s[MPS炵ғl%s[MPS炵ŎgpJ_" CR, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%d%s%d%s%d" CR,
			pp->tsh, TAB, pp->fsh, TAB, pp->saf_typ, TAB, pp->safesize, TAB
			,pp->mv_days, TAB, pp->mv_typ, TAB, pp->mv_clm);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* \̓R[hMST cpm */
int dmp_cpm_td( ZMRP &g, struct cpm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct cpm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "cpm_td", TAB, pm);
	if( g.jmf ) Dprintf("K\̓R[h%s擪̔\" CR, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%d" CR,
			pp->cpm_cd, TAB,pp->topcap);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* \ cap                                      */
int dmp_cap_td( ZMRP &g, struct cap_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct cap_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "cap_td", TAB, pm);
	if( g.jmf ) Dprintf("K\̓R[h%sKLJn%sLI%s莞\%scƔ\%s\̓R[h̎̔\" CR, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%g%s%d" CR,
			pp->cpm, TAB, pp->bgnday, TAB, pp->endday, TAB, pp->cp_fixtm, TAB, pp->cp_ovrtm, TAB, pp->cpmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* A}X^ tpm                                */
int dmp_tpm_td( ZMRP &g, struct tpm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct tpm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "tpm_td", TAB, pm);
	if( g.jmf ) Dprintf("KgpVbvR[h%sKVbvR[h%s擪̗A}X^iԕʁj%sgpVbv̋A}X^%sꋟVbv̎gpA}X^" CR, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%d" CR,
			pp->toshm, TAB, pp->frshm, TAB, pp->toptpm2, TAB, pp->nextfr, TAB, pp->nextto);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* A}X^iԕʁj  tpm2                     */
int dmp_tpm2_td( ZMRP &g, struct tpm2_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct tpm2_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "tpm2_td", TAB, pm);
	if( g.jmf ) Dprintf("KA}X^%sKLJn%sLI%sALT%sAksP%sAks%sAksŎgpJ_%swLT%swksP%swks%swksŎgpJ_%sA}X^̊Jn" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->tpm, TAB, pp->bgnday, TAB, pp->endday, TAB, pp->ylt, TAB, pp->ylt_uni, TAB, pp->ylt_typ, TAB
			,pp->ylt_clm, TAB, pp->buylt, TAB, pp->blt_uni, TAB, pp->blt_typ, TAB, pp->blt_clm, TAB, pp->tpmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* O[v}X^ grp                            */
int dmp_grm_td( ZMRP &g, struct grm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct grm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "grm_td", TAB, pm);
	if( g.jmf ) Dprintf("KO[vR[h%sO[v%s׊t%sR%s擪̕iڃO[v%s擪̃VbvO[v" CR, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%s%s%d%s%d%s%d%s%d%s%d" CR,
			pp->grp_cd, TAB, pp->grp_typ, TAB, pp->warituke, TAB, pp->kuzusi, TAB, pp->topigm, TAB, pp->topsgm);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* iڃO[v}X^ igm                        */
int dmp_igm_td( ZMRP &g, struct igm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct igm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "igm_td", TAB, pm);
	if( g.jmf ) Dprintf("KiڃR[h%sKO[vR[h%sDx%sO[v̕iڃO[v" CR, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d" CR,
			pp->itm, TAB, pp->grm, TAB, pp->prty, TAB, pp->grmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* VbvO[v}X^ sgm                    */
int dmp_sgm_td( ZMRP &g, struct sgm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct sgm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "sgm_td", TAB, pm);
	if( g.jmf ) Dprintf("KVbvR[h%sKO[vR[h%sDx%sO[ṽVbvO[v" CR, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d" CR,
			pp->shm, TAB, pp->grm, TAB, pp->prty, TAB, pp->grmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* iڃVbvO[v isg                      */
int dmp_isg_td( ZMRP &g, struct isg_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct isg_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "isg_td", TAB, pm);
	if( g.jmf ) Dprintf("KiڃR[h%sKVbvR[h%sKO[vR[h%siڃO[v%sVbvO[v%sDx%siڃO[v̕iڃVbvO[v%sVbvO[v̕iڃVbvO[v" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%d%s%d%s%d%s%d%s%d" CR,
			pp->itm, TAB, pp->shm, TAB, pp->grm, TAB, pp->igm, TAB, pp->sgm, TAB, pp->prty
			, TAB, pp->igmnext, TAB, pp->sgmnext);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/* [XAbvi\ ubm */
int dmp_ubm_td( ZMRP &g, struct ubm_td *pp, int pm )
{
	int		rc		= 0;		//߂l
	struct ubm_td *ep = 0;		//I|C^
	//̓`FbN
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	//wb_o
	Dprintf("%s%s%d" CR, "ubm_td", TAB, pm);
	if( g.jmf ) Dprintf("KgpVbvR[h%sKViڃR[h%sKiڃR[h%s%sVbvR[h{iڂ̎̐Viڂal%sVbvR[h{Viڂ̎̋iڂal" CR, TAB, TAB, TAB, TAB, TAB);
	//f[^o
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("%d%s%d%s%d%s%g%s%d%s%d" CR,
			pp->shm, TAB, pp->newitm, TAB, pp->olditm, TAB, pp->size, TAB, pp->nextnew, TAB, pp->nextold);
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}
/*SẴ_v֐Ă */
int	zdumptbl1(ZMRP &g)
{
	int		rc		= 0;		//߂l

	dmp_sys_td( g, &g.sys, 1 );			/* VXe sys */
	dmp_cal_td( g, g.cal.v, g.cal.n );		/* ʎZ[NΉJ_ cal */
	dmp_clm_td( g, g.clm.v, g.clm.n, g.endtd );	/* J_R[hMST clm */
	dmp_org_td( g, g.org.v, g.org.n );		/* gD}X^ org */
	dmp_itm_td( g, g.itm.v, g.itm.n );		/* iڃ}X^ itm */
	dmp_bom_td( g, g.bom.v, g.bom.n );		/* i\ bom */
	dmp_shm_td( g, g.shm.v, g.shm.n );		/* Vbv}X^ shm */
	dmp_fsh_td( g, g.fsh.v, g.fsh.n );		/* Vbv fsh */
	dmp_fsh2_td( g, g.fsh2.v, g.fsh2.n );	/* Vbviԕʁj fsh2 */
	dmp_tsh_td( g, g.tsh.v, g.tsh.n );		/* gpVbv tsh */
	dmp_dlm_td( g, g.dlm.v, g.dlm.n );		/* }X^ dlm */
	dmp_dlm2_td( g, g.dlm2.v, g.dlm2.n );	/* }X^iԕʁjdlm2 */
	dmp_dlm3_td( g, g.dlm3.v, g.dlm3.n );	/* }X^iԕʁjdlm3 */
	dmp_fls_td( g, g.fls.v, g.fls.n );		/* bg܂Ƃߏ fls */
	dmp_fls2_td( g, g.fls2.v, g.fls2.n );	/* bg܂Ƃߏiԕʁj fls2 */
	dmp_dls_td( g, g.dls.v, g.dls.n );		/* ׃bg܂Ƃߏ dls */
	dmp_dls2_td( g, g.dls2.v, g.dls2.n );	/* ׃bg܂Ƃߏiԕʁj dls2 */
	dmp_odm_td( g, g.odm.v, g.odm.n );		/* ԁ^I[_No}X^ odm */
	dmp_rod_td( g, g.rod.v, g.rod.n );		/* 󒍃I[_ rod */
	dmp_pln_td( g, g.pln.v, g.pln.n );		/* ݐY(MPS)  pln */
	dmp_fto_td( g, g.fto.v, g.fto.n );		/* oɗ\ fto */
	dmp_opo_td( g, g.opo.v, g.opo.n );		/* I[_ opo */
	dmp_onh_td( g, g.onh.v, g.onh.n );		/* ݌ onh */
	dmp_saf_td( g, g.saf.v, g.saf.n );		/* S݌ saf */
	dmp_cpm_td( g, g.cpm.v, g.cpm.n );		/* \̓R[hMST cpm */
	dmp_cap_td( g, g.cap.v, g.cap.n );		/* \ cap */
	dmp_tpm_td( g, g.tpm.v, g.tpm.n );		/* A}X^ tpm */
	dmp_tpm2_td( g, g.tpm2.v, g.tpm2.n );	/* A}X^iԕʁj  tpm2 */
	dmp_grm_td( g, g.grm.v, g.grm.n );		/* O[v}X^ grm */
	dmp_igm_td( g, g.igm.v, g.igm.n );		/* iڃO[v}X^ igm */
	dmp_sgm_td( g, g.sgm.v, g.sgm.n );		/* VbvO[v}X^ sgm */
	dmp_isg_td( g, g.isg.v, g.isg.n );		/* iڃVbvO[v isg */
	dmp_ubm_td( g, g.ubm.v, g.ubm.n );		/* [XAbvi\ ubm */
	return( rc );
}
