static char	*__file =__FILE__;  /* should be copied into all .c files   */
/*
 * FILE      : zf1sub.cpp	lqovZ̋ʊ֐
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : lqovZ̋ʊ֐
 * AUTHOR    : N.Tsuchiya  2004.08.30
 */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"
/*	ID_zssc_itobf  lf[^o͗pzɏo
********************************************************/
int zssc_itobf(char *ermes, int pos, unsigned char dlm, int val) /* "%s%d", dlm, val */
{
	int bgn, end;
	char cwk;
	if( dlm ) ermes[pos++] = dlm;  //؂蕶ݒ
	if( val == 0 ) {
		ermes[pos++] = '0';
	} else {
		if( val < 0 ) {
			ermes[pos++] = '-';
			val = -val;
		}
		bgn = pos;
		for( ; val; val /= 10 ) { //10iϊit]j
			ermes[pos++] = '0' + val % 10;
		}
		for( end = pos - 1; bgn < end; ++bgn, --end) { //t]
			cwk = ermes[bgn]; ermes[bgn] = ermes[end]; ermes[end] = cwk;
		}
	}
	ermes[pos] = 0;
//	sprintf(ermes + pos, "%d", val);
//	pos += strlen(ermes + pos);
	return pos;
}
/*	ID_zssc_dtobf  lf[^o͗pzɏo
********************************************************/
int zssc_dtobf(char *ermes, int pos, unsigned char dlm, double val) /* "%s%g", dlm, val */
{
	if( dlm ) ermes[pos++] = dlm;
//	sprintf(ermes + pos, "%e", val);
	sprintf(ermes + pos, "%g", val);
	pos += strlen(ermes + pos);
	return pos;
}
/*	ID_zssc_stobf  f[^o͗pzɏo
********************************************************/
int zssc_stobf(char *ermes, int pos, unsigned char dlm, char *val) /* "%s%s", dlm, val */
{
	if( dlm ) ermes[pos++] = dlm;
	strcpy(ermes + pos, val);
	pos += strlen(ermes + pos);
	return pos;
}

/*	ID_zfGetTsh  iځAVbvgpVbvԂ
********************************************************/
int zfGetTsh( ZMRP &g, int aitm, int ashm, int atsh) /* rc 0: <0:ُ */
{
		                                CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if( atsh >= 0 ) {
		if( atsh >= g.tsh.n ) {         CHKA(0, atsh, g.tsh.n);
			atsh = -1;
		} else {                        CHKB(aitm, g.tsh.v[atsh].itm, aitm); CHKB(ashm, g.tsh.v[atsh].shm, ashm);
			if     ( aitm != g.tsh.v[atsh].itm ) atsh = -1;
			else if( ashm != g.tsh.v[atsh].shm ) atsh = -1;
			// iڂƃVbv}X^n߂vT[`ȂB
		}
		if( atsh >= 0 ) goto                      quit;// iڂƃVbv}X^n߂vT[`ȂB
	}
	if( atsh < 0 ) {
		for( atsh = g.itm.v[aitm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext )
			if( ashm == g.tsh.v[atsh].shm ) break;
	}
quit:                                   CHKA(-1, atsh, g.tsh.n); 
	return atsh;
}
/*	ID_zfGetFsh	iځAVbv狟VbvԂ
********************************************************/
int zfGetFsh( ZMRP &g,   /* rc 0: <0:ُ */
	int aitm,          /* i  iڔԍ */
	int ashm,
	int afsh)
{
		                                CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if( afsh >= 0 ) {
		if( afsh >= g.fsh.n ) {         CHKA(0, afsh, g.fsh.n);
			afsh = -1;
		} else {                        CHKB(aitm, g.fsh.v[afsh].itm, aitm); CHKB(ashm, g.fsh.v[afsh].shm, ashm);
			if     ( aitm != g.fsh.v[afsh].itm ) afsh = -1;
			else if( ashm != g.fsh.v[afsh].shm ) afsh = -1;
		}
		if( afsh >= 0 ) goto                                            quit;
	}
	if( afsh < 0 ) {
		for( afsh = g.itm.v[aitm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext )
			if( ashm == g.fsh.v[afsh].shm ) break;
	}
quit:                                   CHKA(-1, afsh, g.fsh.n); 
	return afsh;
}

/*	ID_zfAddZhi  ݌Ɉڍׂɒǉ
********************************************************/
int zfAddZhi( ZMRP &g, int ityp, int otyp, int iidx, int oidx, double size ) /* rc 0: <0:ُ */
{
	int		rc = 0, azhi;
	zhi_td	wzhi;
	            CHKB(1, ityp, 5); CHKB(1, otyp, 2);
	if(zdbgf[101]) {TRACEA(0); Dprintf("zfAddZhi ityp(%d) otyp(%d) iidx(%d) oidx(%d) size(%g)" CR
		, ityp, otyp, iidx, oidx, size );}
	if( ! ISPLUS(size) ) { CHKX(0.0, 0.0, size - g.epsi); goto                         quit;}
	azhi = g.zhi.n;
	wzhi.ityp  = ityp;      /*  ɑ 1:tonh 2:fto 3:pln 4:opo 5:fonh */
	wzhi.otyp  = otyp;      /*  oɑ 1:TRP1 2:FRP1  */
    wzhi.mrp1  = oidx;      /*K vTRP1܂FRP1           trp1[],frp1[] */
    wzhi.nyuko = iidx;      /*K ɑ                 fto[], pln[], opo[] */
    wzhi.size  = size;        /*  ʁiOj                                 */
	/*  ɑN */
	if       ( ityp == 1 ) {                      CHKA(0, iidx, g.onh.n);
	    wzhi.nextmrp = g.onh.v[iidx].topzhi1;   /*  gpVbv݌ */
		g.onh.v[iidx].topzhi1 = azhi;             CHKB(-1, g.onh.v[iidx].fsh, -1);
	} else if( ityp == 2 ) {                      CHKA(0, iidx, g.fto.n);
	    wzhi.nextmrp = g.fto.v[iidx].topzhi2;   /*  oɗ\ */
		g.fto.v[iidx].topzhi2 = azhi;
	} else if( ityp == 3 ) {                      CHKA(0, iidx, g.pln.n);
	    wzhi.nextmrp = g.pln.v[iidx].topzhi3;   /*  ݐY(MPS) */
		g.pln.v[iidx].topzhi3 = azhi;
	} else if( ityp == 4 ) {                      CHKA(0, iidx, g.opo.n);
	    wzhi.nextmrp = g.opo.v[iidx].topzhi4;   /*  I[_ */
		g.opo.v[iidx].topzhi4 = azhi;
	} else if( ityp == 5 ) {                      CHKA(0, iidx, g.onh.n);
	    wzhi.nextmrp = g.onh.v[iidx].topzhi1;   /*  Vbv݌ */
		g.onh.v[iidx].topzhi1 = azhi;             CHKB(-1, g.onh.v[iidx].tsh, -1);
	} else {                                      CHKA(1, ityp, 5);
	}
	/*  oɑN */
	if       ( otyp == 1 ) {                      CHKA(0, oidx, g.trp1.n);
	    wzhi.nextnyuko = g.trp1[oidx].topzhi1;     /*  vTRP1 */
		g.trp1[oidx].topzhi1 = azhi;
	} else if( otyp == 2 ) {                      CHKA(0, oidx, g.frp1.n);
	    wzhi.nextnyuko = g.frp1[oidx].topzhi2;     /*  vFRP1 */
		g.frp1[oidx].topzhi2 = azhi;
	} else {                                      CHKA(1, otyp, 2);
	}
	if( (rc = g.zhi.push_back(wzhi)) < 0 ) goto   quit;
                                             CHKB(rc, azhi, rc); //chg NT140612 warning C4701 
quit:
	if(zdbgf[101]) {TRACEC(0); Dprintf("zfAddZhi rc(%d) " CR, rc);}
	return rc;
}

/*	ID_zfAddLsz  bg܂Ƃߏڍׂɒǉ
********************************************************/
int zfAddLsz( ZMRP &g, int typ, int *topko, int *topoy, int oymrp, int komrp, double size  ) /* rc 0: <0:ُ */
{
	int		rc, alsz;
	lsz_td	wlsz;
	if( ! ISPLUS(size) ) CHKX(0.0, 0.0, size - g.epsi);
	if       ( typ == 1 ) { CHKA(-1, *topko, g.lsz.n); CHKA(0, komrp, g.trp2.n);
	                        CHKA(-1, *topoy, g.lsz.n); CHKA(0, oymrp, g.trp1.n);
	} else if( typ == 2 ) { CHKA(-1, *topko, g.lsz.n); CHKA(0, komrp, g.drp2.n);
	                        CHKA(-1, *topoy, g.lsz.n); CHKA(0, oymrp, g.drp1.n);
	} else if( typ == 3 ) { CHKA(-1, *topko, g.lsz.n); CHKA(0, komrp, g.frp2.n);
	                        CHKA(-1, *topoy, g.lsz.n); CHKA(0, oymrp, g.frp1.n);
	} else {                            CHKB(1, typ, 3);
	}
	alsz = g.lsz.n;         /* ǉ̃R[hԍ */
    wlsz.zhi_typ = typ;     /*  敪 1:TRP1-TRP2 2:DRP1-DRP2 3:FRP1-FRP2 */
    wlsz.oymrp = oymrp;     /*K ܂ƂߑOMRP1            trp1[],drp1[],frp1[] */
    wlsz.komrp = komrp;     /*K ܂ƂߌMRP2            trp2[],drp2[],frp2[] */
    wlsz.size  = size;      /*  ʁiOj                                 */
    wlsz.nextoy = *topoy;   /*  qMRP̐eMRP                   lsz[]or-1 */
	*topoy = alsz;       /*  擪trp2[].topoylsz1, drp2[].topoylsz2, frp2[].topoylsz3 */
    wlsz.nextko = *topko;   /*  eMRP̎qMRP                   lsz[]or-1 */
	*topko = alsz;
	if( (rc = g.lsz.push_back(wlsz)) < 0 ) goto                        quit;
quit:                                    CHKB(rc, alsz, rc);
	return rc;
}
/*	ID_zfAddTrp1  Trp1R[hǉ
********************************************************/
int zfAddTrp1( ZMRP &g, trp1_td &wtrp1,
	int aodm, int atsh, double size, int due, int abom, int aubm, int oyfrp2, int oytrp1, int lastusetd) /* rc 0: <0:ُ */
{
	int		rc, atrp1, toptrp1;
	trp1_td *ttrp1;
	            CHKA(0, aodm, g.odm.n); CHKA(0, atsh, g.tsh.n);
	            CHKB(0, due, g.endtd); CHKA(-1, oyfrp2, g.frp2.n);  CHKA(-1, oytrp1, g.trp1.n);
	if       ( abom >= 0 ) { CHKA(0, abom, g.bom.n); CHKB(-1, aubm, -1);
	} else if( aubm >= 0 ) { CHKB(-1, abom, -1); CHKA(0, aubm, g.ubm.n);
	}
	if( ! ISPLUS(size) )                CHKX(0.0, 0.0, size - g.epsi);
	atrp1  = g.trp1.n;      /* ǉ̃R[hԍ */
    wtrp1.odm   = aodm;     /*  \                                 odm[] */
	wtrp1.tsh   = atsh;     /*  gpVbv                     tsh[] */
    wtrp1.size  = size;     /*  v                                       */
    wtrp1.net   = 0.0;      /*  v(=0͎̎q)                     */
    wtrp1.uunet = 0.0;      /*  [XAbvvʁiVbv̂ڂpɕʕϐƂj */
    wtrp1.due   = due;      /*  v                                         */
    wtrp1.lastusetd = lastusetd;  /*  ŏIgp\                           */
    wtrp1.bom   = abom;     /*  WJɎgal                     bom[] */
	wtrp1.ubm   = aubm;     /*  WJɎgUBM                      ubm[] */
	wtrp1.oyfrp2 = oyfrp2;  /*  elqo P΂(ei)             frp2[] */
	wtrp1.uuoldtrp1 = oytrp1; /*  iڂsqoP P΂(i)       trp1[] */
    wtrp1.topkolsz1 = -1;   /*  qlqo ΂                 lsz[1]or-1 */
	wtrp1.nextko    = -1;   /*  e̎qTRP1                    trp1[]or-1 */
    wtrp1.topzhi1 = -1;     /*  擪̍݌ɈBnetvZ̏ڍ       zhi[1] */
	wtrp1.topuunew = -1;    /*  擪̐Vi P΂                trp1[1]or-1 */
	wtrp1.nextuunew = -1;   /*  ꋌiڎ̐ViTRP1            trp1[]or-1 */
	/* gpVbvN */
	toptrp1 = g.tsh.v[atsh].toptrp1; // 悸A擪oĒu 
	                                    CHKA(-1, toptrp1, g.trp1.n);
	wtrp1.daynext = toptrp1;        /*  gpVbvTRP1 trp1[]or-1 */
	wtrp1.daypred = -1;             /*  gpVbvOTRP1      trp1[]or-1 */
	g.tsh.v[atsh].toptrp1= atrp1; /*  擪tsh[].toptrp1                        */
	/* ̃R[h̋tNdaypredXV */
	if( toptrp1 < 0 ) {
		g.tsh.v[atsh].lastrp1= atrp1;
	} else {
		ttrp1 = &g.trp1[toptrp1];   /* ̃R[h̃AhX */
		ttrp1->daypred = atrp1;     /*  gpVbvOTRP1      trp1[]or-1 */
	}
	if(oyfrp2 >= 0) { CHKA(0, oyfrp2, g.frp2.n); // eFRP2Lꍇ FS040929
		/* e̎qN */
		wtrp1.nextko  = g.frp2[oyfrp2].topkotrp1; /*  e̎qTRP1      trp1[]or-1 */
		g.frp2[oyfrp2].topkotrp1 = atrp1; /*  擪frp2[].topkotrp1 */
	} else if( oytrp1 >= 0) { CHKA(0, oytrp1, g.trp1.n); // eTRP1Lꍇ
		/* e̎qN */
		wtrp1.nextuunew = g.trp1[oytrp1].topuunew; // ̎ɑO̐擪q
		g.trp1[oytrp1].topuunew = atrp1;           // 擪Ɍq
	} else { // FS040929
		CHKA(atrp1, 0, 0);
	}
	if( (rc = g.trp1.push_back(wtrp1)) < 0 ) goto                       quit;
quit:                                   CHKB(rc, atrp1, rc);
	return rc;
}
/*	ID_zfAddTrp2  Trp2R[hǉ
********************************************************/
int zfAddTrp2( ZMRP &g, trp2_td &wtrp2,
	int aodm, int atsh, double size, int due, int lastusetd) /* rc 0: <0:ُ */
{
	int		rc, atrp2, toptrp2;
	trp2_td *ttrp2;
	            CHKA(0, aodm, g.odm.n); CHKA(0, atsh, g.tsh.n); CHKB(0, due, g.endtd);
	if( ! ISPLUS(size) )                CHKX(0.0, 0.0, size - g.epsi);
	atrp2  = g.trp2.n;      /* ǉ̃R[hԍ */
    wtrp2.odm  = aodm;      /*  \                                 odm[] */
    wtrp2.tsh  = atsh;      /*  gpVbv                         tsh[] */
    wtrp2.size = size;      /*                                             */
	wtrp2.zansize = size;   /*  ̎c  Add TK041126                     */
    wtrp2.due  = due;       /*  v                                         */
    wtrp2.lastusetd = lastusetd;  /*  ŏIgp\                           */
    wtrp2.topoylsz1 = -1;   /*  elqo ΂                 lsz[1]or-1 */
    wtrp2.topkodrp1 = -1;   /*  qlqo P΂                     frp2[] */
	/* gpVbvN */
	toptrp2 = g.tsh.v[atsh].toptrp2;      CHKA(-1, toptrp2, g.trp2.n);
	wtrp2.daynext = toptrp2;        /*  gpVbvtrp2 trp2[]or-1 */
	wtrp2.daypred = -1;             /*  gpVbvOtrp2      trp2[]or-1 */
	g.tsh.v[atsh].toptrp2= atrp2; /*  擪tsh[].toptrp2                        */
	/* ̃R[h̋tNdaypredXV */
	if( toptrp2 < 0 ) {
		g.tsh.v[atsh].lastrp2= atrp2;
	} else {
		ttrp2 = &g.trp2[toptrp2];   /* ̃R[h̃AhX */
		ttrp2->daypred = atrp2;            /*  gpVbvOtrp2      trp2[]or-1 */
	}
	if( (rc = g.trp2.push_back(wtrp2)) < 0 ) goto                       quit;
quit:                                    CHKB(rc, atrp2, rc);
	return rc;
}
/*	ID_zfAddDrp1  Drp1R[hǉ
********************************************************/
int zfAddDrp1( ZMRP &g, drp1_td &wdrp1,
	int aodm,int adlm, double size, int iday, int oytrp2, int lastusetd) /* rc 0: <0:ُ */
{
	int		rc, adrp1, topdrp1, afsh, atsh;
	drp1_td *tdrp1;
	if( ! ISPLUS(size) )                CHKX(0.0, 0.0, size - g.epsi);
	                                    CHKA(-1, aodm, g.odm.n);
	                                    CHKA(0, adlm, g.dlm.n);
	                                    CHKA(0, oytrp2, g.trp2.n);
	                                    CHKB(0, iday, g.endtd);
	atsh = g.dlm.v[adlm].tsh;           CHKA(0, atsh, g.tsh.n);
	afsh = g.dlm.v[adlm].fsh;           CHKA(0, afsh, g.fsh.n);
	adrp1  = g.drp1.n;      /* ǉ̃R[hԍ */
	wdrp1.odm  = aodm;      /*  \                                 odm[] */
    wdrp1.dlm  = adlm;      /*  }X^                           dlm[] */
	wdrp1.size = size;      /*                                             */
	wdrp1.iday = iday;      /*  v                                       */
	wdrp1.oday = -1;        /*  ɓiv|ɂks|wksj         */ //##AddByKuro040916
    wdrp1.lastusetd = lastusetd;  /*  ŏIgp\                           */
	wdrp1.oytrp2 = oytrp2;  /*  elqo P΂(ei)             trp2[] */
	wdrp1.topkolsz2 = -1;   /*  qlqo ΂                 lsz[2]or-1 */
	/* e̎qN */
	wdrp1.nextko  = g.trp2[oytrp2].topkodrp1; /*  e̎qTRP1           drp1[]or-1 */
	g.trp2[oytrp2].topkodrp1 = adrp1; /*  擪trp2[].topkodrp1 */
	/* ꋟ}X^ɓN  NT041001add */
	topdrp1 = g.dlm.v[adlm].topdrp1i;      CHKA(-1, topdrp1, g.drp1.n);
	wdrp1.dlmidaynext = topdrp1;        /*  gpVbvTRP1 drp1[]or-1 */
	wdrp1.dlmidaypred = -1;             /*  gpVbvOTRP1      drp1[]or-1 */
	g.dlm.v[adlm].topdrp1i= adrp1; /*  擪dlm[].topdrp1                        */
	/* ̃R[h̋tNdaypredXV */
	if( topdrp1 < 0 ) {
		g.dlm.v[adlm].lasdrp1i = adrp1;
	} else {
		tdrp1 = &g.drp1[topdrp1];   /* ̃R[h̃AhX */
		tdrp1->dlmidaypred = adrp1;            /*  gpVbvOTRP1      drp1[]or-1 */
	}
	/* ꋟ}X^vN  NT041001add */
	topdrp1 = g.dlm.v[adlm].topdrp1o;      CHKA(-1, topdrp1, g.drp1.n);
	wdrp1.dlmodaynext = topdrp1;        /*  gpVbvTRP1 drp1[]or-1 */
	wdrp1.dlmodaypred = -1;             /*  gpVbvOTRP1      drp1[]or-1 */
	g.dlm.v[adlm].topdrp1o= adrp1; /*  擪dlm[].topdrp1                        */
	/* ̃R[h̋tNdaypredXV */
	if( topdrp1 < 0 ) {
		g.dlm.v[adlm].lasdrp1o = adrp1;
	} else {
		tdrp1 = &g.drp1[topdrp1];   /* ̃R[h̃AhX */
		tdrp1->dlmodaypred = adrp1;            /*  gpVbvOTRP1      drp1[]or-1 */
	}
	if( (rc = g.drp1.push_back(wdrp1)) < 0 ) goto                       quit;
quit:                                    CHKB(rc, adrp1, rc);
	return rc;
}
/*	ID_zfAddDrp2  Drp2R[hǉ
********************************************************/
int zfAddDrp2( ZMRP &g, drp2_td &wdrp2,
	int aodm,int adlm, int iday, int oday,double size, int lastusetd ) /* rc 0: <0:ُ */
{
	int		rc, adrp2, topdrp2, afsh, atsh;
	drp2_td *tdrp2;
	            CHKB(0, iday, g.endtd); CHKA(0, aodm, g.odm.n);
	            CHKB(-1, oday, iday);    CHKA(0, adlm, g.dlm.n);
	if( ! ISPLUS(size) )                CHKX(0.0, 0.0, size - g.epsi);
	atsh = g.dlm.v[adlm].tsh;           CHKA(0, atsh, g.tsh.n);
	afsh = g.dlm.v[adlm].fsh;           CHKA(0, afsh, g.fsh.n);
	adrp2  = g.drp2.n;     /* ǉ̃R[hԍ */
    wdrp2.odm  = aodm;     /*  \                                 odm[] */
    wdrp2.dlm  = adlm;     /*  }X^                           dlm[] */
    wdrp2.size = size;     /*                                             */
    wdrp2.iday = iday;     /*  ɓ                                         */
    wdrp2.oday = oday;     /*  oɓ                                         */
    wdrp2.lastusetd = lastusetd;  /*  ŏIgp\                           */
    wdrp2.yukoday   = -1;  /*  gp                                       */
    wdrp2.topoylsz2 = -1;  /*  elqo ΂                     trp2[] */
    wdrp2.kofrp1 = -1;     /*  qlqo O΂P                 frp1[]or-1 */
	/* ꋟ}X^ɓN  NT041001add */
	topdrp2 = g.dlm.v[adlm].topdrp2i;      CHKA(-1, topdrp2, g.drp2.n);
	wdrp2.dlmidaynext = topdrp2;        /*  ꋟ}X^ɓTRP1 drp2[]or-1 */
	wdrp2.dlmidaypred = -1;             /*  ꋟ}X^ɓOTRP1      drp2[]or-1 */
	g.dlm.v[adlm].topdrp2i= adrp2;        /*  擪dlm[].topdrp2                        */
	/* ̃R[h̋tNdaypredXV */
	if( topdrp2 < 0 ) {
		g.dlm.v[adlm].lasdrp2i = adrp2;
	} else {
		tdrp2 = &g.drp2[topdrp2];       /* ̃R[h̃AhX */
		tdrp2->dlmidaypred = adrp2;     /*  ꋟ}X^OTRP1      drp2[]or-1 */
	}
	/* ꋟ}X^oɓN  NT041001add */
	topdrp2 = g.dlm.v[adlm].topdrp2o;      CHKA(-1, topdrp2, g.drp2.n);
	wdrp2.dlmodaynext = topdrp2;        /*  ꋟ}X^oɓDRP2 drp2[]or-1 */
	wdrp2.dlmodaypred = -1;             /*  ꋟ}X^oɓODRP2 drp2[]or-1 */
	g.dlm.v[adlm].topdrp2o= adrp2;        /*  擪dlm[].topdrp2                        */
	/* ̃R[h̋tNdaypredXV */
	if( topdrp2 < 0 ) {
		g.dlm.v[adlm].lasdrp2o = adrp2;
	} else {
		tdrp2 = &g.drp2[topdrp2];       /* ̃R[h̃AhX */
		tdrp2->dlmodaypred = adrp2;     /*  ꋟ}X^ODRP2      drp2[]or-1 */
	}

	/* R[h̒ǉ */
	if( (rc = g.drp2.push_back(wdrp2)) < 0 ) goto                       quit;
quit:                                    CHKB(rc, adrp2, rc);
	return rc;
}
/*	ID_zfAddFrp1  Frp1R[hǉ
********************************************************/
int zfAddFrp1( ZMRP &g, frp1_td &wfrp1,
	int aodm, int afsh, double size, int due, int oydrp2, int oyodm, int lastusetd ) /* rc 0: <0:ُ */
{
	int		rc, afrp1, topfrp1;
	frp1_td *tfrp1;
	            CHKA(0, aodm, g.odm.n); CHKA(0, afsh, g.fsh.n); CHKB(0, due, g.endtd);
	            CHKA(-1, oydrp2, g.drp2.n); CHKA(-1, oyodm, g.odm.n);
	if( ! ISPLUS(size) )                CHKX(0.0, 0.0, size - g.epsi);
	afrp1  = g.frp1.n;     /* ǉ̃R[hԍ */
    wfrp1.odm  = aodm;     /*  \                                 odm[] */
    wfrp1.fsh  = afsh;     /*  Vbv                         fsh[] */
    wfrp1.size = size;     /*  v                                       */
    wfrp1.net  = size;     /*  v(=0͎̎q)                     */
    wfrp1.due  = due;      /*  v                                         */
    wfrp1.lastusetd = lastusetd; /*  ŏIgp\                           */
    wfrp1.oydrp2 = oydrp2; /*  elqo O΂P                 drp2[]or-1 */
    wfrp1.topkolsz3 = -1;  /*  qlqo ΂                 lsz[3]or-1 */
    wfrp1.topzhi2 = -1;    /*  擪̍݌ɈBnetvZ̏ڍ       zhi[] */
    wfrp1.oyodm = oyodm;   /*  쐬BݐY(MPS)          pln[]or-1 */
	/* e̎qN */
	if( oydrp2 >= 0 ) {  /* edrp2 */
		CHKB(-1, oyodm, -1); CHKA(0, oydrp2, g.drp2.n);
	} else {             /* eԏB(󒍁AoɁA) */
		CHKA(0, oyodm, g.odm.n);
	}
	/* ꋟVbvN */
	topfrp1 = g.fsh.v[afsh].topfrp1;       CHKA(-1, topfrp1, g.frp1.n);
	wfrp1.daynext = topfrp1;        /*  ꋟVbvTRP1 frp1[]or-1 */
	wfrp1.daypred = -1;             /*  ꋟVbvOTRP1 frp1[]or-1 */
	g.fsh.v[afsh].topfrp1= afrp1; /*  擪fsh[].topfrp1                        */
	/* ̃R[h̋tNdaypredXV */
	if( topfrp1 < 0 ) {
		g.fsh.v[afsh].lasfrp1 = afrp1;
	} else {
		tfrp1 = &g.frp1[topfrp1];   /* ̃R[h̃AhX */
		tfrp1->daypred = afrp1;     /*  gpVbvOTRP1      frp1[]or-1 */
	}
	if( (rc = g.frp1.push_back(wfrp1)) < 0 ) goto                       quit;
quit:                                    CHKB(rc, afrp1, rc);
	return rc;
}
/*	ID_zfAddFrp2  Frp2R[hǉ
********************************************************/
int zfAddFrp2( ZMRP &g, frp2_td &wfrp2, int aodm, int afsh, double size, int due, int bgn,
		int maetaosi, int plandue, int planduetm, int planbgn, int planbgntm, int oyodm, int lastusetd, int yukoday) /* rc 0: <0:ُ */
{
	int		rc, afrp2, topfrp2;
	frp2_td *tfrp2;
	            CHKA(0, aodm, g.odm.n); CHKA(0, afsh, g.fsh.n); CHKB(0, due, g.endtd);
	            CHKA(-1, oyodm, g.odm.n); CHKB(-1, bgn, g.endtd);
				CHKB(-1, maetaosi, bgn);
	if( ! ISPLUS(size) )                CHKX(0.0, 0.0, size - g.epsi);
	afrp2  = g.frp2.n;     /* ǉ̃R[hԍ */
    wfrp2.odm  = aodm;     /*  \                                 odm[] */
    wfrp2.fsh  = afsh;     /*  Vbv                         fsh[] */
    wfrp2.size = size;     /*                                             */
    wfrp2.due  = due;      /*  [                                         */
    wfrp2.bgn  = bgn;      /*                                           */
	wfrp2.maetaosi  = maetaosi;   /*  O|\B|O|\(ғ) NT041104add */
    wfrp2.lastusetd = lastusetd;  /*  ŏIgp\                          */
    wfrp2.yukoday   = yukoday;    /*  gp                                */
    wfrp2.plandue   = plandue;    /*  H\                              */
    wfrp2.planbgn   = planbgn;    /*  \                              */
    wfrp2.planduetm = planduetm;  /*  H\莞                            */
    wfrp2.planbgntm = planbgntm;  /*  \莞                            */
    wfrp2.oyodm = oyodm;    /*  쐬ԏBI[_     odm[]or-1 */
	wfrp2.st    = 0.0;      /*  Ǝ      Pʂ͕                         */
    wfrp2.topoylsz3 = -1;   /*  elqo ΂                 lsz[3]or-1 */
    wfrp2.topkotrp1 = -1;   /*  qlqo P΂ (qi)        frp2[]or-1 */
	/* ꋟVbvNi[j */
	topfrp2 = g.fsh.v[afsh].topfrp2due;   CHKA(-1, topfrp2, g.frp2.n);
	wfrp2.duenext = topfrp2;        /*  ꋟVbvFRP2  frp2[]or-1 */
	wfrp2.duepred = -1;             /*  ꋟVbvOFRP2  frp2[]or-1 */
	g.fsh.v[afsh].topfrp2due = afrp2; /*  擪fsh[].topfrp2                        */
	/* ̃R[h̋tNdaypredXV */
	if( topfrp2 < 0 ) {
		g.fsh.v[afsh].lasfrp2due = afrp2;
	} else {
		tfrp2 = &g.frp2[topfrp2];   /* ̃R[h̃AhX */
		tfrp2->duepred = afrp2;     /*  gpVbvOTRP1      frp2[]or-1 */
	}
	/* ꋟVbvNij */
	topfrp2 = g.fsh.v[afsh].topfrp2bgn;   CHKA(-1, topfrp2, g.frp2.n);
	wfrp2.bgnnext = topfrp2;        /*  ꋟVbvFRP2  frp2[]or-1 */
	wfrp2.bgnpred = -1;             /*  ꋟVbvOFRP2  frp2[]or-1 */
	g.fsh.v[afsh].topfrp2bgn = afrp2; /*  擪fsh[].topfrp2                        */
	/* ̃R[h̋tNdaypredXV */
	if( topfrp2 < 0 ) {
		g.fsh.v[afsh].lasfrp2bgn = afrp2;
	} else {
		tfrp2 = &g.frp2[topfrp2];   /* ̃R[h̃AhX */
		tfrp2->bgnpred = afrp2;     /*  gpVbvOTRP1      frp2[]or-1 */
	}
	if( (rc = g.frp2.push_back(wfrp2)) < 0 ) goto                       quit;
quit:                                    CHKB(rc, afrp2, rc);
	return rc;
}
static int setunuse_itm(ZMRP &g, int aitm_p)
{
	int abom, aubm;
	int aitm, aitm2;
	int atsh, afsh;
	                                    CHKA(0, aitm_p, g.itm.n);
	if( aitm_p < 0 || aitm_p >= g.itm.n) goto                           quit;
										CHKB(1, g.itm.v[aitm_p].unuse_flg, 1);
//KS140603chg	if( aitm_p < 0 || aitm_p >= g.itm.n) goto                           quit;
	//iaitm_pLɂ
//	if( g.itm.v[aitm_p].unuse_flg == 0 ) goto                           quit;
	g.itm.v[aitm_p].unuse_flg = 0;
	//ʂanlŕiaitm_p̎qiڂLɂ
	for(abom = g.itm.v[aitm_p].topkobm; abom >= 0; abom = g.bom.v[abom].nextko) { CHKA(0, abom, g.bom.n);
		aitm = g.bom.v[abom].koitm;     CHKA(0, aitm, g.itm.n);
		if(g.itm.v[aitm].unuse_flg == 0) continue;
		setunuse_itm(g, aitm);
	}
	//UUBOMŋiaitm_pɑ΂ViڂLɂ
	for(aubm = g.itm.v[aitm_p].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew) { CHKA(0, aubm, g.ubm.n);
		aitm = g.ubm.v[aubm].newitm;    CHKA(0, aitm, g.itm.n);
		if(g.itm.v[aitm].unuse_flg == 0) continue;
		setunuse_itm(g, aitm);
	}
	//Vbvʂanlŕiaitm_p̎qiڂLɂ
	for(afsh = g.itm.v[aitm_p].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].itmnext) {
		for(abom = g.fsh.v[afsh].topkobm; abom >= 0; abom = g.bom.v[abom].nextko) { CHKA(0, abom, g.bom.n);
			aitm = g.bom.v[abom].koitm; CHKA(0, aitm, g.itm.n);
			if(g.itm.v[aitm].unuse_flg == 0) continue;
			setunuse_itm(g, aitm);
//NT041213del ashm = g.fsh.v[afsh].shm;   CHKA(0, ashm, g.shm.n);
//			for(atsh = g.itm.v[aitm].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext) {
//				if(ashm != g.tsh.v[atsh].shm) continue;
//				for(aubm = g.tsh.v[atsh].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew) {
//			                             CHKA(0, aubm, g.ubm.n);
//					aitm2 = g.ubm.v[aubm].newitm; CHKA(0, aitm2, g.itm.n);
//					if(g.itm.v[aitm2].unuse_flg == 0) continue;
//					setunuse_itm(g, aitm2);
//				}
//			}
		}
	}
	//VbvUUBOMŋiaitm_pɑ΂ViڂLɂ@NT041213add
	for(atsh = g.itm.v[aitm_p].toptsh; atsh >= 0; atsh = g.tsh.v[atsh].itmnext) {
		for(aubm = g.tsh.v[atsh].topnewubm; aubm >= 0; aubm = g.ubm.v[aubm].nextnew) { CHKA(0, aubm, g.ubm.n);
			aitm2 = g.ubm.v[aubm].newitm; CHKA(0, aitm2, g.itm.n);
			if(g.itm.v[aitm2].unuse_flg == 0) continue;
			setunuse_itm(g, aitm2);
		}
	}
quit:
	return 0;
}
int setunuse_flg(ZMRP &g) // FS041207A
{
	int arod, apln, aopo, afto;
	int abom, aubm, ashm, atsh, afsh;
	int aitm, oyitm, koitm;

	//iڂ̖tO1:ɏB0:L 1:
	for(aitm = 0; aitm < g.itm.n; aitm++) {
		g.itm.v[aitm].unuse_flg = 1;
	}
	//󒍃I[_̕iڂƂ̑iڂLɂ
	for(arod = 0; arod < g.rod.n; arod++) {
		afsh = g.rod.v[arod].fsh;       CHKA(0, afsh, g.fsh.n);
		if( afsh < 0 || afsh >= g.fsh.n ) continue;
		aitm = g.fsh.v[afsh].itm;       CHKA(0, aitm, g.itm.n);
		if(g.itm.v[aitm].unuse_flg == 0) continue;
		setunuse_itm(g, aitm);
	}
	//ݐY(MPS)̕iڂƂ̑iڂLɂ
	for(apln = 0; apln < g.pln.n; apln++) {
		afsh = g.pln.v[apln].fsh;       CHKA(0, afsh, g.fsh.n);
		if( afsh < 0 || afsh >= g.fsh.n ) continue;
		aitm = g.fsh.v[afsh].itm;       CHKA(0, aitm, g.itm.n);
		if(g.itm.v[aitm].unuse_flg == 0) continue;
		setunuse_itm(g, aitm);
	}
	//I[_̕iڂƂ̑iڂLɂ
	for(aopo = 0; aopo < g.opo.n; aopo++) {
		afsh = g.opo.v[aopo].fsh;       CHKA(0, afsh, g.fsh.n);
		if( afsh < 0 || afsh >= g.fsh.n ) continue;
		aitm = g.fsh.v[afsh].itm;       CHKA(0, aitm, g.itm.n);
		if(g.itm.v[aitm].unuse_flg == 0) continue;
		setunuse_itm(g, aitm);
	}
	//oɗ\̕iڂƂ̑iڂLɂ
	for(afto = 0; afto < g.fto.n; afto++) {
		atsh = g.fto.v[afto].tsh;       CHKA(0, atsh, g.tsh.n);
		if( atsh < 0 || atsh >= g.tsh.n ) continue;
		aitm = g.tsh.v[atsh].itm;       CHKA(0, aitm, g.itm.n);
		if(g.itm.v[aitm].unuse_flg == 0) continue;
		setunuse_itm(g, aitm);
	}
	//anl̖tOݒB0:L 1:
	for(abom = 0; abom < g.bom.n; abom++) {
		oyitm = g.bom.v[abom].oyitm;      CHKA(0, oyitm, g.itm.n);
		koitm = g.bom.v[abom].koitm;      CHKA(0, koitm, g.itm.n);
		if(g.itm.v[oyitm].unuse_flg == 0 ) { CHKB(0, g.itm.v[koitm].unuse_flg, 0);
			g.bom.v[abom].unuse_flg = 0;
		} else {
			g.bom.v[abom].unuse_flg = 1;
		}
//		if(g.itm.v[oyitm].unuse_flg == 1 || g.itm.v[koitm].unuse_flg == 1) {
//			g.bom.v[abom].unuse_flg = 1;
//		} else {
//			g.bom.v[abom].unuse_flg = 0;
//		}
	}
	//ttal̖tOݒB0:L 1:
	for(aubm = 0; aubm < g.ubm.n; aubm++) {
		oyitm = g.ubm.v[aubm].olditm;      CHKA(0, oyitm, g.itm.n);
		koitm = g.ubm.v[aubm].newitm;      CHKA(0, koitm, g.itm.n);
		if(g.itm.v[oyitm].unuse_flg == 0 ) { CHKB(0, g.itm.v[koitm].unuse_flg, 0);
			g.ubm.v[aubm].unuse_flg = 0;
		} else {
			g.ubm.v[aubm].unuse_flg = 1;
		}
	}
	//Vbv̖tOݒB0:L 1:
	for(afsh = 0; afsh < g.fsh.n; afsh++) {
		aitm = g.fsh.v[afsh].itm;          CHKA(0, aitm, g.itm.n);
		g.fsh.v[afsh].unuse_flg = g.itm.v[aitm].unuse_flg;
	}
	//gpVbv̖tOݒB0:L 1:
	for(atsh = 0; atsh < g.tsh.n; atsh++) {
		aitm = g.tsh.v[atsh].itm;          CHKA(0, aitm, g.itm.n);
		g.tsh.v[atsh].unuse_flg = g.itm.v[aitm].unuse_flg;
	}
	//Vbv}X^̖tO1:ɏB0:L 1:
	for(ashm = 0; ashm < g.shm.n; ashm++) {
		g.shm.v[ashm].unuse_flg = 1;
	}
	//Vbv}X^̖tOݒ(1)B0:L 1:
	for(afsh = 0; afsh < g.fsh.n; afsh++) {
		if(g.fsh.v[afsh].unuse_flg == 0) {
			ashm = g.fsh.v[afsh].shm;          CHKA(0, ashm, g.shm.n);
			g.shm.v[ashm].unuse_flg = 0;
		}
	}
	//Vbv}X^̖tOݒ(2)B0:L 1:
	for(atsh = 0; atsh < g.tsh.n; atsh++) {
		if(g.tsh.v[atsh].unuse_flg == 0) {
			ashm = g.tsh.v[atsh].shm;          CHKA(0, ashm, g.shm.n);
			g.shm.v[ashm].unuse_flg = 0;
		}
	}
#if 0 // FS041209
	{
		int count;
		int aubm;
		int newitm;
		int olditm;
//J		char *tbl[2] = { "L", ""};
		FILE *fp = fopen("fff.txt", "w");
		count = 0;
		for(abom = 0; abom < g.bom.n; abom++) {
			oyitm = g.bom.v[abom].oyitm;
			koitm = g.bom.v[abom].koitm;
			if(g.itm.v[oyitm].unuse_flg == 1) count++;
			if(g.itm.v[oyitm].unuse_flg == 0 && g.itm.v[koitm].unuse_flg == 1)
				fprintf(fp, " %s(%s)-%s(%s)" CR,
//J				fprintf(fp, "L^tOsv %s(%s)-%s(%s)" CR,
					g.itm.v[oyitm].itm_cd,
					tbl[g.itm.v[oyitm].unuse_flg],
					g.itm.v[koitm].itm_cd,
					tbl[g.itm.v[koitm].unuse_flg]);
		}
		fprintf(fp, "total bom(%d) unuse cnt(%d)" CR, g.bom.n, count);
//J		fprintf(fp, "total bom(%d) unuse cnt(%d)" CR, g.bom.n, count);
		count = 0;
		for(aubm = 0; aubm < g.ubm.n; aubm++) {
			newitm = g.ubm.v[aubm].newitm;
			olditm = g.ubm.v[aubm].olditm;
			if(g.itm.v[olditm].unuse_flg == 1) count++;
			if(g.itm.v[olditm].unuse_flg != g.itm.v[newitm].unuse_flg)
				fprintf(fp, " %s-%s" CR,
//J				fprintf(fp, "L^tOsv %s-%s" CR,
					g.itm.v[olditm].itm_cd,
					g.itm.v[newitm].itm_cd);
		}
		fprintf(fp, "total ubm(%d) unuse cnt(%d)" CR, g.ubm.n, count);
//J		fprintf(fp, "total ubm(%d) unuse cnt(%d)" CR, g.ubm.n, count);
		for(aitm = 0; aitm < g.itm.n; aitm++) {
//			fprintf(fp, "i(%4d) flg(%d) %s" CR, aitm, g.itm.v[aitm].unuse_flg, g.itm[aitm].itm_cd);
		}
		fclose(fp);
	}
#endif
	return 0;
}
