/*
 * FILE      : zsortdt.cpp	ԕʏLJnɃ\[g
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : ԕʏLJnɃ\[g
 * AUTHOR    : H.Yamagiwa  2004.09.09
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */

#include <stdio.h>

#if defined _WIN32
//#  include <stdlib.h>
#else
//#  include <conv.h>
#endif

#include "z1mrp.h"
static int Compfsh2( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.fsh2.v[*p].bgnday - g.fsh2.v[*q].bgnday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortfsh	Vbv̊ԕʏLJnɃ\[g
********************************************************/
static int zsortfsh( ZMRP &g )
{
	int		rc = 0, afsh, afsh2, last, i;

	/* Vbv fsh */
	for( afsh = 0; afsh < g.fsh.n; ++afsh ) {
		/* ԕʏLJnɃ\[g */
		g.sortw.clear();
		for( afsh2 = g.fsh.v[afsh].topfsh2; afsh2 >= 0; afsh2 = g.fsh2.v[afsh2].fshnext ) { CHKA(0, afsh2, g.fsh2.n);
			if ( afsh2 >= g.fsh2.n ) goto                               quit;
			if( ( rc = g.sortw.push_back(afsh2)) < 0 ) goto             quit;
		}
		zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Compfsh2 );
		last = -1;
		g.fsh.v[afsh].topfsh2 = -1;  /* 擪 */
		for( i = 0; i < g.sortw.n; ++i ) {
			afsh2 = g.sortw.v[i];       CHKA(0, afsh2, g.fsh2.n);
			if ( afsh2 < 0 || afsh2 >= g.fsh2.n ) continue;
			g.fsh2.v[afsh2].fshnext = -1;
			g.fsh2.v[afsh2].fshpred = last;
			if( g.fsh.v[afsh].topfsh2 < 0 ) {
				g.fsh.v[afsh].topfsh2 = afsh2;
			} else {                    CHKA(0, last, g.fsh2.n);
				g.fsh2.v[last].fshnext = afsh2;
			}
			last = afsh2;
		}
	}
	rc = 0;
quit:
	return( rc );
}
static int Compdlm2( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.dlm2.v[*p].bgnday - g.dlm2.v[*q].bgnday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortdlm	}X^̊ԕʏLJnɃ\[g
********************************************************/
static int zsortdlm( ZMRP &g )
{
	int		rc = 0, adlm, adlm2, last, i;
	/* }X^ dlm */
	for( adlm = 0; adlm < g.dlm.n; ++adlm ) {
		g.sortw.clear();
		for( adlm2 = g.dlm.v[adlm].topdlm2; adlm2 >= 0; adlm2 = g.dlm2.v[adlm2].dlmnext ) { CHKA(0, adlm2, g.dlm2.n);
			if ( adlm2 >= g.dlm2.n ) goto                               quit;
			if( ( rc = g.sortw.push_back(adlm2)) < 0 ) goto             quit;
		}
		zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Compdlm2 );
		last = -1;
		g.dlm.v[adlm].topdlm2 = -1;  /* 擪 */
		for( i = 0; i < g.sortw.n; ++i ) {
			adlm2 = g.sortw.v[i];       CHKA(0, adlm2, g.dlm2.n);
			if ( adlm2 < 0 || adlm2 >= g.dlm2.n ) continue;
			g.dlm2.v[adlm2].dlmnext = -1;
			g.dlm2.v[adlm2].dlmpred = last;
			if( g.dlm.v[adlm].topdlm2 < 0 ) {
				g.dlm.v[adlm].topdlm2 = adlm2;
			} else {                    CHKA(0, last, g.dlm2.n);
				g.dlm2.v[last].dlmnext = adlm2;
			}
			last = adlm2;
		}
	}
	rc = 0;
quit:
	return( rc );
}
static int Compdlmp( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	int   pfsh, qfsh, pshm, qshm;
	//int   pdlm2, qdlm2;

	pfsh  = g.dlm.v[*p].fsh;    CHKA(0, pfsh, g.fsh.n);   //}X^̋Vbv擾
	pshm  = g.fsh.v[pfsh].shm;  CHKA(0, pshm, g.shm.n);   //Vbv񂩂Vbv}X^擾
	//pdlm2 = g.shm.v[pshm].iwk1; CHKA(0, pdlm2, g.dlm2.n); //Vbv}X^ۑdlm2擾

	qfsh  = g.dlm.v[*q].fsh;    CHKA(0, qfsh, g.fsh.n);   //}X^̋Vbv擾
	qshm  = g.fsh.v[qfsh].shm;  CHKA(0, qshm, g.shm.n);   //Vbv񂩂Vbv}X^擾
	//qdlm2 = g.shm.v[qshm].iwk1; CHKA(0, qdlm2, g.dlm2.n); //Vbv}X^ۑdlm2擾

	//rc = (int)g.dlm2.v[pdlm2].haibun - (int)g.dlm2.v[qdlm2].haibun;
	rc = (int)g.shm.v[pshm].dwk2 - (int)g.shm.v[qshm].dwk2; //Change TK041206

	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortdlmp@}X^̊ԕʏD揇ʏɃ\[g
********************************************************/
int zsortdlmp( ZMRP &g, int atsh )
{
	int		rc = 0, adlm, last, i;
	/* }X^ dlm */
	                                    CHKA(0, atsh, g.tsh.n);
	g.sortw.clear();
	for (adlm = g.tsh.v[atsh].topdlm; adlm>=0 ; adlm = g.dlm.v[adlm].tshnext) { CHKA(0, adlm, g.dlm.n);
		if ( adlm >= g.dlm.n ) goto                                     quit;
		if( ( rc = g.sortw.push_back(adlm)) < 0 ) goto                  quit;
	}
	zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Compdlmp );
	last = -1;
	g.tsh.v[atsh].topdlm = -1;  /* 擪 */
	for( i = 0; i < g.sortw.n; ++i ) {
		adlm = g.sortw.v[i];            CHKA(0, adlm, g.dlm.n);
		if ( adlm < 0 || adlm >= g.dlm.n ) continue;
		g.dlm.v[adlm].tshnext = -1;
		if( g.tsh.v[atsh].topdlm < 0 ) {
			g.tsh.v[atsh].topdlm = adlm;
		} else {                        CHKA(0, last, g.dlm.n);
			g.dlm.v[last].tshnext = adlm;
		}
		last = adlm;
	}
	rc = 0;
quit:
	return( rc );
}
static int Compfls2( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.fls2.v[*p].bgnday - g.fls2.v[*q].bgnday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortfls	bg܂Ƃߏ̊ԕʏLJnɃ\[g
********************************************************/
static int zsortfls( ZMRP &g )
{
	int		rc = 0, afls, afls2, last, i;
	/* bg܂Ƃߏ fls  */
	for( afls = 0; afls < g.fls.n; ++afls ) {
		g.sortw.clear();
		for( afls2 = g.fls.v[afls].topfls2; afls2 >= 0; afls2 = g.fls2.v[afls2].flsnext ) { CHKA(0, afls2, g.fls2.n);
			if ( afls2 >= g.fls2.n ) goto                               quit;
			if( ( rc = g.sortw.push_back(afls2)) < 0 ) goto             quit;
		}
		zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Compfls2 );
		last = -1;
		g.fls.v[afls].topfls2 = -1;  /* 擪 */
		for( i = 0; i < g.sortw.n; ++i ) {
			afls2 = g.sortw.v[i];       CHKA(0, afls2, g.fls2.n);
			if ( afls2 < 0 || afls2 >= g.fls2.n ) continue;
			g.fls2.v[afls2].flsnext = -1;
			g.fls2.v[afls2].flspred = last;
			if( g.fls.v[afls].topfls2 < 0 ) {
				g.fls.v[afls].topfls2 = afls2;
			} else {                    CHKA(0, last, g.fls2.n);
				g.fls2.v[last].flsnext = afls2;
			}
			last = afls2;
		}
	}
	rc = 0;
quit:
	return( rc );
}
static int Compdls2( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.dls2.v[*p].bgnday - g.dls2.v[*q].bgnday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortdls	׃bg܂Ƃߏ̊ԕʏLJnɃ\[g
********************************************************/
static int zsortdls( ZMRP &g )
{
	int		rc = 0, adls, adls2, last, i;
	/* ׃bg܂Ƃߏ dls */
	for( adls = 0; adls < g.dls.n; ++adls ) {
		g.sortw.clear();
		for( adls2 = g.dls.v[adls].topdls2; adls2 >= 0; adls2 = g.dls2.v[adls2].dlsnext ) { CHKA(0, adls2, g.dls2.n);
			if ( adls2 >= g.dls2.n ) goto                               quit;
			if( ( rc = g.sortw.push_back(adls2)) < 0 ) goto             quit;
		}
		zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Compdls2 );
		last = -1;
		g.dls.v[adls].topdls2 = -1;
		for( i = 0; i < g.sortw.n; ++i ) {
			adls2 = g.sortw.v[i];       CHKA(0, adls2, g.dls2.n);
			if ( adls2 < 0 || adls2 >= g.dls2.n ) continue;
			g.dls2.v[adls2].dlsnext = -1;  /* 擪 */
			g.dls2.v[adls2].dlspred = last;
			if( g.dls.v[adls].topdls2 < 0 ) {
				g.dls.v[adls].topdls2 = adls2;
			} else {                    CHKA(0, last, g.dls2.n);
				g.dls2.v[last].dlsnext = adls2;
			}
			last = adls2;
		}
	}
	rc = 0;
quit:
	return( rc );
}
static int Comptpm2( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.tpm2.v[*p].bgnday - g.tpm2.v[*q].bgnday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsorttpm	A}X^̊ԕʏLJnɃ\[g
********************************************************/
static int zsorttpm( ZMRP &g )
{
	int		rc = 0, atpm, atpm2, last, i;
	/* A}X^ tpm */
	for( atpm = 0; atpm < g.tpm.n; ++atpm ) {
		g.sortw.clear();
		for( atpm2 = g.tpm.v[atpm].toptpm2; atpm2 >= 0; atpm2 = g.tpm2.v[atpm2].tpmnext ) { CHKA(0, atpm2, g.tpm2.n);
			if ( atpm2 >= g.tpm2.n ) goto                               quit;
			if( ( rc = g.sortw.push_back(atpm2)) < 0 ) goto             quit;
		}
		zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Comptpm2 );
		last = -1;
		g.tpm.v[atpm].toptpm2 = -1;  /* 擪 */
		for( i = 0; i < g.sortw.n; ++i ) {
			atpm2 = g.sortw.v[i];       CHKA(0, atpm2, g.tpm2.n);
			if ( atpm2 < 0 || atpm2 >= g.tpm2.n ) continue;
			g.tpm2.v[atpm2].tpmnext = -1;
			g.tpm2.v[atpm2].tpmpred = last;
			if( g.tpm.v[atpm].toptpm2 < 0 ) {
				g.tpm.v[atpm].toptpm2 = atpm2;
			} else {                    CHKA(0, last, g.tpm2.n);
				g.tpm2.v[last].tpmnext = atpm2;
			}
			last = atpm2;
		}
	}
	rc = 0;
quit:
	return( rc );
}
static int Compcap( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.cap.v[*p].bgnday - g.cap.v[*q].bgnday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortcap	\̓}X^̊ԕʏLJnɃ\[g
********************************************************/
static int zsortcap( ZMRP &g )
{
	int		rc = 0, acpm, acap, last, i;
	/* \̓R[hMST cpm */
	for( acpm = 0; acpm < g.cpm.n; ++acpm ) {
		g.sortw.clear();
		for( acap = g.cpm.v[acpm].topcap; acap >= 0; acap = g.cap.v[acap].cpmnext ) { CHKA(0, acap, g.cap.n);
			if ( acap >= g.cap.n ) goto                                 quit;
			if( ( rc = g.sortw.push_back(acap)) < 0 ) goto              quit;
		}
		zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Compcap );
		last = -1;
		g.cpm.v[acpm].topcap = -1;  /* 擪 */
		for( i = 0; i < g.sortw.n; ++i ) {
			acap = g.sortw.v[i];        CHKA(0, acap, g.cap.n);
			if ( acap < 0 || acap >= g.cap.n ) continue;
			g.cap.v[acap].cpmnext = -1;
			g.cap.v[acap].cpmpred = last;
			if( g.cpm.v[acpm].topcap < 0 ) {
				g.cpm.v[acpm].topcap = acap;
			} else {                    CHKA(0, last, g.cap.n); //NT050212 CHKA(0, last, g.tpm2.n);
				g.cap.v[last].cpmnext = acap;
			}
			last = acap;
		}
	}
	rc = 0;
quit:
	return( rc );
}
static int Componh( ZMRP &g, int *p, int *q ) 
{
	int		rc = 0;
	
	rc = g.onh.v[*p].yukoday - g.onh.v[*q].yukoday;
	if( rc == 0 )  rc = *p - *q;
	return( rc );
}
/*	ID_zsortonh_tsh	gpVbv݌ɂgpɃ\[g NT030924chg gp/pɕ
********************************************************/
int zsortonh_tsh( ZMRP &g, int atsh )
{
	int		rc = 0, aonh, last, i;
	                                    CHKA(0, atsh, g.tsh.n);
	if ( atsh < 0 || atsh >= g.tsh.n ) goto                             quit;
	/* gpVbv tsh */
	if( (aonh = g.tsh.v[atsh].toponh ) < 0 ) goto                       quit;
	g.sortw.clear();
	for( ; aonh >= 0; aonh = g.onh.v[aonh].next ) { CHKA(0, aonh, g.onh.n);
		if ( aonh >= g.onh.n ) goto                                     quit;
		if( ( rc = g.sortw.push_back(aonh)) < 0 ) goto                  quit;
	}
	zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Componh );
	last = -1;
	g.tsh.v[atsh].toponh = -1;  /* 擪 */
	for( i = 0; i < g.sortw.n; ++i ) {
		aonh = g.sortw.v[i];            CHKA(0, aonh, g.onh.n);
		if ( aonh < 0 || aonh >= g.onh.n ) continue;
		g.onh.v[aonh].next = -1;
		if( last < 0 ) {
			g.tsh.v[atsh].toponh = aonh;
		} else {                        CHKA(0, last, g.onh.n);
			g.onh.v[last].next = aonh;
		}
		last = aonh;
	}
	rc = 0;
quit:
	return( rc );
}
/*	ID_zsortonh_fsh	Vbv݌ɂgpɃ\[g NT030924chg gp/pɕ
********************************************************/
int zsortonh_fsh( ZMRP &g, int afsh )
{
	int		rc = 0, aonh, last, i;
	                                    CHKA(0, afsh, g.fsh.n);
	if ( afsh < 0 || afsh >= g.fsh.n ) goto                             quit;
	/* Vbv fsh */
	if( (aonh = g.fsh.v[afsh].toponh ) < 0 ) goto                       quit;
	g.sortw.clear();
	for( ; aonh >= 0; aonh = g.onh.v[aonh].next ) { CHKA(0, aonh, g.onh.n);
		if ( aonh >= g.onh.n ) goto                                     quit;
		if( ( rc = g.sortw.push_back(aonh)) < 0 ) goto                  quit;
	}
	zsort( g, g.sortw.v, g.sortw.n, sizeof(g.sortw.v[0]), QSORT_TYP Componh );
	last = -1;
	g.fsh.v[afsh].toponh = -1;  /* 擪 */
	for( i = 0; i < g.sortw.n; ++i ) {
		aonh = g.sortw.v[i];            CHKA(0, aonh, g.onh.n);
		if ( aonh < 0 || aonh >= g.onh.n ) continue;
		g.onh.v[aonh].next = -1;
		if( last < 0 ) {
			g.fsh.v[afsh].toponh = aonh;
		} else {                        CHKA(0, last, g.onh.n);
			g.onh.v[last].next = aonh;
		}
		last = aonh;
	}
	rc = 0;
quit:
	return( rc );
}
/*	ID_zsortdt	̓f[^̗LJn\[gE݌ɂ̎gp\[g
********************************************************/
int zsortdt( ZMRP &g )
{
	int 	rc, atsh, afsh;

	/* Vbv̗LJn\[g */
	if( ( rc = zsortfsh( g )) < 0 ) goto                                quit;
	/* }X^̗LJn\[g */
	if( ( rc = zsortdlm( g )) < 0 ) goto                                quit;
	/* bg܂Ƃߏ̗LJn\[g */
	if( ( rc = zsortfls( g )) < 0 ) goto                                quit;
	/* ׃bg܂Ƃߏ̗LJn\[g */
	if( ( rc = zsortdls( g )) < 0 ) goto                                quit;
	/* A}X^̗LJn\[g */
	if( ( rc = zsorttpm( g )) < 0 ) goto                                quit;
	/* \̓}X^̗LJn\[g */
	if( ( rc = zsortcap( g )) < 0 ) goto                                quit;
	/* gpVbv݌ɂ̗LJn\[g NT030924chg gp/pɕ */
	for( atsh = 0; atsh < g.tsh.n; ++atsh ) {
		if( (rc = zsortonh_tsh(g, atsh)) < 0 ) goto                                quit;
	}
	/* Vbv݌ɂ̗LJn\[g */
	for( afsh = 0; afsh < g.fsh.n; ++afsh ) {
		if( (rc = zsortonh_fsh(g, afsh)) < 0 ) goto                                quit;
	}
	rc = 0;
quit:
	return( rc );
}
