/*
 * FILE      : zsortlink.cpp	lqoe|uw肳ꂽɂă\[g
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : lqoe|uw肳ꂽɂă\[g
 * AUTHOR    : N.Tsuchiya  2004.08.30
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

/*	ID_compTrp1	Trp1R[hr
********************************************************/
static int compTrp1( ZMRP &g, int *p, int *q )
{
	int rc = g.trp1[*p].due - g.trp1[*q].due; /* v */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortTrp1	Trp1R[hvɃNtւ
********************************************************/
int zSortTrp1( ZMRP &g, int atsh)
{
	int rc=0, i, atrp1, lastrp1, ashm;
	trp1_td	*ptrp1;
	                                              CHKA(0, atsh, g.tsh.n);
	g.sortw.clear();
	for( atrp1 = g.tsh.v[atsh].toptrp1; atrp1 >= 0; atrp1 = g.trp1[atrp1].daynext ) {
		if( (rc = g.sortw.push_back(atrp1)) < 0 ) goto                  quit;
		ptrp1 = &g.trp1[atrp1];  CHKB(atsh, ptrp1->tsh, atsh); CHKA(0, ptrp1->odm, g.odm.n);
		ashm = g.tsh.v[atsh].shm;  CHKA(0, ashm, g.shm.n);
		   CHKX(0.0, 0.0, ptrp1->size); CHKB(0, ptrp1->due, g.endtd); CHKA(-1, ptrp1->bom, g.bom.n);
		if( g.shm.v[ashm].shm_typ == 1 ) { /*  Vbv敪  1:Vbv 2:񐻑Vbv  */
			if( ptrp1->bom >= 0 ) {     CHKA( 0, ptrp1->oyfrp2, g.frp2.n);
				                        CHKA(-1, ptrp1->nextko, g.trp1.n);
			} else {                    CHKA( 0, ptrp1->uuoldtrp1, g.trp1.n);
				                        CHKA(-1, ptrp1->nextuunew, g.trp1.n);
			}
		} else if( g.shm.v[ashm].shm_typ == 2 ) {
				                        CHKA( 0, ptrp1->oyfrp2, g.frp2.n);
		} else                          CHKB( 1, g.shm.v[ashm].shm_typ, 2);
		CHKA(-1, ptrp1->topzhi1, g.zhi.n);
		CHKA(-1, ptrp1->topkolsz1, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compTrp1 );
	g.tsh.v[atsh].toptrp1 = g.tsh.v[atsh].lastrp1 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		atrp1 = g.sortw.v[i];
		/* gpVbvN */
		lastrp1 = g.tsh.v[atsh].lastrp1; 
		if( lastrp1 < 0 ) {
			g.tsh.v[atsh].toptrp1 = atrp1;
		} else {
			g.trp1[lastrp1].daynext = atrp1;
		}
		g.trp1[atrp1].daynext = -1;
		g.trp1[atrp1].daypred = lastrp1;
		g.tsh.v[atsh].lastrp1 = atrp1;
	}
	rc = 0;
quit:
	return rc;
}
/*	ID_compTrp2	Trp2R[hr
********************************************************/
static int compTrp2( ZMRP &g, int *p, int *q )
{
	double	diff;
	int rc = g.trp2[*p].due - g.trp2[*q].due; /* v */
	if( rc == 0 ) {
		diff = g.trp2[*q].size - g.trp2[*p].size; /* ʂ̑傫 */
		if( diff < 0.0 ) rc = -1;
		else if( diff > 0.0 ) rc = 1;
	}
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortTrp2	Trp2R[hvɃNtւ
********************************************************/
int zSortTrp2( ZMRP &g, int atsh)
{
	int i, atrp2, lastrp2, rc=0;
	trp2_td	*ptrp2;
	                                              CHKA(0, atsh, g.tsh.n);
	g.sortw.clear();
	for( atrp2 = g.tsh.v[atsh].toptrp2; atrp2 >= 0; atrp2 = g.trp2[atrp2].daynext ) {
		if( (rc = g.sortw.push_back(atrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(atrp2);
		ptrp2 = &g.trp2[atrp2];  CHKB(atsh, ptrp2->tsh, atsh); CHKA(0, ptrp2->odm, g.odm.n);
		   CHKX(0.0, 0.0, ptrp2->size); CHKB(0, ptrp2->due, g.endtd);
		CHKA(-1, ptrp2->topkodrp1, g.drp1.n);
		CHKA(-1, ptrp2->topoylsz1, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compTrp2 );
	g.tsh.v[atsh].toptrp2 = g.tsh.v[atsh].lastrp2 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		atrp2 = g.sortw.v[i];
		/* gpVbvN */
		lastrp2 = g.tsh.v[atsh].lastrp2; 
		if( lastrp2 < 0 ) {
			g.tsh.v[atsh].toptrp2 = atrp2;
		} else {
			g.trp2[lastrp2].daynext = atrp2;
		}
		g.trp2[atrp2].daynext = -1;
		g.trp2[atrp2].daypred = lastrp2;
		g.tsh.v[atsh].lastrp2 = atrp2;
	}
quit:
	return rc;
}
#if 0
/*	ID_compDrp1tsh	Drp1R[hr
********************************************************/
static int compDrp1tsh( ZMRP &g, int *p, int *q )
{
	int rc = g.drp1[*p].iday - g.drp1[*q].iday; /* v */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp1tsh	Drp1R[hvɃNtւ
********************************************************/
int zSortDrp1tsh( ZMRP &g, int atsh)
{
	int i, adrp1, lasdrp1, rc=0;
	drp1_td	*pdrp1;
	                                              CHKA(0, atsh, g.tsh.n);
	g.sortw.clear();
	for( adrp1 = g.tsh.v[atsh].topdrp1; adrp1 >= 0; adrp1 = g.drp1[adrp1].tshdaynext ) {
		if( (rc = g.sortw.push_back(adrp1)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp1);
		pdrp1 = &g.drp1[adrp1];  CHKA(0, pdrp1->odm, g.odm.n);
		   CHKX(0.0, 0.0, pdrp1->size); CHKB(0, pdrp1->iday, g.endtd); CHKB(-1, pdrp1->oday, pdrp1->iday);
		CHKA(-1, pdrp1->nextko, g.drp1.n); CHKA(0, pdrp1->dlm, g.dlm.n);
		CHKA(-1, pdrp1->oytrp2, g.trp2.n);
		CHKA(-1, pdrp1->topkolsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp1tsh );
	g.tsh.v[atsh].topdrp1 = g.tsh.v[atsh].lasdrp1 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp1 = g.sortw.v[i];
		/* gpVbvN */
		lasdrp1 = g.tsh.v[atsh].lasdrp1; 
		if( lasdrp1 < 0 ) {
			g.tsh.v[atsh].topdrp1 = adrp1;
		} else {
			g.drp1[lasdrp1].tshdaynext = adrp1;
		}
		g.drp1[adrp1].tshdaynext = -1;
		g.drp1[adrp1].tshdaypred = lasdrp1;
		g.tsh.v[atsh].lasdrp1 = adrp1;
	}
quit:
	return rc;
}
#endif
/*	ID_compDrp1DlmIday	Drp1R[hr
********************************************************/
static int compDrp1DlmIday( ZMRP &g, int *p, int *q )
{
	int rc = g.drp1[*p].iday - g.drp1[*q].iday; /* v */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp1DlmIday	Drp1R[hvɃNtւ
********************************************************/
int zSortDrp1DlmIday( ZMRP &g, int adlm)
{
	int i, adrp1, lasdrp1i, rc=0;
	drp1_td	*pdrp1;
	                                              CHKA(0, adlm, g.dlm.n);
	g.sortw.clear();
	for( adrp1 = g.dlm.v[adlm].topdrp1i; adrp1 >= 0; adrp1 = g.drp1[adrp1].dlmidaynext ) {
		if( (rc = g.sortw.push_back(adrp1)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp1);
		pdrp1 = &g.drp1[adrp1];  CHKA(0, pdrp1->odm, g.odm.n);
		   CHKX(0.0, 0.0, pdrp1->size); CHKB(0, pdrp1->iday, g.endtd); CHKB(-1, pdrp1->oday, pdrp1->iday);
		CHKA(-1, pdrp1->nextko, g.drp1.n); CHKB(adlm, pdrp1->dlm, adlm);
		CHKA(-1, pdrp1->oytrp2, g.trp2.n);
		CHKA(-1, pdrp1->topkolsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp1DlmIday );
	g.dlm.v[adlm].topdrp1i = g.dlm.v[adlm].lasdrp1i = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp1 = g.sortw.v[i];
		/* gpVbvN */
		lasdrp1i = g.dlm.v[adlm].lasdrp1i; 
		if( lasdrp1i < 0 ) {
			g.dlm.v[adlm].topdrp1i = adrp1;
		} else {
			g.drp1[lasdrp1i].dlmidaynext = adrp1;
		}
		g.drp1[adrp1].dlmidaynext = -1;
		g.drp1[adrp1].dlmidaypred = lasdrp1i;
		g.dlm.v[adlm].lasdrp1i = adrp1;
	}
quit:
	return rc;
}
#if 0
/*	ID_compDrp1fsh	Drp1R[hr
********************************************************/
static int compDrp1fsh( ZMRP &g, int *p, int *q )
{
	int rc = g.drp1[*p].oday - g.drp1[*q].oday; /* ɓiv|ɂks|wksj */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp1fsh	Drp1R[hvɃNtւ
********************************************************/
int zSortDrp1fsh( ZMRP &g, int afsh)
{
	int i, adrp1, lasdrp1, rc=0;
	drp1_td	*pdrp1;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( adrp1 = g.fsh.v[afsh].topdrp1; adrp1 >= 0; adrp1 = g.drp1[adrp1].fshdaynext ) {
		if( (rc = g.sortw.push_back(adrp1)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp1);
		pdrp1 = &g.drp1[adrp1];  CHKA(0, pdrp1->odm, g.odm.n); CHKA(0, pdrp1->dlm, g.dlm.n);
		   CHKX(0.0, 0.0, pdrp1->size); CHKB(0, pdrp1->iday, g.endtd); CHKB(0, pdrp1->oday, g.endtd);
		CHKA(-1, pdrp1->nextko, g.drp1.n);
		CHKA(-1, pdrp1->oytrp2, g.trp2.n);
		CHKA(-1, pdrp1->topkolsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp1fsh );
	g.fsh.v[afsh].topdrp1 = g.fsh.v[afsh].lasdrp1 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp1 = g.sortw.v[i];
		/* gpVbvN */
		lasdrp1 = g.fsh.v[afsh].lasdrp1; 
		if( lasdrp1 < 0 ) {
			g.fsh.v[afsh].topdrp1 = adrp1;
		} else {
			g.drp1[lasdrp1].fshdaynext = adrp1;
		}
		g.drp1[adrp1].fshdaynext = -1;
		g.drp1[adrp1].fshdaypred = lasdrp1;
		g.fsh.v[afsh].lasdrp1 = adrp1;
	}
quit:
	return rc;
}
#endif
/*	ID_compDrp1DlmOday	Drp1R[hr
********************************************************/
static int compDrp1DlmOday( ZMRP &g, int *p, int *q )
{
	int rc = g.drp1[*p].oday - g.drp1[*q].oday; /* ɓiv|ɂks|wksj */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp1DlmOday	Drp1R[hɓɃNtւ
********************************************************/
int zSortDrp1DlmOday( ZMRP &g, int adlm) // FS041008
{
	int i, adrp1, lasdrp1o, rc=0;
	drp1_td	*pdrp1;
	                                              CHKA(0, adlm, g.dlm.n);
	g.sortw.clear();
//	for( adrp1 = g.fsh.v[afsh].topdrp1; adrp1 >= 0; adrp1 = g.drp1[adrp1].fshdaynext ) {}
	for( adrp1 = g.dlm.v[adlm].topdrp1o; adrp1 >= 0; adrp1 = g.drp1[adrp1].dlmodaynext ) {
		if( (rc = g.sortw.push_back(adrp1)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp1);
		pdrp1 = &g.drp1[adrp1];  CHKA(0, pdrp1->odm, g.odm.n); CHKA(0, pdrp1->dlm, g.dlm.n);
		   CHKX(0.0, 0.0, pdrp1->size); CHKB(0, pdrp1->iday, g.endtd); CHKB(0, pdrp1->oday, g.endtd);
		CHKA(-1, pdrp1->nextko, g.drp1.n);
		CHKA(-1, pdrp1->oytrp2, g.trp2.n); CHKB(adlm, pdrp1->dlm, adlm);
		CHKA(-1, pdrp1->topkolsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp1DlmOday );
//	g.fsh.v[afsh].topdrp1 = g.fsh.v[afsh].lasdrp1 = -1;
//	for( i = 0; i < g.sortw.n; ++i ) {
//		adrp1 = g.sortw.v[i];
//		/* gpVbvN */
//		lasdrp1 = g.fsh.v[afsh].lasdrp1; 
//		if( lasdrp1 < 0 ) {
//			g.fsh.v[afsh].topdrp1 = adrp1;
//		} else {
//			g.drp1[lasdrp1].fshdaynext = adrp1;
//		}
//		g.drp1[adrp1].fshdaynext = -1;
//		g.drp1[adrp1].fshdaypred = lasdrp1;
//		g.fsh.v[afsh].lasdrp1 = adrp1;
//	}
	g.dlm.v[adlm].topdrp1o = g.dlm.v[adlm].lasdrp1o = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp1 = g.sortw.v[i];
		/* ꋟVbvN */
		lasdrp1o = g.dlm.v[adlm].lasdrp1o; 
		if( lasdrp1o < 0 ) {
			g.dlm.v[adlm].topdrp1o = adrp1;
		} else {
			g.drp1[lasdrp1o].dlmodaynext = adrp1;
		}
		g.drp1[adrp1].dlmodaynext = -1;
		g.drp1[adrp1].dlmodaypred = lasdrp1o;
		g.dlm.v[adlm].lasdrp1o = adrp1;
	}
quit:
	return rc;
}
#if 0
/*	ID_compDrp2Tsh	Drp2R[hr
********************************************************/
static int compDrp2Tsh( ZMRP &g, int *p, int *q )
{
	int rc = g.drp2[*p].iday - g.drp2[*q].iday; /* ɓ */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp2Tsh	Drp2R[hɓɃNtւ
********************************************************/
int zSortDrp2Tsh( ZMRP &g, int atsh)
{
	int i, adrp2, lasdrp2, rc=0;
	drp2_td	*pdrp2;
	                                              CHKA(0, atsh, g.tsh.n);
	g.sortw.clear();
	for( adrp2 = g.tsh.v[atsh].topdrp2; adrp2 >= 0; adrp2 = g.drp2[adrp2].tshdaynext ) {
		if( (rc = g.sortw.push_back(adrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp2);
		pdrp2 = &g.drp2[adrp2];  CHKA(0, pdrp2->odm, g.odm.n); CHKA(0, pdrp2->dlm, g.dlm.n);
		   CHKX(0.0, 0.0, pdrp2->size); CHKB(0, pdrp2->iday, g.endtd); CHKB(0, pdrp2->oday, g.endtd);
		CHKA(-1, pdrp2->kofrp1, g.frp1.n);
		CHKA(-1, pdrp2->topoylsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp2Tsh );
	g.tsh.v[atsh].topdrp2 = g.tsh.v[atsh].lasdrp2 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp2 = g.sortw.v[i];
		/* gpVbvN */
		lasdrp2 = g.tsh.v[atsh].lasdrp2; 
		if( lasdrp2 < 0 ) {
			g.tsh.v[atsh].topdrp2 = adrp2;
		} else {
			g.drp2[lasdrp2].tshdaynext = adrp2;
		}
		g.drp2[adrp2].tshdaynext = -1;
		g.drp2[adrp2].tshdaypred = lasdrp2;
		g.tsh.v[atsh].lasdrp2 = adrp2;
	}
quit:
	return rc;
}
/*	ID_compDrp2FshOday	Drp2R[hr
********************************************************/
static int compDrp2FshOday( ZMRP &g, int *p, int *q )
{
	int rc = g.drp2[*p].oday - g.drp2[*q].oday; /* oɓiɓ|Aksj */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp2FshOday	Drp2R[hoɓɃNtւ
********************************************************/
int zSortDrp2FshOday( ZMRP &g, int afsh)
{
	int i, adrp2, lasdrp2, rc=0;
	drp2_td	*pdrp2;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( adrp2 = g.fsh.v[afsh].topdrp2; adrp2 >= 0; adrp2 = g.drp2[adrp2].fshnext ) {
		if( (rc = g.sortw.push_back(adrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp2);
		pdrp2 = &g.drp2[adrp2];  CHKA(0, pdrp2->odm, g.odm.n); CHKA(0, pdrp2->dlm, g.dlm.n);
		   CHKX(0.0, 0.0, pdrp2->size); CHKB(0, pdrp2->iday, g.endtd); CHKB(0, pdrp2->oday, g.endtd);
		CHKA(-1, pdrp2->kofrp1, g.frp1.n);
		CHKA(-1, pdrp2->topoylsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp2FshOday );
	g.fsh.v[afsh].topdrp2 = g.fsh.v[afsh].lasdrp2 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp2 = g.sortw.v[i];
		/* gpVbvN */
		lasdrp2 = g.fsh.v[afsh].lasdrp2; 
		if( lasdrp2 < 0 ) {
			g.fsh.v[afsh].topdrp2 = adrp2;
		} else {
			g.drp2[lasdrp2].fshnext = adrp2;
		}
		g.drp2[adrp2].fshnext = -1;
		g.drp2[adrp2].fshpred = lasdrp2;
		g.fsh.v[afsh].lasdrp2 = adrp2;
	}
quit:
	return rc;
}
/*	ID_compDrp2FshIday	Drp2R[hr
********************************************************/
static int compDrp2FshIday( ZMRP &g, int *p, int *q )
{
	int rc = g.drp2[*p].iday - g.drp2[*q].iday; /* ɓ */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp2FshIday	Drp2R[hɓɃNtւ
********************************************************/
int zSortDrp2FshIday( ZMRP &g, int afsh)
{
	int i, adrp2, lasdrp2, rc=0;
	drp2_td	*pdrp2;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( adrp2 = g.fsh.v[afsh].topdrp2; adrp2 >= 0; adrp2 = g.drp2[adrp2].fshnext ) {
		if( (rc = g.sortw.push_back(adrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp2);
		pdrp2 = &g.drp2[adrp2];  CHKA(0, pdrp2->odm, g.odm.n); CHKB(0, pdrp2->iday, g.endtd);
		   CHKX(0.0, 0.0, pdrp2->size); CHKB(-1, pdrp2->oday, pdrp2->iday);
		CHKA(-1, pdrp2->kofrp1, g.frp1.n);  CHKA(0, pdrp2->dlm, g.dlm.n);
		CHKA(-1, pdrp2->topoylsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp2FshIday );
	g.fsh.v[afsh].topdrp2 = g.fsh.v[afsh].lasdrp2 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp2 = g.sortw.v[i];
		/* ꋟVbvN */
		lasdrp2 = g.fsh.v[afsh].lasdrp2; 
		if( lasdrp2 < 0 ) {
			g.fsh.v[afsh].topdrp2 = adrp2;
		} else {
			g.drp2[lasdrp2].fshnext = adrp2;
		}
		g.drp2[adrp2].fshnext = -1;
		g.drp2[adrp2].fshpred = lasdrp2;
		g.fsh.v[afsh].lasdrp2 = adrp2;
	}
quit:
	return rc;
}
#endif
/*	ID_compDrp2DlmIday	Drp2R[hr
********************************************************/
static int compDrp2DlmIday( ZMRP &g, int *p, int *q )
{
	int rc = g.drp2[*p].iday - g.drp2[*q].iday; /* ɓ */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortDrp2DlmIday	Drp2R[hɓɃNtւ
********************************************************/
int zSortDrp2DlmIday( ZMRP &g, int adlm)
{
	int i, adrp2, lasdrp2i, rc=0;
	drp2_td	*pdrp2;
	                                              CHKA(0, adlm, g.dlm.n);
	g.sortw.clear();
	for( adrp2 = g.dlm.v[adlm].topdrp2i; adrp2 >= 0; adrp2 = g.drp2[adrp2].dlmidaynext ) {
		if( (rc = g.sortw.push_back(adrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(adrp2);
		pdrp2 = &g.drp2[adrp2];  CHKA(0, pdrp2->odm, g.odm.n); CHKB(0, pdrp2->iday, g.endtd);
		   CHKX(0.0, 0.0, pdrp2->size); CHKB(-1, pdrp2->oday, pdrp2->iday);
		CHKA(-1, pdrp2->kofrp1, g.frp1.n);  CHKB(adlm, pdrp2->dlm, adlm);
		CHKA(-1, pdrp2->topoylsz2, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compDrp2DlmIday );
	g.dlm.v[adlm].topdrp2i = g.dlm.v[adlm].lasdrp2i = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		adrp2 = g.sortw.v[i];
		/* ꋟVbvN */
		lasdrp2i = g.dlm.v[adlm].lasdrp2i; 
		if( lasdrp2i < 0 ) {
			g.dlm.v[adlm].topdrp2i = adrp2;
		} else {
			g.drp2[lasdrp2i].dlmidaynext = adrp2;
		}
		g.drp2[adrp2].dlmidaynext = -1;
		g.drp2[adrp2].dlmidaypred = lasdrp2i;
		g.dlm.v[adlm].lasdrp2i = adrp2;
	}
quit:
	return rc;
}
/*	ID_compFrp1	Frp1R[hr
********************************************************/
static int compFrp1( ZMRP &g, int *p, int *q )
{
	int rc = g.frp1[*p].due - g.frp1[*q].due; /* oɓ */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortFrp1	Frp1R[hoɓɃNtւ
********************************************************/
int zSortFrp1( ZMRP &g, int afsh)
{
	int i, afrp1, lasfrp1, rc=0;
	frp1_td	*pfrp1;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( afrp1 = g.fsh.v[afsh].topfrp1; afrp1 >= 0; afrp1 = g.frp1[afrp1].daynext ) {
		if( (rc = g.sortw.push_back(afrp1)) < 0 ) goto                  quit;
//		g.sortw.push_back(afrp1);
		pfrp1 = &g.frp1[afrp1];  CHKA(0, pfrp1->odm, g.odm.n); CHKA(0, pfrp1->fsh, g.fsh.n);
		   CHKX(0.0, 0.0, pfrp1->size); CHKB(0, pfrp1->due, g.endtd);
		CHKA(-1, pfrp1->oydrp2, g.drp2.n);
		CHKA(-1, pfrp1->oyodm, g.odm.n);
		CHKA(-1, pfrp1->topzhi2, g.zhi.n);
		CHKA(-1, pfrp1->topkolsz3, g.lsz.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp1 );
	g.fsh.v[afsh].topfrp1 = g.fsh.v[afsh].lasfrp1 = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		afrp1 = g.sortw.v[i];
		/* gpVbvN */
		lasfrp1 = g.fsh.v[afsh].lasfrp1; 
		if( lasfrp1 < 0 ) {
			g.fsh.v[afsh].topfrp1 = afrp1;
		} else {
			g.frp1[lasfrp1].daynext = afrp1;
		}
		g.frp1[afrp1].daynext = -1;
		g.frp1[afrp1].daypred = lasfrp1;
		g.fsh.v[afsh].lasfrp1 = afrp1;
	}
quit:
	return rc;
}
/*	ID_compFrp2Due	Frp2R[hr
********************************************************/
static int compFrp2Due( ZMRP &g, int *p, int *q )
{
	int rc = g.frp2[*p].due - g.frp2[*q].due; /* [ */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortFrp2Due	Frp2R[h[ɃNtւ
********************************************************/
int zSortFrp2Due( ZMRP &g, int afsh)
{
	int i, afrp2, lasfrp2, rc=0;
	frp2_td	*pfrp2;
	                                    CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( afrp2 = g.fsh.v[afsh].topfrp2due; afrp2 >= 0; afrp2 = g.frp2[afrp2].duenext ) {
		if( (rc = g.sortw.push_back(afrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(afrp2);
		pfrp2 = &g.frp2[afrp2];         CHKA(0, pfrp2->odm, g.odm.n);
		                                CHKX(0.0, 0.0, pfrp2->size);  CHKA(0, pfrp2->fsh, g.fsh.n);
		                                CHKA(-1, pfrp2->oyodm, g.odm.n);
		                                CHKA(-1, pfrp2->topkotrp1, g.trp1.n); CHKB(0, pfrp2->due, g.endtd);
		                                CHKA(-1, pfrp2->topoylsz3, g.lsz.n);  CHKB(-1, pfrp2->bgn, g.endtd);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp2Due );
	g.fsh.v[afsh].topfrp2due = g.fsh.v[afsh].lasfrp2due = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		afrp2 = g.sortw.v[i];
		/* gpVbvN */
		lasfrp2 = g.fsh.v[afsh].lasfrp2due; 
		if( lasfrp2 < 0 ) {
			g.fsh.v[afsh].topfrp2due = afrp2;
		} else {
			g.frp2[lasfrp2].duenext = afrp2;
		}
		g.frp2[afrp2].duenext = -1;
		g.frp2[afrp2].duepred = lasfrp2;
		g.fsh.v[afsh].lasfrp2due = afrp2;
	}
quit:
	return rc;
}
/*	ID_compFrp2Bgn	Frp2R[hr
********************************************************/
static int compFrp2Bgn( ZMRP &g, int *p, int *q )
{
	int rc = g.frp2[*p].bgn - g.frp2[*q].bgn; /*  */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortFrp2Bgn	Frp2R[h𒅉ɃNtւ
********************************************************/
int zSortFrp2Bgn( ZMRP &g, int afsh)
{
	int i, afrp2, lasfrp2, rc=0;
	frp2_td	*pfrp2;
	                                    CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( afrp2 = g.fsh.v[afsh].topfrp2bgn; afrp2 >= 0; afrp2 = g.frp2[afrp2].bgnnext ) {
		if( (rc = g.sortw.push_back(afrp2)) < 0 ) goto                  quit;
//		g.sortw.push_back(afrp2);
		pfrp2 = &g.frp2[afrp2];         CHKA(0, pfrp2->odm, g.odm.n);
		                                CHKX(0.0, 0.0, pfrp2->size);  CHKA(0, pfrp2->fsh, g.fsh.n);
		                                CHKA(-1, pfrp2->oyodm, g.odm.n);
		                                CHKA(-1, pfrp2->topkotrp1, g.trp1.n); CHKB(0, pfrp2->due, g.endtd);
		                                CHKA(-1, pfrp2->topoylsz3, g.lsz.n);  CHKB(0, pfrp2->bgn, g.endtd);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFrp2Bgn );
	g.fsh.v[afsh].topfrp2bgn = g.fsh.v[afsh].lasfrp2bgn = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		afrp2 = g.sortw.v[i];
		/* gpVbvN */
		lasfrp2 = g.fsh.v[afsh].lasfrp2bgn; 
		if( lasfrp2 < 0 ) {
			g.fsh.v[afsh].topfrp2bgn = afrp2;
		} else {
			g.frp2[lasfrp2].bgnnext = afrp2;
		}
		g.frp2[afrp2].bgnnext = -1;
		g.frp2[afrp2].bgnpred = lasfrp2;
		g.fsh.v[afsh].lasfrp2bgn = afrp2;
	}
quit:
	return rc;
}
/*	ID_compFtoAvl	FtoR[hgpɓŔr
********************************************************/
static int compFtoAvl( ZMRP &g, int *p, int *q )
{
//	int rc = g.fto.v[*p].avlday - g.fto.v[*q].avlday; /* gp\͌vZłĂȂ */
	int rc = g.fto.v[*p].inday - g.fto.v[*q].inday; /* gpɓ */
	if( rc == 0 )  rc = g.fto.v[*p].yukoday - g.fto.v[*q].yukoday; /* gp */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortFtoAvl	oɗ\(fto)R[hgpɓAgpɃNtւ
********************************************************/
int zSortFtoAvl( ZMRP &g, int atsh)
{
	int i, afto, lasfto, rc=0;
	fto_td	*pfto;
	                                              CHKA(0, atsh, g.tsh.n);
	g.sortw.clear();
	for( afto = g.tsh.v[atsh].topfto; afto >= 0; afto = g.fto.v[afto].tshnext ) {
		if( (rc = g.sortw.push_back(afto)) < 0 ) goto                  quit;
//		g.sortw.push_back(afto);
		pfto = &g.fto.v[afto];  CHKA(0, pfto->odm, g.odm.n); CHKA(0, pfto->tsh, g.tsh.n);
		CHKA(0, pfto->dlm, g.dlm.n);
		   CHKX(0.0, 0.0, pfto->size); CHKB(0, pfto->inday, g.endtd); CHKB(-1, pfto->outday, g.endtd);
		CHKB(0, pfto->avlday, g.endtd); CHKB(0, pfto->yukoday, g.endtd);
		CHKA(-1, pfto->frp1, g.frp1.n); CHKA(-1, pfto->topzhi2, g.zhi.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compFtoAvl );
	g.tsh.v[atsh].topfto = g.tsh.v[atsh].lastfto = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		afto = g.sortw.v[i];
		/* gpVbvN */
		lasfto = g.tsh.v[atsh].lastfto; 
		if( lasfto < 0 ) {
			g.tsh.v[atsh].topfto = afto;
		} else {
			g.fto.v[lasfto].tshnext = afto;
		}
		g.fto.v[afto].tshnext = -1;
		g.fto.v[afto].tshpred = lasfto;
		g.tsh.v[atsh].lastfto = afto;
	}
quit:
	return rc;
}
/*	ID_compRod	RodR[hr
********************************************************/
static int compRod( ZMRP &g, int *p, int *q )
{
	int rc = g.rod.v[*p].due - g.rod.v[*q].due; /* [ */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortRod	󒍃I[_(rod)R[h[ɃNtւ
********************************************************/
int zSortRod( ZMRP &g, int afsh)
{
	int i, arod, lasrod, rc=0;
	rod_td	*prod;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( arod = g.fsh.v[afsh].toprod; arod >= 0; arod = g.rod.v[arod].fshnext ) {
		if( (rc = g.sortw.push_back(arod)) < 0 ) goto                  quit;
//		g.sortw.push_back(arod);
		prod = &g.rod.v[arod];  CHKA(0, prod->odm, g.odm.n); CHKA(0, prod->fsh, g.fsh.n);
		   CHKX(0.0, 0.0, prod->size); CHKB(0, prod->due, g.endtd);
		   CHKA(0, prod->frp1, g.frp1.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compRod );
	g.fsh.v[afsh].toprod = lasrod = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		arod = g.sortw.v[i];
		/* ꋟVbvN */
		if( lasrod < 0 ) {
			g.fsh.v[afsh].toprod = arod;
			lasrod = arod;
		} else {
			g.rod.v[lasrod].fshnext = arod;
		}
		g.rod.v[arod].fshnext = -1;
//		g.rod.v[arod].fshpred = lasrod;
		lasrod = arod;
	}
quit:
	return rc;
}
/*	ID_compPln	PlnR[hr
********************************************************/
static int compPln( ZMRP &g, int *p, int *q )
{
	int rc = g.pln.v[*p].due - g.pln.v[*q].due; /* [ */
	if( rc == 0 )  rc = g.pln.v[*p].yukoday - g.pln.v[*q].yukoday; /* gp */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortPln	ݐY(pln)R[h[, gpɃNtւ
********************************************************/
int zSortPln( ZMRP &g, int afsh)
{
	int i, apln, laspln, rc=0;
	pln_td	*ppln;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( apln = g.fsh.v[afsh].toppln; apln >= 0; apln = g.pln.v[apln].fshnext ) {
		if( (rc = g.sortw.push_back(apln)) < 0 ) goto                  quit;
//		g.sortw.push_back(apln);
		ppln = &g.pln.v[apln];  CHKA(0, ppln->odm, g.odm.n); CHKA(0, ppln->fsh, g.fsh.n);
		   CHKX(0.0, 0.0, ppln->size); CHKB(0, ppln->due, g.endtd);
		   CHKA(-1, ppln->frp1, g.frp1.n); CHKB(0, ppln->yukoday, g.endtd);
		   CHKA(-1, ppln->topzhi3, g.zhi.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compPln );
	g.fsh.v[afsh].toppln = laspln = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		apln = g.sortw.v[i];
		/* ꋟVbvN */
		if( laspln < 0 ) {
			g.fsh.v[afsh].toppln = apln;
		} else {
			g.pln.v[laspln].fshnext = apln;
		}
		g.pln.v[apln].fshnext = -1;
		g.pln.v[apln].fshpred = laspln;
		laspln = apln;
	}
quit:
	return rc;
}
/*	ID_compOpo	OpoR[hr
********************************************************/
static int compOpo( ZMRP &g, int *p, int *q )
{
	int rc = g.opo.v[*p].plandue - g.opo.v[*q].plandue; /* H\ */
	if( rc == 0 )  rc = g.opo.v[*p].yukoday - g.opo.v[*q].yukoday; /* gp */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortOpo	I[_(opo)R[hH\AgpɃNtւ
********************************************************/
int zSortOpo( ZMRP &g, int afsh)
{
	int i, aopo, lasopo, rc=0;
	opo_td	*popo;
	                                              CHKA(0, afsh, g.fsh.n);
	g.sortw.clear();
	for( aopo = g.fsh.v[afsh].topopo; aopo >= 0; aopo = g.opo.v[aopo].nextdue ) {
		if( (rc = g.sortw.push_back(aopo)) < 0 ) goto                  quit;
//		g.sortw.push_back(aopo);
		popo = &g.opo.v[aopo];  CHKA(0, popo->odm, g.odm.n); CHKA(0, popo->fsh, g.fsh.n);
		   CHKX(0.0, 0.0, popo->size); CHKB(0, popo->due, g.endtd); CHKB(-1, popo->bgn, g.endtd);
		   CHKB(0, popo->plandue, g.endtd); CHKB(-1, popo->planbgn, g.endtd);
		   CHKA(-1, popo->frp2, g.frp2.n); CHKB(0, popo->yukoday, g.endtd);
		   CHKA(-1, popo->topzhi4, g.zhi.n);
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compOpo );
	g.fsh.v[afsh].topopo = lasopo = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		aopo = g.sortw.v[i];
		/* ꋟVbvN */
		if( lasopo < 0 ) {
			g.fsh.v[afsh].topopo = aopo;
		} else {
			g.opo.v[lasopo].nextdue = aopo;
		}
		g.opo.v[aopo].nextdue = -1;
		g.opo.v[aopo].preddue = lasopo;
		lasopo = aopo;
	}
quit:
	return rc;
}
/*	ID_compOpoBgn	OpoR[hr
********************************************************/
static int compOpoBgn( ZMRP &g, int *p, int *q )
{
	int rc = g.opo.v[*p].planbgn - g.opo.v[*q].planbgn;                /* \ */
	if( rc == 0 )  rc = g.opo.v[*p].planbgntm - g.opo.v[*q].planbgntm; /* \莞 */
	if( rc == 0 )  rc = g.opo.v[*p].plandue - g.opo.v[*q].plandue;     /* H\ */
	if( rc == 0 )  rc = g.opo.v[*p].planduetm - g.opo.v[*q].planduetm; /* H\莞 */
	if( rc == 0 )  rc = *p - *q;
	return rc;
}
/*	ID_zSortOpoBgn	I[_(opo)R[h𒅎\A\莞ɃNtւ
********************************************************/
int zSortOpoBgn( ZMRP &g, int ashm)
{
	int aopo, afsh, rc=0;
	opo_td	*popo;
	                                              CHKA(0, ashm, g.shm.n);
	g.sortw.clear();
	for (afsh = g.shm.v[ashm].topfsh; afsh >= 0; afsh = g.fsh.v[afsh].shmnext) { CHKA(0,afsh,g.fsh.n);
		for( aopo = g.fsh.v[afsh].topopo; aopo >= 0; aopo = g.opo.v[aopo].nextdue ) {
		if( (rc = g.sortw.push_back(aopo)) < 0 ) goto                  quit;
//			g.sortw.push_back(aopo);
			popo = &g.opo.v[aopo];  CHKA(0, popo->odm, g.odm.n); CHKA(0, popo->fsh, g.fsh.n);
			CHKX(0.0, 0.0, popo->size); CHKB(0, popo->due, g.endtd); CHKB(-1, popo->bgn, g.endtd);
			CHKB(0, popo->plandue, g.endtd); CHKB(-1, popo->planbgn, g.endtd);
			CHKA(-1, popo->frp2, g.frp2.n); CHKB(0, popo->yukoday, g.endtd);
			CHKA(-1, popo->topzhi4, g.zhi.n);
		}
	}
	zsort(g, g.sortw.v, g.sortw.n, sizeof(int), QSORT_TYP compOpoBgn );
#if 0
	g.fsh.v[afsh].topopo = lasopo = -1;
	for( i = 0; i < g.sortw.n; ++i ) {
		aopo = g.sortw.v[i];
		/* ꋟVbvN */
		if( lasopo < 0 ) {
			g.fsh.v[afsh].topopo = aopo;
		} else {
			g.opo.v[lasopo].nextdue = aopo;
		}
		g.opo.v[aopo].nextdue = -1;
		g.opo.v[aopo].preddue = lasopo;
		lasopo = aopo;
	}
#endif
quit:
	return rc;
}
