/*
 * FILE      : zfpegging1.cpp	yMO
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : yMO
 * AUTHOR    : K.Tamura	2004.11.05
 */
/*   yMO[pegging / pegged requirements]
 *     i⎑ނǂ̐i(Ԑi)I[_[ɈĂ̂֘AtA
 *   i̐YEwI[_[琻iI[_[肷邱ƁBi̔[xꂽꍇA
 *   ǂ̐i̐YɉêȂǂmۂɎgB
 *   EVOyMO
 *     ̕i̒ڂ̐eI[_[݂̂B
 *   EtyMO
 *     i璆Ԑiɂ̐e̍ŏIiI[_[܂őiKŃI[_[ԂRtB 
 */
static char	*__file =__FILE__;	// should be copied into all .c files
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

#if defined(EXTERN)
#undef	EXTERN
#endif
#define EXTERN	/* eXgp_~[(zpegging.hzmrptbl.h֑gݍ݌ɍ폜) */

#include "zpegging.h"

static int zfPEGGING01_proc( ZMRP &g, int aitm );
static int zfPEGGING01_ini(ZMRP &g);
static int find(ZMRP &g, int kind, int Type, int No, int Top);// FS050112A
static int anytableclear(ZMRP &g);
static int dump_pegnode(ZMRP &g, char *id);
static int dump_wpeg();
static int yukomake(ZMRP &g, int aitm);
static int zfPEGGING01_proc1( ZMRP &g, int aitm );
static int zfPEGGING01_yuko( ZMRP &g, int aitm, int peg_bgn, int peg_end );
static int zfPEGGING01_proc2( ZMRP &g, int aitm, int peg_bgn, int peg_end );
static int zfPEGGING01_addw(ZMRP &g,int oyaType,int oyaNo,double oyaNum,int koType,int koNo,double koNum);
static int zfPEGGING01_add(ZMRP &g,int oyaType,int oyaNo,double oyaNum,int koType,int koNo,double koNum);
static int dmp_wpeg_td(ZMRP &g, struct wpeg_td *pp, int pm );

/*	ID_zfPEGGING01	90.yMO */
int zfPEGGING01( ZMRP &g ) /* rc 0: <0:ُ */
{
	int		rc		= 0;		/* ߂l */
	int		fc		= 0;		/* ֐p߂l */
	int		asortw	= -1;		/* sortw[] */
	int		aitm	= -1;		/* itm[] */
	if(zdbgf[99]) {Dprintf("90.zfPEGGING01" CR ); goto quit;}
	if(zdbgf[190]) {TRACEA(0); Dprintf("zfPEGGING01" CR );}

	/* iڂ̃g|WJ\[g
	** ʏɂă\[g
	** iڃ}X^[Aeq֌WAU.U֌WAD揇ʂŃg|WJ\[g
	** ́Fmode 0:\[geˎq 1:\[gqːe 
	*/
	zfPEGGING01_ini(g);
	if( (fc = ztsortptm(g)) < 0 ) goto err2;
	/* nbV */
	else if( (fc = s.h_wpeg.hashopen()) < 0 ) goto	err3;
	/* \[gϕiڂ̉ʕiڂ珈 */
//	for( asortw = 0 ; asortw < g.itm.n ; ++asortw ){}
	for( asortw = 0 ; asortw < g.sortw.n ; ++asortw ){
		/* Piڎo */
		aitm = g.sortw.v[asortw];	CHKA(0, aitm, g.itm.n);
		if (g.itm.v[aitm].unuse_flg == 1) continue; // NT041215add
		if(zdbgf[190]>1) {TRACEB(0); Dprintf("aitm(%d)" CR, aitm );}
		/* Yiڂ̃yMO */
		if( (zfPEGGING01_proc( g, aitm )) < 0 ) goto err5;
	}
quit:
	if(zdbgf[190]) {TRACEC(0); Dprintf("zfPEGGING01 rc(%d)" CR, rc);
	if(zdbgf[190]>8) {
#if 1 // FS041222
		if( g.jmf ) Dprintf("yMO s.peg.n(%d)" CR, s.peg.n);
		else        Dprintf(" s.peg.n(%d)" CR, s.peg.n);
		dmp_peg_td( g, s.peg.v, s.peg.n );
		if( g.jmf ) Dprintf("ړv g.drp2.n(%d)" CR, g.drp2.n);
		else        Dprintf(" g.drp2.n(%d)" CR, g.drp2.n);
		dmp_drp2_td( g, 0, g.drp2.n );
		if( g.jmf ) Dprintf("v g.frp2.n(%d)" CR, g.frp2.n);
		else        Dprintf(" g.frp2.n(%d)" CR, g.frp2.n);
		dmp_frp2_td( g, 0, g.frp2.n );
		if( g.jmf ) Dprintf("I[_ g.opo.n(%d)" CR, g.opo.n);
		else        Dprintf(" g.opo.n(%d)" CR, g.opo.n);
		dmp_opo_td( g, g.opo.v, g.opo.n );
		if( g.jmf ) Dprintf("󒍃I[_ g.rod.n(%d)" CR, g.rod.n);
		else        Dprintf(" g.rod.n(%d)" CR, g.rod.n);
		dmp_rod_td( g, g.rod.v, g.rod.n );
		if( g.jmf ) Dprintf("ݐY(MPS) g.pln.n(%d)" CR, g.pln.n);
		else        Dprintf(" g.pln.n(%d)" CR, g.pln.n);
		dmp_pln_td( g, g.pln.v, g.pln.n );
		if( g.jmf ) Dprintf("݌ g.onh.n(%d)" CR, g.onh.n);
		else        Dprintf(" g.onh.n(%d)" CR, g.onh.n);
		dmp_onh_td( g, g.onh.v, g.onh.n );
		if( g.jmf ) Dprintf("oɗ\ g.fto.n(%d)" CR, g.fto.n);
		else        Dprintf(" g.fto.n(%d)" CR, g.fto.n);
		dmp_fto_td( g, g.fto.v, g.fto.n );
		if( g.jmf ) Dprintf("폜Ώۃf[^" CR);
		else        Dprintf("sakuzyo taisyo data" CR);
		if( g.jmf ) Dprintf("gpVbvsqoP(bg܂ƂߑO) g.trp1.n(%d)" CR, g.trp1.n);
		else        Dprintf(" g.trp1.n(%d)" CR, g.trp1.n);
		dmp_trp1_td( g, 0, g.trp1.n );
		if( g.jmf ) Dprintf("gpVbvsqoQ(bg܂Ƃߌ) g.trp2.n(%d)" CR, g.trp2.n);
		else        Dprintf(" g.trp2.n(%d)" CR, g.trp2.n);
		dmp_trp2_td( g, 0, g.trp2.n );
		if( g.jmf ) Dprintf("zcqoP(bg܂ƂߑO) g.drp1.n(%d)" CR, g.drp1.n);
		else        Dprintf(" g.drp1.n(%d)" CR, g.drp1.n);
		dmp_drp1_td( g, 0, g.drp1.n );
		if( g.jmf ) Dprintf("VbveqoP(bg܂ƂߑO) g.frp1.n(%d)" CR, g.frp1.n);
		else        Dprintf(" g.frp1.n(%d)" CR, g.frp1.n);
		dmp_frp1_td( g, 0, g.frp1.n );
		dmp_itm_td( g, g.itm.v, g.itm.n );
		dmp_bom_td( g, g.bom.v, g.bom.n );
		dmp_lsz_td( g, 0, g.lsz.n );
		dmp_zhi_td( g, 0, g.zhi.n );
#endif
	}}
	return( rc );
err2:
	Esprintf(g.ermes, "zfpegging1.cpp 0010 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "iڂ̃g|WJ\[gsFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -2; goto quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0020 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "nbVI[vsFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -3; goto quit;
err5:
	Esprintf(g.ermes, "zfpegging1.cpp 0030 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "Yiڂ̃yMOsFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -5; goto quit;
}

/*	ID_zfPEGGING01_proc yMO̎W */
static int zfPEGGING01_proc( ZMRP &g, int aitm ) /* rc 0: <0:ُ */
{
	int		rc		= 0;		/* ߂l */
	int		fc		= 0;		/* ֐p߂l */
	int		peg_bgn	= -1;		/* Jnʒu */
	int		peg_end	= -1;		/* Iʒu */
	int		awpeg	= -1;		/* wpeg[] */
	                                    CHKA(0, aitm, g.itm.n);
	if(zdbgf[99]) {Dprintf("90.zfPEGGING01_proc aitm(%d)" CR, aitm); goto quit;}
	if(zdbgf[190]>1) {TRACEA(0); Dprintf("zfPEGGING01_proc aitm(%d)" CR, aitm );}
	/* ̓`FbN */
	if( aitm < 0 || aitm >= g.itm.n) goto                               quit;
	/* nbV */
	else if( (fc = s.h_wpeg.hashreopen()) < 0 ) goto	                err3;
	anytableclear(g);
	s.wpegnode.clear(); // FS050112
	s.wpeg.clear();
	/*** O */
	peg_bgn = s.wpeg.n;
	if( (fc = zfPEGGING01_proc1( g, aitm )) < 0 ) goto                  err1;
	if((fc = yukomake(g, aitm)) < 0) goto                               err4;
	/*** ㏈ */
	peg_end = s.wpeg.n;
	if(zdbgf[190]>2) {TRACEB(0); Dprintf("aitm(%d)peg_bgn(%d)peg_end(%d)" CR, aitm, peg_bgn, peg_end);
		Dprintf("drp2(%d)frp2(%d)opo(%d)rod(%d)pln(%d)onh(%d)fto(%d)trp1(%d)trp2(%d)drp1(%d)frp1(%d)" CR,
			g.drp2.n, g.frp2.n, g.opo.n, g.rod.n, g.pln.n, g.onh.n, g.fto.n, g.trp1.n, g.trp2.n, g.drp1.n, g.frp1.n );
		Dprintf("bom(%d)ubm(%d)lsz(%d)zhi(%d)" CR,
			g.bom.n, g.ubm.n, g.lsz.n, g.zhi.n );
		if( s.wpeg.n > 0 ) dmp_wpeg_td( g, s.wpeg.v, s.wpeg.n );
	}
	if( (fc = zfPEGGING01_proc2( g, aitm, peg_bgn, peg_end )) < 0 ) goto err1;

	if(zdbgf[190]>2) {TRACEB(0); Dprintf("aitm(%d)peg_bgn(%d)peg_end(%d)" CR, aitm, peg_bgn, peg_end);
		Dprintf("drp2(%d)frp2(%d)opo(%d)rod(%d)pln(%d)onh(%d)fto(%d)trp1(%d)trp2(%d)drp1(%d)frp1(%d)" CR,
			g.drp2.n, g.frp2.n, g.opo.n, g.rod.n, g.pln.n, g.onh.n, g.fto.n, g.trp1.n, g.trp2.n, g.drp1.n, g.frp1.n );
		Dprintf("bom(%d)ubm(%d)lsz(%d)zhi(%d)" CR,
			g.bom.n, g.ubm.n, g.lsz.n, g.zhi.n );
		if( s.wpeg.n > 0 ) dmp_wpeg_td( g, s.wpeg.v, s.wpeg.n );
	}
	/* Lf[^̂ݓo^ */
	for( awpeg = 0; awpeg < s.wpeg.n; ++awpeg ){
		if( s.wpeg[awpeg].dflg != 0 ) continue;
		/* No^ */
		fc = zfPEGGING01_add( g, s.wpeg[awpeg].oyaType, s.wpeg[awpeg].oyaNo, s.wpeg[awpeg].oyaNum, s.wpeg[awpeg].koType, s.wpeg[awpeg].koNo, s.wpeg[awpeg].koNum );
		if( fc < 0 ) goto err2;
	}
quit:
	if(zdbgf[190]>1) {TRACEC(0); Dprintf("zfPEGGING01_proc rc(%d)" CR, rc);
		Dprintf("drp2(%d)frp2(%d)opo(%d)rod(%d)pln(%d)onh(%d)fto(%d)trp1(%d)trp2(%d)drp1(%d)frp1(%d)" CR,
			g.drp2.n, g.frp2.n, g.opo.n, g.rod.n, g.pln.n, g.onh.n, g.fto.n, g.trp1.n, g.trp2.n, g.drp1.n, g.frp1.n );
		Dprintf("bom(%d)ubm(%d)lsz(%d)zhi(%d)" CR,
			g.bom.n, g.ubm.n, g.lsz.n, g.zhi.n );
		if( s.peg.n > 0 ) dmp_peg_td( g, s.peg.v, s.peg.n );
	}
	return( rc );
err1:
	Esprintf(g.ermes, "zfpegging1.cpp 0040 (%d)" CR, aitm );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "֐̓͂słFaitm(%d)" CR, aitm ); Eprintf(g.ermes); }
	rc = -1; goto quit;
err2:
	Esprintf(g.ermes, "zfpegging1.cpp 0050 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "No^sFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -2; goto quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0060 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "nbVI[vsFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -3; goto quit;
err4:
	Esprintf(g.ermes, "zfpegging1.cpp 0070 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "gpݒ̎sFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -4; goto quit;
}

/*	ID_zfPEGGING01_proc1 yMO̎W(ڍ׃N̒o) */
static int zfPEGGING01_proc1( ZMRP &g, int aitm ) /* rc 0: <0:ُ */
{
	int		rc		= 0;		/* ߂l */
	int		fc		= 0;		/* ֐p߂l */
	int		atrp1, atrp2, adrp1, adrp2, afrp1, afrp2;
	int		aonh, afto, apln, aopo;
	int		alsz1, alsz2, alsz3, azhi1, azhi2;
	int		atsh, adlm, afsh, aodm, arod;
	int		oyaType	= 0;		/* ě^ */
	int		oyaNo	= -1;		/* e̔ԍ */
	double	oyaNum	= 0.0;		/* e̐ */
	int		koType	= 0;		/* q̌^ */
	int		koNo	= -1;		/* q̔ԍ */
	double	koNum	= 0.0;		/* q̐ */
	int		btsh;
	drp1_td *wdrp1;
	trp1_td *wtrp1;
	frp1_td	*wfrp1;
	frp2_td	*wfrp2;
	                                    CHKA(0, aitm, g.itm.n);
	if(zdbgf[99]) {Dprintf("90.zfPEGGING01_proc1 aitm(%d)" CR, aitm); goto quit;}
	if(zdbgf[190]>1) {TRACEA(0); Dprintf("zfPEGGING01_proc1 aitm(%d)" CR, aitm );}
	/* ̓`FbN */
	if( aitm < 0 || aitm >= g.itm.n) goto err1;
	/*** [trp1̐e] */
	/* alWJ */
	for( atsh = g.itm.v[aitm].toptsh ; atsh >= 0 ; atsh = g.tsh.v[atsh].itmnext ){  CHKA(0, atsh, g.tsh.n);
		/* Ώەiڃ`FbN */
		                                CHKB(aitm, g.tsh.v[atsh].itm, aitm);
//		if(zdbgf[190]>2) {TRACEB(0); Dprintf("g.trp1[%d].bom(%d)ubm(%d)" CR,
//			atrp1, g.trp1[atrp1].bom, g.trp1[atrp1].ubm );}
		for( atrp1 = g.tsh.v[atsh].toptrp1 ; atrp1 >= 0 ; atrp1 = wtrp1->daynext ){  CHKA(0, atrp1, g.trp1.n);
			wtrp1 = &g.trp1(atrp1);
			afrp2 = wtrp1->oyfrp2;
			if( afrp2 >= 0 ) {	        CHKA(0, afrp2, g.frp2.n);
				oyaNum	= g.frp2(afrp2).size;
				koNum	= wtrp1->size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, TYPFRP2, afrp2, oyaNum, TYPTRP1, atrp1, koNum )) < 0 ) goto err2;
			} else {  //[XAbv͖T|[g
			}
			/* vʌvZ */
			for( azhi1 = wtrp1->topzhi1; azhi1 >= 0; azhi1 = g.zhi[azhi1].nextnyuko ){ CHKA(0, azhi1, g.zhi.n);
				/* ɑ 1:tonh 2:fto 3:pln 4:opo 5:fonh */
				switch( g.zhi[azhi1].ityp ){
				case 1:	/* 1:tonh */
				case 5:	/* 5:fonh */
					koNo = aonh = g.zhi[azhi1].nyuko; CHKA(0, aonh, g.onh.n);
					koType = TYPONH;
					break;
				case 2:	/* 2:fto */
					koNo = afto = g.zhi[azhi1].nyuko; CHKA(0, afto, g.fto.n);
					koType = TYPFTO;
					break;
				case 3:	/* 3:pln */
					koNo = apln = g.zhi[azhi1].nyuko; CHKA(0, apln, g.pln.n);
					koType = TYPPLN;    CHKA(3, g.zhi[azhi1].ityp, -1);
					break;
				case 4:	/* 4:opo */
					koNo = aopo = g.zhi[azhi1].nyuko; CHKA(0, aopo, g.opo.n);
					koType = TYPOPO;    CHKA(4, g.zhi[azhi1].ityp, -1);
					break;
				default:                CHKB(1, g.zhi[azhi1].ityp, 5);
				}
				/*  */
				oyaNum = koNum = g.zhi[azhi1].size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, TYPTRP1, atrp1, oyaNum, koType, koNo, koNum )) < 0 ) goto err2;
			}
			/*** [trp2̐e] */
			/* bg܂Ƃ߂P */
			for( alsz1 = wtrp1->topkolsz1 ; alsz1 >= 0 ; alsz1 = g.lsz[alsz1].nextko ){ CHKA(0, alsz1, g.lsz.n);
				atrp2 = g.lsz[alsz1].komrp; CHKA(0, atrp2, g.trp2.n);
				/* Ώەiڃ`FbN */
				btsh = g.trp2(atrp2).tsh;	CHKB(atsh, btsh, atsh); CHKB(aitm, g.tsh.v[btsh].itm, aitm);
				/*  */
				oyaNum	= koNum	= g.lsz[alsz1].size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, TYPTRP1, atrp1, oyaNum, TYPTRP2, atrp2, koNum )) < 0 ) goto err2;
				/*** [drp1̐e] */
				/* Vbvt */
				for( adrp1 = g.trp2(atrp2).topkodrp1 ; adrp1 >= 0 ; adrp1 = wdrp1->nextko ){ CHKA(0, adrp1, g.drp1.n);
					wdrp1 = &g.drp1(adrp1);
					/* Ώەiڃ`FbN */
					adlm = wdrp1->dlm;	CHKA(0, adlm, g.dlm.n); CHKB(aitm, g.dlm[adlm].itm, aitm);
					/*  */
					oyaNum	= koNum	= wdrp1->size;
					/* No^ */
					if( (fc = zfPEGGING01_addw( g, TYPTRP2, atrp2, oyaNum, TYPDRP1, adrp1, koNum )) < 0 ) goto err2;
					/*** [drp2̐e] */
					/* bg܂Ƃ߂Q */
					for( alsz2 = wdrp1->topkolsz2 ; alsz2 >= 0 ; alsz2 = g.lsz[alsz2].nextko ){ CHKA(0, alsz2, g.lsz.n);
						adrp2 = g.lsz[alsz2].komrp; CHKA(0, adrp2, g.drp2.n);
						/* Ώەiڃ`FbN */
						adlm = g.drp2(adrp2).dlm;	CHKA(0, adlm, g.dlm.n); CHKB(aitm, g.dlm[adlm].itm, aitm);
//						if( g.dlm[adlm].itm != aitm ) continue;
						/*  */
						oyaNum	= koNum	= g.lsz[alsz2].size;
						/* No^ */
						if( (fc = zfPEGGING01_addw( g, TYPDRP1, adrp1, oyaNum, TYPDRP2, adrp2, koNum )) < 0 ) goto err2;
					}
				}
			}
		}
	}
	/*** [frp1̐e] */
	for( afsh = g.itm.v[aitm].topfsh ; afsh >= 0 ; afsh = g.fsh.v[afsh].itmnext ){ CHKA(0, afsh, g.fsh.n);
		/* Ώەiڃ`FbN */
		                                CHKB(aitm, g.fsh.v[afsh].itm, aitm);
		/* [drp2->frp1] */
		for( afrp1 = g.fsh.v[afsh].topfrp1 ; afrp1 >= 0 ; afrp1 = wfrp1->daynext ){ CHKA(0, afrp1, g.frp1.n);
			wfrp1 = &g.frp1(afrp1);
			adrp2 = wfrp1->oydrp2;
			if( adrp2 >= 0 ){	CHKA(0, adrp2, g.drp2.n);
				/*  */
				oyaNum	= g.drp2(adrp2).size;
				koNum	= wfrp1->size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, TYPDRP2, adrp2, oyaNum, TYPFRP1, afrp1, koNum )) < 0 ) goto err2;
			} else {
				/* [odm->frp1] */
				aodm = wfrp1->oyodm;	CHKA(0, aodm, g.odm.n);
				/*
				**  1:󒍃I[_ 2:(MPS) 3:oɗ\ 4:I[_
				**	-1:}X^ǉ(index|P)
				*/
				switch( g.odm[aodm].odm_typ ){
				case 1:	/* 1:󒍃I[_ */
					oyaNo = arod = g.odm[aodm].index; CHKA(0, arod, g.rod.n);
					oyaType = TYPROD;
					break;
				case 2:	/* 2:(MPS) */
					oyaNo = apln = g.odm[aodm].index; CHKA(0, apln, g.pln.n);
					oyaType = TYPPLN;
					break;
				case 3:	/* 3:oɗ\ */
					oyaNo = afto = g.odm[aodm].index; CHKA(0, afto, g.fto.n);
					oyaType = TYPFTO;
					break;
				case 4:	/* 4:I[_ */
					oyaNo = aopo = g.odm[aodm].index; CHKA(0, aopo, g.opo.n);
					oyaType = TYPOPO;   CHKA(4, g.odm[aodm].odm_typ, -1);
					break;
				default:                CHKB(1, g.odm[aodm].odm_typ, 4);
				}
				/*  */
				oyaNum = koNum = wfrp1->size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, oyaType, oyaNo, oyaNum, TYPFRP1, afrp1, koNum )) < 0 ) goto err2;
			}
			/* vʌvZ */
			for( azhi2 = wfrp1->topzhi2; azhi2 >= 0; azhi2 = g.zhi[azhi2].nextnyuko ){ CHKA(0, azhi2, g.zhi.n);
				/* ɑ 1:tonh 2:fto 3:pln 4:opo 5:fonh */
				switch( g.zhi[azhi2].ityp ){
				case 1:	/* 1:tonh */
				case 5:	/* 5:fonh */
					koNo = aonh = g.zhi[azhi2].nyuko; CHKA(0, aonh, g.onh.n);
					koType = TYPONH;
					break;
				case 2:	/* 2:fto */
					koNo = afto = g.zhi[azhi2].nyuko; CHKA(0, afto, g.fto.n);
					koType = TYPFTO;    CHKA(2, g.zhi[azhi2].ityp, -1);
					break;
				case 3:	/* 3:pln */
					koNo = apln = g.zhi[azhi2].nyuko; CHKA(0, apln, g.pln.n);
					koType = TYPPLN;
					break;
				case 4:	/* 4:opo */
					koNo = aopo = g.zhi[azhi2].nyuko; CHKA(0, aopo, g.opo.n);
					koType = TYPOPO;
					break;
				default:                CHKB(1, g.zhi[azhi2].ityp, 5);
				}
				/*  */
				oyaNum = koNum = g.zhi[azhi2].size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, TYPFRP1, afrp1, oyaNum, koType, koNo, koNum )) < 0 ) goto err2;
			}
			/*** [frp2̐e] */
			if(zdbgf[190]>3) {TRACEB(0); Dprintf("g.frp1(%d).topkolsz3(%d)" CR, afrp1, g.frp1(afrp1).topkolsz3);}
			/* bg܂Ƃ߂R */
			for( alsz3 = wfrp1->topkolsz3 ; alsz3 >= 0 ; alsz3 = g.lsz[alsz3].nextko ){ CHKA(0, alsz3, g.lsz.n);
				afrp2 = g.lsz[alsz3].komrp; CHKA(0, afrp2, g.frp2.n);
				/*  */
				oyaNum	= koNum	= g.lsz[alsz3].size;
				/* No^ */
				if( (fc = zfPEGGING01_addw( g, TYPFRP1, afrp1, oyaNum, TYPFRP2, afrp2, koNum )) < 0 ) goto err2;
			}
		}
		/* [opo->frp2] */
		for( afrp2 = g.fsh.v[afsh].topfrp2due ; afrp2 >= 0 ; afrp2 = wfrp2->duenext ){ CHKA(0, afrp2, g.frp2.n);
			wfrp2 = &g.frp2(afrp2);
			aodm = wfrp2->oyodm;        CHKA(-1, aodm, g.odm.n); /* 쐬I[_Btopoylsz3Ɣr odm[]or-1 */
			if( aodm < 0 ) continue;    CHKB(4, g.odm[aodm].odm_typ, 4); /* 4:I[_ */
			if(zdbgf[190]>3) {TRACEB(0); Dprintf("g.fsh(%d).itm(%d):aitm(%d)" CR, afsh, g.fsh.v[afsh].itm, aitm);}
			aopo = g.odm[aodm].index;   CHKA(0, aopo, g.opo.n);
			/*  */
			oyaNum	= koNum	= g.opo[aopo].size;
			/* No^ */
			if( (fc = zfPEGGING01_addw( g, TYPOPO, aopo, oyaNum, TYPFRP2, afrp2, koNum )) < 0 ) goto err2;
		}
	}
//	for( aopo = 0 ; aopo < g.opo.n ; ++aopo ){
//		afrp2 = g.opo[aopo].frp2; CHKA(0, afrp2, g.frp2.n);
//		afsh = g.frp2[afrp2].fsh;	CHKA(0, afsh, g.fsh.n);
//		if(zdbgf[190]>3) {TRACEB(0); Dprintf("g.fsh[%d].itm(%d):aitm(%d)" CR, afsh, g.fsh.v[afsh].itm, aitm);}
//		if( g.fsh.v[afsh].itm != aitm ) continue;
//		/*  */
//		oyaNum	= koNum	= g.opo[aopo].size;
//		/* No^ */
//		if( (fc = zfPEGGING01_addw( g, TYPOPO, aopo, oyaNum, TYPFRP2, afrp2, koNum )) < 0 ) goto err2;
//	}
quit:
	if(zdbgf[190]>1) {TRACEC(0); Dprintf("zfPEGGING01_proc1 rc(%d)" CR, rc);
		Dprintf("drp2(%d)frp2(%d)opo(%d)rod(%d)pln(%d)onh(%d)fto(%d)trp1(%d)trp2(%d)drp1(%d)frp1(%d)" CR,
			g.drp2.n, g.frp2.n, g.opo.n, g.rod.n, g.pln.n, g.onh.n, g.fto.n, g.trp1.n, g.trp2.n, g.drp1.n, g.frp1.n );
		Dprintf("bom(%d)ubm(%d)lsz(%d)zhi(%d)" CR,
			g.bom.n, g.ubm.n, g.lsz.n, g.zhi.n );
		if( s.peg.n > 0 ) dmp_peg_td( g, s.peg.v, s.peg.n );
		if(zdbgf[190] > 2) {
			dump_wpeg();
			dump_pegnode(g, "proc1_quit");
		}
	}
	return( rc );
err1:
	Esprintf(g.ermes, "zfpegging1.cpp 0080 (%d)" CR, aitm );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "֐̓͂słFaitm(%d)" CR, aitm ); Eprintf(g.ermes); }
	rc = -1; goto quit;
err2:
	Esprintf(g.ermes, "zfpegging1.cpp 0090 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "No^sFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -2; goto quit;
}
/*	ID_zfPEGGING01_ini e[uQ̏ */
static int zfPEGGING01_ini(ZMRP &g)
{
	int adrp2, afrp2, aopo, arod, apln, aonh, afto;
	int atrp1, atrp2, adrp1, afrp1;
	drp2_td *wdrp2;
	frp2_td *wfrp2;
	opo_td *wopo;
	rod_td *wrod;
	pln_td *wpln;
	onh_td *wonh;
	fto_td *wfto;

	for(adrp2 = 0; adrp2 < g.drp2.n; adrp2++) {
		wdrp2 = &g.drp2[adrp2];
		wdrp2->wpegnode = -1;
		wdrp2->pegoy = -1;
		wdrp2->pegko = -1;
		wdrp2->yukoday = -1;		//KS050128 ADD
	}
	for(afrp2 = 0; afrp2 < g.frp2.n; afrp2++) {
		wfrp2 = &g.frp2[afrp2];
		wfrp2->wpegnode = -1;
		wfrp2->pegoy = -1;
		wfrp2->pegko = -1;
		wfrp2->yukoday = -1;
	}
	for(aopo = 0; aopo < g.opo.n; aopo++) {
		wopo = &g.opo.v[aopo];
		wopo->wpegnode = -1;
		wopo->pegoy = -1;
		wopo->pegko = -1;
	}
	for(arod = 0; arod < g.rod.n; arod++) {
		wrod = &g.rod.v[arod];
		wrod->wpegnode = -1;
		wrod->pegoy = -1;
		wrod->pegko = -1;
	}
	for(apln = 0; apln < g.pln.n; apln++) {
		wpln = &g.pln.v[apln];
		wpln->wpegnode = -1;
		wpln->pegoy = -1;
		wpln->pegko = -1;
	}
	for(aonh = 0; aonh < g.onh.n; aonh++) {
		wonh = &g.onh.v[aonh];
		wonh->wpegnode = -1;
		wonh->pegoy = -1;
		wonh->pegko = -1;
	}
	for(afto = 0; afto < g.fto.n; afto++) {
		wfto = &g.fto.v[afto];
		wfto->wpegnode = -1;
		wfto->pegoy = -1;
		wfto->pegko = -1;
	}
	for(atrp1 = 0; atrp1 < g.trp1.n; atrp1++) {
		g.trp1.v[atrp1].wpegnode = -1;
	}
	for(atrp2 = 0; atrp2 < g.trp2.n; atrp2++) {
		g.trp2.v[atrp2].wpegnode = -1;
	}
	for(adrp1 = 0; adrp1 < g.drp1.n; adrp1++) {
		g.drp1.v[adrp1].wpegnode = -1;
	}
	for(afrp1 = 0; afrp1 < g.frp1.n; afrp1++) {
		g.frp1.v[afrp1].wpegnode = -1;
	}
	return 0;
}
/*	ID_anytableclear Piڕ̌e[ũm[h}X^ԍ̏ */
static int anytableclear(ZMRP &g)
{
	int rc = 0;
	int awpegnode;
	wpegnode_td *pwpegnode;
	int Type;
	int No;
	for(awpegnode = 0; awpegnode < s.wpegnode.n; awpegnode++) {
		pwpegnode = &s.wpegnode[awpegnode];
		Type = pwpegnode->Type;
		No = pwpegnode->No;
		switch( Type ){
		case TYPTRP1:	CHKA(0, No, g.trp1.n); g.trp1[No].wpegnode = -1; break;
		case TYPTRP2:	CHKA(0, No, g.trp2.n); g.trp2[No].wpegnode = -1; break;
		case TYPDRP1:	CHKA(0, No, g.drp1.n); g.drp1[No].wpegnode = -1; break;
		case TYPDRP2:	CHKA(0, No, g.drp2.n); g.drp2[No].wpegnode = -1; break;
		case TYPFRP1:	CHKA(0, No, g.frp1.n); g.frp1[No].wpegnode = -1; break;
		case TYPFRP2:	CHKA(0, No, g.frp2.n); g.frp2[No].wpegnode = -1; break;
		case TYPONH:	CHKA(0, No, g.onh.n);  g.onh.v[No].wpegnode = -1;break;
		case TYPFTO:	CHKA(0, No, g.fto.n);  g.fto.v[No].wpegnode = -1;break;
		case TYPROD:	CHKA(0, No, g.rod.n);  g.rod.v[No].wpegnode = -1;break;
		case TYPPLN:	CHKA(0, No, g.pln.n);  g.pln.v[No].wpegnode = -1;break;
		case TYPOPO:	CHKA(0, No, g.opo.n);  g.opo.v[No].wpegnode = -1;break;
		default:	CHKA(0, Type, 0);
			rc = -1;goto err1;
		}

	}
quit:
	return rc;
err1:
	goto quit;
}
#if 0 //add NT140612
/*	ID_anytablefind gpvZpm[h}X^쐬 */
static int anytablefind_UNUSED(ZMRP &g, int kind, int Type, int No, int Top) // FS050112A gp
{
	int rc = 0;
	int *pwpegnode;
	wpegnode_td wwpegnode;
	wpegnode_td *ppegnode;
	switch( Type ){
	case TYPTRP1:	CHKA(0, No, g.trp1.n); pwpegnode = &g.trp1 [No].wpegnode; break;
	case TYPTRP2:	CHKA(0, No, g.trp2.n); pwpegnode = &g.trp2 [No].wpegnode; break;
	case TYPDRP1:	CHKA(0, No, g.drp1.n); pwpegnode = &g.drp1 [No].wpegnode; break;
	case TYPDRP2:	CHKA(0, No, g.drp2.n); pwpegnode = &g.drp2 [No].wpegnode; break;
	case TYPFRP1:	CHKA(0, No, g.frp1.n); pwpegnode = &g.frp1 [No].wpegnode; break;
	case TYPFRP2:	CHKA(0, No, g.frp2.n); pwpegnode = &g.frp2 [No].wpegnode; break;
	case TYPONH:	CHKA(0, No, g.onh.n);  pwpegnode = &g.onh.v[No].wpegnode; break;
	case TYPFTO:	CHKA(0, No, g.fto.n);  pwpegnode = &g.fto.v[No].wpegnode; break;
	case TYPROD:	CHKA(0, No, g.rod.n);  pwpegnode = &g.rod.v[No].wpegnode; break;
	case TYPPLN:	CHKA(0, No, g.pln.n);  pwpegnode = &g.pln.v[No].wpegnode; break;
	case TYPOPO:	CHKA(0, No, g.opo.n);  pwpegnode = &g.opo.v[No].wpegnode; break;
	default:	CHKA(0, Type, 0);
		rc = -1;goto err1;
	}
	if(*pwpegnode < 0) { // m[h}X^[o^Ȃ
		wwpegnode.Type = Type;
		wwpegnode.No   = No;
		wwpegnode.yukoday = g.endtd;
		if(kind == 'o') {        // e^CvȂ
			wwpegnode.oyaTop = -1;
			wwpegnode.koTop = Top;
			wwpegnode.count = 1;
		} else if(kind == 'k') { // q^CvȂ
			wwpegnode.oyaTop = Top;
			wwpegnode.koTop = -1;
			wwpegnode.count = 0;
		}
		*pwpegnode = s.wpegnode.n;
		if( (rc = s.wpegnode.push_back(wwpegnode)) < 0 ) goto err3;
	} else {
		ppegnode = &s.wpegnode[*pwpegnode]; CHKA(0, *pwpegnode, s.wpegnode.n);
		if(kind == 'o') {        // e
			if(ppegnode->koTop < 0) { // qo^Ȃ
				ppegnode->koTop = Top;
			} else {                             // qo^ς݂Ȃ
				CHKB(Top, ppegnode->koTop, Top);
			}
			(ppegnode->count)++;
		} else if(kind == 'k') { // q
			if(ppegnode->oyaTop < 0) { // eo^Ȃ
				ppegnode->oyaTop = Top;
			} else {                               // eo^ς݂Ȃ
				CHKB(Top, ppegnode->oyaTop, Top);
			}
		} else {
			rc = -2; goto                                               err1;
		}
	}
quit:
	return rc;
err1:
	goto quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0100 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "yMOf[^̓o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -3; goto	                                                    quit;
}
#endif //0

#define NEWPEG
#ifndef NEWPEG // FS050117
/*	ID_zfPEGGING01_addw yMO̒ǉij */
static int zfPEGGING01_addw( ZMRP &g, int oyaType, int oyaNo, double oyaNum, int koType, int koNo, double koNum )
{
	int		rc		= 0;	/* ߂l */
	int		keyNo	= -1;	/* nbVԍ */
	int		datNo	= -1;	/* o^f[^ԍ */
	wpeg_td	wwpeg;			/* o^f[^ */
	int fc;
	unsigned int	size, size1;
	char	*key;

	if(zdbgf[99]) {Dprintf("90.zfPEGGING01_addw oyaType(%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum); goto quit;}
	if(zdbgf[190]>4) {TRACEA(0); Dprintf("zfPEGGING01_addw oyaType(%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum);}

	/* ̓`FbN */
	switch( oyaType ){
	case TYPTRP1:	CHKA(0, oyaNo, g.trp1.n); break;
	case TYPTRP2:	CHKA(0, oyaNo, g.trp2.n); break;
	case TYPDRP1:	CHKA(0, oyaNo, g.drp1.n); break;
	case TYPDRP2:	CHKA(0, oyaNo, g.drp2.n); break;
	case TYPFRP1:	CHKA(0, oyaNo, g.frp1.n); break;
	case TYPFRP2:	CHKA(0, oyaNo, g.frp2.n); break;
	case TYPONH:	CHKA(0, oyaNo, g.onh.n);  break;
	case TYPFTO:	CHKA(0, oyaNo, g.fto.n);  break;
	case TYPROD:	CHKA(0, oyaNo, g.rod.n);  break;
	case TYPPLN:	CHKA(0, oyaNo, g.pln.n);  break;
	case TYPOPO:	CHKA(0, oyaNo, g.opo.n);  break;
	default:	CHKB(TYPTRP1, oyaType, TYPOPO);
		goto                                                            err1;
	}
	switch( koType ){
	case TYPTRP1:	CHKA(0, koNo, g.trp1.n); break;
	case TYPTRP2:	CHKA(0, koNo, g.trp2.n); break;
	case TYPDRP1:	CHKA(0, koNo, g.drp1.n); break;
	case TYPDRP2:	CHKA(0, koNo, g.drp2.n); break;
	case TYPFRP1:	CHKA(0, koNo, g.frp1.n); break;
	case TYPFRP2:	CHKA(0, koNo, g.frp2.n); break;
	case TYPONH:	CHKA(0, koNo, g.onh.n);  break;
	case TYPFTO:	CHKA(0, koNo, g.fto.n);  break;
	case TYPROD:	CHKA(0, koNo, g.rod.n);  break;
	case TYPPLN:	CHKA(0, koNo, g.pln.n);  break;
	case TYPOPO:	CHKA(0, koNo, g.opo.n);  break;
	default:	CHKB(TYPTRP1, koType, TYPOPO);
		goto                                                            err1;
	}
	/* f[^ݒ */
	wwpeg.dflg		= 0;		/* 폜tO */
	wwpeg.oyaType	= oyaType;
	wwpeg.oyaNo		= oyaNo;
	wwpeg.oyaNum	= oyaNum;
	wwpeg.koType	= koType;
	wwpeg.koNo		= koNo;
	wwpeg.koNum		= koNum;
	wwpeg.oyaTop	= -1;
	wwpeg.oyaNext	= -1;
	wwpeg.koTop		= -1;
	wwpeg.koNext	= -1;
	/*  */
	size  = sizeof(int) * 4;
	size1 = sizeof(int) * 2;
	/*  */
	if( (keyNo = s.h_wpeg.hashfind( &wwpeg.oyaType, size )) >= 0 ){
		/* o^̏ꍇ */
		s.wpeg[keyNo].oyaNum += wwpeg.oyaNum;
		s.wpeg[keyNo].koNum	 += wwpeg.koNum;
		datNo = keyNo;
	} else {
		/* o^̏ꍇ */
		datNo = s.wpeg.n;	/* ǉf[^i[zY */
		if( (rc = s.h_wpeg.hashaddr( &wwpeg.oyaType, size, datNo, &key )) < 0 ) goto err_h;
		if( (rc = s.wpeg.push_back(wwpeg)) < 0 ) goto err3;
		/*  */
		if( (keyNo = s.h_wpoy.hashfind( &wwpeg.oyaType, size1 )) >= 0 ){
			/* o^̏ꍇ */
			s.wpeg[datNo].koTop		= keyNo;
			s.wpeg[datNo].koNext	= s.wpeg[keyNo].koNext;
			s.wpeg[keyNo].koNext	= datNo;
		} else {
			/* o^̏ꍇ */
			if( (rc = s.h_wpoy.hashaddr( &wwpeg.oyaType, size1, datNo, &key )) < 0 ) goto err_h;
			s.wpeg[datNo].koTop	= datNo;
			s.wpeg[datNo].koNext= -1;
		}
		if((fc = anytablefind(g, 'o', oyaType, oyaNo, s.wpeg[datNo].koTop)) < 0) goto err3;
		/*  */
		if( (keyNo = s.h_wpko.hashfind( &wwpeg.koType, size1 )) >= 0 ){
			/* o^̏ꍇ */
			s.wpeg[datNo].oyaTop	= keyNo;
			s.wpeg[datNo].oyaNext	= s.wpeg[keyNo].oyaNext;
			s.wpeg[keyNo].oyaNext	= datNo;
		} else {
			/* o^̏ꍇ */
			if( (rc = s.h_wpko.hashaddr( &wwpeg.koType, size1, datNo, &key )) < 0 ) goto err_h;
			s.wpeg[datNo].oyaTop	= datNo;
			s.wpeg[datNo].oyaNext	= -1;
		}
		if((fc = anytablefind(g, 'k', koType, koNo, s.wpeg[datNo].oyaTop)) < 0) goto err3;
	}
	rc = s.wpeg.n;
quit:
	if(zdbgf[190]>4) {TRACEC(0); Dprintf("zfPEGGING01_addw rc(%d)" CR, rc);}
	return( rc );
err1:
	Esprintf(g.ermes, "zfpegging1.cpp 0110 (%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "֐̓͂słFoyaType(%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum); Eprintf(g.ermes); }
	rc = -1; goto                                                       quit;
err_h:
	Esprintf(g.ermes, "zfpegging1.cpp 0120 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "yMOf[^̃L[̃nbV\o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -2; goto                                                       quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0130 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "yMOf[^̓o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -3; goto                                                       quit;
}
#else
/*	ID_getTop@e[u擪̎}e[uԍo */
static int getTop(ZMRP &g, int kind, int Type, int No)
{
	int rc;
	int Top;
	if(kind == 'o') {
		switch( Type ) {
//		case TYPTRP1:	CHKA(0, No, g.trp1.n); Top = g.trp1 [No].pegoy; break;
//		case TYPTRP2:	CHKA(0, No, g.trp2.n); Top = g.trp2 [No].pegoy; break;
//		case TYPDRP1:	CHKA(0, No, g.drp1.n); Top = g.drp1 [No].pegoy; break;
		case TYPDRP2:	CHKA(0, No, g.drp2.n); Top = g.drp2 [No].pegoy; break;
//		case TYPFRP1:	CHKA(0, No, g.frp1.n); Top = g.frp1 [No].pegoy; break;
		case TYPFRP2:	CHKA(0, No, g.frp2.n); Top = g.frp2 [No].pegoy; break;
		case TYPONH:	CHKA(0, No, g.onh.n);  Top = g.onh.v[No].pegoy; break;
		case TYPFTO:	CHKA(0, No, g.fto.n);  Top = g.fto.v[No].pegoy; break;
		case TYPROD:	CHKA(0, No, g.rod.n);  Top = g.rod.v[No].pegoy; break;
		case TYPPLN:	CHKA(0, No, g.pln.n);  Top = g.pln.v[No].pegoy; break;
		case TYPOPO:	CHKA(0, No, g.opo.n);  Top = g.opo.v[No].pegoy; break;
		default:	CHKA(0, Type, 0);
			rc = -1;goto err1;
		}
	} else if(kind == 'k') {
		switch( Type ) {
//		case TYPTRP1:	CHKA(0, No, g.trp1.n); Top = g.trp1 [No].pegko; break;
//		case TYPTRP2:	CHKA(0, No, g.trp2.n); Top = g.trp2 [No].pegko; break;
//		case TYPDRP1:	CHKA(0, No, g.drp1.n); Top = g.drp1 [No].pegko; break;
		case TYPDRP2:	CHKA(0, No, g.drp2.n); Top = g.drp2 [No].pegko; break;
//		case TYPFRP1:	CHKA(0, No, g.frp1.n); Top = g.frp1 [No].pegko; break;
		case TYPFRP2:	CHKA(0, No, g.frp2.n); Top = g.frp2 [No].pegko; break;
		case TYPONH:	CHKA(0, No, g.onh.n);  Top = g.onh.v[No].pegko; break;
		case TYPFTO:	CHKA(0, No, g.fto.n);  Top = g.fto.v[No].pegko; break;
		case TYPROD:	CHKA(0, No, g.rod.n);  Top = g.rod.v[No].pegko; break;
		case TYPPLN:	CHKA(0, No, g.pln.n);  Top = g.pln.v[No].pegko; break;
		case TYPOPO:	CHKA(0, No, g.opo.n);  Top = g.opo.v[No].pegko; break;
		default:	CHKA(0, Type, 0);
			rc = -1;goto err1;
		}   
	} else {
		rc = -2;goto err1;
	}
	rc = Top;
quit:
	return rc;
err1:
	goto quit;
}
/*	ID_putTop e[u֐擪̎}e[uԍݒ肷 */
static int putTop(ZMRP &g, int kind, int Type, int No, int Top)
{
	int rc;
	if(kind == 'o') {
		switch( Type ) {
//		case TYPTRP1:	CHKA(0, No, g.trp1.n); g.trp1 [No].pegoy = Top; break;
//		case TYPTRP2:	CHKA(0, No, g.trp2.n); g.trp2 [No].pegoy = Top; break;
//		case TYPDRP1:	CHKA(0, No, g.drp1.n); g.drp1 [No].pegoy = Top; break;
		case TYPDRP2:	CHKA(0, No, g.drp2.n); g.drp2 [No].pegoy = Top; break;
//		case TYPFRP1:	CHKA(0, No, g.frp1.n); g.frp1 [No].pegoy = Top; break;
		case TYPFRP2:	CHKA(0, No, g.frp2.n); g.frp2 [No].pegoy = Top; break;
		case TYPONH:	CHKA(0, No, g.onh.n);  g.onh.v[No].pegoy = Top; break;
		case TYPFTO:	CHKA(0, No, g.fto.n);  g.fto.v[No].pegoy = Top; break;
		case TYPROD:	CHKA(0, No, g.rod.n);  g.rod.v[No].pegoy = Top; break;
		case TYPPLN:	CHKA(0, No, g.pln.n);  g.pln.v[No].pegoy = Top; break;
		case TYPOPO:	CHKA(0, No, g.opo.n);  g.opo.v[No].pegoy = Top; break;
		default:	CHKA(0, Type, 0);
			rc = -1;goto err1;
		}
	} else if(kind == 'k') {
		switch( Type ) {
//		case TYPTRP1:	CHKA(0, No, g.trp1.n); g.trp1 [No].pegko = Top; break;
//		case TYPTRP2:	CHKA(0, No, g.trp2.n); g.trp2 [No].pegko = Top; break;
//		case TYPDRP1:	CHKA(0, No, g.drp1.n); g.drp1 [No].pegko = Top; break;
		case TYPDRP2:	CHKA(0, No, g.drp2.n); g.drp2 [No].pegko = Top; break;
//		case TYPFRP1:	CHKA(0, No, g.frp1.n); g.frp1 [No].pegko = Top; break;
		case TYPFRP2:	CHKA(0, No, g.frp2.n); g.frp2 [No].pegko = Top; break;
		case TYPONH:	CHKA(0, No, g.onh.n);  g.onh.v[No].pegko = Top; break;
		case TYPFTO:	CHKA(0, No, g.fto.n);  g.fto.v[No].pegko = Top; break;
		case TYPROD:	CHKA(0, No, g.rod.n);  g.rod.v[No].pegko = Top; break;
		case TYPPLN:	CHKA(0, No, g.pln.n);  g.pln.v[No].pegko = Top; break;
		case TYPOPO:	CHKA(0, No, g.opo.n);  g.opo.v[No].pegko = Top; break;
		default:	CHKA(0, Type, 0);
			rc = -1;goto err1;
		}   
	} else {
		rc = -2; goto err1;
	}
	rc = 0;
quit:
	return rc;
err1:
	goto quit;
}
/*	ID_getoyaoyaTop Y}̐e̐e̐擪}e[uԍo */
static int getoyaoyaTop(ZMRP &g, int awpeg) // FS050117
{
	int rc = 0;
	int oyaType;
	int oyaNo;
	int *poyawpegnode;

	oyaType = s.wpeg[awpeg].oyaType;
	oyaNo   = s.wpeg[awpeg].oyaNo;
	switch( oyaType ) {
	case TYPTRP1:	CHKA(0, oyaNo, g.trp1.n); poyawpegnode = &g.trp1 [oyaNo].wpegnode; break;
	case TYPTRP2:	CHKA(0, oyaNo, g.trp2.n); poyawpegnode = &g.trp2 [oyaNo].wpegnode; break;
	case TYPDRP1:	CHKA(0, oyaNo, g.drp1.n); poyawpegnode = &g.drp1 [oyaNo].wpegnode; break;
	case TYPDRP2:	CHKA(0, oyaNo, g.drp2.n); poyawpegnode = &g.drp2 [oyaNo].wpegnode; break;
	case TYPFRP1:	CHKA(0, oyaNo, g.frp1.n); poyawpegnode = &g.frp1 [oyaNo].wpegnode; break;
	case TYPFRP2:	CHKA(0, oyaNo, g.frp2.n); poyawpegnode = &g.frp2 [oyaNo].wpegnode; break;
	case TYPONH:	CHKA(0, oyaNo, g.onh.n);  poyawpegnode = &g.onh.v[oyaNo].wpegnode; break;
	case TYPFTO:	CHKA(0, oyaNo, g.fto.n);  poyawpegnode = &g.fto.v[oyaNo].wpegnode; break;
	case TYPROD:	CHKA(0, oyaNo, g.rod.n);  poyawpegnode = &g.rod.v[oyaNo].wpegnode; break;
	case TYPPLN:	CHKA(0, oyaNo, g.pln.n);  poyawpegnode = &g.pln.v[oyaNo].wpegnode; break;
	case TYPOPO:	CHKA(0, oyaNo, g.opo.n);  poyawpegnode = &g.opo.v[oyaNo].wpegnode; break;
	default:	CHKA(0, oyaType, 0);
		rc = -1;goto err1;
	}                                          CHKA(-1, *poyawpegnode, s.wpegnode.n);
	    
	if(*poyawpegnode < 0) return -1;
	rc = s.wpegnode[*poyawpegnode].oyaTop;
quit:
	return rc;
err1:
	goto quit;
}
/*	ID_zfPEGGING01_addw Piږ̎}ǉAKvȂm[h}X^쐬 */
static int zfPEGGING01_addw( ZMRP &g,      // FS050117
							int oyaType, int oyaNo, double oyaNum,
							int koType,  int koNo,  double koNum )
{
	int rc = 0;
	int touroku = 0;
	int oyaTop, koTop;
	int *next;
	int *poyawpegnode;
	int *pkowpegnode;
	wpeg_td	wwpeg;			/* o^f[^ */
	wpegnode_td wwpegnode;
	wpegnode_td *ppegnode;

	switch( oyaType ) {
	case TYPTRP1:	CHKA(0, oyaNo, g.trp1.n); poyawpegnode = &g.trp1 [oyaNo].wpegnode; break;
	case TYPTRP2:	CHKA(0, oyaNo, g.trp2.n); poyawpegnode = &g.trp2 [oyaNo].wpegnode; break;
	case TYPDRP1:	CHKA(0, oyaNo, g.drp1.n); poyawpegnode = &g.drp1 [oyaNo].wpegnode; break;
	case TYPDRP2:	CHKA(0, oyaNo, g.drp2.n); poyawpegnode = &g.drp2 [oyaNo].wpegnode; break;
	case TYPFRP1:	CHKA(0, oyaNo, g.frp1.n); poyawpegnode = &g.frp1 [oyaNo].wpegnode; break;
	case TYPFRP2:	CHKA(0, oyaNo, g.frp2.n); poyawpegnode = &g.frp2 [oyaNo].wpegnode; break;
	case TYPONH:	CHKA(0, oyaNo, g.onh.n);  poyawpegnode = &g.onh.v[oyaNo].wpegnode; break;
	case TYPFTO:	CHKA(0, oyaNo, g.fto.n);  poyawpegnode = &g.fto.v[oyaNo].wpegnode; break;
	case TYPROD:	CHKA(0, oyaNo, g.rod.n);  poyawpegnode = &g.rod.v[oyaNo].wpegnode; break;
	case TYPPLN:	CHKA(0, oyaNo, g.pln.n);  poyawpegnode = &g.pln.v[oyaNo].wpegnode; break;
	case TYPOPO:	CHKA(0, oyaNo, g.opo.n);  poyawpegnode = &g.opo.v[oyaNo].wpegnode; break;
	default:	CHKA(0, oyaType, 0);
		rc = -1;goto err1;
	}
	switch( koType ){
	case TYPTRP1:	CHKA(0, koNo, g.trp1.n); pkowpegnode = &g.trp1 [koNo].wpegnode; break;
	case TYPTRP2:	CHKA(0, koNo, g.trp2.n); pkowpegnode = &g.trp2 [koNo].wpegnode; break;
	case TYPDRP1:	CHKA(0, koNo, g.drp1.n); pkowpegnode = &g.drp1 [koNo].wpegnode; break;
	case TYPDRP2:	CHKA(0, koNo, g.drp2.n); pkowpegnode = &g.drp2 [koNo].wpegnode; break;
	case TYPFRP1:	CHKA(0, koNo, g.frp1.n); pkowpegnode = &g.frp1 [koNo].wpegnode; break;
	case TYPFRP2:	CHKA(0, koNo, g.frp2.n); pkowpegnode = &g.frp2 [koNo].wpegnode; break;
	case TYPONH:	CHKA(0, koNo, g.onh.n);  pkowpegnode = &g.onh.v[koNo].wpegnode; break;
	case TYPFTO:	CHKA(0, koNo, g.fto.n);  pkowpegnode = &g.fto.v[koNo].wpegnode; break;
	case TYPROD:	CHKA(0, koNo, g.rod.n);  pkowpegnode = &g.rod.v[koNo].wpegnode; break;
	case TYPPLN:	CHKA(0, koNo, g.pln.n);  pkowpegnode = &g.pln.v[koNo].wpegnode; break;
	case TYPOPO:	CHKA(0, koNo, g.opo.n);  pkowpegnode = &g.opo.v[koNo].wpegnode; break;
	default:	CHKA(0, koType, 0);
		rc = -1;goto err1;
	}
	/* f[^ݒ */
	wwpeg.dflg		= 0;		/* 폜tO */
	wwpeg.oyaType	= oyaType;
	wwpeg.oyaNo		= oyaNo;
	wwpeg.oyaNum	= oyaNum;
	wwpeg.koType	= koType;
	wwpeg.koNo		= koNo;
	wwpeg.koNum		= koNum;
	wwpeg.oyaTop	= -1;
	wwpeg.oyaNext	= -1;
	wwpeg.koTop		= -1;
	wwpeg.koNext	= -1;
	if(*poyawpegnode < 0) { // ẽm[h}X^[o^Ȃ
		wwpegnode.Type = oyaType;
		wwpegnode.No   = oyaNo;
		wwpegnode.yukoday = g.endtd;
		wwpegnode.count = 1;
		wwpegnode.oyaTop = -1;
		wwpegnode.koTop = s.wpeg.n; touroku = 1;
		wwpeg.koTop = s.wpeg.n;
		wwpeg.koNext = -1;
		*poyawpegnode = s.wpegnode.n;
		if( (rc = s.wpegnode.push_back(wwpegnode)) < 0 ) goto err3;
	} else {                                  CHKA(0, *poyawpegnode, s.wpegnode.n);
		ppegnode = &s.wpegnode[*poyawpegnode];
		if(ppegnode->koTop < 0) { // qo^Ȃ
			ppegnode->koTop = s.wpeg.n; touroku = 1;
			wwpeg.koTop = s.wpeg.n;
			wwpeg.koNext = -1;
			(ppegnode->count)++;
		} else {                  // qo^ς݂Ȃ
			int cur;
			wpeg_td *wcur;
			for(cur = ppegnode->koTop; cur >= 0; cur = wcur->koNext) { CHKA(0, cur, s.wpeg.n);
				wcur = &s.wpeg[cur]; CHKB(oyaType, wcur->oyaType, oyaType);
				                     CHKB(oyaNo, wcur->oyaNo, oyaNo);
				if(wcur->koType == koType && wcur->koNo == koNo) {
					break;
				}
			}
			if(cur >= 0) { // d}̏ꍇ
				touroku = 2;
				wcur->oyaNum += oyaNum;
				wcur->koNum	 += koNum;
			} else { // d}Ŗꍇ
				koTop = wwpeg.koTop = ppegnode->koTop; CHKA(0, koTop, s.wpeg.n);
				next = &s.wpeg[koTop].koNext;
				wwpeg.koNext = *next;
				*next = s.wpeg.n;
				touroku = 1;
				(ppegnode->count)++;
			}
		}
	}
	if(*pkowpegnode < 0) { // q̃m[h}X^o^Ȃ
		wwpegnode.Type = koType;
		wwpegnode.No   = koNo;
		wwpegnode.yukoday = g.endtd;
		wwpegnode.count = 0;
		wwpegnode.koTop = -1;
		wwpegnode.oyaTop = s.wpeg.n; touroku = 1;
		wwpeg.oyaTop = s.wpeg.n;
		wwpeg.oyaNext = -1;
		*pkowpegnode = s.wpegnode.n;
		if( (rc = s.wpegnode.push_back(wwpegnode)) < 0 ) goto           err3;
	} else {                               CHKA(0, *pkowpegnode, s.wpegnode.n);
		ppegnode = &s.wpegnode[*pkowpegnode];
		if(ppegnode->oyaTop < 0) { // eo^Ȃ
			ppegnode->oyaTop = s.wpeg.n; touroku = 1;
			wwpeg.oyaTop = s.wpeg.n;
			wwpeg.oyaNext = -1;
		} else if(touroku == 2) { // eo^ς݂łAY}d}(ēo^)̏ꍇ
			;
		} else {                   // eo^ς݂łAY}VKo^̏ꍇ
			oyaTop = wwpeg.oyaTop = ppegnode->oyaTop; CHKA(0, oyaTop, s.wpeg.n);
			next = &s.wpeg[oyaTop].oyaNext;
			wwpeg.oyaNext = *next;
			*next = s.wpeg.n;
			touroku = 1;
		}
	}
	if(touroku == 1) { // wpeg[]̓o^Kvȏꍇ(o^)
		if( (rc = s.wpeg.push_back(wwpeg)) < 0 ) goto                   err3;
	}
quit:
	return rc;
err1:
	goto                                                                quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0140 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "E301 yMOf[^̓o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -3; goto                                                       quit;
}
#endif
/*	ID_TypeS e[u^Cvԍ𕶎IDɕϊ */
char *TypeS(int Type)
{
	static char work[100];
	switch(Type) {
	case TYPDRP2: return "DRP2";
	case TYPFRP2: return "FRP2";
	case TYPOPO:  return "OPO";
	case TYPROD:  return "ROD";
	case TYPPLN:  return "PLN";
	case TYPONH:  return "ONH";
	case TYPFTO:  return "FTO";
	case TYPTRP1: return "TRP1";
	case TYPTRP2: return "TRP2";
	case TYPDRP1: return "DRP1";
	case TYPFRP1: return "FRP1";
	default:
		sprintf(work, "(%d)", Type);
		return work;
	}
}
/*	ID_dump_wpeg yMÕ_v */
static int dump_wpeg()
{
	int		rc		= 0;		/* ߂l */
	struct wpeg_td *pp = 0;
	int awpeg;

	/* wb_o */
	Dprintf("E231 %s %d" CR, "wpeg_td", s.wpeg.n);
	Dprintf("(seq) dflg oyaType oyaType oyaNo oyaNum koType koType koNo koNum oyaTop oyaNext koTop koNext" CR);
	/* f[^o */
	for( awpeg = 0; awpeg < s.wpeg.n; awpeg++ ){
		pp = &s.wpeg[awpeg];
		Dprintf("(%3d) %4d %-7s %7d %5d %6g %-6s %6d %4d %5g %6d %7d %5d %6d" CR, awpeg,
			pp->dflg,
			TypeS(pp->oyaType),pp->oyaType, pp->oyaNo, pp->oyaNum,
			TypeS(pp->koType), pp->koType, pp->koNo, pp->koNum,
			pp->oyaTop, pp->oyaNext, pp->koTop, pp->koNext );
	}
	return( rc );
}
/*	ID_dump_pegnode m[h}X^_v */
int dump_pegnode(ZMRP &g, char *id)
{
	int rc=0;
	int awpegnode;
	int Type, No;
	int awpeg;
	int wpegnode;
	wpegnode_td *pwpegnode;
	wpeg_td *pwpeg;
	Dprintf("E234 ----------id(%s)----------" CR, id);
	Dprintf("E234 _seq Type Type __No yuko yyyymmdd count oyaTop koTop _oya" CR);
	for(awpegnode = 0; awpegnode < s.wpegnode.n; awpegnode++) {
		pwpegnode = &s.wpegnode[awpegnode];
		Dprintf("E234 %4d %-4s %4d %4d %4d %8s %5d %6d %5d",
			awpegnode,
			TypeS(pwpegnode->Type),
			pwpegnode->Type,
			pwpegnode->No,
			pwpegnode->yukoday,
			zmd_td2str(g,NULL,pwpegnode->yukoday),
			pwpegnode->count,
			pwpegnode->oyaTop,
			pwpegnode->koTop);
		for(awpeg = pwpegnode->oyaTop; awpeg >= 0; awpeg = pwpeg->oyaNext) {
			pwpeg = &s.wpeg[awpeg];
			Type = pwpeg->oyaType;
			No   = pwpeg->oyaNo;
			switch( Type ){
			case TYPTRP1:	CHKA(0, No, g.trp1.n); wpegnode = g.trp1[No].wpegnode; break;
			case TYPTRP2:	CHKA(0, No, g.trp2.n); wpegnode = g.trp2[No].wpegnode; break;
			case TYPDRP1:	CHKA(0, No, g.drp1.n); wpegnode = g.drp1[No].wpegnode; break;
			case TYPDRP2:	CHKA(0, No, g.drp2.n); wpegnode = g.drp2[No].wpegnode; break;
			case TYPFRP1:	CHKA(0, No, g.frp1.n); wpegnode = g.frp1[No].wpegnode; break;
			case TYPFRP2:	CHKA(0, No, g.frp2.n); wpegnode = g.frp2[No].wpegnode; break;
			case TYPONH:	CHKA(0, No, g.onh.n);  wpegnode = g.onh.v[No].wpegnode;break;
			case TYPFTO:	CHKA(0, No, g.fto.n);  wpegnode = g.fto.v[No].wpegnode;break;
			case TYPROD:	CHKA(0, No, g.rod.n);  wpegnode = g.rod.v[No].wpegnode;break;
			case TYPPLN:	CHKA(0, No, g.pln.n);  wpegnode = g.pln.v[No].wpegnode;break;
			case TYPOPO:	CHKA(0, No, g.opo.n);  wpegnode = g.opo.v[No].wpegnode;break;
			default:	CHKB(TYPTRP1, Type, TYPOPO);
				rc = -1;goto err1;
			}
			Dprintf(" %4d", wpegnode);
		}
		Dprintf(CR);
	}
err1:
	return rc;
}
/*	ID_yukomake e[u֎gpݒ肷 */
int yukomake(ZMRP &g, int aitm)
{
	int rc = 0;
	int awpegnode;
	int wmatchi;
	int awmachi;
	int awpeg;
	int Type;
	int No;
	int wpegnode;
	int afsh;
	int aitm2;
	int koyukoday;
	int wkyukoday;
	int ashm;
	frp2_td *wfrp2;
	drp2_td *wdrp2;
	pln_td *wpln;
	opo_td *wopo;
	fto_td *wfto;
	fsh_td *wfsh;
	wpeg_td *pwpeg;
	wpegnode_td *pwpegnode;
	wpegnode_td *pwpegnode2;

	                                                         CHKA(0, aitm, g.itm.n);
	s.wmachi.clear();
	for(awpegnode = 0; awpegnode < s.wpegnode.n; awpegnode++) { // [̎gpݒ
		pwpegnode = &s.wpegnode[awpegnode];
		pwpegnode->count_save = pwpegnode->count; // \ׂ̈ɕۑĒuifobO\pj
		if(pwpegnode->count != 0) continue; // [łȂ΁A
		CHKB(-1, pwpegnode->koTop, -1);
		wmatchi = awpegnode;
//		s.wmachi.push_back(wmatchi); // ʂ̃m[hݒ肷ׂ̏
		if( (rc = s.wmachi.push_back(wmatchi)) < 0 ) goto err3;
		Type = pwpegnode->Type;
		No   = pwpegnode->No;
		switch( Type ){ // e[uɎgpݒ肷
		case TYPTRP1:	CHKA(0, No, g.trp1.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.trp1[No].wpegnode; CHKA(0, No, 0);
			break;
		case TYPTRP2:	CHKA(0, No, g.trp2.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.trp2[No].wpegnode; CHKA(0, No, 0);
			break;
		case TYPDRP1:	CHKA(0, No, g.drp1.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.drp1[No].wpegnode; CHKA(0, No, 0);
			break;
		case TYPDRP2:	CHKA(0, No, g.drp2.n);
			wdrp2 = &g.drp2[No];
			wpegnode = wdrp2->wpegnode; CHKA(0, wpegnode, s.wpegnode.n);

			wkyukoday = wdrp2->lastusetd;                 // FS050118
			if(wkyukoday > g.endtd) wkyukoday = g.endtd;  // FS050118

			pwpegnode->yukoday = wkyukoday; // ŏIgp\gpƂ
			wdrp2->yukoday = pwpegnode->yukoday;
			break;
		case TYPFRP1:	CHKA(0, No, g.frp1.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.frp1[No].wpegnode; CHKA(0, No, 0);
			break;
		case TYPFRP2:	CHKA(0, No, g.frp2.n); // [̓x_VbvVbvijA񐻑Vbv͗Ȃ
			wfrp2 = &g.frp2[No];
			wpegnode = wfrp2->wpegnode;
#if 0 // qFRPpȂ FS050113B
			if(wfrp2->yukoday >= 0) { // qꍇ́AɃe[uɓĂ邩
				pwpegnode->yukoday = wfrp2->yukoday;
			} else {
				pwpegnode->yukoday = wfrp2->due + g.itm.v[aitm].yukodays; // [(frp2){L(itm)
			}
#else
			wkyukoday = wfrp2->due + g.itm.v[aitm].yukodays; // FS050118
			if(wkyukoday > g.endtd) wkyukoday = g.endtd;     // FS050118

			pwpegnode->yukoday = wkyukoday; // [(frp2){L(itm)
//			if(pwpegnode->yukoday > g.endtd) pwpegnode->yukoday = g.endtd; // FS050113C
#endif
			wfrp2->yukoday = pwpegnode->yukoday;
			break;
		case TYPONH:	CHKA(0, No, g.onh.n);
			wpegnode = g.onh.v[No].wpegnode;
			pwpegnode->yukoday = g.onh.v[No].yukoday; // t@Cŗ^̂ŁA荞ނ
			break;
		case TYPFTO:	CHKA(0, No, g.fto.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.fto.v[No].wpegnode;
//			pwpegnode->yukoday = g.fto.v[No].yukoday; // t@Cŗ^̂ŁA荞ނ
			break;
		case TYPROD:	CHKA(0, No, g.rod.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.rod.v[No].wpegnode; CHKA(0, No, 0);
			break;
		case TYPPLN:	CHKA(0, No, g.pln.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.pln.v[No].wpegnode; CHKA(0, No, 0);
			break;
		case TYPOPO:	CHKA(0, No, g.opo.n); // [ɂ͂Ȃ蓾Ȃ
			wpegnode = g.opo.v[No].wpegnode; CHKA(0, No, 0);
			break;
		default:	CHKB(TYPTRP1, Type, TYPOPO);
			rc = -1;goto err1;
		}
	}
	for(awmachi = 0; awmachi < s.wmachi.n; awmachi++) {
		if(zdbgf[190]>2)
		{
			Dprintf("E235 %4d %4d" CR,
				awmachi, s.wmachi[awmachi]);
		}
		awpegnode = s.wmachi[awmachi]; CHKA(0, awpegnode, s.wpegnode.n);
		pwpegnode = &s.wpegnode[awpegnode];
		if(pwpegnode->Type == TYPDRP2) { // qDRP2̏ꍇAeɉeȂ FS050113B
			koyukoday = g.endtd;
		} else {
			koyukoday = pwpegnode->yukoday; // q̎gp߂Ēu
		}
		for(awpeg = pwpegnode->oyaTop; awpeg >= 0; awpeg = pwpeg->oyaNext) {
			pwpeg = &s.wpeg[awpeg];
			Type = pwpeg->oyaType;
			No = pwpeg->oyaNo;
			switch( Type ){
			case TYPTRP1:	CHKA(0, No, g.trp1.n);
				wpegnode = g.trp1[No].wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				break;
			case TYPTRP2:	CHKA(0, No, g.trp2.n);
				wpegnode = g.trp2[No].wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				break;
			case TYPDRP1:	CHKA(0, No, g.drp1.n);
				wpegnode = g.drp1[No].wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				break;
			case TYPDRP2:	CHKA(0, No, g.drp2.n);
				wdrp2 = &g.drp2.v[No];
				wpegnode = wdrp2->wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				if(pwpegnode2->count == 1) {
					wdrp2->yukoday = pwpegnode2->yukoday;
				}
				break;
			case TYPFRP1:	CHKA(0, No, g.frp1.n);
				wpegnode = g.frp1[No].wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				break;
			case TYPFRP2:	CHKA(0, No, g.frp2.n); // ł́A^񐻑VbvL肦Ax_Vbv͗Ȃ
				wfrp2 = &g.frp2[No];
				wpegnode = wfrp2->wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				afsh = wfrp2->fsh; CHKA(0, afsh, g.fsh.n);
				wfsh = &g.fsh.v[afsh]; // Vbv𓾂
				aitm2 = wfsh->itm; CHKA(0, aitm2, g.itm.n);
				ashm = wfsh->shm; CHKA(0, ashm, g.shm.n);
				pwpegnode2 = &s.wpegnode[wpegnode]; // ẽm[h}X^[߂
				if(pwpegnode2->oyaTop >= 0) { // e΁A񐻑Vbv
					CHKB(2, g.shm[ashm].shm_typ, 2); // 2:񐻑Vbv
#if 1 // qp̂ŗL΁A𒼂 FS050113B
					if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
						pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
					}
#else
					if(pwpegnode2->count == 1) {
						pwpegnode2->yukoday = wfrp2->due + g.itm.v[aitm2].yukodays; // [(frp2){L(itm)
//						if(pwpegnode2->yukoday > g.endtd) pwpegnode2->yukoday = g.endtd; // FS050113C
					}
#endif
				} else { // eȂ΁AVbv

					CHKB(1, g.shm[ashm].shm_typ, 1); // 1:Vbv
#if 0 // qp̂ŗL΁A𒼂 FS050113B
					if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
						pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
					}
#else
					if(pwpegnode2->count == 1) {
						wkyukoday = wfrp2->due + g.itm.v[aitm2].yukodays;    // FS050118
						if(wkyukoday > g.endtd) wkyukoday = g.endtd;         // FS050118
						pwpegnode2->yukoday = wkyukoday; // [(frp2){L(itm)
//						if(pwpegnode2->yukoday > g.endtd) pwpegnode2->yukoday = g.endtd; // FS050113C
					}
#endif

				}
				if(pwpegnode2->count == 1) wfrp2->yukoday = pwpegnode2->yukoday;
				break;
			case TYPONH:	CHKA(0, No, g.onh.n); // eɂ͂Ȃ蓾Ȃ̂ŁA͒ʂȂ
				wpegnode = g.onh.v[No].wpegnode; CHKA(0, No, 0);
				pwpegnode2 = &s.wpegnode[wpegnode];
				break;
			case TYPFTO:	CHKA(0, No, g.fto.n);
				wfto = &g.fto.v[No];
				wpegnode = wfto->wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				s.wpegnode[wpegnode].yukoday = wfto->yukoday; // t@Cŗ^̂ŁA荞ނ
				pwpegnode2 = &s.wpegnode[wpegnode]; // FS050119
				break;
			case TYPROD:	CHKA(0, No, g.rod.n); // e[uɎgp̃tB[hAeȂ̂ŉȂ
				wpegnode = g.rod.v[No].wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode]; CHKB(-1, pwpegnode2->oyaTop, -1); // e͋ȂɈႢȂ
				break;
			case TYPPLN:	CHKA(0, No, g.pln.n);
				wpln = &g.pln.v[No];
				wpegnode = wpln->wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				if(pwpegnode2->count == 1) wpln->yukoday = pwpegnode2->yukoday;
				break;
			case TYPOPO:	CHKA(0, No, g.opo.n);
				wopo = &g.opo.v[No];
				wpegnode = wopo->wpegnode; CHKA(0, wpegnode, s.wpegnode.n);
				pwpegnode2 = &s.wpegnode[wpegnode];
				if(koyukoday < pwpegnode2->yukoday) { // q̎gp̕
					pwpegnode2->yukoday = koyukoday;  // q̎gpݒ肷
				}
				if(pwpegnode2->count == 1) wopo->yukoday = pwpegnode2->yukoday;
				break;
			default:	CHKB(TYPTRP1, Type, TYPOPO);
				rc = -1;goto err1;
			}
//			pwpegnode2 = &s.wpegnode[wpegnode];
			(pwpegnode2->count)--; CHKB(0, 0, pwpegnode2->count);
			if(pwpegnode2->count == 0) {
				wmatchi = wpegnode;
//				s.wmachi.push_back(wmatchi);
				if( (rc = s.wmachi.push_back(wmatchi)) < 0 ) goto err3;
			}
		}
	}
	if(zdbgf[190]>1)
	{
		Dprintf("E200 endtd(%d) aitm(%d) itm(%s)" CR, g.endtd, aitm, g.itm.v[aitm].itm_cd);
		Dprintf("E234 _seq Type Type __No yuko yyyymmdd count oyaTop koTop _oya" CR);
		for(awpegnode = 0; awpegnode < s.wpegnode.n; awpegnode++) {
			pwpegnode = &s.wpegnode[awpegnode];
			Dprintf("E234 %4d %-4s %4d %4d %4d %8s %5d %6d %5d",
				awpegnode,
				TypeS(pwpegnode->Type),
				pwpegnode->Type,
				pwpegnode->No,
				pwpegnode->yukoday,
				zmd_td2str(g,NULL,pwpegnode->yukoday),
				pwpegnode->count_save, // count FS050113A
				pwpegnode->oyaTop,
				pwpegnode->koTop);
			for(awpeg = pwpegnode->oyaTop; awpeg >= 0; awpeg = pwpeg->oyaNext) {
				pwpeg = &s.wpeg[awpeg];
				Type = pwpeg->oyaType;
				No   = pwpeg->oyaNo;
				switch( Type ){
				case TYPTRP1:	CHKA(0, No, g.trp1.n); wpegnode = g.trp1[No].wpegnode; break;
				case TYPTRP2:	CHKA(0, No, g.trp2.n); wpegnode = g.trp2[No].wpegnode; break;
				case TYPDRP1:	CHKA(0, No, g.drp1.n); wpegnode = g.drp1[No].wpegnode; break;
				case TYPDRP2:	CHKA(0, No, g.drp2.n); wpegnode = g.drp2[No].wpegnode; break;
				case TYPFRP1:	CHKA(0, No, g.frp1.n); wpegnode = g.frp1[No].wpegnode; break;
				case TYPFRP2:	CHKA(0, No, g.frp2.n); wpegnode = g.frp2[No].wpegnode; break;
				case TYPONH:	CHKA(0, No, g.onh.n);  wpegnode = g.onh.v[No].wpegnode;break;
				case TYPFTO:	CHKA(0, No, g.fto.n);  wpegnode = g.fto.v[No].wpegnode;break;
				case TYPROD:	CHKA(0, No, g.rod.n);  wpegnode = g.rod.v[No].wpegnode;break;
				case TYPPLN:	CHKA(0, No, g.pln.n);  wpegnode = g.pln.v[No].wpegnode;break;
				case TYPOPO:	CHKA(0, No, g.opo.n);  wpegnode = g.opo.v[No].wpegnode;break;
				default:	CHKB(TYPTRP1, Type, TYPOPO);
					rc = -1;goto err1;
				}
				Dprintf(" %4d", wpegnode);
			}
			Dprintf(CR);
		}
	}
quit:
	return rc;
err1:
	goto quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0150 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "yMOf[^̓o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -3; goto	quit;
}
/*	ID_zfPEGGING01_proc2 yMO̎W(svN̍폜) */
static int zfPEGGING01_proc2( ZMRP &g, int aitm, int peg_bgn, int peg_end ) /* rc 0: <0:ُ */
{
	int		rc		= 0;		/* ߂l */
	int		fc		= 0;		/* ֐p߂l */
	int		oyaNo	= -1;		/* e̔ԍ */
	double	oyaNum	= 0.0;		/* e̐ */
	double	oyaNumSum	= 0.0;	/* e̐ʂ̍v */
	int		koNo	= -1;		/* q̔ԍ */
	int		awpeg	= -1;		/* wpeg[] */
	int		oyaTop	= -1;		/* eN̐擪 */
	int		koTop	= -1;		/* N̐擪 */
	unsigned int	size;
	                                    CHKA(0, aitm, g.itm.n);
	if(zdbgf[99]) {Dprintf("90.zfPEGGING01_proc2 aitm(%d)" CR, aitm); goto quit;}
	if(zdbgf[190]>1) {TRACEA(0); Dprintf("zfPEGGING01_proc2 aitm(%d)" CR, aitm );}
	/* ̓`FbN */
	if( aitm < 0 || aitm >= g.itm.n) goto err1;
	size = sizeof(int) * 2;
	/* svN̍폜 */
	for( awpeg = peg_bgn ; awpeg < peg_end ; ++awpeg ){
		/* 폜ς͑ΏۊO */
		if( s.wpeg[awpeg].dflg == 1 ) continue;
		/* 폜Ώۃ^Cv`FbN */
		switch( s.wpeg[awpeg].oyaType ){
		/* 폜ΏۊO */
		case TYPDRP2:
		case TYPFRP2:
		case TYPONH:
		case TYPFTO:
		case TYPROD:
		case TYPPLN:
		case TYPOPO:
			continue;
			break;
		/* 폜Ώ */
		default: ;
		}
		/* eN */
		/*  */
#ifndef NEWPEG
		if( (oyaTop = s.h_wpko.hashfind( &s.wpeg[awpeg].oyaType, size )) < 0 ) continue;
#else
		if(( oyaTop = getoyaoyaTop(g, awpeg)) < 0) continue; // FS050117
#endif
		/* N */
		koTop = s.wpeg[awpeg].koTop;
		/*
		** Dx
		** (1)[
		** (2)iڂ̗Dx
		** (3)\Ԃ̗Dx
		** (4)bgTCY̑傫ɂ悹
		** (5)ォ珇
		*/
		/*
		** (1)OFҏW
		** e|qNo
		*/
		oyaNumSum = 0;
		for( oyaNo = oyaTop ; oyaNo >= 0 ; oyaNo = s.wpeg[oyaNo].oyaNext ){  CHKA(0, oyaNo, s.wpeg.n);
			if( s.wpeg[oyaNo].dflg == 1 ) continue;
			s.wpeg[oyaNo].dflg	= 2;	/* 폜tOɕҏWݒ */
			oyaNumSum += s.wpeg[oyaNo].oyaNum;
		}
		/* q|No */
		for( koNo = koTop ; koNo >= 0 ; koNo = s.wpeg[koNo].koNext ){  CHKA(0, koNo, s.wpeg.n);
			if( s.wpeg[koNo].dflg == 1 ) continue;
			s.wpeg[koNo].dflg	= 2;	/* 폜tOɕҏWݒ */
		}
		/*
		** (2)又F쐬
		** eƑ݂ꍇ
		*/
		for( oyaNo = oyaTop ; oyaNo >= 0 ; oyaNo = s.wpeg[oyaNo].oyaNext ){
			if( s.wpeg[oyaNo].dflg != 2 ) continue;
			for( koNo = koTop ; koNo >= 0 ; koNo = s.wpeg[koNo].koNext ){
				if( s.wpeg[koNo].dflg != 2 ) continue;
				oyaNum = s.wpeg[koNo].oyaNum * s.wpeg[oyaNo].oyaNum / s.wpeg[oyaNo].koNum;
				/* e̍v`FbN(ŏIeɖtt) */
				oyaNumSum -= oyaNum;
				/* No^ */
				fc = zfPEGGING01_addw( g, s.wpeg[oyaNo].oyaType, s.wpeg[oyaNo].oyaNo, oyaNum,
										s.wpeg[koNo].koType, s.wpeg[koNo].koNo, s.wpeg[koNo].koNum );
				if( fc < 0 ) goto err2;
			}
		}
		/*
		** (3)㏈F폜
		** e|qNo
		*/
		for( oyaNo = oyaTop ; oyaNo >= 0 ; oyaNo = s.wpeg[oyaNo].oyaNext ){
			if( s.wpeg[oyaNo].dflg != 2 ) continue;
			s.wpeg[oyaNo].dflg	= 1;	/* 폜tOɍ폜ϐݒ */
		}
		/* q|No */
		for( koNo = koTop ; koNo >= 0 ; koNo = s.wpeg[koNo].koNext ){
			if( s.wpeg[koNo].dflg != 2 ) continue;
			s.wpeg[koNo].dflg	= 1;	/* 폜tOɍ폜ϐݒ */
		}
	}
quit:
	if(zdbgf[190]>1) {TRACEC(0); Dprintf("zfPEGGING01_proc2 rc(%d)" CR, rc);
		Dprintf("drp2(%d)frp2(%d)opo(%d)rod(%d)pln(%d)onh(%d)fto(%d)trp1(%d)trp2(%d)drp1(%d)frp1(%d)" CR,
			g.drp2.n, g.frp2.n, g.opo.n, g.rod.n, g.pln.n, g.onh.n, g.fto.n, g.trp1.n, g.trp2.n, g.drp1.n, g.frp1.n );
		Dprintf("bom(%d)ubm(%d)lsz(%d)zhi(%d)" CR,
			g.bom.n, g.ubm.n, g.lsz.n, g.zhi.n );
		if( s.peg.n > 0 ) dmp_peg_td( g, s.peg.v, s.peg.n );
	}
	return( rc );
err1:
	Esprintf(g.ermes, "zfpegging1.cpp 0160 (%d)" CR, aitm );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "֐̓͂słFaitm(%d)" CR, aitm ); Eprintf(g.ermes); }
	rc = -1; goto                                                       quit;
err2:
	Esprintf(g.ermes, "zfpegging1.cpp 0170 (%d)" CR, fc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "No^sFfc(%d)" CR, fc ); Eprintf(g.ermes); }
	rc = -2; goto                                                       quit;
}

/*	ID_zfPEGGING01_add yMO̒ǉ */
static int zfPEGGING01_add( ZMRP &g, int oyaType, int oyaNo, double oyaNum, int koType, int koNo, double koNum )
{
	int		rc		= 0;	/* ߂l */
	int		keyNo	= -1;	/* nbVԍ */
	int		datNo	= -1;	/* o^f[^ԍ */
	peg_td	wpeg;			/* o^f[^ */
	unsigned int	size, size1;
#ifndef NEWPEG
	char	*key;
#endif

	if(zdbgf[99]) {Dprintf("90.zfPEGGING01_add oyaType(%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum); goto quit;}
	if(zdbgf[190]>4) {TRACEA(0); Dprintf("zfPEGGING01_add oyaType(%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum);}

	/* ̓`FbN */
	switch( oyaType ){
	case TYPDRP2:	CHKA(0, oyaNo, g.drp2.n); break;
	case TYPFRP2:	CHKA(0, oyaNo, g.frp2.n); break;
	case TYPONH:	CHKA(0, oyaNo, g.onh.n);  break;
	case TYPFTO:	CHKA(0, oyaNo, g.fto.n);  break;
	case TYPROD:	CHKA(0, oyaNo, g.rod.n);  break;
	case TYPPLN:	CHKA(0, oyaNo, g.pln.n);  break;
	case TYPOPO:	CHKA(0, oyaNo, g.opo.n);  break;
	default:	CHKB(TYPTRP1, oyaType, TYPOPO);
		goto err1;
	}
	switch( koType ){
	case TYPDRP2:	CHKA(0, koNo, g.drp2.n); break;
	case TYPFRP2:	CHKA(0, koNo, g.frp2.n); break;
	case TYPONH:	CHKA(0, koNo, g.onh.n);  break;
	case TYPFTO:	CHKA(0, koNo, g.fto.n);  break;
	case TYPROD:	CHKA(0, koNo, g.rod.n);  break;
	case TYPPLN:	CHKA(0, koNo, g.pln.n);  break;
	case TYPOPO:	CHKA(0, koNo, g.opo.n);  break;
	default:	CHKB(TYPTRP1, koType, TYPOPO);
		goto err1;
	}
	/* f[^ݒ */
	wpeg.oyaType	= oyaType;
	wpeg.oyaNo		= oyaNo;
	wpeg.oyaNum	= oyaNum;
	wpeg.koType	= koType;
	wpeg.koNo		= koNo;
	wpeg.koNum		= koNum;
	wpeg.oyaTop	= -1;
	wpeg.oyaNext	= -1;
	wpeg.koTop		= -1;
	wpeg.koNext	= -1;
	size = sizeof(int)  * 4;
	size1 = sizeof(int) * 2;
	/* o^̏ꍇ */
	datNo = s.peg.n;	/* ǉf[^i[zY */
	if( (rc = s.peg.push_back(wpeg)) < 0 ) goto err3;
	/*  */
#ifndef NEWPEG // FS050118
	if( (keyNo = s.h_poy.hashfind( &wpeg.oyaType, size1 )) >= 0 ){
		/* o^̏ꍇ */
		s.peg[datNo].koTop		= keyNo;
		s.peg[datNo].koNext	= s.peg[keyNo].koNext;
		s.peg[keyNo].koNext	= datNo;
	} else {
		/* o^̏ꍇ */
		if( (rc = s.h_poy.hashaddr( &wpeg.oyaType, size1, datNo, &key )) < 0 ) goto err_h;
		s.peg[datNo].koTop	= datNo;
		s.peg[datNo].koNext= -1;
	}
#else
	if( (keyNo = getTop(g, 'o', wpeg.oyaType, wpeg.oyaNo)) >= 0 ){
		/* o^̏ꍇ */
		s.peg[datNo].koTop		= keyNo;             CHKA(0, keyNo, s.peg.n);
		s.peg[datNo].koNext	= s.peg[keyNo].koNext;
		s.peg[keyNo].koNext	= datNo;
	} else {
		/* o^̏ꍇ */
		if( (rc = putTop(g, 'o', wpeg.oyaType, wpeg.oyaNo, datNo)) < 0 ) goto err_h;
		s.peg[datNo].koTop	= datNo;
		s.peg[datNo].koNext= -1;
	}
#endif
	/*  */
#ifndef NEWPEG // FS050118	
	if( (keyNo = s.h_pko.hashfind( &wpeg.koType, size1 )) >= 0 ){
		/* o^̏ꍇ */
		s.peg[datNo].oyaTop	= keyNo;
		s.peg[datNo].oyaNext	= s.peg[keyNo].oyaNext;
		s.peg[keyNo].oyaNext	= datNo;
	} else {
		/* o^̏ꍇ */
		if( (rc = s.h_pko.hashaddr( &wpeg.koType, size1, datNo, &key )) < 0 ) goto err_h;
		s.peg[datNo].oyaTop	= datNo;
		s.peg[datNo].oyaNext	= -1;
	}
#else
	if( (keyNo = getTop(g, 'k', wpeg.koType, wpeg.koNo)) >= 0 ){
		/* o^̏ꍇ */
		s.peg[datNo].oyaTop	= keyNo;                 CHKA(0, keyNo, s.peg.n);
		s.peg[datNo].oyaNext	= s.peg[keyNo].oyaNext;
		s.peg[keyNo].oyaNext	= datNo;
	} else {
		/* o^̏ꍇ */
		if( (rc = putTop(g, 'k', wpeg.koType, wpeg.koNo, datNo)) < 0 ) goto err_h;
		s.peg[datNo].oyaTop	= datNo;
		s.peg[datNo].oyaNext	= -1;
	}
#endif
quit:
	if(zdbgf[190]>4) {TRACEC(0); Dprintf("zfPEGGING01_add rc(%d)" CR, rc);}
	return( rc );
err1:
	Esprintf(g.ermes, "zfpegging1.cpp 0180 (%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "֐̓͂słFoyaType(%d)oyaNo(%d)oyaNum(%g)koType(%d)koNo(%d)koNum(%g)" CR, oyaType, oyaNo, oyaNum, koType, koNo, koNum); Eprintf(g.ermes); }
	rc = -1; goto                                                       quit;
err_h:
	Esprintf(g.ermes, "zfpegging1.cpp 0190 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "yMOf[^̃L[̃nbV\o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -2; goto                                                       quit;
err3:
	Esprintf(g.ermes, "zfpegging1.cpp 0200 :rc(%d)" CR, rc );
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "yMOf[^̓o^G[:rc(%d)" CR, rc ); Eprintf(g.ermes); }
	rc = -3; goto                                                       quit;
}

/*	ID_dmp_wpeg_td yMÕ_v */
static int dmp_wpeg_td(ZMRP &g, struct wpeg_td *pp, int pm )
{
	int		rc		= 0;		/* ߂l */
	int		cnt		= 0;		/* f[^JE^ */
	struct wpeg_td *ep = 0;		/* I|C^ */

	/* ̓`FbN */
	if( pp == 0 ) goto err1;
	if( pm < 0 ) goto err1;
	/* wb_o */
	Dprintf("%s%s%d" CR, "wpeg_td", TAB, pm );
	if( g.jmf ) Dprintf("[]%s폜%se%seԍ%se%sq%sqԍ%sq%se%se%sq%sq" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB );
	/* f[^o */
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("(%3d)%s%d%s%d%s%d%s%g%s%d%s%d%s%g%s%d%s%d%s%d%s%d" CR, cnt++,
			TAB, pp->dflg,
			TAB, pp->oyaType, TAB, pp->oyaNo, TAB, pp->oyaNum, TAB, pp->koType, TAB, pp->koNo, TAB, pp->koNum,
			TAB, pp->oyaTop, TAB, pp->oyaNext, TAB, pp->koTop, TAB, pp->koNext );
	}
quit:
	return( rc );
err1:
	rc = -1; goto quit;
}

/*	ID_dmp_peg_td yMÕ_v */
int dmp_peg_td( ZMRP &g, struct peg_td *pp, int pm )
{
	int		rc		= 0;		/* ߂l */
	int		cnt		= 0;		/* f[^JE^ */
	struct peg_td *ep = 0;		/* I|C^ */

	/* ̓`FbN */
	if( pp == 0 ) goto                                                  err1;
	if( pm < 0 ) goto                                                   err1;
	/* wb_o */
	Dprintf("%s%s%d" CR, "peg_td", TAB, pm );
	if( g.jmf ) Dprintf("[]%se%seԍ%se%sq%sqԍ%sq%se%se%sq%sq" CR, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB, TAB );
	/* f[^o */
	for( ep = pp + pm; pp < ep; pp++ ){
		Dprintf("(%3d)%s%d%s%d%s%g%s%d%s%d%s%g%s%d%s%d%s%d%s%d" CR, cnt++,
			TAB, pp->oyaType, TAB, pp->oyaNo, TAB, pp->oyaNum, TAB, pp->koType, TAB, pp->koNo, TAB, pp->koNum,
			TAB, pp->oyaTop, TAB, pp->oyaNext, TAB, pp->koTop, TAB, pp->koNext );
	}
quit:
	return( rc );
err1:
	rc = -1; goto                                                       quit;
}

/*	ID_zwtPEGGING01	91.yMOo */
int zwtPEGGING01(ZMRP &g, char *fname)
{
	int		rc		= 0;	/* ߂l */
	int		apeg	= -1;	/* peg[] */
	int		oyaNo	= -1;	/* eԍ */
	int		koNo	= -1;	/* qԍ */
	int		oyaTop	= -1;	/* e */
	int		oyaNext	= -1;	/* e */
	int		koTop	= -1;	/* q */
	int		koNext	= -1;	/* q */
	peg_td	*wpeg	= NULL;
	FILE	*fp		= NULL;	/* o̓t@C|C^ */
	unsigned char dlm;

	if(zdbgf[99]) {Dprintf("91.zwtPEGGING01" CR ); goto quit;}
	if(zdbgf[191]) {TRACEA(0); Dprintf("91.zwtPEGGING01 fname(%s)" CR, fname);}
	sprintf( g.fname, "%s/%s", g.sys.dir_out, fname );
	if( (fp = fopen(g.fname, "w")) == NULL ) goto	err_op;
	/* Psڂ̃o[Wo */
	dlm = g.delimiter;
	fprintf( fp, "%s" CR, "!V01");
	if( g.jmf ) {
	/* 擪̌oo */
		fprintf( fp, "!%s%s", "", "e" );	/* e */
//		fprintf( fp, "%s%s", TAB, "eԍ"  );	/* eԍ */
//		fprintf( fp, "%s%s", TAB, "e"  );	/* e */
//		fprintf( fp, "%s%s", TAB, "q"  );	/* q */
//		fprintf( fp, "%s%s", TAB, "qԍ"  );	/* qԍ */
//		fprintf( fp, "%s%s", TAB, "q"  );	/* q */
//		fprintf( fp, "%s%s", TAB, "e"    );	/* e */
//		fprintf( fp, "%s%s", TAB, "e"    );	/* e */
//		fprintf( fp, "%s%s", TAB, "q"    );	/* q */
//		fprintf( fp, "%s%s", TAB, "q"    );	/* q */
		fprintf( fp, "%c%s", dlm, "eԍ"  );	/* eԍ *///chg KS140624 TAB  dlm ɕύX
		fprintf( fp, "%c%s", dlm, "e"  );	/* e */
		fprintf( fp, "%c%s", dlm, "q"  );	/* q */
		fprintf( fp, "%c%s", dlm, "qԍ"  );	/* qԍ */
		fprintf( fp, "%c%s", dlm, "q"  );	/* q */
		fprintf( fp, "%c%s", dlm, "e"    );	/* e */
		fprintf( fp, "%c%s", dlm, "e"    );	/* e */
		fprintf( fp, "%c%s", dlm, "q"    );	/* q */
		fprintf( fp, "%c%s", dlm, "q"    );	/* q */
		fprintf( fp, CR );
	}
	for( apeg = 0; apeg < s.peg.n; ++apeg ) {
		wpeg = &s.peg.v[apeg];
		switch( wpeg->oyaType ){
		case TYPDRP2:	CHKA(0, wpeg->oyaNo, g.drp2.n);
			oyaNo = g.drp2(wpeg->oyaNo).outseq;	/* oɌvt@C̏o͍sԍPn܂(Rgs) */
			break;
		case TYPFRP2:	CHKA(0, wpeg->oyaNo, g.frp2.n);
			oyaNo = g.frp2(wpeg->oyaNo).outseq;	/* vt@C̏o͍sԍPn܂(Rgs) */
			break;
		default:
			oyaNo = wpeg->oyaNo + 1;	/* zԍOn܂ */
		}
		switch( wpeg->koType ){
		case TYPDRP2:	CHKA(0, wpeg->koNo, g.drp2.n);
			koNo = g.drp2(wpeg->koNo).outseq;	/* oɌvt@C̏o͍sԍPn܂(Rgs) */
			break;
		case TYPFRP2:	CHKA(0, wpeg->koNo, g.frp2.n);
			koNo = g.frp2(wpeg->koNo).outseq;	/* vt@C̏o͍sԍPn܂(Rgs) */
			break;
		default:
			koNo = wpeg->koNo + 1;	/* zԍOn܂ */
		}
		oyaTop = (wpeg->oyaTop<0)?(wpeg->oyaTop):(wpeg->oyaTop+1);
		oyaNext = (wpeg->oyaNext<0)?(wpeg->oyaNext):(wpeg->oyaNext+1);
		koTop = (wpeg->koTop<0)?(wpeg->koTop):(wpeg->koTop+1);
		koNext = (wpeg->koNext<0)?(wpeg->koNext):(wpeg->koNext+1);
#if 1
		int pos = 0;
		pos = zssc_itobf(g.ermes, pos, 0  , wpeg->oyaType); /* e "%s%d", "", wpeg->oyaType */
		pos = zssc_itobf(g.ermes, pos, dlm, oyaNo        ); /* eԍ "%s%d", TAB, oyaNo */
		pos = zssc_dtobf(g.ermes, pos, dlm, wpeg->oyaNum ); /* e "%s%g", TAB, wpeg->oyaNum */
		pos = zssc_itobf(g.ermes, pos, dlm, wpeg->koType ); /* q "%s%d", TAB, wpeg->koType */
		pos = zssc_itobf(g.ermes, pos, dlm, koNo         ); /* qԍ "%s%d", TAB, koNo        */
		pos = zssc_dtobf(g.ermes, pos, dlm, wpeg->koNum  ); /* ߐ "%s%g", TAB, wpeg->koNum  */
		pos = zssc_itobf(g.ermes, pos, dlm, oyaTop       ); /* e   "%s%d", TAB, oyaTop       */
		pos = zssc_itobf(g.ermes, pos, dlm, oyaNext      ); /* e   "%s%d", TAB, oyaNext      */
		pos = zssc_itobf(g.ermes, pos, dlm, koTop        ); /* q   "%s%d", TAB, koTop        */
		pos = zssc_itobf(g.ermes, pos, dlm, koNext       ); /* q   "%s%d", TAB, koNext       */
		fprintf( fp, "%s" CR, g.ermes );
#else
		fprintf( fp, "%s%d", "", wpeg->oyaType	);	/* e */
		fprintf( fp, "%s%d", TAB, oyaNo	        );	/* eԍ */
		fprintf( fp, "%s%g", TAB, wpeg->oyaNum	);	/* e */
		fprintf( fp, "%s%d", TAB, wpeg->koType	);	/* q */
		fprintf( fp, "%s%d", TAB, koNo       	);	/* qԍ */
		fprintf( fp, "%s%g", TAB, wpeg->koNum   );	/* ߐ */
		fprintf( fp, "%s%d", TAB, oyaTop        );	/* e */
		fprintf( fp, "%s%d", TAB, oyaNext       );	/* e */
		fprintf( fp, "%s%d", TAB, koTop         );	/* q */
		fprintf( fp, "%s%d", TAB, koNext        );	/* q */
		fprintf( fp, CR );
#endif
	}
	rc = 0;
quit:
	if( fp ) { fclose(fp); fp = NULL; }
	if(zdbgf[191]) {TRACEC(0); Dprintf("91.zwtPEGGING01 rc(%d)" CR, rc);}
	return rc;
err_op: rc = -1;
	Esprintf(g.ermes, "zfpegging1.cpp 0210 zwtPEGGING01:(%s)" CR, g.fname);
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes, "zwtPEGGING01:t@C(%s)J܂" CR, g.fname); Eprintf(g.ermes); }
	goto	quit;
}
#if 0 // FS050119A
/*	ID_zfPEGGING02	90.yMO(gp̐ݒ) gp */
/* gpʂɓ`d */
/* (1)gpLFg.pln[apln].yukoday,g.opo[aopo].yukoday,g.onh[aonh].yukoday */
/* (2)gpFg.frp2[afrp2].yukoday,g.drp2[adrp2].yukoday */
/* (3)ΏۊOFrod(gp),g.fto[afto].yukoday(gpɓ{gp) */
int zfPEGGING02( ZMRP &g ) /* rc 0: <0:ُ */
{
	int		rc		= 0;		/* ߂l */
	int		fc		= 0;		/* ֐p߂l */
	int		apeg	= -1;	/* peg[] */
	int		apln	= -1;	/* pln[] */
	int		aopo	= -1;	/* opo[] */
	int		aonh	= -1;	/* onh[] */
	int		oyaNo	= -1;	/* eԍ */
	int		koNo	= -1;	/* qԍ */
	int		oyaTop	= -1;	/* e */
	int		oyaNext	= -1;	/* e */
	int		koTop	= -1;	/* q */
	int		koNext	= -1;	/* q */
	peg_td	*wpeg	= NULL;
	int		afrp2	= -1;	/* frp2[] */
	int		adrp2	= -1;	/* drp2[] */
	char	wpeg_key[22+1];	/* L[ */
	if(zdbgf[99]) {Dprintf("90.zfPEGGING02" CR ); goto quit;}
	if(zdbgf[190]) {TRACEA(0); Dprintf("zfPEGGING02" CR );}

	/* ̓`FbN */
	/* (1)gpLFg.pln[apln].yukoday,g.opo[aopo].yukoday,g.onh[aonh].yukoday */
	/* (1-1)g.pln[apln].yukoday */
	for( apln = 0 ; apln < g.pln.n ; apln++ ){
		/* qL[쐬 */
		sprintf(wpeg_key,"k%02d%08d", TYPPLN, apln );
		/*  */
//		if( (apeg = s.h_peg.hashfind( wpeg_key, 0 )) < 0 ) continue;
		/* N */
		for( apeg = s.peg[apeg].oyaTop; apeg >= 0; apeg = s.peg[apeg].oyaNext ){  CHKA(0, apeg, s.peg.n);
			wpeg = &s.peg.v[apeg];
			switch( wpeg->oyaType ){
			case TYPDRP2:	CHKA(0, wpeg->oyaNo, g.drp2.n);
				adrp2 = wpeg->oyaNo;
				if( g.drp2[adrp2].yukoday < 0 ||
					(g.drp2[adrp2].yukoday >= 0 && g.drp2[adrp2].yukoday < g.pln[apln].yukoday) ){
					g.drp2[adrp2].yukoday = g.pln[apln].yukoday;
				}
				break;
			case TYPFRP2:	CHKA(0, wpeg->oyaNo, g.frp2.n);
				afrp2 = wpeg->oyaNo;
				if( g.frp2[afrp2].yukoday < 0 ||
					(g.frp2[afrp2].yukoday >= 0 && g.frp2[afrp2].yukoday < g.pln[apln].yukoday) ){
					g.frp2[afrp2].yukoday = g.pln[apln].yukoday;
				}
				break;
			default: ;
			}
		}
	}
	/* (1-2)g.opo[aopo].yukoday */
	for( aopo = 0 ; aopo < g.opo.n ; aopo++ ){
		/* qL[쐬 */
		sprintf(wpeg_key,"k%02d%08d", TYPOPO, aopo );
		/*  */
//		if( (apeg = s.h_peg.hashfind( wpeg_key, 0 )) < 0 ) continue;
		/* N */
		for( apeg = s.peg.v[apeg].oyaTop; apeg >= 0; apeg = s.peg.v[apeg].oyaNext ){  CHKA(0, apeg, s.peg.n);
			wpeg = &s.peg.v[apeg];
			switch( wpeg->oyaType ){
			case TYPDRP2:	CHKA(0, wpeg->oyaNo, g.drp2.n);
				adrp2 = wpeg->oyaNo;
				if( g.drp2[adrp2].yukoday < 0 ||
					(g.drp2[adrp2].yukoday >= 0 && g.drp2[adrp2].yukoday < g.opo.v[aopo].yukoday) ){
					g.drp2[adrp2].yukoday = g.opo.v[aopo].yukoday;
				}
				break;
			case TYPFRP2:	CHKA(0, wpeg->oyaNo, g.frp2.n);
				afrp2 = wpeg->oyaNo;
				if( g.frp2[afrp2].yukoday < 0 ||
					(g.frp2[afrp2].yukoday >= 0 && g.frp2[afrp2].yukoday < g.opo.v[aopo].yukoday) ){
					g.frp2[afrp2].yukoday = g.opo.v[aopo].yukoday;
				}
				break;
			default: ;
			}
		}
	}
	/* (1-3)g.onh[aonh].yukoday */
	for( aonh = 0 ; aonh < g.onh.n ; aonh++ ){
		/* qL[쐬 */
		sprintf(wpeg_key,"k%02d%08d", TYPONH, aonh );
		/*  */
//		if( (apeg = s.h_peg.hashfind( wpeg_key, 0 )) < 0 ) continue;
		/* N */
		for( apeg = s.peg.v[apeg].oyaTop; apeg >= 0; apeg = s.peg.v[apeg].oyaNext ){  CHKA(0, apeg, s.peg.n);
			wpeg = &s.peg.v[apeg];
			switch( wpeg->oyaType ){
			case TYPDRP2:	CHKA(0, wpeg->oyaNo, g.drp2.n);
				adrp2 = wpeg->oyaNo;
				if( g.drp2[adrp2].yukoday < 0 ||
					(g.drp2[adrp2].yukoday >= 0 && g.drp2[adrp2].yukoday < g.onh.v[aonh].yukoday) ){
					g.drp2[adrp2].yukoday = g.onh.v[aonh].yukoday;
				}
				break;
			case TYPFRP2:	CHKA(0, wpeg->oyaNo, g.frp2.n);
				afrp2 = wpeg->oyaNo;
				if( g.frp2[afrp2].yukoday < 0 ||
					(g.frp2[afrp2].yukoday >= 0 && g.frp2[afrp2].yukoday < g.onh[aonh].yukoday) ){
					g.frp2[afrp2].yukoday = g.onh[aonh].yukoday;
				}
				break;
			default: ;
			}
		}
	}
	for( apeg = 0; apeg < s.peg.n; ++apeg ) {
		wpeg = &s.peg.v[apeg];
		afrp2 = adrp2 = -1;
		switch( wpeg->oyaType ){
		case TYPDRP2:	CHKA(0, wpeg->oyaNo, g.drp2.n);
			adrp2 = wpeg->oyaNo;
			oyaNo = g.drp2[wpeg->oyaNo].outseq;	/* oɌvt@C̏o͍sԍPn܂(Rgs) */
			break;
		case TYPFRP2:	CHKA(0, wpeg->oyaNo, g.frp2.n);
			afrp2 = wpeg->oyaNo;
			oyaNo = g.frp2[wpeg->oyaNo].outseq;	/* vt@C̏o͍sԍPn܂(Rgs) */
			break;
		default:
			oyaNo = wpeg->oyaNo + 1;	/* zԍOn܂ */
		}
		switch( wpeg->koType ){
		case TYPDRP2:	CHKA(0, wpeg->koNo, g.drp2.n);
			adrp2 = wpeg->oyaNo;
			koNo = g.drp2[wpeg->koNo].outseq;	/* oɌvt@C̏o͍sԍPn܂(Rgs) */
			break;
		case TYPFRP2:	CHKA(0, wpeg->koNo, g.frp2.n);
			afrp2 = wpeg->oyaNo;
			koNo = g.frp2[wpeg->koNo].outseq;	/* vt@C̏o͍sԍPn܂(Rgs) */
			break;
		default:
			koNo = wpeg->koNo + 1;	/* zԍOn܂ */
		}
		oyaTop = (wpeg->oyaTop<0)?(wpeg->oyaTop):(wpeg->oyaTop+1);
		oyaNext = (wpeg->oyaNext<0)?(wpeg->oyaNext):(wpeg->oyaNext+1);
		koTop = (wpeg->koTop<0)?(wpeg->koTop):(wpeg->koTop+1);
		koNext = (wpeg->koNext<0)?(wpeg->koNext):(wpeg->koNext+1);
		if(zdbgf[190]>8) {
			if( adrp2 >= 0 ) Dprintf("%s g.drp2(%d).yukoday(%d)" CR, g.jmf ? "gp":"", adrp2, g.drp2[adrp2].yukoday);
			if( afrp2 >= 0 ) Dprintf("%s g.frp2(%d).yukoday(%d)" CR, g.jmf ? "gp":"", afrp2, g.frp2[afrp2].yukoday);
		}
	}
	rc = 0;
quit:
	if(zdbgf[190]) {TRACEC(0); Dprintf("zfPEGGING02 rc(%d)" CR, rc);
	if(zdbgf[190]>8) {
#if 1 // FS041222
		if( g.jmf ) Dprintf("yMO s.peg.n(%d)" CR, s.peg.n);
		else        Dprintf(" s.peg.n(%d)" CR, s.peg.n);
		dmp_peg_td( g, s.peg.v, s.peg.n );
		if( g.jmf ) Dprintf("ړv g.drp2.n(%d)" CR, g.drp2.n);
		else        Dprintf(" g.drp2.n(%d)" CR, g.drp2.n);
		dmp_drp2_td( g, 0, g.drp2.n );
		if( g.jmf ) Dprintf("v g.frp2.n(%d)" CR, g.frp2.n);
		else        Dprintf(" g.frp2.n(%d)" CR, g.frp2.n);
		dmp_frp2_td( g, 0, g.frp2.n );
#endif
	}}
	return( rc );
}
#endif