/*
 * FILE      : zfsmstla1.cpp	[h^CvZ(Vbv)
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : [h^CvZ(Vbv)
 * AUTHOR    : N.Tsuchiya  2004.08.30
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

/* 31.[h^CvZƓ */
/*	ID_getLt	[h^CvZ
********************************************************/
static int getLt( ZMRP &g, fsh2_td *pfsh2, double size )
{
	double	lt = 0.0;

	lt = pfsh2->lt + pfsh2->hendo * size;
	if( pfsh2->lt_rtyp == 0 ) {        /* 0:؏グ */
		keta_marume( lt, &lt, 0, 0 );
	} else if( pfsh2->lt_rtyp == 1 ) { /* 1:ľܓ */
		keta_marume( lt, &lt, 0, 1 );
	} else if( pfsh2->lt_rtyp == 2 ) { /* 2:؎̂ */
		keta_marume( lt, &lt, 0, 2 );
	} else { /* 3:܂߂Ȃ */
		CHKB(0, pfsh2->lt_rtyp, 2);  /* ʖΉ */
	}
	return( (int)lt);
}
/*	ID_zfCalcWLT	[h^CvZʊ֐
********************************************************/
int zfCalcWLT( ZMRP &g, int ashm, int aitm, int afsh)
{
	int		rc = 0, afrp2, afsh2, pred, maxlt, ilt, lt, oyodm, aclm, bgnday, maetaosi, bclm;
	frp2_td	*wfrp2;
	fsh2_td	*wfsh2;
			  CHKA(0, ashm, g.shm.n);  CHKA(0, aitm, g.itm.n);

	if( ashm < 0 || ashm >= g.shm.n || aitm < 0 || aitm >= g.itm.n ) goto quit;
	bclm = g.shm.v[ashm].clm; /* VbṽJ_ */
	/* iڂ̋Vbv̔ԍ */
	afsh = zfGetFsh(g, aitm, ashm, afsh); CHKA(0, afsh, g.fsh.n);
	if( afsh < 0 || afsh >= g.fsh.n ) goto                      quit;
	zSortFrp2Due( g, afsh );  /* [Ƀ\[g */
	/* 擪̊ԕʏݒ */
	afsh2 = g.fsh.v[afsh].topfsh2;     CHKA(0, afsh2, g.fsh2.n);
	if( afsh2 < 0 || afsh2 >= g.fsh2.n ) goto                   quit;
	for( afrp2 = g.fsh.v[afsh].topfrp2due; afrp2 >= 0; afrp2 = wfrp2->duenext ) { CHKA(0, afrp2, g.frp2.n);
		if( afrp2 >= g.frp2.n ) goto                            quit;
		/* lqoo */
		wfrp2 = &g.frp2[afrp2];
		/* ߋɂȂWJȂ */
		if( wfrp2->due < g.today ) wfrp2->expstopflg = 1; /* [ߋiߋj */
		else                       wfrp2->expstopflg = 0;
		oyodm = wfrp2->oyodm;  CHKA(-1, oyodm, g.odm.n);
		if( oyodm >= 0 && wfrp2->bgn >= 0 ) {   /* I[_쐬frp2͍ς */
			                              CHKB(0, wfrp2->maetaosi, wfrp2->bgn);
			if( wfrp2->bgn < g.today ) wfrp2->expstopflg = 1;
			continue;
		}                                 CHKB(-1, wfrp2->bgn, -1); CHKB(0, wfrp2->due, g.endtd);
										  CHKB(wfrp2->bgn, wfrp2->planbgn, wfrp2->bgn);
										  CHKB(0, wfrp2->planduetm, 0);
										  CHKB(0, wfrp2->planbgntm, 0);
		/* ɔ[ݒ */
		wfrp2->maetaosi = wfrp2->bgn = wfrp2->planbgn = wfrp2->due;
		if( wfrp2->due <= 0 ) continue;
		/* [̑ԕʏ擾 */
		pred = g.fsh2.v[afsh2].fshpred;   CHKA(-1, pred, g.fsh2.n);
		for( ; afsh2 >= 0; pred = afsh2, afsh2 = g.fsh2.v[afsh2].fshnext ) { CHKA(0, afsh2, g.fsh2.n);
			if( afsh2 >= g.fsh2.n ) goto                        quit;
                                          CHKB(pred, g.fsh2.v[afsh2].fshpred, pred);
			if( pred >= 0 ) {  CHKB(afsh2, g.fsh2.v[pred].fshnext, afsh2);
				CHKB(g.fsh2.v[afsh2].bgnday, g.fsh2.v[pred].endday+1, g.fsh2.v[afsh2].bgnday);
			} else  CHKB(0, g.fsh2.v[afsh2].bgnday, 0);
			if( g.fsh2.v[afsh2].fshnext < 0 )  CHKB(g.endtd, g.fsh2.v[afsh2].endday, g.endtd);
			if( g.fsh2.v[afsh2].endday >= wfrp2->due ) break;
		}                                 CHKA(0, afsh2, g.fsh2.n);
		/* ԕʏ񂪕sŌ̏g NT140617 */
//		if( afsh2 < 0 )        continue;
		if( afsh2 < 0 ) afsh2 = pred;     //chg NT140617 afsh2<0̂܂ܔzQƂĂ܂̂
		wfsh2 = &g.fsh2.v[afsh2];
		/*  t@giڎʃtO 1:t@g <>1:ʏi */
		if( wfsh2->fant == 1 ) continue;
		if( wfsh2->bgnday > wfrp2->due ) { /* [̏ԕʏ񂪑݂Ȃ */ 
			CHKB(wfsh2->bgnday, wfrp2->due, g.endtd); continue;
		}
		/* [h^CvZ */
		maxlt = lt = getLt(g, wfsh2, wfrp2->size );
		maetaosi = wfsh2->maetaosi;
		if( lt <= 0 ) {
			wfrp2->maetaosi = zmd_zurasi( g, bclm, wfrp2->bgn, -maetaosi );
			continue;
		}
		/* vZ */
		aclm = wfsh2->lt_clm;   CHKA(0, aclm, g.clm.n);
		wfrp2->bgn = zmd_zurasi( g, aclm, wfrp2->due, -lt );
		bgnday = wfsh2->bgnday;
		while( wfrp2->bgn < bgnday ) { /* vZʂ̒ڔ͈͊O */
			/* ̑ԕʏ̍ő僊[h^CvZ */
			for( ; pred >= 0; pred = g.fsh2.v[pred].fshpred ) {  CHKA(0, pred, g.fsh2.n);
				if( pred >= g.fsh2.n ) goto                     quit;
				wfsh2 = &g.fsh2.v[pred];
				if( wfsh2->endday < wfrp2->bgn ) break;
				ilt = getLt(g, wfsh2, wfrp2->size );
				if( ilt > maxlt ) {
					maxlt = ilt;
					maetaosi = wfsh2->maetaosi; /* O|\ */
				}
				bgnday = wfsh2->bgnday;
			}
			if( maxlt > lt ) { /* ČvZ */
				lt = maxlt;
				wfrp2->bgn = zmd_zurasi( g, aclm, wfrp2->due, -lt );
			}
			if( pred < 0 ) { CHKB(0, wfsh2->bgnday, 0);
				bgnday = 0;
			} else if( bgnday > wfsh2->endday + 1 ) { CHKB(bgnday, (wfsh2->endday+1), bgnday);
				bgnday = wfsh2->endday + 1;
			}
		}
		wfrp2->maetaosi = zmd_zurasi( g, bclm, wfrp2->bgn, -maetaosi ); /* O|\ */
		wfrp2->planbgn = wfrp2->bgn;
		if( wfrp2->bgn < g.today ) wfrp2->expstopflg = 1;
	}
	rc = 0;
quit:
	if(zdbgf[131]>1||zdbgf[153]>1) {
		TRACEB(0);
		if( (afrp2 = g.fsh.v[afsh].topfrp2due) >= 0 ) {
			if( g.jmf ) Dprintf( CR "      \ i Vbv  [  O| H  쐬" CR);
			for( ; afrp2 >= 0; afrp2 = wfrp2->duenext ) {
				wfrp2 = &g.frp2[afrp2];
				Dprintf( "frp2(%4d) %d %s %s %g %s %s %s %s %s %d" CR
					,afrp2,wfrp2->odm,g.itm.v[aitm].itm_cd,g.shm.v[ashm].shm_cd,wfrp2->size,ST(wfrp2->due),
					ST(wfrp2->bgn),ST(wfrp2->maetaosi),ST(wfrp2->plandue),ST(wfrp2->planbgn),wfrp2->oyodm);
			}
		}
	}
	return( rc );
}
/*	ID_zfSMSTLA1	53.[h^CvZ
********************************************************/
int zfSMSTLA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh) /* rc 0: <0:ُ */
{
	int		rc = 0;
	            CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if(zdbgf[99]) {Dprintf("53.zfSMSTLA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); goto quit;}
	if(zdbgf[153]) {TRACEA(0); Dprintf("zfSMSTLA1 nodtyp(%d) ashm(%d) aitm(%d) afsh(%d)" CR, nodtyp, ashm, aitm, afsh );}
	rc = zfCalcWLT( g, ashm, aitm, afsh );
quit:
	if(zdbgf[153]) {TRACEC(0); Dprintf("zfSMSTLA1 rc(%d)" CR, rc);}
	return( rc );
}
