/*
 * FILE      : zfsmstoa1.cpp	[h^CvZ(񐻑Vbv)
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : [h^CvZ(񐻑Vbv)
 * AUTHOR    : N.Tsuchiya  2004.08.30
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <string.h>

#include "z1mrp.h"

/* 21.A[h^CvZƓ */
/*	ID_zfCalcYLT	A[h^CvZʊ֐
********************************************************/
int zfCalcYLT( ZMRP &g, int ashm, int aitm, int afsh )
{
	int		rc = 0, adrp2, oday, atsh, adlm, atpm, atpm2, toshm;
	int		ylt, maxlt, bgnday, pred;
	drp2_td	*wdrp2;
	tpm2_td	*wtpm2;

			CHKA(0, ashm, g.shm.n);	CHKA(0, aitm, g.itm.n);
	if( ashm < 0 || ashm >= g.shm.n || aitm < 0 || aitm >= g.itm.n ) goto   quit;
	/* iڂ̋Vbv̔ԍ */
	afsh = zfGetFsh(g, aitm, ashm, afsh); CHKA(0, afsh, g.fsh.n);
	if( afsh < 0 || afsh >= g.fsh.n ) goto                      quit;
	/* Vbv}X^̃[N */
	for( adlm = g.fsh.v[afsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].fshnext ) {	CHKA(0, adlm, g.dlm.n);
		if( adlm >= g.dlm.n ) goto                              quit;
		                            CHKB(afsh, g.dlm.v[adlm].fsh, afsh);
		atsh = g.dlm.v[adlm].tsh;   CHKA(0, atsh, g.tsh.n);
		if( atsh < 0 || atsh >= g.tsh.n ) continue;
		toshm = g.tsh.v[atsh].shm;  CHKA(0, toshm, g.shm.n);
		if( toshm < 0 || toshm >= g.shm.n ) continue;
		g.shm.v[toshm].iwk1 = -1;   /* A}X^(ԕ)[] */
		g.shm.v[toshm].iwk2 = -1;   /* ړɓ */
		g.shm.v[toshm].iwk3 = 0;    /* oɓ */
	}
	/* A}X^(ԕ)̐擪ݒ */
	for( atpm = g.shm.v[ashm].toptotpm; atpm >= 0; atpm = g.tpm.v[atpm].nextto ) { CHKA(0, atpm, g.tpm.n);
		if( atpm >= g.tpm.n ) goto                              quit;
		toshm = g.tpm.v[atpm].toshm;      CHKA(0, toshm, g.shm.n);
		if( toshm < 0 || toshm >= g.shm.n ) continue;
		g.shm.v[toshm].iwk1 = g.tpm.v[atpm].toptpm2;  /* A}X^(ԕ)[] ̐擪 */
	}
	for( adlm = g.fsh.v[afsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].fshnext ) { CHKA(0, adlm, g.dlm.n);
		if( adlm >= g.dlm.n ) goto                              quit;
		atsh  = g.dlm.v[adlm].tsh;    CHKA(0, atsh, g.tsh.n);
		if( atsh < 0 || atsh >= g.tsh.n ) continue;
		toshm = g.tsh.v[atsh].shm;    CHKA(0, toshm, g.shm.n);
		if( toshm < 0 || toshm >= g.shm.n ) continue;
		zSortDrp2DlmIday( g, adlm );
		for( adrp2 = g.dlm.v[adlm].topdrp2i; adrp2 >= 0; adrp2 = wdrp2->dlmidaynext ) { CHKA(0, adrp2, g.drp2.n);
			if( adrp2 >= g.drp2.n ) goto                        quit;
			/* lqoo */
			wdrp2 = &g.drp2[adrp2];       CHKB(0, wdrp2->iday, g.endtd);
										  CHKB(-1, wdrp2->oday, -1);
										  CHKB(adlm, wdrp2->dlm, adlm);
			/* ɓoɓvZ */
			wdrp2->oday = wdrp2->iday;
			/* oɓߋ͓̂̂WJȂ */
			if( wdrp2->oday < g.today ) wdrp2->expstopflg = 1;
			else                        wdrp2->expstopflg = 0;
			if( ( atpm2 = g.shm.v[toshm].iwk1 ) < 0 ) continue;  /* A}X^݂Ȃ */
			if( atpm2 >= g.tpm2.n ) continue;
			if( g.shm.v[toshm].iwk2 == wdrp2->iday ) {  /* ɓȂoɓ */
				wdrp2->oday = g.shm.v[toshm].iwk3;
			} else {  CHKA(-1, g.shm.v[toshm].iwk2, wdrp2->iday);
					  CHKA(0, atpm2, g.tpm2.n);
				/* ɓԂɓĂA[h^C擾 */
				pred = g.tpm2.v[atpm2].tpmpred;
				for( ; atpm2 >= 0; pred = atpm2, atpm2 = g.tpm2.v[atpm2].tpmnext ) { CHKA(0, atpm2, g.tpm2.n);
					if( atpm2 >= g.tpm2.n ) goto                quit;
												  CHKB(pred, g.tpm2.v[atpm2].tpmpred, pred);
					if( pred >= 0 ) { CHKB(atpm2, g.tpm2.v[pred].tpmnext, atpm2);
						CHKA(g.tpm2.v[pred].bgnday, g.tpm2.v[pred].endday, g.tpm2.v[atpm2].bgnday);
					}
					if( g.tpm2.v[atpm2].endday >= wdrp2->iday ) break;
				}
				if( atpm2 < 0 ) {  /* ɓȍ~̗A}X^iԕʁj݂Ȃ */
					oday = wdrp2->iday;
				} else if( g.tpm2.v[atpm2].bgnday > wdrp2->iday ) { /* ɓ̗A}X^iԕʁjĂ */
					oday = wdrp2->iday;
				} else {
					wtpm2 = &g.tpm2.v[atpm2];
									 CHKB(0, wtpm2->ylt_uni, 0);
									 CHKA(0, wtpm2->ylt_clm, g.clm.n);
					maxlt = ylt = wtpm2->ylt;   CHKB(0, ylt, ylt);
					oday = zmd_zurasi( g, wtpm2->ylt_clm, wdrp2->iday, -ylt);
													 CHKB(0, oday, g.endtd);
					bgnday = wtpm2->bgnday;
					while( oday < bgnday ) { /* oɓ͈͊O */
						/* oɓ̑ԕʏ̍ő僊[h^CvZ */
						for( ; pred >= 0; pred = g.tpm2.v[pred].tpmpred ) { CHKA(0, pred, g.tpm2.n);
							if( pred >= g.tpm2.n ) goto         quit;
							if( g.tpm2.v[pred].endday < oday ) break;
							                        CHKB(0, g.tpm2.v[pred].ylt, g.tpm2.v[pred].ylt);
							if( maxlt < g.tpm2.v[pred].ylt ) maxlt = g.tpm2.v[pred].ylt;
							bgnday = g.tpm2.v[pred].bgnday;
						}
						if( maxlt > ylt ) {
							ylt = maxlt;
							oday = zmd_zurasi( g, wtpm2->ylt_clm, wdrp2->iday, -ylt );
													 CHKB(0, oday, g.endtd);
						}
						if( pred < 0 ) bgnday = 0;
						else if( bgnday > g.tpm2.v[pred].endday + 1 ) { /* AĂȂ */
							bgnday = g.tpm2.v[pred].endday + 1;
						}
					}
				}
				wdrp2->oday = oday;
				if( wdrp2->oday < g.today ) wdrp2->expstopflg = 1;
				g.shm.v[toshm].iwk1 = atpm2;
				g.shm.v[toshm].iwk2 = wdrp2->iday;
				g.shm.v[toshm].iwk3 = oday;
			}
		}
	}
	if(zdbgf[121]>1||zdbgf[141]>1) {
		TRACEB(0);
		if( g.jmf ) Dprintf( CR "      \ i gpVbv Vbv  ɓ oɓ" CR);
		for( adlm = g.fsh.v[afsh].topdlm; adlm >= 0; adlm = g.dlm.v[adlm].fshnext ) {
			atsh  = g.dlm.v[adlm].tsh;
			toshm = g.tsh.v[atsh].shm;
			for( adrp2 = g.dlm.v[adlm].topdrp2i; adrp2 >= 0; adrp2 = wdrp2->dlmidaynext ) {
				wdrp2 = &g.drp2[adrp2];
				Dprintf( "drp2(%4d) %d %s %s %s %g %s %s" CR
						,adrp2,wdrp2->odm,g.itm.v[aitm].itm_cd,g.shm.v[toshm].shm_cd,g.shm.v[ashm].shm_cd
						,wdrp2->size,ST(wdrp2->iday),ST(wdrp2->oday));
			}
		}
	}
	rc = 0;
quit:
	return( rc );
}
/*	ID_zfSMSTOA1	41.A[h^CvZB(drp2).oɓ<==Aks
********************************************************/
int zfSMSTOA1( ZMRP &g, int nodtyp, int ashm, int aitm, int afsh) /* rc 0: <0:ُ */
{
	int		rc = 0;
	            CHKA(0, aitm, g.itm.n); CHKA(0, ashm, g.shm.n);
	if(zdbgf[99]) {Dprintf("41.zfSMSTOA1 nodtyp(%d) ashm(%d) aitm(%d)" CR, nodtyp, ashm, aitm); goto quit;}
	if(zdbgf[141]) {TRACEA(0); Dprintf("zfSMSTOA1 nodtyp(%d) ashm(%d) aitm(%d) afsh(%d)" CR, nodtyp, ashm, aitm, afsh );}
	rc = zfCalcYLT( g, ashm, aitm, afsh );
quit:
	if(zdbgf[141]) {TRACEC(0); Dprintf("zfSMSTOA1 rc(%d)" CR, rc);}
	return( rc );
}
