/*
 * FILE     : zginit.cpp	m[h쐬f[^i[
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * FUNCTION	: m[h쐬f[^i[
 * AUTHOR   : 2004.08.02 s.kobayashi
 */
static char __file[] = __FILE__ ;

#include			<memory.h>
#include			"zg.h"
#include			"zgsscp.h"

/*************************************************************
//zginit: f[^̊i[
************************************************************************/
int  zginit(ZMRP &g)
{
	int		rc = 0 ;

	if(DBG[11]) TRACEA(0), Dprintf("zginit:" CR) ;
	memset( &zg.n, 0, sizeof(zg.n) );
    zg.n.ft = MAX_NODE_TYPE;
	/* iڐƃVbv */
	if( (rc= GetPtmNum(g, &zg.g.numptm )) < 0 ) { CHKB(0, 0, rc); goto     quit; }
	if( (rc= GetUbmNum(g, &zg.g.numubm )) < 0 ) { CHKB(0, 0, rc); goto     quit; } //##AddByKuro040930
	if( (rc= GetShpNum(g, &zg.g.numshp )) < 0 ) { CHKB(0, 0, rc); goto     quit; }
	if( (rc= GetPtmShpNum(g, &zg.g.numptmshp )) < 0 ) { CHKB(0, 0, rc); goto     quit; } //990702

	if( zg.g.numptm <= 0 ) goto                                           err1;
	if( zg.g.numshp <= 0 ) goto                                           err2;
	/* zCɊm */
	if( (rc = zgnew_exp_ptm(g, zg.g.numptm)) < 0 ) goto                      quit; /* zg.ptm[] */
	if( (rc = zgnew_exp_shp(g, zg.g.numshp)) < 0 ) goto                      quit; /* zg.shp[] */
	if( (rc = zgnew_exp_arptm(g, zg.g.numptm+zg.g.numubm)) < 0 ) goto        quit; /* zg.arptm[] ##ChangeByKuro040930 */
	if( (rc = zgnew_exp_arshp(g, zg.g.numshp)) < 0 ) goto                    quit; /* zg.arshp[] */
	/* }X^\̍쐬 */
	/* iڕ\ptm[]쐬 */
	if( (rc = zginit_ptm(g)) < 0 ) goto                         			  quit;
	/* Vbv\shp[]쐬 */
	if( (rc = zginit_shp(g)) < 0 ) goto                                    quit;
	/* i+Vbv\usp,sok,ssp[]̍쐬 */
	if( (rc = zginit_usps(g)) < 0 ) goto                                   quit;
	/* iڂ̃\[g 990614ĂяoύX */
	if( (rc = zginit_ptm_order(g)) < 0 ) goto                              quit;
quit :
	if(DBG[11]) TRACEC(0), Dprintf("zginit:rc(%d)" CR,rc) ;
	return( rc ) ;
err1 :rc = -1 ;
	Esprintf(g.ermes,"zginit.cpp 0010 " CR) ;				
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes,"iڌO" CR) ;	 Eprintf(g.ermes); }
	goto                                                                  quit;
err2 :rc = -1 ;
	Esprintf(g.ermes,"zginit.cpp 0020 " CR) ;
	Eprintf(g.ermes);
	if( g.jmf ) { Esprintf(g.ermes,"VbvO" CR) ; Eprintf(g.ermes); }
	goto                                                                  quit;
}

/*	compPtm: iڂ̗D揇lr֐ tsortp()p
*/
int	 compPtm( int arg1, int arg2 )
{
	int rc=zg.ptm[arg2].asprty - zg.ptm[arg1].asprty ;	/* D揇ʂ̂̏ */
	return( rc ? rc : (arg1 - arg2) ) ; 
}
 
/*	zginit_ptm_order: iڂeqAD揇ʏɃ\[g
*/
int  zginit_ptm_order(ZMRP &g)
{
	int rc=0 ;
	int i, j, k, mode, koptm ;
	if(DBG[11]) TRACEA(0), Dprintf("zginit_ptm_order:" CR) ;
	zg.n.eda = 0 ;
	/*	eq֌W */
	for( i=0 ; i<zg.g.numptm ; i++ ) {
		if(IsUnusePtm(g, i)) continue; // FS041216B
		rc =  GetPtmKo(g, i, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
		if( rc < 0 ) goto                                                 quit;
		for( j=0 ; j<zg.n.arptm ; j++ ) {
			koptm = zg.arptm[j];             CHKA(0, koptm, zg.g.numptm);
			if( koptm < 0 || koptm >= zg.g.numptm ) continue;
			if( (rc = zgnew_eda(g)) < 0 ) goto                             quit;
			zg.eda[rc][0] = i ;	   /* e */
			zg.eda[rc][1] = koptm; /* q */
		}
	}
	/*	jO`FWi->Viڂloop`FbN */
	for( i=0 ; i<zg.g.numptm ; i++ ) {
		if(IsUnusePtm(g, i)) continue; // FS041216B
		//gpVbvi
		for( j=zg.ptm[i].usptop ; j>=0 ; j=zg.usp[j].ptmnext ) {
			rc =  GetPtmRc(g, i, zg.usp[j].shp, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
			for( k=0 ; k<zg.n.arptm ; k++ ) { 
				if( (rc = zgnew_eda(g)) < 0 ) goto                             quit;
				zg.eda[rc][0] = i ;	         /* i */
				zg.eda[rc][1] = zg.arptm[k]; /* Vi */
			}
		}
		//qɂ̎gpi
//		for( j=zg.ptm[i].soktop ; j>=0 ; j=zg.sok[j].ptmnext ) {
//			rc =  GetPtmRc(g, i, zg.sok[j].shp, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
//			for( k=0 ; k<zg.n.arptm ; k++ ) { 
//				if( (rc = zgnew_eda(g)) < 0 ) goto                             quit;
//				zg.eda[rc][0] = i ;	         // i
//				zg.eda[rc][1] = zg.arptm[k]; // Vi 
//			}
//		} <--- Delete TK041203
		//Vbvw薳̏ꍇ ##AddByKuro041001
		rc =  GetPtmRc(g, i, -1, zg.g.numptm, &zg.n.arptm, zg.arptm ); CHKB(0, 0, rc);
		for( k=0 ; k<zg.n.arptm ; k++ ) { 
			if( (rc = zgnew_eda(g)) < 0 ) goto                             quit;
			zg.eda[rc][0] = i ;	         /* i */
			zg.eda[rc][1] = zg.arptm[k]; /* Vi */
		}

	}

/*	eq֌WAD揇ʏɃ\[g mode=0:Asc */
	memset( zg.arptm, 0, zg.n.ptm * sizeof(zg.arptm[0]) ) ;
//	rc = tsortp( zg.n.eda, zg.eda, zg.n.ptm, zg.arptm, /*compPtm, */ (mode=0) ) ;   */
	rc = tsortpl(g, zg.n.eda, zg.eda, zg.n.ptm, zg.arptm, /*compPtm, */ (mode=0), 1 ); /* LoopErrorMsgΉ */
	if( rc < 0 ) goto                                                     errT;
/*	\[g烊N쐬(nextptm͈ȍ~QƂĂȂ) */
	zg.g.headptm = -1 ;  /* 擪̕i */
	for( i=zg.n.ptm-1 ; i>=0 ; i-- ) {
		j = zg.arptm[i] ;
		zg.ptm[j].nextptm = zg.g.headptm ;
		zg.g.headptm      = j ;
	}
quit :
	if(DBG[11]) TRACEC(0), Dprintf("zginit_ptm_order: rc(%d)" CR,rc) ;
	return( rc ) ;
errT :/*	rc = -1 ; */ 
//	Esprintf(g.ermes, "zginit.cpp 0030 Tsortpl(%d)ŃG[B%s" CR,rc,( rc == -2 ? "iڂ̐eq֌WɃ[v܂B" : "" ) ) ; 
//J	Esprintf(g.ermes, "Tsortpl(%d)ŃG[B%s" CR,rc,( rc == -2 ? "iڂ̐eq֌WɃ[v܂B" : "" ) ) ; 
//	Eprintf(g.ermes);
	goto                                                                  quit ;
}
/*	zginit_ptm: D揇ʁAt@gtOi[B
*/
#define ZGNEW_PTM( ) (zg.n.ptm<zg.x.ptm ? zg.n.ptm++ : -1)	//990702 reallocȂGA͂łɃNAς
#define ZGNEW_SHP( ) (zg.n.shp<zg.x.shp ? zg.n.shp++ : -1)	//990702 reallocȂGA͂łɃNAς

int  zginit_ptm(ZMRP &g)
{
	int rc=0 ;
	int iptm;
	                                         CHKB(1, zg.g.numptm, zg.x.ptm);
	if(DBG[11]) TRACEA(0), Dprintf("zginit_ptm:" CR) ;
	for( iptm = 0 ; iptm < zg.g.numptm ; iptm++ ) {
		if( (rc = ZGNEW_PTM( )) < 0 ) goto quit ;
			      CHKB(rc, iptm, rc);
		zg.ptm[rc].nDPBGN = -1;
		zg.ptm[rc].nDPEND1 = -1; //##ChangeByKuro nDPEND->nDPEND1
        zg.ptm[rc].nDPEND2 = -1; //##AddByKuro040902
		//zg.ptm[rc].nSPOASA1 = -1; //##DeleteByKuro
//		zg.ptm[rc].nNPBDA1 = -1;    //##DeleteByKuro
		zg.ptm[rc].nDWOEND = -1;
		zg.ptm[rc].nDUEND  = -1;
		zg.ptm[rc].nDSBGN  = -1;		//?????? nDWABGN  nDWAEND ̃NAȂB̂zginit.c(164)
		zg.ptm[rc].usptop = -1;
		zg.ptm[rc].soktop = -1;
		zg.ptm[rc].ssptop = -1;
		zg.ptm[rc].nextptm = -1;	
/*		D揇 */
		rc =  GetPtmOrder(g, iptm, &zg.ptm[iptm].asprty); CHKB(0, 0, rc);
		if( rc < 0 ) goto                                          quit;
/*		t@g敪 iځ{VbvŔ 990630 */
//		rc =  GetPtmData( iptm, &flag );              CHKB(0, 0, rc);
//		if( rc < 0 ) goto                                                 quit;
//		zg.ptm[iptm].fPhantom = (unsigned char)flag ;        CHKB(0, flag, 1);
	}
quit :
	if(DBG[11]) TRACEC(0), Dprintf("zginit_ptm:rc(%d)" CR,rc) ;
	return( rc ) ;
}
int  zginit_shp(ZMRP &g)
{
	int		rc, ishp, flgshpType;
	if(DBG[11]) TRACEA(0), Dprintf("zginit_shp:" CR) ;
	rc = 0; //add NT140612 warning C4701 
	                                         CHKB(1, zg.g.numshp, zg.x.shp);
	for( ishp = 0 ; ishp < zg.g.numshp ; ishp++ ) {
		if( (rc = ZGNEW_SHP( )) < 0 ) goto                                 quit;//990702
		zg.shp[ishp].topusp = -1;
		zg.shp[ishp].topsok = -1;
		zg.shp[ishp].topssp = -1;
		zg.shp[ishp].nCMSSLA1 = -1; //AddByKuro041101 
		/* Vbv敪(qorNOT) */        CHKB(rc, ishp, rc);
		rc =  GetShpType(g, ishp, &flgshpType ) ; CHKB(0, 0, rc);
		if( rc < 0 ) goto                                                 quit;
		zg.shp[ishp].soko = (flgshpType == SHPTYPE_SOKO); CHKB(1, flgshpType, 3); //##ChangeByKuro 040907
	}
quit :
	if(DBG[11]) TRACEC(0), Dprintf("zginit_shp:rc(%d)" CR,rc) ;
	return( rc );
}
/*	zginit_usps: iځ{Vbv\usp[],sok[],ssp[]sok[]쐬
*/
int  zginit_usps(ZMRP &g)
{
	int rc=0, rc1, j, hikflg, iptm, ishp, iusp, isok, issp;
	int flgPhantom ;
	                                         CHKB(zg.n.ptm, zg.g.numptm, zg.n.ptm);
	if(DBG[11]) TRACEA(0), Dprintf("zginit_usps:" CR) ;
	for( iptm = 0 ; iptm < zg.g.numptm ; iptm++ ) {
		if(IsUnusePtm(g, iptm)) continue; // FS041216B
		/*		gpANeBreBusp[]܂sok[]ɓo^ */
		rc =  GetPtmUshp(g, iptm, zg.g.numshp, &zg.n.arshp, zg.arshp ) ; CHKB(0, 0, rc);
		if( rc < 0 ) goto                                                 quit;
		for( j = 0 ; j < zg.n.arshp ; j++ ) {
			ishp = zg.arshp[j];                     CHKA(0, ishp, zg.n.shp);
			if( ishp < 0 || ishp >= zg.n.shp ) continue;
			if( ! zg.shp[ishp].soko ) { /* gpVbv */
				iusp = find_usp( iptm, ishp ) ;
				if( iusp >= 0 ) { CHKA(iptm, 0, iusp); continue; }
				if( (iusp = rc = zgnew_usp(g)) < 0 ) goto                         quit;
				zg.usp[iusp].nNUOHA1 = -1;
				zg.usp[iusp].ptm     = iptm;
				zg.usp[iusp].shp     = ishp;
				zg.usp[iusp].ptmnext = zg.ptm[iptm].usptop;
				zg.ptm[iptm].usptop = iusp;
				zg.usp[iusp].shpnext  = zg.shp[ishp].topusp;
				zg.shp[ishp].topusp = iusp;
				/*				gpVbviڂ̃t@gtO */
				rc1 =  IsPhant2(g, iptm, ishp, &flgPhantom) ;	CHKB(0,0,rc1) ;
				if( rc1 < 0 ) continue ;								CHKB(0,flgPhantom,1) ;
				zg.usp[iusp].fPhantom = (unsigned char)flgPhantom;
			} else {                    /* q */
				isok = find_sok( iptm, ishp ) ;
				if( isok < 0 ) {
					if( (isok = rc = zgnew_sok(g)) < 0 ) goto                         quit;
					zg.sok[isok].nDW1BGN  = -1;  //##ChaneByKuro 040901 nDWBGN->nDW1BGN
					zg.sok[isok].nNWOHA1 = -1;
					zg.sok[isok].nNWMPA1 = -1;
					zg.sok[isok].ptm = iptm;
					zg.sok[isok].shp = ishp;
					zg.sok[isok].ptmnext = zg.ptm[iptm].soktop;
					zg.ptm[iptm].soktop = isok;
					zg.sok[isok].shpnext  = zg.shp[ishp].topsok;
					zg.shp[ishp].topsok = isok;
				}
				zg.sok[isok].usflg |= SOKO_U;
			}
			/*			jO`FWiڃtÕZbg 990614 */
			if( zg.ptm[iptm].fRc == 0 ) {	//VbvP
				zg.ptm[iptm].fRc = (unsigned char) IsRc(g, iptm, ishp ) ;
					CHKB(0,zg.ptm[iptm].fRc,1) ;
			}
		}
		/*		ANeBreBssp[]܂sok[]ɓo^ */
		rc =  GetPtmSshp(g, iptm, zg.g.numshp, &zg.n.arshp, zg.arshp ) ;  CHKB(0, 0, rc);
		if( rc < 0 ) goto                                                 quit;
		for( j = 0 ; j < zg.n.arshp ; j++ ) {
			ishp = zg.arshp[j];                     CHKA(0, ishp, zg.n.shp);
			if( ishp < 0 || ishp >= zg.n.shp ) continue;
			if( ! zg.shp[ishp].soko ) { /* Vbv */
				issp = find_ssp( iptm, ishp ) ;
				if( issp >= 0 ) { CHKA(iptm, 0, issp); continue; }
				if( (issp = rc = zgnew_ssp(g)) < 0 ) goto                         quit;
				zg.ssp[issp].nNSMPA1 = -1;
				zg.ssp[issp].nNSOHA1 = -1;
				zg.ssp[issp].ptm = iptm;
				zg.ssp[issp].shp = ishp;
				zg.ssp[issp].ptmnext = zg.ptm[iptm].ssptop;
				zg.ptm[iptm].ssptop = issp;
				zg.ssp[issp].shpnext  = zg.shp[ishp].topssp;
				zg.shp[ishp].topssp = issp;
				/*	Vbv̈ */
				rc1 =  IsHikiate(g, iptm, ishp, &hikflg ) ; CHKB(0, 0, rc1);
				if( rc1 < 0 ) continue;					CHKB(0, hikflg, 1);
				zg.ssp[issp].hikflg = hikflg ;
				/*				Vbvt@g̔ */
				//if( zg.ptm[iptm].usptop < 0 ) {
					rc1 =  IsPhant2(g, iptm, ishp, &flgPhantom) ;	CHKB(0,0,rc1) ;
					if( rc1 < 0 ) continue ;								CHKB(0,flgPhantom,1) ;
					zg.ssp[issp].fPhantom = (unsigned char)flgPhantom ;
				//}
			} else {                    /* q */
				isok = find_sok( iptm, ishp ) ;
				if( isok < 0 ) {  //CHKA(iptm, 0, isok);	//qɂfrom,to̕iڂ͂
					if( (isok = rc = zgnew_sok(g)) < 0 ) goto                         quit;
					zg.sok[isok].nDW1BGN  = -1;  //##ChaneByKuro 040901 nDWBGN->nDW1BGN
					zg.sok[isok].nNWOHA1 = -1;
					zg.sok[isok].nNWMPA1 = -1;
					zg.sok[isok].ptm = iptm;
					zg.sok[isok].shp = ishp;
					zg.sok[isok].ptmnext = zg.ptm[iptm].soktop;
					zg.ptm[iptm].soktop = isok;
					zg.sok[isok].shpnext  = zg.shp[ishp].topsok;
					zg.shp[ishp].topsok = isok;
				}
				zg.sok[isok].usflg     |= SOKO_S;
			}
		}
//		/* ssp[].hikflgFoɉ\ʂ̈ 0:Ȃ 1:Bݒ 990630ړ */
//		for( issp = zg.ptm[iptm].ssptop; issp >= 0; issp = zg.ssp[issp].ptmnext ) {
//			ishp = zg.ssp[issp].shp;
//			rc =  IsHikiate( iptm, ishp, &hikflg ) ; CHKB(0, 0, rc);
//			if( rc < 0 ) continue;            CHKB(0, hikflg, 1);
//			zg.ssp[issp].hikflg = hikflg; 
//		}
		/* sok[].hikflgFoɉ\ʂ̈ 0:Ȃ 1:Bݒ 990630 */
		for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) {
			ishp = zg.sok[isok].shp;
			rc =  IsHikiate(g, iptm, ishp, &hikflg ) ; CHKB(0, 0, rc);
			if( rc < 0 ) continue;								CHKB(0, hikflg, 1);
			zg.sok[isok].hikflg = hikflg; 
		}
		/*		toq->fromqɂ̊֌W쐬 */
		if( (rc = zginit_sok_order(g, iptm )) < 0 ) goto quit ;
	}
quit :
	if(DBG[11]) TRACEC(0), Dprintf("zginit_usps:rc(%d)" CR,rc) ;
	return( rc ) ;
}
/*	zginit_sok_order: iڂ̑qɂtoq->fromqɂ̏Ɋi[
*/
int  zginit_sok_order(ZMRP &g, int iptm )
{
	int rc=0 ;
	int nsok, isok ;
	int i, j, mode ;
	int ishp, jshp;
	int nsok2, iar, ino;

	//l=0 zg.stk[]ɂ݂͌̕iڃN̑qɔԍ(1ȏ)i[
	//gptopqɂꍇ́Azg.stk[]Ɋi[Ăl(1ȏ)-ɕύX
//	zgnew_exp_stk(g, zg.n.shp );
	if( (rc = zgnew_exp_stk(g, zg.n.shp)) < 0 ) goto                             quit;
	memset( zg.stk, 0, sizeof(zg.stk[0]) * zg.n.shp );
	nsok = 0;
	for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) { /* gpqɂ狟qɂ擾 */
		//iړqɔԍzg.stk[]Ɋi[
		ishp = zg.sok[isok].shp;
		zg.stk[ishp] = ++nsok;		//iڃN̏ɃJE^Abvli[(Pȏ)
	}
	zg.n.eda = 0 ;
	for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) {
		rc =  GetFromSoko(g, iptm, zg.sok[isok].shp, zg.g.numshp, &zg.n.arshp, zg.arshp ) ;  CHKB(0, 0, rc);
		if( rc < 0 ) continue ;
		for( j=0 ; j<zg.n.arshp ; j++ ) {
				CHKA(0,zg.arshp[j],zg.g.numshp) ;
				CHKB(1,zg.shp[zg.arshp[j]].soko,1) ;
			if( (rc = zgnew_eda(g)) < 0 ) goto                             quit;
			ishp = zg.sok[isok].shp;
			zg.eda[rc][0] = zg.stk[ishp] -1;	  /* to   zg.shp[] */
					CHKA(0,zg.stk[ishp]-1,nsok);
			jshp = zg.arshp[j];
			zg.eda[rc][1] = zg.stk[jshp] -1;      /* from zg.shp[] */
					CHKA(0,zg.stk[jshp]-1,nsok);	
			//zg.eda[rc][0] = ishp;  /* iڂƂ̑qɃJE^ */
			//zg.eda[rc][1] = zg.arshp[j];  /* iڂƂ̑qɃJE^ */
		}
	}		CHKB(zg.g.numshp,zg.n.shp,zg.g.numshp) ;

	if( zg.n.eda > 0 && nsok > 0 ) {
		/*		eq֌WAD揇ʏɃ\[g mode=0:Asc */
		memset( zg.arshp, 0, zg.n.shp * sizeof(zg.arshp[0]) ) ;
		rc = tsortpl(g, zg.n.eda, zg.eda, nsok/*zg.n.shp */, zg.arshp, /*compPtm, */ (mode=0), 0 ) ;
		if( rc < 0 ) goto                                                     errT;
		/*		\[g烊Nč쐬 */
		nsok2 = 0;
		for( isok = zg.ptm[iptm].soktop; isok >= 0; isok = zg.sok[isok].ptmnext ) {
			zg.stk[nsok2++] = isok;	//isokzԍOl߂Ŋi[
		}
		for( iar=0; iar<nsok ; iar++ ) {
			ino = zg.arshp[iar];
				CHKA(0,ino,nsok);
			zg.arshp[iar] = zg.stk[ino];	//zg.arshp[]zg.sok[]ԍɕϊ
				CHKA(0,zg.stk[ino],zg.n.sok);
		}
		//iږ̑qɃNgp->ɕт
		zg.ptm[iptm].soktop = -1 ;
		for( j=0, i=nsok-1 ; i>=0 ; i-- ) {
			isok = zg.arshp[i];
				CHKA(0,isok,zg.n.sok) ;
			zg.sok[isok].ptmnext = zg.ptm[iptm].soktop;
			zg.ptm[iptm].soktop  = isok ;
			j++ ;
		}		CHKB(nsok,j,nsok) ;
	}
quit :
	return( rc ) ;
errT :/*	rc = -1 ; */ 
//	Esprintf(g.ermes, "zginit.cpp 0040 (%d) %s" CR,rc,( rc == -2 ? "qɂfrom->to֌WɃ[v܂B" : "" ) ) ; 
//J	Esprintf(g.ermes, "Tsortpl(%d)ŃG[B%s" CR,rc,( rc == -2 ? "qɂfrom->to֌WɃ[v܂B" : "" ) ) ; 
//	Eprintf(g.ermes);
	goto                                                                  quit ;
}
