/*
 * FILE     : zgmake.cpp	m[h쐬C
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * FUNCTION	: m[h쐬C
 * AUTHOR   : 2004.08.02 s.kobayashi
 */
//#define ZG_DEFINE_GLOBAL	/* GLOBAL` */

static char __file[] = __FILE__ ;
#include			<string.h>
#include			<memory.h>
#include			"zg.h"
#include			"zgsscp.h"

#ifdef _DEBUG
//#define DBGF 1
static int DBGF = 1;  //chg NT140612
#else
//#define DBGF 0
static int DBGF = 0;
#endif

/* zgmake: m[h쐬C
*/
int zgmake( ZMRP &g )
{
	int rc=0 ;
	
	if(DBGF||DBG[10]) TRACEA(0), Dprintf("zgmake:" CR) ;

    /*********  *******/
	rc = zgmake_init(g);			
	if( rc < 0 ) goto                                           quit;

    /********* f[^Ȃǂ̊i[ *********/
	rc = zginit(g);		            
	if( rc < 0 ) goto                                           quit;
    
	/********* m[h쐬 *********/
	rc = zgnode(g, NGRAPH_SIMPLE );	
	if( rc < 0 ) goto                                           quit;
	
	/* m[hA}̌i[ */
	zg.g.nsnod_regen = zg.n.snod;
	zg.g.nsedg_regen = zg.n.sedg;
quit :
	zgchk_ptm( g,  0 );	/* iڃ`FbN */
	zgchk_usp( g, 0 );	/* gpVbv`FbN */
	zgchk_nod( g, 0 );	/* m[hBUG`FbN */
	/*	e[u_v */
	zgdebug_g( );
	if(DBG[2]) zgdebug_memory( g );
	zgdebug_ptm( ) ;
	zgdebug_shp( ) ;
	zgdebug_usp( ) ;
	zgdebug_sok( ) ;
	zgdebug_ssp( ) ;
	zgdebug_nod( ) ;
	zgdebug_edg( ) ;
	if(DBG[10]) TRACEC(0), Dprintf("zgmake: rc(%d)" CR,rc) ;
	Dpclose( ) ;	//rc=ɂȂ
	return( rc ) ;
}

/*************************************************
//zgmake_init: zg
+*************************************************/
int zgmake_init(ZMRP &g)
{
	int rc=0 ;
	static int	init_flag = 0;
	if(DBGF) TRACEA(0), Dprintf("zgmake_init:" CR) ;
/*	zg */
	if( init_flag == 0 ) {
		memset( &zg, 0, sizeof(zg) );
		rc = zgdebug_init_ft(g);
		if( rc < 0 ) goto                                       quit;
	}
	strcpy( zg.g.dbgfname, "SSCLog/zg.dbg" ) ;

	rc = Dpinitflag( "SSCLog/dbg.flg" ) ; /*	fobOtO̓Ǎ */
	if( init_flag == 0 ) { /* ʏo̓t@C|C^ism[hOj */
		init_flag = 1;
		if( DBG[0] ) zg.lfp = fopen( "SSCLog/zgout.txt", "w" );
	}
/*	debug̗p */
	rc = Dpopen( zg.g.dbgfname, 0 ) ;	/* DebugOpen */
	rc = 0 ;
quit:
	if(DBGF) TRACEC(0), Dprintf("zgmake_init rc(0)" CR) ;
	return( rc ) ;
}

/*************************************************
//zgmake_shut: zgI
+*************************************************/
int zgmake_shut(ZMRP &g)
{
	if(DBG[10]) TRACEA(0), Dprintf("zgmake_shut:" CR) ;
	if(DBG[2]) zgdebug_memory( g );
/*	GA */
	if( zg.lfp )  fclose(zg.lfp), zg.lfp = NULL;
	Dpclose( ) ;	/* DebugClose */
	zgnew_all_free();
	if(DBG[10]) TRACEC(0), Dprintf("zgmake_shut: rc(0)" CR) ;
	return( 0 ) ;
}
