/*
 * FILE     : zgnode2.cpp	m[h쐬p[c
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : MRP system
 * FUNCTION	: m[h쐬p[c
 * AUTHOR   : 2004.08.05 s.kobayashi
 */
static char __file[] = __FILE__ ;
#include			<memory.h>
#include			"zg.h"
#include			"zgsscp.h"

/*	nod_apd:	qm[h쐬
*/
int  nod_apd(
	ZMRP &g,
	int type,	/* m[h^Cvʎq */
	int ptm,	/* iڔzԍ */
	int shp		/* Vbvzԍ */
	)			/* return( m[hzԍ or -1 ) */
{
	struct nod_s *wnod ;
	int rc = 0;

	switch(type) {
//	case DABGN: case DAEND: case DNBGN: //##DeleteByKuro
	case DABGN: case DAEND: //##AddByKuro
		CHKB(-1, ptm, -1); CHKB(-1, shp, -1); break;
	//case DPBGN:   case DPEND: case DSBGN: case DUEND: case SPOASA1: case DWOEND: //##DeleteByKuro
	case DPBGN:   case DPEND1: case DPEND2: case DSBGN: case DUEND: case DWOEND:  case DWABGN: case DWAEND: //##AddByKuro
#ifdef SUMICHAN //DeleteByKuro
	case NPBDA1: 
#endif //SUMICHAN
		CHKA(0, ptm, zg.n.ptm); CHKB(-1, shp, -1); break;

	//case SLDCK:
	//	CHKB(-1, ptm, -1); CHKA(0, shp, zg.n.shp); break;
	default: CHKA(0, shp, zg.n.shp); CHKA(0, ptm, zg.n.ptm);
		if( shp < 0 || ptm < 0 ) CHKA(0,type,0);
	}
	if( (rc = zgnew2_snod(g)) < 0 ) { 
		CHKB(0,rc,0) ;
		goto                           quit;
	}
	wnod = ZG_SNOD(rc) ;
	wnod->type     = type ;
	wnod->ptm      = ptm ;
	wnod->shp      = shp ;
	wnod->visitf   = 0 ;
	wnod->oyanum   = 0 ;
	wnod->edgko    = -1 ;
	wnod->edgoya   = -1 ;
quit : 
	return( rc ) ;
}
/*	edg_apd:	em[hqm[hɌ}쐬
*/
int  edg_apd(
	ZMRP &g,
	int oyanode,	/* em[hzԍ */
	int konode		/* qm[hzԍ */
	)				/* return( }zԍ or -1 ) */
{
	struct edg_s *wedg ;
	int rc=-1 ;
	struct nod_s *wnod ;
	int iedg ;
//	                                  CHKA(0, oyanode, zg.n.nod);
//	                                  CHKA(0, konode, zg.n.nod);
	if( oyanode < 0 || konode < 0 ) {
		CHKA(0, oyanode, zg.n.snod); CHKA(0, konode, zg.n.snod);
		goto                     quit;
	}
	if( (iedg = ZG_SNOD(oyanode)->edgko) >= 0 ) {
		if( ZG_SEDG(iedg)->nodoya == oyanode && ZG_SEDG(iedg)->nodko == konode ) { //ւ̃NȂ̂ŒǉȂ
//			CHKB(-1,iedg,-1) ;	//ŉʕĩt@g̎(VbvȂ)Aʂ͂DSBGN->DPEND 990908
//			return -1 ;
			return 0 ;
		}
	}
	if( (iedg = ZG_SNOD(konode)->edgoya) >= 0 ) { //2000.01.28
		if( ZG_SEDG(iedg)->nodko == konode && ZG_SEDG(iedg)->nodoya == oyanode ) { //ւ̃NȂ̂ŒǉȂ
//			CHKB(-1,iedg,-1) ;	//ŉʕĩt@g̎(VbvȂ)Aʂ͂DSBGN->DPEND 990908
//			return -1 ;
			return 0 ;
		}
	}
	if( oyanode == konode ) { //ǉȂ
		CHKB(-1,oyanode,konode) ; return 0 ;
	}
	if( (rc = zgnew2_sedg(g)) < 0 ) {
			CHKB(0,rc,0) ;
		goto                           quit;
	}
	wedg = ZG_SEDG(rc) ;
	wedg->nodoya  = oyanode ;
	wedg->nodko   = konode ;
	/* em[hq̎}N 擪ɒǉ */
	wnod = ZG_SNOD(oyanode) ;
	wedg->nextko  = wnod->edgko ;
	wnod->edgko = rc;

	/* qm[he̎}N@擪ɒǉ */
	wnod = ZG_SNOD(konode) ;
	wedg->nextoya  = wnod->edgoya ;
	wnod->edgoya = rc;

quit :
	return( rc ) ;
}
//P̎}̍폜
// int  ieda (i) }zԍ
// 폜}́Anodko = nodoya = nextoya = nextko = -1
int  edg_del( int iedg )
{
	int rc=0 ;
	int jedg, jedg0 ;
	int oyanod, konod ;

		CHKA(0,iedg,zg.n.sedg) ;
	if( (oyanod=ZG_SEDG(iedg)->nodoya) < 0 || (konod=ZG_SEDG(iedg)->nodko) < 0 ) goto err1 ;
	//em[h̎}N폜
	if( oyanod >= 0 ) {
		for( jedg=ZG_SNOD(oyanod)->edgko,jedg0=-1; jedg>=0 ; jedg=ZG_SEDG(jedg)->nextko ) {
			if( jedg == iedg ) break ;
			jedg0 = jedg;
		}
		if( jedg < 0 ) {
			CHKB(iedg,jedg,iedg) ;
			goto err1 ;
		}
		if( jedg0 < 0 ) ZG_SNOD(oyanod)->edgko = ZG_SEDG(iedg)->nextko ;
		else            ZG_SEDG(jedg0)->nextko = ZG_SEDG(iedg)->nextko ;
		ZG_SEDG(iedg)->nodoya = -1 ;
		ZG_SEDG(iedg)->nextko = -1 ;
	}
	//qm[h̎}N폜
	if( konod >= 0 ) {
		for( jedg=ZG_SNOD(konod)->edgoya,jedg0=-1 ; jedg>=0 ; jedg=ZG_SEDG(jedg)->nextoya ) {
			if( jedg == iedg ) break ;
			jedg0 = jedg ;
		}
		if( jedg < 0 ) {
			CHKB(iedg,jedg,iedg) ;
			goto err1 ;
		}
		if( jedg0 < 0 ) ZG_SNOD(konod)->edgoya  = ZG_SEDG(iedg)->nextoya ;
		else            ZG_SEDG(jedg0)->nextoya = ZG_SEDG(iedg)->nextoya ;
		ZG_SEDG(iedg)->nodko = -1 ;
		ZG_SEDG(iedg)->nextoya = -1 ;
	}
quit :
	return( rc )  ;
err1 : 
	rc = -1 ; goto quit ;
}
