/*
 * FILE     : sscvect.h	xN^[ev[g
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : xN^[ev[g
 * AUTHER   : N.Tsuchiya  2004.05.18
 */

#if ! defined(SSCVECTpH)
#define SSCVECTpH

//#include	<malloc.h>
#include	<stdlib.h>

#if ! defined(TIL_sscvect)
#define TIL_sscvect ~sscvect
#endif

//sscvect.h
template <class T>
class sscvect {
public:
	int n, x;
	T	*v;
	sscvect() { n = x = 0; v = 0; } //RXgN^
//	~sscvect() { if( v ) free(v); }    //fXgN^
	TIL_sscvect() { if( v ) free(v); }    //fXgN^
	int push_back(const T &x);            //PvfǉAYԂ(STLɖdl)
	void pop_back(void){if(n >= 0) --n;}; //łȂŌ̗vf܂B
	T	*peep( int idx){ return &v[idx];} //v[idx]̃|C^Ԃ
	T	&operator[](int idx){ return v[idx];}
	T	&operator()(int idx){ return v[idx];}
	T	*begin(){ return &v[0];}
	T	*end(){ return &v[n];}
	void clear(){ n = 0; }
	int assign(T *first, T *last);
	int size(){ return n; }
	int typsize(){ return sizeof(T); }
	int reserved(){ return x; }	//mۍϐ
	int resize(int size);
	int resize(int size,const T &e);
private:
	int expand( void **tbl, int *max, int nsz, int size, char *name);//ev[gg<T>gȂ
};
//#if 0 //o[֐sscvect.cppɕ
/*	ID_expand_com	z̊g
***************************************************************************/
template <class T> int sscvect<T>::expand(  //ev[gg<T>gȂ
	void	**tbl,  /* io z  */
	int		*max,   /* io z̗e(ővf) */
	int		nsz,    /* i  g̃f[^  */
	int		leng,   /* i Pvf̒ioCgj  */
	char	*name)  /* i  z񖼏  */
{
	int		rc = -1;
	void	*pwk;
	char errmes[1024];

	++nsz;        //end()̂߂ɂPvf]Ɋm
	if( nsz < 16 ) nsz = 16;
	if( *max <= 0 ) {               //CHKB(1, 1, nsz);
		if( (*tbl = (void*)malloc(nsz * leng)) == 0) goto         err;
		*max = nsz;
	} else if( nsz > *max ) {
		if( nsz < (*max * 2) ) nsz = *max * 2;
		if( (pwk = (void*)realloc(*tbl, nsz * leng)) == 0) goto   err;
		*tbl = pwk;
		*max = nsz;
	}
	rc = *max;
quit:
	return( rc );
err: rc = -1;
	 if( name != NULL ) {
		Esprintf(errmes, "**** expand_com: cannot allocate table(%s) nsz(%d) max(%d) leng(%d)***" CR
			, name, nsz, *max, leng );
		Eprintf(errmes);
	}
	goto                                quit;
}
/*	ID_push_back	z̒ǉ
***************************************************************************/
template <class T> int sscvect<T>::push_back(const T &e) {
	int 	rc;
#if 1
	//z̊g
	if( n >= x )
		if( (rc = expand( (void**)&v, &x, n+1, sizeof(T), "sscvect::push_back()")) < 0 ) goto quit;
#else
	if( x <= 0 ) {
//		x = 1;      /* for test */
		x = 16;
		v = (T*)malloc( x * sizeof(T) );
	} else if( n >= x ) {
//		x += 1;      /* for test */
		x *= 2;
		v = (T*)realloc(v, x * sizeof(T) );
	}
#endif
	v[n] = e;
	rc = n++;
quit:
	return rc;
}

/*	ID_resize	z̊g
***************************************************************************/
template <class T> int sscvect<T>::resize(int size) {
	int 	rc;
	//z̊g
	if( (rc = expand( (void**)&v, &x, size, sizeof(T), "sscvect::resize()")) < 0 ) goto quit;
	n = size;
quit:
	return rc;
}
/*	ID_resize	z̊gƏ
***************************************************************************/
template <class T> int sscvect<T>::resize(int size,const T &e) {
	int 	rc;
	register T *p, *end;
	//z̊g
	if( (rc = expand( (void**)&v, &x, size, sizeof(T), "sscvect::resize()")) < 0 ) goto quit;
//	for( n = 0; n < size; ++n ) v[n] = e;
	p = v; end = &v[size];
	while( p < end ) *p++ = e;
	n = size;
quit:
	return rc;
}
/*	ID_assign	z̒ǉ
***************************************************************************/
template <class T> int sscvect<T>::assign(T *first, T *last) {
	int 	rc;
	T	*pwk = v;
	//z̊g
	n = last - first;
	if( (rc = expand( (void**)&v, &x, n, sizeof(T), "sscvect::assign()")) < 0 ) goto quit;
	while( first < last ) *pwk++ = *first++;
	rc = n;
quit:
	return rc;
}

/////////////////////////////////////////////////////////////////
#endif // ! defined(SSCVECTpH)
