/*
 * FILE      : z1mrp.h	lqovZŎg\̐錾
 * Copyright (C) 2004 Sogen System Co., Ltd
 * SYSTEM    : MRP system
 * FUNCTION  : lqovZŎg\̐錾
 * AUTHOR    : N.Tsuchiya  2004.08.25
 */
#if ! defined(Z1MRPpH)
#define Z1MRPpH

#include "zchardif.h"
#include "zmrpssc.h"
#include "zmrptbl.h"
#include "zmrprec.h"
#include "sscvect.h"

//#define HOME_PAGE    //z[y[Wp 2019/12/02  N.Tsuchiya

#if 0
#include "sscvect3.h"
#else
#define sscvect3 sscvect
#endif

#include "chash3g.h"
#define HASH void *
#define UNIT 0.00001  


struct ZMRP {
	double	epsi;                    /* [Ƃ݂ȂlB1e-3 */
	int		jmf;                     /* {ꃁbZ[WtO !=0:{o KS140609add */
	int errcnt_rd;                   /* t@Cǂݍݎ̃G[ */
	char	ermes[1024];             /* G[bZ[W쐬p */
	char	rdbf[1024];              /* t@ĈPs͗p */
//	char    defclmcd[12];            /* ftHgJ_(J_R[hXy[X)R[h "!DEFCLM" */
	int     defclm;                  /* ftHgJ_ "!DEFCLM" clm[] */
	char    fname[512];              /* ͒t@C */
	int		rdseq;                   /* t@Cs */
    int     baseyear;                /* NBS */
	int     today;                   /* ̒ʎZ ȗl:VXet cal[] */
	int     endtd;                   /* J_̍ŏIʎZisys.pastdays+sys.futudays-1jcal[] */
	int		yobi0;                   /* ʎZO̗jB0:j`6:yj NT040917add */
	unsigned char delimiter;         /* ؕBTAB(^u)A,(J})A|(Xg[N) */
	HASH_CNAME	h_clm;               /* J_R[h */
	HASH_CNAME	h_org;               /* gDR[h */
	HASH_CNAME	h_shm;               /* VbvR[h */
	HASH_CNAME	h_itm;               /* iڃR[h */
	HASH_CNAME	h_odm;               /* ԃR[h */
	HASH_CNAME	h_cpm;               /* \̓R[h */
	HASH_CNAME	h_grm;               /* O[vR[h */
	struct  sys_td  	sys;         /* VXe sys */
	sscvect<int> 		kimatu;      /* ̒ʎZ̔z */
	sscvect<cal_td> 	cal;         /* ʎZ[NΉJ_ cal */
	sscvect<clm_td> 	clm;         /* J_R[hMST clm */
	sscvect<org_td> 	org;         /* gD}X^ org */
	sscvect<itm_td> 	itm;         /* iڃ}X^ itm */
	sscvect<bom_td> 	bom;         /* i\ bom */
	sscvect<shm_td> 	shm;         /* Vbv}X^ shm */
	sscvect<fsh_td> 	fsh;         /* Vbv fsh */
	sscvect<fsh2_td> 	fsh2;        /* Vbviԕʁj fsh2 */
	sscvect<tsh_td> 	tsh;         /* gpVbv tsh */
	sscvect<dlm_td> 	dlm;         /* }X^ dlm */
	sscvect<dlm2_td> 	dlm2;        /* }X^iԕʁjdlm2 */
	sscvect<dlm3_td> 	dlm3;        /* }X^iԕʁjdlm3 */
	sscvect<fls_td> 	fls;         /* bg܂Ƃߏ fls */
	sscvect<fls2_td> 	fls2;        /* bg܂Ƃߏiԕʁj fls2 */
	sscvect<dls_td> 	dls;         /* ׃bg܂Ƃߏ dls */
	sscvect<dls2_td> 	dls2;        /* ׃bg܂Ƃߏiԕʁj dls2 */
	sscvect<odm_td> 	odm;         /* ԁ^I[_No}X^ odm */
	sscvect<rod_td> 	rod;         /* 󒍃I[_ rod */
	sscvect<pln_td> 	pln;         /* ݐY(MPS)  pln */
	sscvect<fto_td> 	fto;         /* oɗ\ fto */
	sscvect<opo_td> 	opo;         /* I[_ opo */
	sscvect<onh_td> 	onh;         /* ݌ onh */
	sscvect<saf_td> 	saf;         /* S݌ saf */
	sscvect<cpm_td> 	cpm;         /* \̓R[hMST cpm */
	sscvect<cap_td> 	cap;         /* \ cap */
	sscvect<tpm_td> 	tpm;         /* A}X^ tpm */
	sscvect<tpm2_td> 	tpm2;        /* A}X^iԕʁj  tpm2 */
	sscvect<grm_td> 	grm;         /* O[v}X^ grm */
	sscvect<igm_td> 	igm;         /* iڃO[v}X^ igm */
	sscvect<sgm_td> 	sgm;         /* VbvO[v}X^ sgm */
	sscvect<isg_td> 	isg;         /* iڃVbvO[v isg */
	sscvect<ubm_td> 	ubm;         /* [XAbvi\ ubm */

//	sscvect<int> 		fshtopmrp;   /* VbvʎZʐ擪mrp ~S */
//	sscvect<int> 		tshtopmrp;   /* gpVbvʎZʐ擪mrp ~S */
	sscvect<int> 		sortw;       /* [NzBzsort()gƂ */
	sscvect<int> 		tsw_eda1;    /* [NzBztsort()gƂ AddByKuro041108 */
	sscvect<int> 		tsw_eda2;    /* [NzBztsort()gƂ AddByKuro041108 */
//	sscvect<int[2]> 		tsw_eda;    /* [NzBztsort()gƂ AddByKuro041108 */
	sscvect<double> 	capa;        /* ʔ\͔z   ~\͎wVbv */
	sscvect<double> 	fuka;        /* ׎Rϔz   ~\͎wVbv */
#if 1 // FS041222A
	sscvect3<zhi_td> 	zhi;         /* ݌Ɉڍ zhi v(Net)vZ̈ڍ */
	sscvect3<lsz_td> 	lsz;         /* bg܂Ƃߏڍ lsz */
	sscvect3<trp1_td> 	trp1;        /* gpVbvsqoPibg܂ƂߑOj */
	sscvect3<trp2_td> 	trp2;        /* gpVbvsqoQibg܂Ƃߌj */
	sscvect3<drp1_td> 	drp1;        /* zcqoPibg܂ƂߑOj */
	sscvect3<drp2_td> 	drp2;        /* zcqoQibg܂Ƃߌj */
	sscvect3<frp1_td> 	frp1;        /* VbveqoPibg܂ƂߑOj */
	sscvect3<frp2_td> 	frp2;        /* VbveqoQibg܂Ƃߌj */
#else
	sscvect<zhi_td> 	zhi;         /* ݌Ɉڍ zhi v(Net)vZ̈ڍ */
	sscvect<lsz_td> 	lsz;         /* bg܂Ƃߏڍ lsz */
	sscvect<trp1_td> 	trp1;        /* gpVbvsqoPibg܂ƂߑOj */
	sscvect<trp2_td> 	trp2;        /* gpVbvsqoQibg܂Ƃߌj */
	sscvect<drp1_td> 	drp1;        /* zcqoPibg܂ƂߑOj */
	sscvect<drp2_td> 	drp2;        /* zcqoQibg܂Ƃߌj */
	sscvect<frp1_td> 	frp1;        /* VbveqoPibg܂ƂߑOj */
	sscvect<frp2_td> 	frp2;        /* VbveqoQibg܂Ƃߌj */
#endif
	sscvect<wmrp_td> 	wmrp;        /* ׎Rςݗpbgz */
	sscvect<double>		ruiseki;     /* ݐϔ\͔z    */
	xset_s	idxset;                  /* YW NT050217add */
} ;
#define QSORT_TYP	(int(*)(ZMRP &,const void*,const void*)) /* qsort()p */
#include "zprot.h"
#include "zprotf.h"
#endif //! defined(Z1MRPpH)
